<?php
/**
 * @package		Joomla Bamboo Zen Grid Framework
 * @Type        Core Framework Files
 * @version		v1.0
 * @author		Joomal Bamboo http://www.joomlabamboo.com
 * @copyright 	Copyright (C) 2007 - 2010 Joomla Bamboo
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();
jimport('joomla.html.html');
jimport('joomla.form.formfield');

/**
 * Renders a list element
 *
 * @package 	Joomla.Framework
 * @subpackage		Form
 * @since		1.6
 */

class JFormFieldZenfonts extends JFormField
{
	/**
	* Element type
	*
	* @access	protected
	* @var		string
	*/
	protected $type = 'Zenfonts';

	protected function getInput()
	{
		$class = ( $this->element['class'] ? 'class="'.$this->element['class'].'"' : 'class="inputbox"' );
			$values = array(
					'------------------- Standard ---------------------' => '--------------------- Standard ---------------------',
					'cambria' => 'Cambria, Georgia, Times, Times New Roman, serif',
					'caslon' => 'Adobe Caslon Pro, Georgia, Garamond, Times, serif',
					'courier' => 'Courier new”, Courier, “Andale Mono',
					'garamond' => 'Garamond, ‘Times New Roman’, Times, serif',
					'georgia' => 'Georgia, Times, ‘Times New Roman’, serif', 
					'gillsans' => 'GillSans, Calibri, Trebuchet, arial sans-serif', 
					'helvetica' => 'Helvetica Neue, Helvetica, Arial, sans-serif',
					'lucida' => 'Lucida Grande, Geneva, Helvetica, sans-serif', 
					'palatino' => 'Palatino, ‘Times New Roman’, serif', 
					'tahoma' => 'Tahoma, Verdana, Geneva',
					'trebuchet' => 'Trebuchet ms, Tahoma, Arial, sans-serif',
					'EBGaramond' => 'EB Garamond - Google Font Replacement',
					'------------------- Serif ---------------------' => '--------------------- Serif ---------------------',
					'Artifika' => 'Artifika - Google Font Replacement',
					'Arvo' => 'Arvo - Google Font Replacement', 
					'Bentham' => 'Bentham - Google Font Replacement',
					'Bevan' => 'Bevan - Google Font Replacement',
					'Cardo' => 'Cardo - Google Font Replacement',
					'Corben' => 'Corben  - Google Font Replacement',
					'CrimsonText' => 'Crimson Text - Google Font Replacement',
					'DroidSerif' => 'Droid Serif - Google Font Replacement',
					'EBGaramond' => 'EB Garamond - Google Font Replacement',
					'GoudyBookletter1911' => 'Goudy Bookletter - Google Font Replacement',
					'Gruppo' => 'Gruppo  - Google Font Replacement',
					'IMFellGreatPrimer' => 'IM Fell - Google Font Replacement',
					'JosefinSlab' => 'Josefin Slab - Google Font Replacement',
					'Kameron' => 'Kameron - Google Font Replacement',
					'Kreon' => 'Kreon - Google Font Replacement',
					'Lora' => 'Lora - Google Font Replacement',
					'MaidenOrange' => 'Maiden Orange - Google Font Replacement',
					'Merriweather' => 'Merriweather - Google Font Replacement',
					'Neuton' => 'Neuton - Google Font Replacement',
					'OFLSorts' => 'OFL Sorts - Google Font Replacement',
					'OldStandard' => 'OldStandard - Google Font Replacement',
					'PlayfairDisplay' => 'Playfair Display - Google Font Replacement',
					'PTSerif' => 'PT Serif - Google Font Replacement',
					'Quattrocento' => 'Quattrocentro - Google Font Replacement',
					'Radley' => 'Radley - Google Font Replacement',
					'Tinos' => 'Tinos - Google Font Replacement',
					'Vollkorn' => 'Vollkorn - Google Font Replacement',			
					'------------------- Sans Serif -------------------' => '------------------- Sans Serif -------------------',
					'Aclonica' => 'Aclonica - Google Font Replacement',
					'Allerta' => 'Allerta - Google Font Replacement',
					'AllertaStencil' => 'Allerta Stencil - Google Font Replacement',
					'AnonymousPro' => 'Anonymous Pro - Google Font Replacement',
					'Anton' => 'Anton - Google Font Replacement',
					'Arimo' => 'Arimo - Google Font Replacement',
					'Buda' => 'Buda - Google Font Replacement',
					'Cabin' => 'Cabin  - Google Font Replacement',
					'CarterOne' => 'Carter One - Google Font Replacement',
					'Candal' => 'Candal - Google Font Replacement',
					'Coda' => 'Coda - Google Font Replacement',
					'Cuprum' => 'Cuprum - Google Font Replacement',
					'Cantarell' => 'Cantarell - Google Font Replacement', 
					'Cousine' => 'Cousine - Google Font Replacement',
					'DroidSans' => 'Droid Sans - Google Font Replacement', 
					'DroidSansMono' => 'Droid Sans Mono - Google Font Replacement',
					'Geo' => 'Geo - Google Font Replacement',
					'Inconsolata' => 'Inconsolata - Google Font Replacement',
					'Josefin' => 'Josefin Sans - Google Font Replacement',
					'Jura' => 'Jura - Google Font Replacement',
					'Kenia' => 'Kenia - Google Font Replacement',
					'Lato' => 'Lato  - Google Font Replacement',
					'Lekton' => 'Lekton  - Google Font Replacement',
					'Metrophobic' => 'Metrophobic - Google Font Replacement',
					'Michroma' => 'Michroma - Google Font Replacement',
					'Molengo' => 'Molengo - Google Font Replacement',
					'Muli' => 'Muli - Google Font Replacement',
					'Neucha' => 'Neucha - Google Font Replacement',
					'NewsCycle' => 'News Cycle - Google Font Replacement',
					'Nobile' => 'Nobile - Google Font Replacement',	
					'Nunito' => 'Nunito - Google Font Replacement',
					'Orbitron' => 'Orbitron  - Google Font Replacement',
					'Oswald' => 'Oswald - Google Font Replacement',
					'Play' => 'Play - Google Font Replacement',
					'Podkova' => 'Podkova - Google Font Replacement',
					'PTSans' => 'PT Sans - Google Font Replacement',
					'Puritan' => 'Puritan - Google Font Replacement',
					'QuattrocentoSans' => 'Quattrocento Sans - Google Font Replacement',
					'Raleway' => 'Raleway  - Google Font Replacement',
					'SixCaps' => 'Six Caps - Google Font Replacement',	
					'Syncopate' => 'Syncopate  - Google Font Replacement',
					'TerminalDosisLight' => 'Terminal Dosis Light - Google Font Replacement',
					'Ubuntu' => 'Ubuntu  - Google Font Replacement',
					'WireOne' => 'Wire One - Google Font Replacement',
					'Yanone' => 'Yanone Kaffeesatz - Google Font Replacement',

					'------------------- Handwriting -------------------' => '------------------- Handwriting -------------------',
					'AnnieUseYourTelescope' => 'Annie Use Your Telescope  - Google Font Replacement',
					'ArchitectsDaughter' => 'Architects Daughter - Google Font Replacement',
					'Calligraffitti' => 'Calligraffitti  - Google Font Replacement',
					'CedarvilleCursive' => 'CedarvilleCursive  - Google Font Replacement',
					'ComingSoon' => 'Coming Soon - Google Font Replacement',
					'CoveredByYourGrace' => 'Covered by Your Grace - Google Font Replacement',
					'CraftyGirls' => 'Crafty Girls  - Google Font Replacement',
					'Crushed' => 'Crushed  - Google Font Replacement',
					'Damion' => 'Damion - Google Font Replacement',
					'DancingScript' => 'Dancing Script - Google Font Replacement',
					'DawningofaNewDay' => 'Dawning of a New Day - Google Font Replacement',
					'HomemadeApple' => 'Homemade Apple  - Google Font Replacement',
					'IndieFlower' => 'Indie Flower - Google Font Replacement',
					'JustAnotherHand' => 'Just Another Hand - Google Font Replacement',
					'JustMeAgainDownHere' => 'Just Me Again Down Here  - Google Font Replacement',
					'Kristi' => 'Kristi - Google Font Replacement',
					'LaBelleAurore' => 'La Bell Aurore - Google Font Replacement',
					'Meddon' => 'Meddon - Google Font Replacement',
					'Neucha' => 'Neucha - Google Font Replacement',
					'OverTheRainbow' => 'Over the Rainbow - Google Font Replacement',
					'Pacifico' => 'Pacifico - Google Font Replacement',
					'ReenieBeanie' => 'Reenie Beanie - Google Font Replacement',
					'RockSalt' => 'Rock Salt  - Google Font Replacement',
					'Schoolbell' => 'Schoolbell  - Google Font Replacement',
					'ShadowsIntoLight' => 'Shadows into Light - Google Font Replacement',
					'Slackey' => 'Slackey  - Google Font Replacement',
					'Sniglet' => 'Sniglet  - Google Font Replacement',
					'SueEllenFrancisco' => 'Sue Ellen Francisco  - Google Font Replacement',
					'Sunshiney' => 'Sunshiney  - Google Font Replacement',
					'SwankyandMooMoo' => 'Swanky and Moo Moo - Google Font Replacement',
					'TheGirlNextDoor' => 'The Girl Next Door  - Google Font Replacement',
					'WaitingfortheSunrise' => 'Waiting for the Sunrise  - Google Font Replacement',
					'WalterTurncoat' => 'Walter Turncoat  - Google Font Replacement',
					'Vibur' => 'Vibur  - Google Font Replacement',
					'Zeyada' => 'Zeyada  - Google Font Replacement',	


					'------------------- Display --------------------' => '------------------- Display --------------------',
					'Allan' => 'Allan - Google Font Replacement',
					'Astloch' => 'Astloch - Google Font Replacement',
					'Bangers' => 'Bangers - Google Font Replacement',
					'CabinSketch' => 'Cabin Sketch - Google Font Replacement',
					'CherryCreamSoda' => 'Cherry Cream Soda  - Google Font Replacement',
					'Chewy' => 'Chewy  - Google Font Replacement',
					'Copse' => 'Copse - Google Font Replacement',
					'Crushed' => 'Crushed - Google Font Replacement',
					'ExpletusSans' => 'Expletus Sans - Google Font Replacement',
					'FontdinerSwanky' => 'Fontdiner Swanky  - Google Font Replacement',
					'IrishGrowler' => 'Irish Growler  - Google Font Replacement',
					'Kranky' => 'Kranky  - Google Font Replacement',
					'LeagueScript' => 'League Script - Google Font Replacement',
					'Limelight' => 'Limelight - Google Font Replacement',	
					'Lobster' => 'Lobster - Google Font Replacement',
					'LuckiestGuy' => 'Luckiest Guy  - Google Font Replacement',
					'MavenPro' => 'Maven Pro - Google Font Replacement',
					'MedievalSharp' => 'Medieval Sharp - Google Font Replacement',
					'Miltonian' => 'Miltonian - Google Font Replacement',
					'MountainsOfChristmas' => 'Mountains Of Christmas  - Google Font Replacement',
					'Nova' => 'Nova - Google Font Replacement',
					'PermanentMarker' => 'Permanent Marker  - Google Font Replacement',
					'Philosopher' => 'Philosopher - Google Font Replacement',
					'Slackey' => 'Slackey  - Google Font Replacement',
					'Smythe' => 'Smythe - Google Font Replacement',
					'Sniglet' => 'Sniglet - Google Font Replacement',
					'SpecialElite' => 'Special Elite - Google Font Replacement',
					'Tangerine' => 'Tangerine - Google Font Replacement',
					'TenorSans' => 'Tenor Sans - Google Font Replacement',
					'UnifrakturCook' => 'UnifrakturCook - Google Font Replacement',
					'UnifrakturMaguntia' => 'UnifrakturMaguntia - Google Font Replacement',
					'Unkempt' => 'Unkempt - Google Font Replacement',
					'Wallpoet' => 'Wallpoet - Google Font Replacement',
					'VT323'	 => 'VT323 - Google Font Replacement'
									);
						
		
		$options = array ();
		foreach ($values as $val => $text)
		{
			$options[] = JHTML::_('select.option', $val, JText::_($text));
		}



		return JHTML::_('select.genericlist',  $options, ''.$this->formControl.'[params]['.$this->fieldname.']', $class, 'value', 'text', $this->value, $this->formControl.$this->fieldname);
	}
	
}
