<?php
/**
 * @package		Joomla Bamboo Zen Grid Framework
 * @Type        Core Framework Files
 * @version		v1.0
 * @author		Joomal Bamboo http://www.joomlabamboo.com
 * @copyright 	Copyright (C) 2007 - 2010 Joomla Bamboo
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();
jimport('joomla.html.html');
jimport('joomla.form.formfield');

/**
 * Renders a editors element
 *
 * @package 	Joomla.Framework
 * @subpackage		Form
 * @since		1.6
 */

class JFormFieldZentploverview extends JFormField
{
	/**
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	
	protected $type = 'zentploverview';

	protected function getInput()
	{
		$app = JFactory::getApplication();
		require_once(JPATH_ROOT.DS.'/templates/zengridframework/admin/classes/zengrid.php');

		$logo = false;
		if (file_exists(JPATH_ROOT.DS.(Zengrid::getParam('logoFile')))) {
			$logo = true;
        }
		
		if (!$logo) JError::raiseNotice('400', JText::_('TPL_ZEN_LOGODOESNOTEXIST').' <a id="accordionLink" href="#logo">'.JText::_('TPL_ZEN_LOGOSETTINGS').'</a>');

		$manifest = Zengrid::getManifest();
		$style = Zengrid::getParam('style');
		$path = JPATH_ROOT.DS.'templates'.DS.Zengrid::getTemplate().DS.'layout'.DS;
		$override['banner'] = JText::_('TPL_ZEN_BANNER');
		$override['bottom'] = JText::_('TPL_ZEN_BOTTOM');
		$override['closeContainer'] = JText::_('TPL_ZEN_CLOSECONTAINER');
		$override['footer'] = JText::_('TPL_ZEN_FOOTER');
		$override['grid1'] = JText::_('TPL_ZEN_GRID1');
		$override['grid2'] = JText::_('TPL_ZEN_GRID2');
		$override['grid3'] = JText::_('TPL_ZEN_GRID3');
		$override['grid4'] = JText::_('TPL_ZEN_GRID4');
		$override['grid5'] = JText::_('TPL_ZEN_GRID5');
		$override['grid6'] = JText::_('TPL_ZEN_GRID6');
		$override['header'] = JText::_('TPL_ZEN_HEADER');
		$override['index'] = JText::_('TPL_ZEN_INDEX');
		$override['main'] = JText::_('TPL_ZEN_MAINCONTENT');
		$override['nav'] = JText::_('TPL_ZEN_NAVIGATION');
		$override['openContainer'] = JText::_('TPL_ZEN_OPENCONTAINER');
		$override['panel'] = JText::_('TPL_ZEN_PANEL');
		$override['top'] = JText::_('TPL_ZEN_TOP');
		$override_check = JText::_('TPL_ZEN_THEREARENOOVERRIDESAFFECTINGYOURTEMPLATES');
		foreach ($override as $name => $label) {
			if(file_exists($path.$name.".php")) { 
				$override_check = JText::_('TPL_ZEN_YOURTEMPLATEHASACTIVEOVERRIDES').JText::_('TPL_ZEN_PLEASEVIEWTHEACTIVEOVERRIDES').'<a id="accordionLink" href="#overrides">'.JText::_('TPL_ZEN_HERE').'</a>.';
			}
		}
		
		$html = '<div class="jboverview right"><div id="tplStyleForm"></div><div id="menuSelect"></div></div><div class="jboverview"><a href="http://www.joomlabamboo.com"><img src="'.JURI::root(true).'/templates/'.Zengrid::getTemplate().'/templateTeaser.jpg" alt="joomla Bamboo" style="float:left;margin: 0 20px 20px 0;"/></a></div><div class="jboverview"><p>'.JText::_('TPL_ZEN_TEMPLATEBUILTUPONGRID').'</p></div>';
		$html .= '<div class="jboverview"><h3 class="intro">'.JText::_('TPL_ZEN_CURRENTSETTINGS').'</h3><ul id="zgf_overview">';
		$html .= '<li><strong>'.JText::_('TPL_ZEN_GRIDVERSION').'</strong> ' . $manifest->version . '</li>';
		$html .= '<li><strong>'.JText::_('TPL_ZEN_CURRENTLOGO').'</strong> ' . Zengrid::getParam('logoFile') . '</li>';
		$html .= '<li><strong>'.JText::_('TPL_ZEN_CORETEMPLATEOVERRIDES').'</strong> ' . $override_check . '</li>';
		$html .= '</ul></div>';
		
		return $html;
	}

        public function getLabel() {
            return '<span class="hideLabel">' . parent::getLabel() . '</span>';
        }

}
?>
