<?php
/**
* @version		$Id: helper.php 10857 2008-08-30 06:41:16Z willebil $
* @package		Joomla
* @copyright	Copyright (C) 2005 - 2008 Open Source Matters. All rights reserved.
* @license		GNU/GPL, see LICENSE.php
* Joomla! is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
* See COPYRIGHT.php for copyright notices and details.
*/
// no direct access
defined('_JEXEC') or die('Restricted access');


if (substr(JVERSION, 0, 3) >= '1.6') {
	
	/***********************************************************************************************************************
	 * 
	 *  Helper for Joomla 1.7 +
	 * 
	**********************************************************************************************************************/
	

	jimport('joomla.application.component.model');

	$com_path = JPATH_SITE.DS.'components'.DS.'com_content'.DS;
	require_once $com_path.'router.php';
	require_once $com_path.'helpers'.DS.'route.php';

	jimport('joomla.application.component.model');

	JModel::addIncludePath($com_path.DS.'models', 'ContentModel');


	if($contentSource == "article") {
		abstract class modMicroBlogHelper
		{
			public static function getList(&$params)
			{
				// Get an instance of the generic articles model
				$articles = JModel::getInstance('Articles', 'ContentModel', array('ignore_request' => true));

				// Set application parameters in model
				$app = JFactory::getApplication();
				$appParams = $app->getParams();
				$articles->setState('params', $appParams);

				// Set the filters based on the module params
				$articles->setState('list.start', 0);
				$articles->setState('list.limit', (int) $params->get('count', 5));
				$articles->setState('filter.published', 1);

				// Access filter
				$access = !JComponentHelper::getParams('com_content')->get('show_noauth');
				$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
				$articles->setState('filter.access', $access);
		
				$artids		= $params->get('artid');
				$catids = $params->get('catid');
				$articles->setState('filter.category_id.include', (bool) $params->get('category_filtering_type', 1));
		
				// Category filter
				if ($catids) {
					if ($params->get('show_child_category_articles', 0) && (int) $params->get('levels', 0) > 0) {
						// Get an instance of the generic categories model
						$categories = JModel::getInstance('Categories', 'ContentModel', array('ignore_request' => true));
						$categories->setState('params', $appParams);
						$levels = $params->get('levels', 1) ? $params->get('levels', 1) : 9999;
						$categories->setState('filter.get_children', $levels);
						$categories->setState('filter.published', 1);
						$categories->setState('filter.access', $access);
						$additional_catids = array();

						foreach($catids as $catid)
						{
							$categories->setState('filter.parentId', $catid);
							$recursive = true;
							$items = $categories->getItems($recursive);

							if ($items)
							{
								foreach($items as $category)
								{
									$condition = (($category->level - $categories->getParent()->level) <= $levels);
									if ($condition) {
										$additional_catids[] = $category->id;
									}

								}
							}
						}

						$catids = array_unique(array_merge($catids, $additional_catids));
					}

					$articles->setState('filter.category_id', $catids);
				}
				if($artids) {
					$articles->setState('filter.article_id', $artids);
					$articles->setState('filter.article_id.include', $params->get('article_filtering_type', 1));
				}
				// Ordering
				$articles->setState('list.ordering', $params->get('ordering', 'a.ordering'));
				$articles->setState('list.direction', $params->get('ordering_direction', 'ASC'));

				// New Parameters
				$articles->setState('filter.featured', $params->get('show_front', 'show'));
				$articles->setState('filter.author_id', $params->get('created_by', ""));
				$articles->setState('filter.author_id.include', $params->get('author_filtering_type', 1));
				$articles->setState('filter.author_alias', $params->get('created_by_alias', ""));
				$articles->setState('filter.author_alias.include', $params->get('author_alias_filtering_type', 1));
				$excluded_articles = $params->get('excluded_articles', '');

				$articles->setState('filter.language',$app->getLanguageFilter());

				$items = $articles->getItems();
		
				$count		= (int) $params->get('count', 5);
				$show_front	= $params->get('show_front', 1);
				$dateFormat		= $params->get('dateFormat', 'j M, y');
				$translateDate		= $params->get('translateDate', '0');
				$dateString		= $params->get('dateString', 'DATE_FORMAT_LC3');
				$renderPlugin	= $params->get('renderPlugin','render');
				$tags	= $params->get( 'allowed_tags', '<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br />' );
				$wordCount	= $params->get( 'wordCount',0);		
				$introSuffix = $params->get('introSuffix','');
				$stripTags = $params->get('strip_tags',0);
				$linkTarget = $params->get('linkTarget','article');
				$showCategory = $params->get('showCategory',0);
				$catlink = $params->get('catLink',0);
				$option = JRequest::getCmd('option');
				$view = JRequest::getCmd('view');

				if ($option === 'com_content' && $view === 'article') {
					$active_article_id = JRequest::getInt('id');
				}
				else {
					$active_article_id = 0;
				}
		
				foreach ( $items as $item )
				{
					$item->fulltext = $item->introtext;
					$item->slug = $item->id.':'.$item->alias;
					$item->catslug = $item->catid ? $item->catid .':'.$item->category_alias : $item->catid;

					if ($access || in_array($item->access, $authorised)) {
				
						if($linkTarget == 'article') $item->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catslug));

						if($linkTarget == 'default') $item->link = JRoute::_(ContentHelperRoute::getCategoryRoute($item->catslug).'&layout=default');

						if($linkTarget == 'blog') $item->link = JRoute::_(ContentHelperRoute::getCategoryRoute($item->catslug).'&layout=blog');

						$item->catlink = JRoute::_(ContentHelperRoute::getCategoryRoute($item->catslug).'&layout=blog');
					}
					 else {
						// Angie Fixed Routing
						$app	= JFactory::getApplication();
						$menu	= $app->getMenu();
						$menuitems	= $menu->getItems('link', 'index.php?option=com_users&view=login');
					if(isset($menuitems[0])) {
							$Itemid = $menuitems[0]->id;
						} else if (JRequest::getInt('Itemid') > 0) { //use Itemid from requesting page only if there is no existing menu
							$Itemid = JRequest::getInt('Itemid');
						}

						$item->link = JRoute::_('index.php?option=com_users&view=login&Itemid='.$Itemid);
						}
				
					if ($renderPlugin == 'strip') {
						$item->introtext = preg_replace('/{([a-zA-Z0-9\-_]*)\s*(.*?)}/i','', $item->introtext);
					}else{
						$item->introtext = JHtml::_('content.prepare', $item->introtext);
					}
			
					$item->image = "";

					$html= $item->introtext;
					$html .= "alt='...' title='...' />";
					$pattern = '/<img[^>]+src[\\s=\'"]';
					$pattern .= '+([^"\'>\\s]+)/is';
					if(preg_match($pattern,$html,$match)){
						$item->image = "$match[1]";
						}	
					else {
						$item->image = "";
						}
					$item->introtext = $stripTags ? self::_cleanIntrotext($item->introtext,$tags) : $item->introtext;
					$item->introtext = $wordCount ? self::truncate($item->introtext, $wordCount, $introSuffix) : $item->introtext;

					// Used for styling the active article
					$item->active = $item->id == $active_article_id ? 'active' : '';
					$date = new JDate($item->created);			
			
					if (!$translateDate) {
						$item->date= $date->format($dateFormat);
					}
					else {
						$item->date=  JHtml::_('date',$item->created, JText::_(''.$dateString.''));
					}

					if ($showCategory) $item->catname = $item->category_title;
				}
				return $items;
			}
	
			public static function _cleanIntrotext($introtext,$tags)
			{
				//$introtext = str_replace('<p>', ' ', $introtext);
				//$introtext = str_replace('</p>', ' ', $introtext);
				$introtext = strip_tags($introtext, $tags);

				$introtext = trim($introtext);

				return $introtext;
			}
	
			/**
			* This is a better truncate implementation than what we
			* currently have available in the library. In particular,
			* on index.php/Banners/Banners/site-map.html JHtml's truncate
			* method would only return "Article...". This implementation
			* was taken directly from the Stack Overflow thread referenced
			* below. It was then modified to return a string rather than
			* print out the output and made to use the relevant JString
			* methods. Now, modified to work with utf-8 chars.
			*
			* @link http://stackoverflow.com/questions/1193500/php-truncate-html-ignoring-tags
			* @param mixed $html
			* @param mixed $maxLength
			*/
			public static function truncate($html, $maxLength = 0, $suffixChar='&hellip;')
			{
				$printedLength = 0;
				$position = 0;
				$tags = array();
				$suffix = '';
				$output = '';

				if((mb_strlen($html)) > ($maxLength+1)){
					$suffix = $suffixChar;
				}

				if (empty($html)) {
					return $output;
				}

				while ($printedLength < $maxLength && modMicroBlogHelper::mb_preg_match('{</?([a-z]+)[^>]*>|&#?[a-zA-Z0-9]+;}', $html, $match, PREG_OFFSET_CAPTURE, $position))
				{
					list($tag, $tagPosition) = $match[0];

					// Print text leading up to the tag.
					$str = mb_substr($html, $position, $tagPosition - $position);
					if ($printedLength + mb_strlen($str) > $maxLength) {
						$output .= mb_substr($str, 0, $maxLength - $printedLength);
						$printedLength = $maxLength;
						break;
					}

					$output .= $str;
					$lastCharacterIsOpenBracket = (mb_substr($output, -1, 1) === '<');

					if ($lastCharacterIsOpenBracket) {
						$output = mb_substr($output, 0, mb_strlen($output) - 1);
					}

					$printedLength += mb_strlen($str);

					if ($tag[0] == '&') {
						// Handle the entity.
						$output .= $tag;
						$printedLength++;
					}
					else {
						// Handle the tag.
						$tagName = $match[1][0];

						if ($tag[1] == '/') {
							// This is a closing tag.
							$openingTag = array_pop($tags);

							$output .= $tag;
						}
						else if ($tag[mb_strlen($tag) - 2] == '/') {
							// Self-closing tag.
							$output .= $tag;
						}
						else {
							// Opening tag.
							$output .= $tag;
							$tags[] = $tagName;
						}
					}

					// Continue after the tag.
					if ($lastCharacterIsOpenBracket) {
						$position = ($tagPosition - 1) + mb_strlen($tag);
					}
					else {
						$position = $tagPosition + mb_strlen($tag);
					}

				}

				// Print any remaining text.
				if ($printedLength < $maxLength && $position < mb_strlen($html)) {
					$output .= mb_substr($html, $position, $maxLength - $printedLength);
				}

				$output .= $suffix;
				// Close any open tags.
				while (!empty($tags))
				{
					$output .= sprintf('</%s>', array_pop($tags));
				}

				$length = mb_strlen($output);
				$lastChar = mb_substr($output, ($length - 1), 1);
				$characterNumber = ord($lastChar);

				if ($characterNumber === 194) {
					$output = mb_substr($output, 0, mb_strlen($output) - 1);
				}

				$output = JString::rtrim($output);

				return $output;
			}

			public static function mb_preg_match(
				$ps_pattern,
				$ps_subject,
				&$pa_matches,
				$pn_flags = 0,
				$pn_offset = 0,
				$ps_encoding = NULL
				)
			{
				// WARNING! - All this function does is to correct offsets, nothing else:
				//(code is independent of PREG_PATTER_ORDER / PREG_SET_ORDER)

				if (is_null($ps_encoding)) $ps_encoding = mb_internal_encoding();

				$pn_offset = strlen(mb_substr($ps_subject, 0, $pn_offset, $ps_encoding));
				$ret = preg_match($ps_pattern, $ps_subject, $pa_matches, $pn_flags, $pn_offset);

				if ($ret && ($pn_flags & PREG_OFFSET_CAPTURE))
				{
					foreach($pa_matches as &$ha_match) {
						$ha_match[1] = mb_strlen(substr($ps_subject, 0, $ha_match[1]), $ps_encoding);
				 	}
				}

				return $ret;
			}
		}
	}
	
}	

else {
	
	/***********************************************************************************************************************
	 * 
	 *  Content Override for Joomla 1.5 +
	 * 
	**********************************************************************************************************************/
	
	
	require_once (JPATH_SITE.DS.'components'.DS.'com_content'.DS.'helpers'.DS.'route.php');
	class modMicroBlogHelper
	{
		function getList(&$params)
		{
			global $mainframe;
			$db			=& JFactory::getDBO();
			$user		=& JFactory::getUser();
			$userId		= (int) $user->get('id');
			$articleSource = $params->get('article_source','cat');
			$count		= (int) $params->get('count', 5);
			$catid		= $params->get('catid');
			$artid		= $params->get('artid');
			$show_front	= (int)$params->get('show_front', 1);
			$aid		= $user->get('aid', 0);
			$dateFormat		= $params->get('dateFormat', 'j M, y');
			$translateDate		= $params->get('translateDate', '0');
			$dateString		= $params->get('dateString', 'DATE_FORMAT_LC3');	
			$renderPlugin	= $params->get('renderPlugin','render');
			$contentConfig = &JComponentHelper::getParams( 'com_content' );
			$access		= !$contentConfig->get('show_noauth');
			$linkTarget = $params->get('linkTarget','article');
			$showCategory = $params->get('showCategory',0);
			$catlink = $params->get('catLink',0);
			$stripTags = $params->get('strip_tags',0);
			$introSuffix = $params->get('introSuffix','');
			$wordCount	= $params->get( 'wordCount','');		
			$tags	= $params->get( 'allowed_tags', '<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br />' );
			$nullDate	= $db->getNullDate();
			$date =& JFactory::getDate();
			$now = $date->toMySQL();
			$where		= 'a.state = 1'
				. ' AND ( a.publish_up = '.$db->Quote($nullDate).' OR a.publish_up <= '.$db->Quote($now).' )'
				. ' AND ( a.publish_down = '.$db->Quote($nullDate).' OR a.publish_down >= '.$db->Quote($now).' )'
				;
			// User Filter
			switch ($params->get( 'user_id' ))
			{
				case 'by_me':
					$where .= ' AND (created_by = ' . (int) $userId . ' OR modified_by = ' . (int) $userId . ')';
					break;
				case 'not_me':
					$where .= ' AND (created_by <> ' . (int) $userId . ' AND modified_by <> ' . (int) $userId . ')';
					break;
			}
			// Ordering
			switch ($params->get( 'ordering' ))
			{
				case 'random':
					$ordering = 'rand()';
					break;
				case 'm_dsc':
					$ordering		= 'a.modified DESC, a.created DESC';
					break;
				case 'date':
					$ordering = 'a.created';
					break;
				case 'rdate':
					$ordering = 'a.created DESC';
					break;
				case 'alpha':
					$ordering = 'a.title';
					break;
				case 'ralpha':
					$ordering = 'a.title DESC';
					break;
				case 'hits':
					$ordering = 'a.hits DESC';
					break;
				case 'rhits':
					$ordering = 'a.hits ASC';
					break;
				case 'order':
				default:
					$ordering = 'a.ordering';
					break;
			}
			$frontCondition1 = ($show_front  ? ' INNER JOIN #__content_frontpage AS f ON f.content_id = a.id' : '');
			$frontCondition2 = ($show_front  ? ' AND f.content_id IS NULL ' : '');
			//we get articles in the selected categories
			$catCondition = '';
			if (($catid)&&($articleSource=='cat'))
			{ 
				if( is_array( $catid ) ) {
					if(!($catid[0])) {$catCondition = "";}else{
					$catCondition = ' AND (cc.id IN ( ' . implode( ',', $catid ) . ') )';}
				} else {
					$catCondition = ' AND (cc.id = '.$catid.')';
				}	
			} 			
			//we get the selected articles
			$artCondition = '';
			if ($artid)
			{ 
				if( is_array( $artid ) ) {
					$artCondition = ' AND (a.id IN ( ' . implode( ',', $artid ) . ') )';
				} else {
					$artCondition = ' AND (a.id = '.$artid.')';
				}	
			}
			// Content Items only
			$query = 'SELECT a.*, ' .
				' cc.title as catname,'.
				' CASE WHEN CHAR_LENGTH(a.alias) THEN CONCAT_WS(":", a.id, a.alias) ELSE a.id END as slug,'.
				' CASE WHEN CHAR_LENGTH(cc.alias) THEN CONCAT_WS(":", cc.id, cc.alias) ELSE cc.id END as catslug'.
				' FROM #__content AS a' .
				$frontCondition1.
				' INNER JOIN #__categories AS cc ON cc.id = a.catid' .
				' INNER JOIN #__sections AS s ON s.id = a.sectionid' .
				' WHERE '. $where .' AND s.id > 0' .
				($access ? ' AND a.access <= ' .(int) $aid. ' AND cc.access <= ' .(int) $aid. ' AND s.access <= ' .(int) $aid : '').
				$artCondition.
				$catCondition.
				' AND s.published = 1' .
				' AND cc.published = 1' .
				' ORDER BY '. $ordering;
			$db->setQuery($query, 0, $count);
			$rows = $db->loadObjectList();
			$i		= 0;
			$lists	= array();
			foreach ( $rows as $row )
			{
				if($row->access <= $aid)
				{
					if($linkTarget == 'article' or $linkTarget == 'panel') $lists[$i]->link = JRoute::_(ContentHelperRoute::getArticleRoute($row->slug, $row->catslug, $row->sectionid));
					if($linkTarget == 'default') $lists[$i]->link = JRoute::_(ContentHelperRoute::getCategoryRoute($row->catslug,$row->sectionid).'&layout=default');
					if($linkTarget == 'blog') $lists[$i]->link = JRoute::_(ContentHelperRoute::getCategoryRoute($row->catslug,$row->sectionid).'&layout=blog');
					$lists[$i]->catlink = JRoute::_(ContentHelperRoute::getCategoryRoute($row->catslug,$row->sectionid).'&layout=blog');
				} else {
					$lists[$i]->link = JRoute::_('index.php?option=com_user&view=login');
				}

				$imghtml= $row->introtext;
				$imghtml .= "alt='...' title='...' />";
				$pattern = '/<img[^>]+src[\\s=\'"]';
				$pattern .= '+([^"\'>\\s]+)/is';
				if(preg_match(
				$pattern,
				$imghtml,
				$match))
				$lists[$i]->image = "$match[1]";
				else $lists[$i]->image = "";
				$row->introtext = $stripTags ? self::_cleanIntrotext($row->introtext,$tags) : $row->introtext;
				$row->introtext = $wordCount ? self::string_limit_words($row->introtext, $wordCount, $introSuffix) : $row->introtext;
				$lists[$i]->metakey = $row->metakey;
				$lists[$i]->title = $row->title;
				$lists[$i]->introtext = $row->introtext;
				$lists[$i]->fulltext = $row->fulltext;

				if (!$translateDate) {
					$lists[$i]->date = date($dateFormat,  (strtotime($row->created)));
				}
				else {
					$lists[$i]->date = JHTML::_('date', $row->created, JText::_(''.$dateString.''));
				}

				$lists[$i]->id = $row->id;
				if($showCategory)$lists[$i]->catname = $row->catname;
				$i++;
			}
			return $lists;
		}

		public static function _cleanIntrotext($introtext,$tags)
		{
			//$introtext = str_replace('<p>', ' ', $introtext);
			//$introtext = str_replace('</p>', ' ', $introtext);
			$introtext = strip_tags($introtext, $tags);

			$introtext = trim($introtext);

			return $introtext;
		}

		public static function string_limit_words($introText, $wordCount, $suffixChar='&hellip;') 
		{
		    $introText = trim($introText); 
			$id = explode(' ', $introText);
			 $suffix = count($id) <= $wordCount ? '' : $suffixChar;
		     return implode(' ', array_slice($id, 0, $wordCount)) . $suffix;
		 }

		/**
		* This is a better truncate implementation than what we
		* currently have available in the library. In particular,
		* on index.php/Banners/Banners/site-map.html JHtml's truncate
		* method would only return "Article...". This implementation
		* was taken directly from the Stack Overflow thread referenced
		* below. It was then modified to return a string rather than
		* print out the output and made to use the relevant JString
		* methods. Now, modified to work with utf-8 chars.
		*
		* @link http://stackoverflow.com/questions/1193500/php-truncate-html-ignoring-tags
		* @param mixed $html
		* @param mixed $maxLength
		*/
		public static function truncate($html, $maxLength = 0, $suffixChar='&hellip;')
		{
			$printedLength = 0;
			$position = 0;
			$tags = array();
			$suffix = '';
			$output = '';

			if((mb_strlen($html)) > ($maxLength+1)){
				$suffix = $suffixChar;
			}

			if (empty($html)) {
				return $output;
			}

			while ($printedLength < $maxLength && modMicroBlogHelper::mb_preg_match('{</?([a-z]+)[^>]*>|&#?[a-zA-Z0-9]+;}', $html, $match, PREG_OFFSET_CAPTURE, $position))
			{
				list($tag, $tagPosition) = $match[0];

				// Print text leading up to the tag.
				$str = mb_substr($html, $position, $tagPosition - $position);
				if ($printedLength + mb_strlen($str) > $maxLength) {
					$output .= mb_substr($str, 0, $maxLength - $printedLength);
					$printedLength = $maxLength;
					break;
				}

				$output .= $str;
				$lastCharacterIsOpenBracket = (mb_substr($output, -1, 1) === '<');

				if ($lastCharacterIsOpenBracket) {
					$output = mb_substr($output, 0, mb_strlen($output) - 1);
				}

				$printedLength += mb_strlen($str);

				if ($tag[0] == '&') {
					// Handle the entity.
					$output .= $tag;
					$printedLength++;
				}
				else {
					// Handle the tag.
					$tagName = $match[1][0];

					if ($tag[1] == '/') {
						// This is a closing tag.
						$openingTag = array_pop($tags);

						$output .= $tag;
					}
					else if ($tag[mb_strlen($tag) - 2] == '/') {
						// Self-closing tag.
						$output .= $tag;
					}
					else {
						// Opening tag.
						$output .= $tag;
						$tags[] = $tagName;
					}
				}

				// Continue after the tag.
				if ($lastCharacterIsOpenBracket) {
					$position = ($tagPosition - 1) + mb_strlen($tag);
				}
				else {
					$position = $tagPosition + mb_strlen($tag);
				}

			}

			// Print any remaining text.
			if ($printedLength < $maxLength && $position < mb_strlen($html)) {
				$output .= mb_substr($html, $position, $maxLength - $printedLength);
			}

			$output .= $suffix;
			// Close any open tags.
			while (!empty($tags))
			{
				$output .= sprintf('</%s>', array_pop($tags));
			}

			$length = mb_strlen($output);
			$lastChar = mb_substr($output, ($length - 1), 1);
			$characterNumber = ord($lastChar);

			if ($characterNumber === 194) {
				$output = mb_substr($output, 0, mb_strlen($output) - 1);
			}

			$output = JString::rtrim($output);

			return $output;
		}

		public static function mb_preg_match(
			$ps_pattern,
			$ps_subject,
			&$pa_matches,
			$pn_flags = 0,
			$pn_offset = 0,
			$ps_encoding = NULL
			)
		{
			// WARNING! - All this function does is to correct offsets, nothing else:
			//(code is independent of PREG_PATTER_ORDER / PREG_SET_ORDER)

			if (is_null($ps_encoding)) $ps_encoding = mb_internal_encoding();

			$pn_offset = strlen(mb_substr($ps_subject, 0, $pn_offset, $ps_encoding));
			$ret = preg_match($ps_pattern, $ps_subject, $pa_matches, $pn_flags, $pn_offset);

			if ($ret && ($pn_flags & PREG_OFFSET_CAPTURE))
			{
				foreach($pa_matches as &$ha_match) {
					$ha_match[1] = mb_strlen(substr($ps_subject, 0, $ha_match[1]), $ps_encoding);
			 	}
			}

			return $ret;
		}
	}	
}
	
	/***********************************************************************************************************************
	 * 
	 *  Content Override for Joomla 1.7 +
	 *  Class modified from K2 Content Module helper
	 * 
	**********************************************************************************************************************/
		$k2file = JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'comments.php';
	 	
		if (file_exists($k2file)){ 
	
			//Class modified from K2 Content Module helper
			// This is the helper for v2.4. We can remove this once all template files have been updated to 2.5 
			class modMicroblogK2Helper {
			  function getList(&$params) {
			  	global $mainframe;
			    jimport('joomla.filesystem.file');
			    $limit = (int) $params->get('count', 5);
			    $cid = $params->get('k2catid', NULL);
			    $ordering = $params->get('orderingK2');
			    $limitstart = JRequest::getInt('limitstart');
			    $user = &JFactory::getUser();
			    $aid = $user->get('aid');
			    $db = &JFactory::getDBO();
			    $linkTarget = $params->get('linkTarget','article');
				$dateFormat	= $params->get('dateFormat', 'j M, y');	
				$translateDate		= $params->get('translateDate', '0');
				$dateString		= $params->get('dateString', 'DATE_FORMAT_LC3');	
				$stripTags = $params->get('strip_tags',0);
				$introSuffix = $params->get('introSuffix','');
				$wordCount	= $params->get( 'wordCount','');
				$tags	= $params->get( 'allowed_tags', '<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br />' );
			    $jnow = &JFactory::getDate();
			    $now = $jnow->toMySQL();
			    $nullDate = $db->getNullDate();
				$itemid = $params->get('itemid','');
				$userAuthorisedLevels = implode(',', $user->authorisedLevels());
				
			    $query = "SELECT i.*, c.name AS categoryname,c.id AS categoryid, c.alias AS categoryalias, c.params AS categoryparams";
			    if ($ordering == 'best')
			      $query .= ", (r.rating_sum/r.rating_count) AS rating";
			    $query .= " FROM #__k2_items as i LEFT JOIN #__k2_categories c ON c.id = i.catid";
			    if ($ordering == 'best')
			      $query .= " LEFT JOIN #__k2_rating r ON r.itemID = i.id";
			    $query .= " WHERE i.published = 1 ";
				
				if(K2_JVERSION=='16') {
					$query .= " AND i.access IN(".$userAuthorisedLevels.")"
					." AND i.trash = 0"
					." AND c.published = 1"
					." AND c.access IN(".$userAuthorisedLevels.")"
					." AND c.trash = 0";
				}
				else
				{
					$query .= " AND i.access <= {$aid}"
					." AND i.trash = 0"
					." AND c.published = 1"
					." AND c.access <= {$aid}"
					." AND c.trash = 0";
				}
				
			    $query .= " AND ( i.publish_up = ".$db->Quote($nullDate)." OR i.publish_up <= ".$db->Quote($now)." )";
			    $query .= " AND ( i.publish_down = ".$db->Quote($nullDate)." OR i.publish_down >= ".$db->Quote($now)." )";
				if($params->get('source') != 'specific'){
					if (!is_null($cid)) {
				        if (!is_null($cid)) {
							if (is_array($cid)) {
								if ($params->get('getChildren')) {
									require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'itemlist.php');
									$categories = K2ModelItemlist::getCategoryTree($cid);
									$sql = @implode(',', $categories);
									$query .= " AND i.catid IN ({$sql})";

								} else {
									JArrayHelper::toInteger($cid);
									$query .= " AND i.catid IN(".implode(',', $cid).")";
								}

							} else {
								if ($params->get('getChildren')) {
									require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'itemlist.php');
									$categories = K2ModelItemlist::getCategoryTree($cid);
									$sql = @implode(',', $categories);
									$query .= " AND i.catid IN ({$sql})";
								} else {
									$query .= " AND i.catid=".(int)$cid;
								}

							}
						}
				     }
				}
			    if($params->get('source') == 'specific'){
					if(!is_array($itemid)) {$itemid		= preg_split("/[\s,]+/", $itemid);}
					JArrayHelper::toInteger( $itemid );
					$query .= ' AND (i.id=' . implode( ' OR i.id=', $itemid ) . ')';
				}
				if($params->get('itemFilter') == 'catitem'){
					$itemid		= preg_split("/[\s,]+/", $itemid);
					JArrayHelper::toInteger( $itemid );
					$query .= ' OR (i.id=' . implode( ' OR i.id=', $itemid ) . ')';
				}
			    if ($params->get('itemFilter') == 'feat')
			      $query .= " AND i.featured = 1";
			    switch ($ordering) {
			      case 'date':
			        $orderby = 'i.created ASC';
			        break;
			      case 'rdate':
			        $orderby = 'i.created DESC';
			        break;
			      case 'alpha':
			        $orderby = 'i.title';
			        break;
			      case 'ralpha':
			        $orderby = 'i.title DESC';
			        break;
			      case 'order':
			        if ($params->get('itemFilter') == 'feat')
			          $orderby = 'i.featured_ordering';
			        else
			          $orderby = 'i.ordering';
			        break;
			      case 'hits':
			        $orderby = 'i.hits DESC';
			        break;
			      case 'rand':
			        $orderby = 'RAND()';
			        break;
			      case 'best':
			        $orderby = 'rating DESC';
			        break;
			      default:
			        $orderby = 'i.id DESC';
			        break;
			    }
			    $query .= " ORDER BY ".$orderby;
			    $db->setQuery($query, 0, $limit);
			    $items = $db->loadObjectList();
				require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'item.php');
				$model = new K2ModelItem;
				require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php');
			    if (count($items)) {
			      	$k2ImageSource = $params->get('displayImages','k2content');
					foreach ($items as $item) {
			        //Images
					$item->image = "";
					if($k2ImageSource == "k2item")
					{
						if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'src'.DS.md5("Image".$item->id).'.jpg'))
				            $item->imageOriginal = 'media/k2/items/src/'.md5("Image".$item->id).'.jpg';
						if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_XS.jpg'))
				            $item->imageXSmall = 'media/k2/items/cache/'.md5("Image".$item->id).'_XS.jpg';
			          if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_S.jpg'))
			            $item->imageSmall = 'media/k2/items/cache/'.md5("Image".$item->id).'_S.jpg';
			          if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_M.jpg'))
			            $item->imageMedium = 'media/k2/items/cache/'.md5("Image".$item->id).'_M.jpg';
			          if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_L.jpg'))
			            $item->imageLarge = 'media/k2/items/cache/'.md5("Image".$item->id).'_L.jpg';
			          if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_XL.jpg'))
			            $item->imageXLarge = 'media/k2/items/cache/'.md5("Image".$item->id).'_XL.jpg';
			          if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_Generic.jpg'))
			            $item->imageGeneric = 'media/k2/items/cache/'.md5("Image".$item->id).'_Generic.jpg';
			        $image = 'image'.$params->get('itemImageSize');
			            $item->image = $item->$image;
					}
					elseif($k2ImageSource == "k2content")
					{
						$imghtml= $item->introtext;
						$imghtml .= "alt='...' title='...' />";
						$pattern = '/<img[^>]+src[\\s=\'"]';
						$pattern .= '+([^"\'>\\s]+)/is';
						if(preg_match(
						$pattern,
						$imghtml,
						$match))
						$item->image = "$match[1]";
						else $item->image = "";
					}
			        $item->numOfComments = $model->countItemComments($item->id);
			        //Read more link
			        if($linkTarget == 'article'){$item->link = urldecode(JRoute::_(K2HelperRoute::getItemRoute($item->id.':'.urlencode($item->alias), $item->catid.':'.urlencode($item->categoryalias))));
			}else{
			$item->link = urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($item->catid.':'.urlencode($item->categoryalias))));
			}
			       // Item text
					$item->text = $item->title;
					$item->fulltext = $item->fulltext;
					$item->introtext = $stripTags ? self::_cleanIntrotext($item->introtext,$tags) : $item->introtext;
					$item->introtext = $wordCount ? self::string_limit_words($item->introtext, $wordCount, $introSuffix) : $item->introtext;
					
					if ($renderPlugin == 'strip') {
						$item->introtext = preg_replace('/{([a-zA-Z0-9\-_]*)\s*(.*?)}/i','', $item->introtext);
					}else{
						$item->introtext = JHtml::_('content.prepare', $item->introtext);
					}
					
					$item->video = $item->video;
					$item->metakey = $item->metakey;
					$item->catname = $item->categoryname;
					// Date Variables
					if (!$translateDate) {
					$item->date = date($dateFormat, (strtotime($item->created))); 
					}
					else {
						$item->date = JHTML::Date($item->date, JText::_(''.$dateString.'')); 	
					}
					$item->catlink = urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($item->catid.':'.urlencode($item->categoryalias))));
			        $rows[] = $item;
			      }
			      return $rows;
			    }
			  }
				public static function _cleanIntrotext($introtext,$tags)
				{
					//$introtext = str_replace('<p>', ' ', $introtext);
					//$introtext = str_replace('</p>', ' ', $introtext);
					$introtext = strip_tags($introtext, $tags);

					$introtext = trim($introtext);

					return $introtext;
				}

				public static function string_limit_words($introText, $wordCount, $suffixChar='&hellip;') 
				{
				     $introText = trim($introText); 
					 $id = explode(' ', $introText);
					 $suffix = count($id) <= $wordCount ? '' : $suffixChar;
				     return implode(' ', array_slice($id, 0, $wordCount)) . $suffix;
				 }

				/**
				* This is a better truncate implementation than what we
				* currently have available in the library. In particular,
				* on index.php/Banners/Banners/site-map.html JHtml's truncate
				* method would only return "Article...". This implementation
				* was taken directly from the Stack Overflow thread referenced
				* below. It was then modified to return a string rather than
				* print out the output and made to use the relevant JString
				* methods. Now, modified to work with utf-8 chars.
				*
				* @link http://stackoverflow.com/questions/1193500/php-truncate-html-ignoring-tags
				* @param mixed $html
				* @param mixed $maxLength
				*/
				public static function truncate($html, $maxLength = 0, $suffixChar='&hellip;')
				{
					$printedLength = 0;
					$position = 0;
					$tags = array();
					$suffix = '';
					$output = '';

					if((mb_strlen($html)) > ($maxLength+1)){
						$suffix = $suffixChar;
					}

					if (empty($html)) {
						return $output;
					}

					while ($printedLength < $maxLength && modMicroblogK2Helper::mb_preg_match('{</?([a-z]+)[^>]*>|&#?[a-zA-Z0-9]+;}', $html, $match, PREG_OFFSET_CAPTURE, $position))
					{
						list($tag, $tagPosition) = $match[0];

						// Print text leading up to the tag.
						$str = mb_substr($html, $position, $tagPosition - $position);
						if ($printedLength + mb_strlen($str) > $maxLength) {
							$output .= mb_substr($str, 0, $maxLength - $printedLength);
							$printedLength = $maxLength;
							break;
						}

						$output .= $str;
						$lastCharacterIsOpenBracket = (mb_substr($output, -1, 1) === '<');

						if ($lastCharacterIsOpenBracket) {
							$output = mb_substr($output, 0, mb_strlen($output) - 1);
						}

						$printedLength += mb_strlen($str);

						if ($tag[0] == '&') {
							// Handle the entity.
							$output .= $tag;
							$printedLength++;
						}
						else {
							// Handle the tag.
							$tagName = $match[1][0];

							if ($tag[1] == '/') {
								// This is a closing tag.
								$openingTag = array_pop($tags);

								$output .= $tag;
							}
							else if ($tag[mb_strlen($tag) - 2] == '/') {
								// Self-closing tag.
								$output .= $tag;
							}
							else {
								// Opening tag.
								$output .= $tag;
								$tags[] = $tagName;
							}
						}

						// Continue after the tag.
						if ($lastCharacterIsOpenBracket) {
							$position = ($tagPosition - 1) + mb_strlen($tag);
						}
						else {
							$position = $tagPosition + mb_strlen($tag);
						}

					}

					// Print any remaining text.
					if ($printedLength < $maxLength && $position < mb_strlen($html)) {
						$output .= mb_substr($html, $position, $maxLength - $printedLength);
					}

					$output .= $suffix;
					// Close any open tags.
					while (!empty($tags))
					{
						$output .= sprintf('</%s>', array_pop($tags));
					}

					$length = mb_strlen($output);
					$lastChar = mb_substr($output, ($length - 1), 1);
					$characterNumber = ord($lastChar);

					if ($characterNumber === 194) {
						$output = mb_substr($output, 0, mb_strlen($output) - 1);
					}

					$output = JString::rtrim($output);

					return $output;
				}

				public static function mb_preg_match(
					$ps_pattern,
					$ps_subject,
					&$pa_matches,
					$pn_flags = 0,
					$pn_offset = 0,
					$ps_encoding = NULL
					)
				{
					// WARNING! - All this function does is to correct offsets, nothing else:
					//(code is independent of PREG_PATTER_ORDER / PREG_SET_ORDER)

					if (is_null($ps_encoding)) $ps_encoding = mb_internal_encoding();

					$pn_offset = strlen(mb_substr($ps_subject, 0, $pn_offset, $ps_encoding));
					$ret = preg_match($ps_pattern, $ps_subject, $pa_matches, $pn_flags, $pn_offset);

					if ($ret && ($pn_flags & PREG_OFFSET_CAPTURE))
					{
						foreach($pa_matches as &$ha_match) {
							$ha_match[1] = mb_strlen(substr($ps_subject, 0, $ha_match[1]), $ps_encoding);
					 	}
					}

					return $ret;
				}
			}
		
		}
		else {
	
		// Helper file for k2 2.5
		$k2file = JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php';
		
		if (file_exists($k2file)){ 
		
		require_once(JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php');
		require_once(JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'utilities.php');

			class modMicroblogK2Helper {
	
				function getList($params, $id,$format = 'html')
				{

					jimport('joomla.filesystem.file');
					$mainframe = &JFactory::getApplication();
					$limit = $params->get('count', 5);
					$cid = $params->get('k2catid', NULL);
					$itemid = $params->get('k2items','');
					$ordering = $params->get('k2Ordering','');
					$componentParams = &JComponentHelper::getParams('com_k2');
					$limitstart = JRequest::getInt('limitstart');
					$link = $params->get('link');
					$user = &JFactory::getUser();
					$aid = $user->get('aid');
					$db = &JFactory::getDBO();
					$userAuthorisedLevels = implode(',', $user->authorisedLevels());
					
					$jnow = &JFactory::getDate();
					$now = $jnow->toMySQL();
					$nullDate = $db->getNullDate();

					$dateFormat	= $params->get('dateFormat', 'j M, y');	

					// Image Size and container, remove px if user entered
					$resizeImage = $params->get('resizeImage',1);
					$option = $params->get( 'option', 'crop');
					$img_width = str_replace('px', '', $params->get( 'image_width','170'));
					$img_height = str_replace('px', '', $params->get( 'image_height','85'));
				
					$count		= (int) $params->get('count', 5);
					$show_front	= $params->get('show_front', 1);
					$dateFormat		= $params->get('dateFormat', 'j M, y');
					$translateDate		= $params->get('translateDate', '0');
					$dateString		= $params->get('dateString', 'DATE_FORMAT_LC3');
					$renderPlugin	= $params->get('renderPlugin','render');
					$tags	= $params->get( 'allowed_tags', '<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br />' );
					$wordCount	= $params->get( 'wordCount',0);		
					$introSuffix = $params->get('introSuffix','');
					$stripTags = $params->get('strip_tags',0);
					$linkTarget = $params->get('linkTarget','article');
					$showCategory = $params->get('showCategory',0);
					

					if($params->get('source')=='specific'){

						$value = $params->get('k2items');
						$current = array();
						if(is_string($value) && !empty($value))
						$current[]=$value;
						if(is_array($value))
						$current=$value;

						$items = array();

						foreach($current as $id){

							$query = "SELECT i.*, c.name AS categoryname,c.id AS categoryid, c.alias AS categoryalias, c.params AS categoryparams 
							FROM #__k2_items as i 
							LEFT JOIN #__k2_categories c ON c.id = i.catid 
							WHERE i.published = 1 ";
							if(K2_JVERSION=='16'){
								$query .= " AND i.access IN(".$userAuthorisedLevels.") ";
							}
							else {
								$query .=" AND i.access<={$aid} ";
							}				
							$query .= " AND i.trash = 0 AND c.published = 1 ";
							if(K2_JVERSION=='16'){
								$query .= " AND c.access IN(".$userAuthorisedLevels.") ";
							}
							else {
								$query .=" AND c.access<={$aid} ";
							}				
							$query .= " AND c.trash = 0 
							AND ( i.publish_up = ".$db->Quote($nullDate)." OR i.publish_up <= ".$db->Quote($now)." ) 
							AND ( i.publish_down = ".$db->Quote($nullDate)." OR i.publish_down >= ".$db->Quote($now)." ) 
							AND i.id={$id}";
							if(K2_JVERSION=='16'){
								if($mainframe->getLanguageFilter()) {
									$languageTag = JFactory::getLanguage()->getTag();
									$query .= " AND c.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').") AND i.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').")";
								}
							}
							$db->setQuery($query);
							$item = $db->loadObject();
							if($item)
							$items[]=$item;

						}
					}

					else {
					
						$query = "SELECT i.*, c.name AS categoryname,c.id AS categoryid, c.alias AS categoryalias, c.params AS categoryparams";
						
						if ($ordering == 'best')
						$query .= ", (r.rating_sum/r.rating_count) AS rating";

						if ($ordering == 'comments')
						$query .= ", COUNT(comments.id) AS numOfComments";

						$query .= " FROM #__k2_items as i LEFT JOIN #__k2_categories c ON c.id = i.catid";

						if ($ordering == 'best')
						$query .= " LEFT JOIN #__k2_rating r ON r.itemID = i.id";

						if ($ordering == 'comments')
						$query .= " LEFT JOIN #__k2_comments comments ON comments.itemID = i.id";

						if(K2_JVERSION=='16'){
							$query .= " WHERE i.published = 1 AND i.access IN(".$userAuthorisedLevels.") AND i.trash = 0 AND c.published = 1 AND c.access IN(".$userAuthorisedLevels.")  AND c.trash = 0";
						}
						else {
							$query .= " WHERE i.published = 1 AND i.access <= {$aid} AND i.trash = 0 AND c.published = 1 AND c.access <= {$aid} AND c.trash = 0";
						}

						$query .= " AND ( i.publish_up = ".$db->Quote($nullDate)." OR i.publish_up <= ".$db->Quote($now)." )";
						$query .= " AND ( i.publish_down = ".$db->Quote($nullDate)." OR i.publish_down >= ".$db->Quote($now)." )";


					
							if (!is_null($cid)) {
								if (is_array($cid)) {
									if ($params->get('getChildren')) {
										require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'itemlist.php');
										$categories = K2ModelItemlist::getCategoryTree($cid);
										$sql = @implode(',', $categories);
										$query .= " AND i.catid IN ({$sql})";

									} else {
										JArrayHelper::toInteger($cid);
										$query .= " AND i.catid IN(".implode(',', $cid).")";
									}

								} else {
									if ($params->get('getChildren')) {
										require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'itemlist.php');
										$categories = K2ModelItemlist::getCategoryTree($cid);
										$sql = @implode(',', $categories);
										$query .= " AND i.catid IN ({$sql})";
									} else {
										$query .= " AND i.catid=".(int)$cid;
									}

								}
							}
				

						if ($params->get('FeaturedItems') == '0')
						$query .= " AND i.featured != 1";

						if ($params->get('FeaturedItems') == '2')
						$query .= " AND i.featured = 1";

						if ($params->get('videosOnly'))
						$query .= " AND (i.video IS NOT NULL AND i.video!='')";

						if ($ordering == 'comments')
						$query .= " AND comments.published = 1";

						if(K2_JVERSION=='16'){
							if($mainframe->getLanguageFilter()) {
								$languageTag = JFactory::getLanguage()->getTag();
								$query .= " AND c.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').") AND i.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').")";
							}
						}

						switch ($ordering) {

							case 'date':
								$orderby = 'i.created ASC';
								break;

							case 'rdate':
								$orderby = 'i.created DESC';
								break;

							case 'alpha':
								$orderby = 'i.title';
								break;

							case 'ralpha':
								$orderby = 'i.title DESC';
								break;

							case 'order':
								if ($params->get('FeaturedItems') == '2')
								$orderby = 'i.featured_ordering';
								else
								$orderby = 'i.ordering';
								break;

							case 'rorder':
								if ($params->get('FeaturedItems') == '2')
								$orderby = 'i.featured_ordering DESC';
								else
								$orderby = 'i.ordering DESC';
								break;

							case 'hits':
								if ($params->get('popularityRange')){
									$datenow = &JFactory::getDate();
									$date = $datenow->toMySQL();
									$query.=" AND i.created > DATE_SUB('{$date}',INTERVAL ".$params->get('popularityRange')." DAY) ";
								}
								$orderby = 'i.hits DESC';
								break;

							case 'rand':
								$orderby = 'RAND()';
								break;

							case 'best':
								$orderby = 'rating DESC';
								break;

							case 'comments':
								if ($params->get('popularityRange')){
									$datenow = &JFactory::getDate();
									$date = $datenow->toMySQL();
									$query.=" AND i.created > DATE_SUB('{$date}',INTERVAL ".$params->get('popularityRange')." DAY) ";
								}
								$query.=" GROUP BY i.id ";
								$orderby = 'numOfComments DESC';
								break;

							case 'modified':
								$orderby = 'i.modified DESC';
								break;

							default:
								$orderby = 'i.id DESC';
								break;
						}


						$query .= " ORDER BY ".$orderby;
						$db->setQuery($query, 0, $limit);
						$items = $db->loadObjectList();
					}

					require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'item.php');
					$model = new K2ModelItem;

					if (count($items)) {

						foreach ($items as $item) {

								$item->imageMedium = false;
								$item->imageXSmall = false;
								$item->imageSmall = false;
								$item->imageLarge = false;
								$item->imageXLarge = false;
								$item->imageGeneric = false;
								$item->closelink = false;
							

							//Clean title
							$item->title = JFilterOutput::ampReplace($item->title);

							//Images


							    $date =& JFactory::getDate($item->modified);
					            $timestamp = '?t='.$date->toUnix();
								$item->imageSmall ="";
							
							
								if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_XS.jpg')){
								    $item->imageXSmall = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_XS.jpg';
								    if($componentParams->get('imageTimestamp')){
								        $item->imageXSmall.=$timestamp;
								    }
								}

								if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_S.jpg')){
								    $item->imageSmall = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_S.jpg';
									if($componentParams->get('imageTimestamp')){
								        $item->imageSmall.=$timestamp;
								    }
								}

								if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_M.jpg')){
								    $item->imageMedium = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_M.jpg';
									if($componentParams->get('imageTimestamp')){
								        $item->imageMedium.=$timestamp;
								    }					    
								}

								if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_L.jpg')){
								    $item->imageLarge = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_L.jpg';
									if($componentParams->get('imageTimestamp')){
								        $item->imageLarge.=$timestamp;
								    }	
								}

								if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_XL.jpg')){
								    $item->imageXLarge = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_XL.jpg';
									if($componentParams->get('imageTimestamp')){
								        $item->imageXLarge.=$timestamp;
								    }	
								}

								if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_Generic.jpg')){
								    $item->imageGeneric = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_Generic.jpg';
									if($componentParams->get('imageTimestamp')){
								        $item->imageGeneric.=$timestamp;
								    }	
								}



								$image = 'image'.$params->get('itemImgSize','Small');

								if (isset($item->$image)) 
									$item->image = $item->$image;

								$i		= 0;
								// If the k2 item image isnt set lets grab the image from the introtext	
								if(($params->get('itemImgSize') == "introtext") or (empty($item->$image))) {

									$i		= 0;
									$lists	= array();
									$imghtml= $item->introtext;
									$imghtml .= "alt='...' title='...' />";
									$pattern = '/<img[^>]+src[\\s=\'"]';
									$pattern .= '+([^"\'>\\s]+)/is';
										if(preg_match(
										$pattern,
										$imghtml,
										$match))						
										$item->image = "$match[1]";	

									// Resize Image
									if ($resizeImage) {
										if($item->image !=="") {
											$item->image =  resizeImageHelper::getResizedImage($item->image, $img_width, $img_height, $option);
										}								
									}
									else {
										$item->image = $item->image;
									}
								}
							
						
							//Read more link
							if($linkTarget == "lightbox") {
								$item->link = '<a rel="group1" class="inline" href="#data'.$item->id.'">';
								$lists[$i]->closelink = '</a>';
							}
							else {
								$item->link = urldecode(JRoute::_(K2HelperRoute::getItemRoute($item->id.':'.urlencode($item->alias), $item->catid.':'.urlencode($item->categoryalias))));
								$lists[$i]->closelink = '</a>';
							}

							// Introtext
							$item->introtext = $stripTags ? self::_cleanIntrotext($item->introtext,$tags) : $item->introtext;
							$item->introtext = $wordCount ? self::truncate($item->introtext, $wordCount, $introSuffix) : $item->introtext;							
							
							if ($renderPlugin == 'strip') {
									$item->introtext = preg_replace('/{([a-zA-Z0-9\-_]*)\s*(.*?)}/i','', $item->introtext);
							}else{
								$item->introtext = JHtml::_('content.prepare', $item->introtext);
							}
								

							$item->catname = $item->categoryname;				
							$item->catlink = '<a href="'.urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($item->catid.':'.urlencode($item->categoryalias)))).'';

							$item->date = date($dateFormat, (strtotime($item->created))); 
							$item->fulltext = $item->fulltext;
							$rows[] = $item;
						}

						return $rows;

					}

				}
				public static function _cleanIntrotext($introtext,$tags)
				{
					//$introtext = str_replace('<p>', ' ', $introtext);
					//$introtext = str_replace('</p>', ' ', $introtext);
					$introtext = strip_tags($introtext, $tags);

					$introtext = trim($introtext);

					return $introtext;
				}

				/**
				* This is a better truncate implementation than what we
				* currently have available in the library. In particular,
				* on index.php/Banners/Banners/site-map.html JHtml's truncate
				* method would only return "Article...". This implementation
				* was taken directly from the Stack Overflow thread referenced
				* below. It was then modified to return a string rather than
				* print out the output and made to use the relevant JString
				* methods. Now, modified to work with utf-8 chars.
				*
				* @link http://stackoverflow.com/questions/1193500/php-truncate-html-ignoring-tags
				* @param mixed $html
				* @param mixed $maxLength
				*/
				public static function truncate($html, $maxLength = 0, $suffixChar='&hellip;')
				{
					$printedLength = 0;
					$position = 0;
					$tags = array();
					$suffix = '';
					$output = '';

					if((mb_strlen($html)) > ($maxLength+1)){
						$suffix = $suffixChar;
					}

					if (empty($html)) {
						return $output;
					}

					while ($printedLength < $maxLength && modMicroblogK2Helper::mb_preg_match('{</?([a-z]+)[^>]*>|&#?[a-zA-Z0-9]+;}', $html, $match, PREG_OFFSET_CAPTURE, $position))
					{
						list($tag, $tagPosition) = $match[0];

						// Print text leading up to the tag.
						$str = mb_substr($html, $position, $tagPosition - $position);
						if ($printedLength + mb_strlen($str) > $maxLength) {
							$output .= mb_substr($str, 0, $maxLength - $printedLength);
							$printedLength = $maxLength;
							break;
						}

						$output .= $str;
						$lastCharacterIsOpenBracket = (mb_substr($output, -1, 1) === '<');

						if ($lastCharacterIsOpenBracket) {
							$output = mb_substr($output, 0, mb_strlen($output) - 1);
						}

						$printedLength += mb_strlen($str);

						if ($tag[0] == '&') {
							// Handle the entity.
							$output .= $tag;
							$printedLength++;
						}
						else {
							// Handle the tag.
							$tagName = $match[1][0];

							if ($tag[1] == '/') {
								// This is a closing tag.
								$openingTag = array_pop($tags);

								$output .= $tag;
							}
							else if ($tag[mb_strlen($tag) - 2] == '/') {
								// Self-closing tag.
								$output .= $tag;
							}
							else {
								// Opening tag.
								$output .= $tag;
								$tags[] = $tagName;
							}
						}

						// Continue after the tag.
						if ($lastCharacterIsOpenBracket) {
							$position = ($tagPosition - 1) + mb_strlen($tag);
						}
						else {
							$position = $tagPosition + mb_strlen($tag);
						}

					}

					// Print any remaining text.
					if ($printedLength < $maxLength && $position < mb_strlen($html)) {
						$output .= mb_substr($html, $position, $maxLength - $printedLength);
					}

					$output .= $suffix;
					// Close any open tags.
					while (!empty($tags))
					{
						$output .= sprintf('</%s>', array_pop($tags));
					}

					$length = mb_strlen($output);
					$lastChar = mb_substr($output, ($length - 1), 1);
					$characterNumber = ord($lastChar);

					if ($characterNumber === 194) {
						$output = mb_substr($output, 0, mb_strlen($output) - 1);
					}

					$output = JString::rtrim($output);

					return $output;
				}

				public static function mb_preg_match(
					$ps_pattern,
					$ps_subject,
					&$pa_matches,
					$pn_flags = 0,
					$pn_offset = 0,
					$ps_encoding = NULL
					)
				{
					// WARNING! - All this function does is to correct offsets, nothing else:
					//(code is independent of PREG_PATTER_ORDER / PREG_SET_ORDER)

					if (is_null($ps_encoding)) $ps_encoding = mb_internal_encoding();

					$pn_offset = strlen(mb_substr($ps_subject, 0, $pn_offset, $ps_encoding));
					$ret = preg_match($ps_pattern, $ps_subject, $pa_matches, $pn_flags, $pn_offset);

					if ($ret && ($pn_flags & PREG_OFFSET_CAPTURE))
					{
						foreach($pa_matches as &$ha_match) {
							$ha_match[1] = mb_strlen(substr($ps_subject, 0, $ha_match[1]), $ps_encoding);
					 	}
					}

					return $ret;
				}

		} 
		}	
}