<?php

/**
* @id $Id$
* @author  Joomla Bamboo
* @package  JB Slideshow3
* @copyright Copyright (C) 2006 - 2010 Joomla Bamboo. http://www.joomlabamboo.com  All rights reserved.
* @license  GNU/GPL license: http://www.gnu.org/copyleft/gpl.html
*/

// no direct access

defined('_JEXEC') or die('Restricted access');

jimport('joomla.application.component.model');

$com_path = JPATH_SITE.DS.'components'.DS.'com_content'.DS;
require_once $com_path.'router.php';
require_once $com_path.'helpers'.DS.'route.php';

jimport('joomla.application.component.model');

JModel::addIncludePath($com_path.DS.'models', 'ContentModel');

abstract class modSlideshow3Helper
{
	public static function getList(&$params)
	{
		// Get an instance of the generic articles model
		$articles = JModel::getInstance('Articles', 'ContentModel', array('ignore_request' => true));

		// Set application parameters in model
		$app = JFactory::getApplication();
		$appParams = $app->getParams();
		$articles->setState('params', $appParams);
		$ordering = $params->get('ordering') == 'random' ? 'a.ordering' : $params->get('ordering', 'a.ordering');
		// Set the filters based on the module params
		$articles->setState('list.start', 0);
		$articles->setState('list.limit', (int) $params->get('count', 5));
		$articles->setState('filter.published', 1);

		// Access filter
		$access = !JComponentHelper::getParams('com_content')->get('show_noauth');
		$authorised = JAccess::getAuthorisedViewLevels(JFactory::getUser()->get('id'));
		$articles->setState('filter.access', $access);
		$artids		= $params->get('artid');
		$catids = $params->get('catid');
		$articles->setState('filter.category_id.include', (bool) $params->get('category_filtering_type', 1));
		
		// Category filter
		if ($catids) {
			if ($params->get('show_child_category_articles', 0) && (int) $params->get('levels', 0) > 0) {
				// Get an instance of the generic categories model
				$categories = JModel::getInstance('Categories', 'ContentModel', array('ignore_request' => true));
				$categories->setState('params', $appParams);
				$levels = $params->get('levels', 1) ? $params->get('levels', 1) : 9999;
				$categories->setState('filter.get_children', $levels);
				$categories->setState('filter.published', 1);
				$categories->setState('filter.access', $access);
				$additional_catids = array();

				foreach($catids as $catid)
				{
					$categories->setState('filter.parentId', $catid);
					$recursive = true;
					$items = $categories->getItems($recursive);

					if ($items)
					{
						foreach($items as $category)
						{
							$condition = (($category->level - $categories->getParent()->level) <= $levels);
							if ($condition) {
								$additional_catids[] = $category->id;
							}

						}
					}
				}

				$catids = array_unique(array_merge($catids, $additional_catids));
			}

			$articles->setState('filter.category_id', $catids);
		}
		if($artids) {
			$articles->setState('filter.article_id', $artids);
			$articles->setState('filter.article_id.include', $params->get('article_filtering_type', 1));
		}
		// Ordering
		$articles->setState('list.ordering', $ordering);
		$articles->setState('list.direction', $params->get('ordering_direction', 'ASC'));

		// New Parameters
		$articles->setState('filter.featured', $params->get('show_front', 'show'));
		$articles->setState('filter.author_id', $params->get('created_by', ""));
		$articles->setState('filter.author_id.include', $params->get('author_filtering_type', 1));
		$articles->setState('filter.author_alias', $params->get('created_by_alias', ""));
		$articles->setState('filter.author_alias.include', $params->get('author_alias_filtering_type', 1));
		$excluded_articles = $params->get('excluded_articles', '');

		$articles->setState('filter.language',$app->getLanguageFilter());

		$items = $articles->getItems();	
		
		
		$stripTags = $params->get(	'striptags','1');
		$tags	= $params->get( 'tags', '<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br />' );
		$count		= (int) $params->get('count', 5);
		$show_front	= $params->get('show_front', 1);
		$dateFormat		= $params->get('dateFormat', 'j M, y');
		$linkTarget = $params->get('linkTarget','article');
		$showCategory = $params->get('showCategory',0);
		$catlink = $params->get('catLink',0);
		$introtext_limit = $params->get('introtext_limit', 500);
		$jbIntroText	= $params->get( 'jbIntroText', 1 );
		$contentConfig = &JComponentHelper::getParams( 'com_content' );
		$createdDate = $params->get( 'createdDate', "1" );
		$renderPlugin	= $params->get('renderPlugin','render');
		$introtext_suffix = $params->get('introtext_suffix','');
		// Find current Article ID if on an article page
		$option = JRequest::getCmd('option');
		$view = JRequest::getCmd('view');

		if ($option === 'com_content' && $view === 'article') {
			$active_article_id = JRequest::getInt('id');
		}
		else {
			$active_article_id = 0;
		}
		if ($params->get('ordering') == 'random') shuffle($items);
		// Prepare data for display using display options
		foreach ($items as &$item)
		{
			$item->slug = $item->id.':'.$item->alias;
			$item->catslug = $item->catid ? $item->catid .':'.$item->category_alias : $item->catid;

			if ($access || in_array($item->access, $authorised)) {
				
				if($linkTarget == 'article') $item->link = JRoute::_(ContentHelperRoute::getArticleRoute($item->slug, $item->catslug));

				if($linkTarget == 'default') $item->link = JRoute::_(ContentHelperRoute::getCategoryRoute($item->catslug).'&layout=default');

				if($linkTarget == 'blog') $item->link = JRoute::_(ContentHelperRoute::getCategoryRoute($item->catslug).'&layout=blog');

				$item->catlink = JRoute::_(ContentHelperRoute::getCategoryRoute($item->catslug).'&layout=blog');
			}
			 else {
				// Angie Fixed Routing
				$app	= JFactory::getApplication();
				$menu	= $app->getMenu();
				$menuitems	= $menu->getItems('link', 'index.php?option=com_users&view=login');
			if(isset($menuitems[0])) {
					$Itemid = $menuitems[0]->id;
				} else if (JRequest::getInt('Itemid') > 0) { //use Itemid from requesting page only if there is no existing menu
					$Itemid = JRequest::getInt('Itemid');
				}

				$item->link = JRoute::_('index.php?option=com_users&view=login&Itemid='.$Itemid);
				}

			// Used for styling the active article
			$item->active = $item->id == $active_article_id ? 'active' : '';
			
			$item->dateCreated = '';
			if ($createdDate) {
				$date = new JDate($item->created);
				$item->dateCreated= $date->format($dateFormat);
			}

			if ($showCategory) $item->catname = $item->category_title;
			if ($renderPlugin == 'strip') {
				$item->introtext = preg_replace('/{([a-zA-Z0-9\-_]*)\s*(.*?)}/i','', $item->introtext);
			}else{
				$item->introtext = JHtml::_('content.prepare', $item->introtext);
			}	
			$item->firstimage = $item->introtext;
			$item->introtext = $stripTags ? self::_cleanIntrotext($item->introtext,$tags) : $item->introtext;
			$item->text = self::truncate($item->introtext, $introtext_limit, $introtext_suffix);
			// added Angie show_unauthorizid
			$item->displayReadmore = $item->alternative_readmore;

		}

		return $items;

	}
	
	public static function _cleanIntrotext($introtext,$tags)
	{
		$introtext = str_replace('<p>', ' ', $introtext);
		$introtext = str_replace('</p>', ' ', $introtext);
		$introtext = strip_tags($introtext, $tags);

		$introtext = trim($introtext);

		return $introtext;
	}
	
	/**
	* This is a better truncate implementation than what we
	* currently have available in the library. In particular,
	* on index.php/Banners/Banners/site-map.html JHtml's truncate
	* method would only return "Article...". This implementation
	* was taken directly from the Stack Overflow thread referenced
	* below. It was then modified to return a string rather than
	* print out the output and made to use the relevant JString
	* methods. Now, modified to work with utf-8 chars.
	*
	* @link http://stackoverflow.com/questions/1193500/php-truncate-html-ignoring-tags
	* @param mixed $html
	* @param mixed $maxLength
	*/
	public static function truncate($html, $maxLength = 0, $suffixChar='&hellip;')
	{
		$printedLength = 0;
		$position = 0;
		$tags = array();
		$suffix = '';
		$output = '';

		if((mb_strlen($html)) > ($maxLength+1)){
			$suffix = $suffixChar;
		}

		if (empty($html)) {
			return $output;
		}

		while ($printedLength < $maxLength && modSlideshow3Helper::mb_preg_match('{</?([a-z]+)[^>]*>|&#?[a-zA-Z0-9]+;}', $html, $match, PREG_OFFSET_CAPTURE, $position))
		{
			list($tag, $tagPosition) = $match[0];

			// Print text leading up to the tag.
			$str = mb_substr($html, $position, $tagPosition - $position);
			if ($printedLength + mb_strlen($str) > $maxLength) {
				$output .= mb_substr($str, 0, $maxLength - $printedLength);
				$printedLength = $maxLength;
				break;
			}

			$output .= $str;
			$lastCharacterIsOpenBracket = (mb_substr($output, -1, 1) === '<');

			if ($lastCharacterIsOpenBracket) {
				$output = mb_substr($output, 0, mb_strlen($output) - 1);
			}

			$printedLength += mb_strlen($str);

			if ($tag[0] == '&') {
				// Handle the entity.
				$output .= $tag;
				$printedLength++;
			}
			else {
				// Handle the tag.
				$tagName = $match[1][0];

				if ($tag[1] == '/') {
					// This is a closing tag.
					$openingTag = array_pop($tags);

					$output .= $tag;
				}
				else if ($tag[mb_strlen($tag) - 2] == '/') {
					// Self-closing tag.
					$output .= $tag;
				}
				else {
					// Opening tag.
					$output .= $tag;
					$tags[] = $tagName;
				}
			}

			// Continue after the tag.
			if ($lastCharacterIsOpenBracket) {
				$position = ($tagPosition - 1) + mb_strlen($tag);
			}
			else {
				$position = $tagPosition + mb_strlen($tag);
			}

		}

		// Print any remaining text.
		if ($printedLength < $maxLength && $position < mb_strlen($html)) {
			$output .= mb_substr($html, $position, $maxLength - $printedLength);
		}

		$output .= $suffix;
		// Close any open tags.
		while (!empty($tags))
		{
			$output .= sprintf('</%s>', array_pop($tags));
		}

		$length = mb_strlen($output);
		$lastChar = mb_substr($output, ($length - 1), 1);
		$characterNumber = ord($lastChar);

		if ($characterNumber === 194) {
			$output = mb_substr($output, 0, mb_strlen($output) - 1);
		}

		$output = JString::rtrim($output);

		return $output;
	}

	public static function mb_preg_match(
		$ps_pattern,
		$ps_subject,
		&$pa_matches,
		$pn_flags = 0,
		$pn_offset = 0,
		$ps_encoding = NULL
		)
	{
		// WARNING! - All this function does is to correct offsets, nothing else:
		//(code is independent of PREG_PATTER_ORDER / PREG_SET_ORDER)

		if (is_null($ps_encoding)) $ps_encoding = mb_internal_encoding();

		$pn_offset = strlen(mb_substr($ps_subject, 0, $pn_offset, $ps_encoding));
		$ret = preg_match($ps_pattern, $ps_subject, $pa_matches, $pn_flags, $pn_offset);

		if ($ret && ($pn_flags & PREG_OFFSET_CAPTURE))
		{
			foreach($pa_matches as &$ha_match) {
				$ha_match[1] = mb_strlen(substr($ps_subject, 0, $ha_match[1]), $ps_encoding);
		 	}
		}

		return $ret;
	}

}

if($k2) {
	abstract class modSlideshow3K2Helper {
	
		public static function getList(&$params) {
			jimport('joomla.filesystem.file');
			require_once(JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'route.php');
			require_once(JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'helpers'.DS.'utilities.php');
			$mainframe = &JFactory::getApplication();
			$limit = $params->get('k2count', 5);
			$cid = $params->get('k2catid', NULL);
			$itemid = $params->get('k2items','');
			$ordering = $params->get('k2Ordering','');
			$componentParams = &JComponentHelper::getParams('com_k2');
			$limitstart = JRequest::getInt('limitstart');
			$stripTags = $params->get(	'striptags','1');
			$tags	= $params->get( 'tags', '<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br />' );
			$linkTarget = $params->get('linkTarget','article');
			$showCategory = $params->get('showCategory',0);
			$catlink = $params->get('catLink',0);
			$introtext_limit = $params->get('introtext_limit', 500);
			$jbIntroText	= $params->get( 'jbIntroText', 1 );
			$createdDate = $params->get( 'createdDate', "1" );
			$dateFormat		= $params->get('dateFormat', 'j M, y');
			$renderPlugin	= $params->get('renderPlugin','render');
			$introtext_suffix = $params->get('introtext_suffix','');
			$user = &JFactory::getUser();
			$aid = $user->get('aid');
			$db = &JFactory::getDBO();
		
			$jnow = &JFactory::getDate();
			$now = $jnow->toMySQL();
			$nullDate = $db->getNullDate();
		
		
			$query = "SELECT i.*, c.name AS categoryname,c.id AS categoryid, c.alias AS categoryalias, c.params AS categoryparams";

			if ($ordering == 'best')
			$query .= ", (r.rating_sum/r.rating_count) AS rating";

			if ($ordering == 'comments')
			$query .= ", COUNT(comments.id) AS numOfComments";

			$query .= " FROM #__k2_items as i LEFT JOIN #__k2_categories c ON c.id = i.catid";

			if ($ordering == 'best')
			$query .= " LEFT JOIN #__k2_rating r ON r.itemID = i.id";

			if ($ordering == 'comments')
			$query .= " LEFT JOIN #__k2_comments comments ON comments.itemID = i.id";

			$query .= " WHERE i.published = 1 AND i.access IN(".implode(',', $user->authorisedLevels()).") AND i.trash = 0 AND c.published = 1 AND c.access IN(".implode(',', $user->authorisedLevels()).")  AND c.trash = 0";
		
			$query .= " AND ( i.publish_up = ".$db->Quote($nullDate)." OR i.publish_up <= ".$db->Quote($now)." )";
			$query .= " AND ( i.publish_down = ".$db->Quote($nullDate)." OR i.publish_down >= ".$db->Quote($now)." )";
		
		    if($itemid[0] == ''){
				if (!is_null($cid)) {
			        if ((is_array($cid)) && $cid[0] != '') {
			         if ($params->get('getChildren')) {
			           require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'itemlist.php');
			           	$categories = K2ModelItemlist::getCategoryTree($cid);
						$sql = @implode(',', $categories);
						$query .= " AND i.catid IN ({$sql})";
			         } else {
			           		JArrayHelper::toInteger($cid);
							$query .= " AND i.catid IN(".implode(',', $cid).")";
			         }
			       } else {
			         if ($params->get('getChildren')) {
			           require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'itemlist.php');
			           	$categories = K2ModelItemlist::getCategoryTree($cid[0]);
						$sql = @implode(',', $categories);
						$query .= " AND i.catid IN ({$sql})";
					} else {
						//$query .= " AND i.catid=".(int)$cid;
					}
			       }
			     }
			}
		    if($itemid[0] != ''){
				if( is_array( $itemid ) ) {
					$query .= ' AND (i.id IN ( ' . implode( ',', $itemid ) . ') )';
				} else {
					$query .= ' AND (i.id = '.$itemid.')';
				}
			}
		
			if ($params->get('k2FeaturedItems') == '0')
			$query .= " AND i.featured != 1";

			if ($params->get('k2FeaturedItems') == '2')
			$query .= " AND i.featured = 1";
		
			if ($ordering == 'comments')
			$query .= " AND comments.published = 1";
		
			if($mainframe->getLanguageFilter()) {
				$languageTag = JFactory::getLanguage()->getTag();
				$query .= " AND c.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').") AND i.language IN (".$db->Quote($languageTag).", ".$db->Quote('*').")";
			}
		
			switch ($ordering) {

				case 'date':
					$orderby = 'i.created ASC';
					break;

				case 'rdate':
					$orderby = 'i.created DESC';
					break;

				case 'alpha':
					$orderby = 'i.title';
					break;

				case 'ralpha':
					$orderby = 'i.title DESC';
					break;

				case 'order':
					if ($params->get('k2FeaturedItems') == '2')
					$orderby = 'i.featured_ordering';
					else
					$orderby = 'i.ordering';
					break;

				case 'rorder':
					if ($params->get('k2FeaturedItems') == '2')
					$orderby = 'i.featured_ordering DESC';
					else
					$orderby = 'i.ordering DESC';
					break;

				case 'hits':
					if ($params->get('popularityRange')){
						$datenow = &JFactory::getDate();
						$date = $datenow->toMySQL();
						$query.=" AND i.created > DATE_SUB('{$date}',INTERVAL ".$params->get('popularityRange')." DAY) ";
					}
					$orderby = 'i.hits DESC';
					break;

				case 'rand':
					$orderby = 'RAND()';
					break;

				case 'best':
					$orderby = 'rating DESC';
					break;

				case 'comments':
					if ($params->get('popularityRange')){
						$datenow = &JFactory::getDate();
						$date = $datenow->toMySQL();
						$query.=" AND i.created > DATE_SUB('{$date}',INTERVAL ".$params->get('popularityRange')." DAY) ";
					}
					$query.=" GROUP BY i.id ";
					$orderby = 'numOfComments DESC';
					break;
				
				case 'modified':
					$orderby = 'i.modified DESC';
					break;

				default:
					$orderby = 'i.id DESC';
					break;
			}


			$query .= " ORDER BY ".$orderby;
			$db->setQuery($query, 0, $limit);
			$items = $db->loadObjectList();

	    
			require_once (JPATH_SITE.DS.'components'.DS.'com_k2'.DS.'models'.DS.'item.php');
			$model = new K2ModelItem;

			if (count($items)) {
				$k2ImageSource = $params->get('content_image','k2content');
				if (!(($k2ImageSource == 'k2content') or ($k2ImageSource == 'k2item') or ($k2ImageSource == 'directory'))) $k2ImageSource = 'k2content';
				foreach ($items as $item) {
					//Clean title
					$item->title = JFilterOutput::ampReplace($item->title);
					if ($renderPlugin == 'strip') {
						$item->introtext = preg_replace('/{([a-zA-Z0-9\-_]*)\s*(.*?)}/i','', $item->introtext);
					}else{
						$item->introtext = JHtml::_('content.prepare', $item->introtext);
					}
					//Images
					if($k2ImageSource == "k2item") {
				    
					    $date =& JFactory::getDate($item->modified);
			            $timestamp = '?t='.$date->toUnix();
						$itemImageSize = $params->get('itemImageSize');
						if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_XS.jpg')){
						    $item->imageXSmall = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_XS.jpg';
						    if($componentParams->get('imageTimestamp')){
						        $item->imageXSmall.=$timestamp;
						    }
						}

						if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_S.jpg')){
						    $item->imageSmall = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_S.jpg';
							if($componentParams->get('imageTimestamp')){
						        $item->imageSmall.=$timestamp;
						    }
						}

						if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_M.jpg')){
						    $item->imageMedium = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_M.jpg';
							if($componentParams->get('imageTimestamp')){
						        $item->imageMedium.=$timestamp;
						    }					    
						}

						if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_L.jpg')){
						    $item->imageLarge = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_L.jpg';
							if($componentParams->get('imageTimestamp')){
						        $item->imageLarge.=$timestamp;
						    }	
						}

						if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_XL.jpg')){
						    $item->imageXLarge = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_XL.jpg';
							if($componentParams->get('imageTimestamp')){
						        $item->imageXLarge.=$timestamp;
						    }	
						}

						if (JFile::exists(JPATH_SITE.DS.'media'.DS.'k2'.DS.'items'.DS.'cache'.DS.md5("Image".$item->id).'_Generic.jpg')){
						    $item->imageGeneric = JURI::base(true).'/media/k2/items/cache/'.md5("Image".$item->id).'_Generic.jpg';
							if($componentParams->get('imageTimestamp')){
						        $item->imageGeneric.=$timestamp;
						    }	
						}

						$image = 'image'.$params->get('itemImgSize','Small');
						
				
						if (isset($item->$image)) 
							$item->image = $item->$image;
					
						
					
					
				
					}elseif($k2ImageSource == "k2content"){
						$item->firstimage = $item->introtext;
					}	
				
					if($linkTarget == 'article'){
						$item->link = urldecode(JRoute::_(K2HelperRoute::getItemRoute($item->id.':'.urlencode($item->alias), $item->catid.':'.urlencode($item->categoryalias))));
						}else{
						$item->link = urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($item->catid.':'.urlencode($item->categoryalias))));
						}
					
						$item->dateCreated = '';
						if ($createdDate) {
							$date = new JDate($item->created);
							$item->dateCreated= $date->format($dateFormat);
						}

						if ($showCategory) $item->catname = $item->categoryname;
					
						$item->firstimage = $item->introtext;
						$item->introtext = $stripTags ? self::_cleanIntrotext($item->introtext,$tags) : $item->introtext;
						$item->text = self::truncate($item->introtext, $introtext_limit, $introtext_suffix);
						$item->catlink = urldecode(JRoute::_(K2HelperRoute::getCategoryRoute($item->catid.':'.urlencode($item->categoryalias))));
			     
						$rows[] = $item;
				}

				return $rows;
			}
		}

	
		public static function _cleanIntrotext($introtext,$tags)
		{
			$introtext = str_replace('<p>', ' ', $introtext);
			$introtext = str_replace('</p>', ' ', $introtext);
			$introtext = strip_tags($introtext, $tags);

			$introtext = trim($introtext);

			return $introtext;
		}
	
		/**
		* This is a better truncate implementation than what we
		* currently have available in the library. In particular,
		* on index.php/Banners/Banners/site-map.html JHtml's truncate
		* method would only return "Article...". This implementation
		* was taken directly from the Stack Overflow thread referenced
		* below. It was then modified to return a string rather than
		* print out the output and made to use the relevant JString
		* methods. Now, modified to work with utf-8 chars.
		*
		* @link http://stackoverflow.com/questions/1193500/php-truncate-html-ignoring-tags
		* @param mixed $html
		* @param mixed $maxLength
		*/
		public static function truncate($html, $maxLength = 0, $suffixChar='&hellip;')
		{
			$printedLength = 0;
			$position = 0;
			$tags = array();
			$suffix = '';
			$output = '';

			if((mb_strlen($html)) > ($maxLength+1)){
				$suffix = $suffixChar;
			}

			if (empty($html)) {
				return $output;
			}

			while ($printedLength < $maxLength && modSlideshow3K2Helper::mb_preg_match('{</?([a-z]+)[^>]*>|&#?[a-zA-Z0-9]+;}', $html, $match, PREG_OFFSET_CAPTURE, $position))
			{
				list($tag, $tagPosition) = $match[0];

				// Print text leading up to the tag.
				$str = mb_substr($html, $position, $tagPosition - $position);
				if ($printedLength + mb_strlen($str) > $maxLength) {
					$output .= mb_substr($str, 0, $maxLength - $printedLength);
					$printedLength = $maxLength;
					break;
				}

				$output .= $str;
				$lastCharacterIsOpenBracket = (mb_substr($output, -1, 1) === '<');

				if ($lastCharacterIsOpenBracket) {
					$output = mb_substr($output, 0, mb_strlen($output) - 1);
				}

				$printedLength += mb_strlen($str);

				if ($tag[0] == '&') {
					// Handle the entity.
					$output .= $tag;
					$printedLength++;
				}
				else {
					// Handle the tag.
					$tagName = $match[1][0];

					if ($tag[1] == '/') {
						// This is a closing tag.
						$openingTag = array_pop($tags);

						$output .= $tag;
					}
					else if ($tag[mb_strlen($tag) - 2] == '/') {
						// Self-closing tag.
						$output .= $tag;
					}
					else {
						// Opening tag.
						$output .= $tag;
						$tags[] = $tagName;
					}
				}

				// Continue after the tag.
				if ($lastCharacterIsOpenBracket) {
					$position = ($tagPosition - 1) + mb_strlen($tag);
				}
				else {
					$position = $tagPosition + mb_strlen($tag);
				}

			}

			// Print any remaining text.
			if ($printedLength < $maxLength && $position < mb_strlen($html)) {
				$output .= mb_substr($html, $position, $maxLength - $printedLength);
			}

			$output .= $suffix;
			// Close any open tags.
			while (!empty($tags))
			{
				$output .= sprintf('</%s>', array_pop($tags));
			}

			$length = mb_strlen($output);
			$lastChar = mb_substr($output, ($length - 1), 1);
			$characterNumber = ord($lastChar);

			if ($characterNumber === 194) {
				$output = mb_substr($output, 0, mb_strlen($output) - 1);
			}

			$output = JString::rtrim($output);

			return $output;
		}

		public static function mb_preg_match(
			$ps_pattern,
			$ps_subject,
			&$pa_matches,
			$pn_flags = 0,
			$pn_offset = 0,
			$ps_encoding = NULL
			)
		{
			// WARNING! - All this function does is to correct offsets, nothing else:
			//(code is independent of PREG_PATTER_ORDER / PREG_SET_ORDER)

			if (is_null($ps_encoding)) $ps_encoding = mb_internal_encoding();

			$pn_offset = strlen(mb_substr($ps_subject, 0, $pn_offset, $ps_encoding));
			$ret = preg_match($ps_pattern, $ps_subject, $pa_matches, $pn_flags, $pn_offset);

			if ($ret && ($pn_flags & PREG_OFFSET_CAPTURE))
			{
				foreach($pa_matches as &$ha_match) {
					$ha_match[1] = mb_strlen(substr($ps_subject, 0, $ha_match[1]), $ps_encoding);
			 	}
			}

			return $ret;
		}
	}
}