<?php
/**
 * @package		Joomla Bamboo Zen Grid Framework
 * @Type        Core Framework Files
 * @version		v1.0
 * @author		Joomal Bamboo http://www.joomlabamboo.com
 * @copyright 	Copyright (C) 2007 - 2010 Joomla Bamboo
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();
jimport('joomla.html.html');
jimport('joomla.form.formfield');

/**
 * Renders a editors element
 *
 * @package 	Joomla.Framework
 * @subpackage		Form
 * @since		1.6
 */

class JFormFieldZendocs extends JFormField
{
	/**
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	
    protected $type = 'zendocs';

	protected function getInput()
	{
$html = '';
$html .= '<div id="documentation">
    <div class="width30">
        <p><strong>'.JText::_('TPL_ZEN_APPEARANCE').'</strong></p>
        <ul>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-template-overview-page?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_TEMPLATE_OVERVIEW').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-theme-settings?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_THEMEOPTIONS').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-zen-grid-2-logo-options?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_LOGOSETTINGS').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-tagline-appearance?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_CONTROLLINGTHETAGLINE').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-font-stacks?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_USINGTHEFONTSTACKS').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-css-overrides?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_CSSOVERRIDES').'</a></li>
        </ul>
    </div>';
    $html .= '<div class="width30">
        <p><strong>'.JText::_('TPL_ZEN_LAYOUTOPTIONS').'</strong></p>
        <ul>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-general-layout-settings?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_GENERALSETTINGS').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-exploring-template-overrides?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_TEMPLATEOVERRIDES').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-controlling-the-main-content-area?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_MAINCONTENTLAYOUTOPTIONS').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-controlling-module-layouts?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_CONTROLINGMODULEWIDTHS').'</a></li>
        </ul>
    </div>';
    $html .= '<div class="width30">
        <p><strong>'.JText::_('TPL_ZEN_SCRIPTSANDEXTRAS').'</strong></p>
        <ul>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-performance-scripts-and-extras?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_PERFORMANCETWEAKS').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-hidden-panel?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_THEHIDDENPANEL').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-analytics-feature?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_ADDINGANALYTICS').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-enabling-menu-scripts?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_MENUSCRIPTS').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-ie6-png-fix?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_IE6PNGFIX').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-extra-scripts?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_EXTRASCRIPTS').'</a></li>
        </ul>
    </div>';
    $html .= '<div class="clear"></div>';
    $html .= '<div class="width30">
        <p><strong>'.JText::_('TPL_ZEN_WORKINGWITHJOOMLABAMBOOTEMPLATES').'</strong></p>
        <ul>
            <li><a href="http://www.joomlabamboo.com/documentation/what-is-the-difference-between-a-joomla-template-and-the-quickstart-packages?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_THEDIFFERENCEBETWEENTHEQUICKSTARTANDTHETEMPLATE').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/how-to-install-the-quickstart-package?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_HOWTOINSTALLTHEQUICKSTARTPACKAGE').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/how-to-install-the-jb-library-plugin?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_HOWTOINSTALLTHEJBLIBRARYPLUGIN').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-setting-up-the-panel-menu?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_SETTINGUPTHEPANELMENU').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/zen-grid-framework-setting-up-the-superfish-menu?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_SETTINGUPTHESUPERFISHMENU').'</a></li>
        </ul>
    </div>';
    $html .='<div class="width30">
        <p><strong>'.JText::_('TPL_ZEN_GENERALJOOMLADOCUMENTATION').'</strong></p>
        <ul>
            <li><a href="http://www.joomlabamboo.com/documentation/how-to-create-parentchild-menu-items-in-joomla?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_CREATINGPARENTCHILEMENUITEMS').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/how-do-i-remove-the-welcome-to-the-front-page-text?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_HOWTOCHANGETHEWELCOMETOFRONTPAGETEXT').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/how-to-install-a-joomla-module?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_HOWTOINSTALLAJOOMLAMODULE').'</a></li>
            <li><a href="http://www.joomlabamboo.com/documentation/how-to-install-a-joomla-template?template=docs" class="modal positions" rel="{handler: \'iframe\', size: {x: 800, y: 500}}">'.JText::_('TPL_ZEN_HOWTOINSTALLAJOOMLATEMPLATE').'</a></li>
        </ul>
    </div>';
$html .= '</div>';
		
	
		
		
		return $html;
	}
	
	public function getLabel() {
		return '<span class="hideLabel">' . parent::getLabel() . '</span>';
	}

}
?>