<?php
/**
 * @package		Joomla Bamboo Zen Grid Framework
 * @Type        Core Framework Files
 * @version		v1.0
 * @author		Joomal Bamboo http://www.joomlabamboo.com
 * @copyright 	Copyright (C) 2007 - 2010 Joomla Bamboo
 * @license		http://www.gnu.org/licenses/gpl-2.0.html GNU/GPLv2 only
 */

// Check to ensure this file is within the rest of the framework
defined('JPATH_BASE') or die();
jimport('joomla.html.html');
jimport('joomla.form.formfield');

/**
 * Renders a editors element
 *
 * @package 	Joomla.Framework
 * @subpackage		Form
 * @since		1.6
 */

class JFormFieldZentabs extends JFormField
{
	/**
	* Element name
	*
	* @access	protected
	* @var		string
	*/
	
	protected $type = 'zentabs';

	protected function getInput()
	{
		$app = JFactory::getApplication();
		jimport('joomla.environment.browser');
		require_once(JPATH_ROOT.DS.'/templates/zengridframework/admin/classes/zengrid.php');
		$document =& JFactory::getDocument();
		$document->addStylesheet(JURI::root(true).'/templates/zengridframework/admin/css/zentabs.css');
		$document->addScript(JURI::root(true).'/templates/zengridframework/admin/js/zentabs.js');
		$browser = JBrowser::getInstance();
		if (substr_count(strtolower($browser->getBrowser()), 'msie') && $browser->getVersion() < 8) $document->addStylesheet(JURI::root(true).'/templates/zengridframework/admin/css/zentabs_ie.css');

		JHTML::_('behavior.modal', 'a.modal');
		
		$allEqual = Zengrid::getParam('allEqual');
		$html = '';
		$html .= 
'<div id="jbtabs">
    <ul class="tabs">
	';
		$html .= '
        <!------Overview------>
        <li><a class="parent active" href="#overview"><span class="overview">'.JText::_('TPL_ZEN_OVERVIEW').'</span></a>
            <ul>
                <li><a class="child" href="#overview">'.JText::_('TPL_ZEN_OVERVIEW').'</a></li>
                <li><a class="child" href="#documentation">'.JText::_('TPL_ZEN_DOCUMENTATION').'</a></li>
                <li><a class="child modal positions" rel="{handler: \'iframe\', size: {x: 700, y: 600}}" href="'.JURI::root(true).'/templates/'.Zengrid::getTemplate().'/'.Zengrid::getTemplate().'_positions.png">'.JText::_('TPL_ZEN_MODULEPOSITIONS').'</a></li>
            </ul>
        </li>
		';
		$html .= '
        <!------Appearance------>
        <li><a class="parent" href="#style"><span class="appearance">'.JText::_('TPL_ZEN_APPEARANCE').'</span></a>
            <ul>
                <li><a class="child" href="#style">'.JText::_('TPL_ZEN_STYLE').'</a></li>
                <li><a class="child" href="#logo">'.JText::_('TPL_ZEN_LOGO').'</a></li>
                <li><a class="child" href="#tagline">'.JText::_('TPL_ZEN_TAGLINE').'</a></li>
                <li><a class="child" href="#fonts">'.JText::_('TPL_ZEN_FONTS').'</a></li>
                <li><a class="child" href="#cssOverrides">'.JText::_('TPL_ZEN_CSSOVERRIDES').'</a></li>
            </ul>
		</li>
		';
		$html .= '
        <!------Layout------> 
        <li><a class="parent" href="#settings"><span class="layout">'.JText::_('TPL_ZEN_LAYOUT').'</span></a>
            <ul>
                ';
                if ($allEqual) { 
                $html .= '
        		<!------All Equal On------> 
                <li><a class="child" href="#settings">'.JText::_('TPL_ZEN_SETTINGS').'</a></li>
                
				<li><a class="child inactive thisisatooltip" href="#" 
				title="'.JText::_('TPL_ZEN_DISABLED_TIP_TITLE').'::'.JText::_('TPL_ZEN_DISABLED_TIP_TEXT').'">
				'.JText::_('TPL_ZEN_TOP').'</a></li>
                
				<li><a class="child inactive thisisatooltip" href="#" 
				title="'.JText::_('TPL_ZEN_DISABLED_TIP_TITLE').'::'.JText::_('TPL_ZEN_DISABLED_TIP_TEXT').'">
				'.JText::_('TPL_ZEN_HEADER').'</a></li>
                
				<li><a class="child" href="#menuLayout">'.JText::_('TPL_ZEN_MENU').'</a></li>
                
				<li><a class="child inactive thisisatooltip" href="#" 
				title="'.JText::_('TPL_ZEN_DISABLED_TIP_TITLE').'::'.JText::_('TPL_ZEN_DISABLED_TIP_TEXT').'">
				'.JText::_('TPL_ZEN_GRID112').'</a></li>
                
				<li><a class="child" href="#main">'.JText::_('TPL_ZEN_MAIN').'</a></li>
                <li><a class="child" href="#advert16">'.JText::_('TPL_ZEN_ADVERT16').'</a></li>				
				
				<li><a class="child inactive thisisatooltip" href="#" 
				title="'.JText::_('TPL_ZEN_DISABLED_TIP_TITLE').'::'.JText::_('TPL_ZEN_DISABLED_TIP_TEXT').'">
				'.JText::_('TPL_ZEN_GRID1324').'</a></li>
                
				<li><a class="child inactive thisisatooltip" href="#" 
				title="'.JText::_('TPL_ZEN_DISABLED_TIP_TITLE').'::'.JText::_('TPL_ZEN_DISABLED_TIP_TEXT').'">
				'.JText::_('TPL_ZEN_BOTTOM').'</a></li>
                
				<li><a class="child" href="#footer">'.JText::_('TPL_ZEN_FOOTER').'</a></li>
                <li><a class="child" href="#overrides">'.JText::_('TPL_ZEN_OVERRIDES').'</a></li>
                '; 
                }
                else {
                $html .= '
        		<!------All Equal Off------> 
                <li><a class="child" href="#settings">'.JText::_('TPL_ZEN_SETTINGS').'</a></li>
                <li><a class="child" href="#top">'.JText::_('TPL_ZEN_TOP').'</a></li>
                <li><a class="child" href="#header">'.JText::_('TPL_ZEN_HEADER').'</a></li>
                <li><a class="child" href="#menuLayout">'.JText::_('TPL_ZEN_MENU').'</a></li>
                <li><a class="child" href="#grid112">'.JText::_('TPL_ZEN_GRID112').'</a></li>
                <li><a class="child" href="#main">'.JText::_('TPL_ZEN_MAIN').'</a></li>
                <li><a class="child" href="#advert16">'.JText::_('TPL_ZEN_ADVERT16').'</a></li>
                <li><a class="child" href="#grid1324">'.JText::_('TPL_ZEN_GRID1324').'</a></li>
                <li><a class="child" href="#bottom">'.JText::_('TPL_ZEN_BOTTOM').'</a></li>
                <li><a class="child" href="#footer">'.JText::_('TPL_ZEN_FOOTER').'</a></li>
                <li><a class="child" href="#overrides">'.JText::_('TPL_ZEN_OVERRIDES').'</a></li>
				';
				}
				$html .= '
            </ul>
        </li>
		';
		$html .= '
        <!------Menus------>
        <li><a class="parent" href="#superfishMenu"><span class="menus">'.JText::_('TPL_ZEN_MENUS').'</span></a>
            <ul>
            <li><a class="child" href="#superfishMenu">'.JText::_('TPL_ZEN_SUPERFISHMENU').'</a></li>
            <li><a class="child" href="#panelMenu">'.JText::_('TPL_ZEN_PANELMENU').'</a></li>
            <li><a class="child" href="#splitMenu">'.JText::_('TPL_ZEN_SPLITMENU').'</a></li>                
            </ul>
        </li>
		';
        $html .= '
        <!------Extras------>
        <li><a class="parent" href="#hiddenPanel"><span class="extras">'.JText::_('TPL_ZEN_EXTRAS').'</span></a>
            <ul class="misc">
            <li><a class="child" href="#performance">'.JText::_('TPL_ZEN_PERFORMANCE').'</a></li>
            <li><a class="child" href="#hiddenPanel">'.JText::_('TPL_ZEN_HIDDENPANEL').'</a></li>
            <li><a class="child" href="#tabbedModules">'.JText::_('TPL_ZEN_TABBEDMODULES').'</a></li>
            <li><a class="child" href="#analytics">'.JText::_('TPL_ZEN_ANALYTICS').'</a></li>
            <li><a class="child" href="#iePNGfix">'.JText::_('TPL_ZEN_IE6PNGFIX').'</a></li>
            <li><a class="child" href="#extraScripts">'.JText::_('TPL_ZEN_EXTRASCRIPTS').'</a></li>
            <!--<li><a class="child" href="#moduleScripts">'.JText::_('TPL_ZEN_SCRIPTSFORMODULES').'</a></li>-->
            <li><a class="child" href="#copyright">'.JText::_('TPL_ZEN_COPYRIGHT').'</a></li>
            </ul>
        </li>
		';
        $html .= '
		<!------Documentation------>
        <li><a class="parent" id="documentation" href="#documentation"><span class="documentation">'.JText::_('TPL_ZEN_DOCUMENTATION').'</span></a>
            <ul>
                <li><a class="child" href="#overview">'.JText::_('TPL_ZEN_OVERVIEW').'</a></li>
                <li><a class="child" href="#documentation">'.JText::_('TPL_ZEN_DOCUMENTATION').'</a></li>
                <li><a class="child modal positions" rel="{handler: \'iframe\', size: {x: 700, y: 600}}" href="http://www.joomlabamboo.com/images/stories/zengrid2/ZenGridFrameworkModulePositions.png">'.JText::_('TPL_ZEN_MODULEPOSITIONS').'</a></li>
            </ul>
        </li>
		';
		$html .= '
    </ul>
</div>';		
		return $html;
	}
	
	public function getLabel() {
		return '<span class="hideLabel">' . parent::getLabel() . '</span>';
	}

}
?>