# ************************************************************
# Sequel Pro SQL dump
# Version 3408
#
# http://www.sequelpro.com/
# http://code.google.com/p/sequel-pro/
#
# Host: localhost (MySQL 5.5.9)
# Database: qs17_Rasa
# Generation Time: 2012-03-20 00:43:53 +0000
# ************************************************************


/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!40101 SET NAMES utf8 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;


# Dump of table #__assets
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__assets`;

CREATE TABLE `#__assets` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set parent.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `level` int(10) unsigned NOT NULL COMMENT 'The cached level in the nested tree.',
  `name` varchar(50) NOT NULL COMMENT 'The unique name for the asset.\n',
  `title` varchar(100) NOT NULL COMMENT 'The descriptive title for the asset.',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_asset_name` (`name`),
  KEY `idx_lft_rgt` (`lft`,`rgt`),
  KEY `idx_parent_id` (`parent_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__assets` WRITE;
/*!40000 ALTER TABLE `#__assets` DISABLE KEYS */;

INSERT INTO `#__assets` (`id`, `parent_id`, `lft`, `rgt`, `level`, `name`, `title`, `rules`)
VALUES
	(1,0,1,350,0,'root.1','Root Asset','{\"core.login.site\":{\"6\":1,\"2\":1},\"core.login.admin\":{\"6\":1},\"core.login.offline\":[],\"core.admin\":{\"8\":1},\"core.manage\":{\"7\":1},\"core.create\":{\"6\":1,\"3\":1},\"core.delete\":{\"6\":1},\"core.edit\":{\"6\":1,\"4\":1},\"core.edit.state\":{\"6\":1,\"5\":1},\"core.edit.own\":{\"6\":1,\"3\":1}}'),
	(2,1,2,3,1,'com_admin','com_admin','{}'),
	(3,1,4,11,1,'com_banners','com_banners','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(4,1,12,13,1,'com_cache','com_cache','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
	(5,1,14,15,1,'com_checkin','com_checkin','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
	(6,1,16,17,1,'com_config','com_config','{}'),
	(7,1,18,87,1,'com_contact','com_contact','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(8,1,88,229,1,'com_content','com_content','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1},\"core.edit.own\":[]}'),
	(9,1,230,231,1,'com_cpanel','com_cpanel','{}'),
	(10,1,232,233,1,'com_installer','com_installer','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1},\"core.create\":[],\"core.delete\":[],\"core.edit.state\":[]}'),
	(11,1,234,235,1,'com_languages','com_languages','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(12,1,236,237,1,'com_login','com_login','{}'),
	(13,1,238,239,1,'com_mailto','com_mailto','{}'),
	(14,1,240,241,1,'com_massmail','com_massmail','{}'),
	(15,1,242,243,1,'com_media','com_media','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1},\"core.delete\":{\"5\":1},\"core.edit\":[],\"core.edit.state\":[]}'),
	(16,1,244,245,1,'com_menus','com_menus','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(17,1,37,38,1,'com_messages','com_messages','{\"core.admin\":{\"7\":1},\"core.manage\":{\"7\":1}}'),
	(18,1,248,249,1,'com_modules','com_modules','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(19,1,250,257,1,'com_newsfeeds','com_newsfeeds','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(20,1,258,259,1,'com_plugins','com_plugins','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(21,1,260,261,1,'com_redirect','com_redirect','{\"core.admin\":{\"7\":1},\"core.manage\":[]}'),
	(22,1,262,263,1,'com_search','com_search','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1}}'),
	(23,1,264,265,1,'com_templates','com_templates','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(24,1,266,267,1,'com_users','com_users','{\"core.admin\":{\"7\":1},\"core.manage\":[],\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.own\":{\"6\":1},\"core.edit.state\":[]}'),
	(25,1,268,285,1,'com_weblinks','com_weblinks','{\"core.admin\":{\"7\":1},\"core.manage\":{\"6\":1},\"core.create\":{\"3\":1,\"10\":0,\"12\":0},\"core.delete\":[],\"core.edit\":{\"4\":1},\"core.edit.state\":{\"5\":1}}'),
	(26,1,286,287,1,'com_wrapper','com_wrapper','{}'),
	(39,8,109,206,2,'com_content.category.14','Sample Data-Articles','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(38,25,275,276,2,'com_weblinks.category.13','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(37,19,253,254,2,'com_newsfeeds.category.12','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(36,7,23,24,2,'com_contact.category.11','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(35,3,7,8,2,'com_banners.category.10','Uncategorised','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(34,8,105,108,2,'com_content.category.9','Uncategorised','{\"core.create\":{\"10\":0,\"12\":0},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(40,3,9,10,2,'com_banners.category.15','Sample Data-Banners','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(41,7,25,86,2,'com_contact.category.16','Sample Data-Contact','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(42,19,255,256,2,'com_newsfeeds.category.17','Sample Data-Newsfeeds','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(43,25,277,284,2,'com_weblinks.category.18','Sample Data-Weblinks','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(44,39,110,187,3,'com_content.category.19','Joomla!','{\"core.create\":{\"10\":0,\"12\":0},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(45,44,111,186,4,'com_content.category.20','Extensions','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(46,45,112,113,5,'com_content.category.21','Components','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(47,45,114,139,5,'com_content.category.22','Modules','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(48,45,140,175,5,'com_content.category.23','Templates','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(49,45,176,183,5,'com_content.category.24','Languages','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(50,45,184,185,5,'com_content.category.25','Plugins','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(51,39,188,197,3,'com_content.category.26','Park Site','{\"core.create\":{\"10\":0,\"12\":0},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(52,51,189,190,4,'com_content.category.27','Park Blog','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(53,51,191,196,4,'com_content.category.28','Photo Gallery','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(54,39,198,203,3,'com_content.category.29','Fruit Shop Site','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(55,54,199,200,4,'com_content.category.30','Growers','{\"core.create\":{\"12\":0},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":{\"10\":1}}'),
	(56,43,278,279,3,'com_weblinks.category.31','Park Links','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(57,43,280,283,3,'com_weblinks.category.32','Joomla! Specific Links','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(58,57,281,282,4,'com_weblinks.category.33','Other Resources','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(59,41,26,27,3,'com_contact.category.34','Park Site','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(60,41,28,85,3,'com_contact.category.35','Shop Site','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(61,60,29,30,4,'com_contact.category.36','Staff','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(62,60,31,84,4,'com_contact.category.37','Fruit Encyclopedia','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(63,62,32,33,5,'com_contact.category.38','A','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(64,62,34,35,5,'com_contact.category.39','B','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(65,62,36,37,5,'com_contact.category.40','C','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(66,62,38,39,5,'com_contact.category.41','D','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(67,62,40,41,5,'com_contact.category.42','E','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(68,62,42,43,5,'com_contact.category.43','F','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(69,62,44,45,5,'com_contact.category.44','G','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(70,62,46,47,5,'com_contact.category.45','H','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(71,62,48,49,5,'com_contact.category.46','I','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(72,62,50,51,5,'com_contact.category.47','J','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(73,62,52,53,5,'com_contact.category.48','K','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(74,62,54,55,5,'com_contact.category.49','L','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(75,62,56,57,5,'com_contact.category.50','M','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(76,62,58,59,5,'com_contact.category.51','N','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(77,62,60,61,5,'com_contact.category.52','O','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(78,62,62,63,5,'com_contact.category.53','P','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(79,62,64,65,5,'com_contact.category.54','Q','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(80,62,66,67,5,'com_contact.category.55','R','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(81,62,68,69,5,'com_contact.category.56','S','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(82,62,70,71,5,'com_contact.category.57','T','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(83,62,72,73,5,'com_contact.category.58','U','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(84,62,74,75,5,'com_contact.category.59','V','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(85,62,76,77,5,'com_contact.category.60','W','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(86,62,78,79,5,'com_contact.category.61','X','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(87,62,80,81,5,'com_contact.category.62','Y','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(88,62,82,83,5,'com_contact.category.63','Z','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(93,47,115,116,6,'com_content.category.64','Content Modules','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(94,47,117,118,6,'com_content.category.65','User Modules','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(95,47,119,120,6,'com_content.category.66','Display Modules','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(96,47,121,122,6,'com_content.category.67','Utility Modules','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(97,48,141,142,6,'com_content.category.68','Atomic','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(98,48,143,144,6,'com_content.category.69','Beez 20','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(99,48,145,146,6,'com_content.category.70','Beez5','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(100,48,147,148,6,'com_content.category.71','Milky Way','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(108,53,192,193,5,'com_content.category.72','Animals','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(109,53,194,195,5,'com_content.category.73','Scenery','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(166,47,125,126,6,'com_content.category.75','Navigation Modules','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(167,54,201,202,4,'com_content.category.76','Recipes','{\"core.create\":{\"12\":1,\"10\":1},\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":{\"12\":1,\"10\":1}}'),
	(168,34,106,107,3,'com_content.article.67','What\'s New in 1.5?','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(169,8,207,208,2,'com_content.category.77','Slideshow','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(172,8,209,222,2,'com_content.category.78','Demo Content','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(173,185,213,214,4,'com_content.article.70','Calculating Business Advice','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(174,185,215,216,4,'com_content.article.71','Strategies for office peace','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(175,185,211,212,4,'com_content.article.72','Brilliant and incompetent','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(176,185,217,218,4,'com_content.article.73','Lorem Ipsum Dolor','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(177,8,223,226,2,'com_content.category.79','Features','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(178,8,227,228,2,'com_content.category.80','Extensions','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(185,172,210,219,3,'com_content.category.81','Dummy Content','{\"core.create\":[],\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[],\"core.edit.own\":[]}'),
	(186,177,224,225,3,'com_content.article.80','Template Features','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(187,48,161,162,6,'com_content.article.81','Polar bears dont feel the cold','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(188,48,171,172,6,'com_content.article.82','Toes, massage and lotus birth','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(189,172,220,221,3,'com_content.article.83','Module Classes','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(190,49,177,178,6,'com_content.article.119','Dont be afraid to commit to change','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(191,49,179,180,6,'com_content.article.117','Friends and lovers','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(192,49,181,182,6,'com_content.article.118','Interior design for exterior people','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(193,48,149,150,6,'com_content.article.56','A lone flower starts to uncurl','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(194,48,151,152,6,'com_content.article.54','Eco business systems and environmental transaction','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(195,48,153,154,6,'com_content.article.88','Focus remains a useful creative tension','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(196,48,155,156,6,'com_content.article.76','Investors strike against corporate excess','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(197,48,157,158,6,'com_content.article.49','Maintaining equity in your assets','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(198,48,159,160,6,'com_content.article.78','Moonlight Classics - Summer viewing','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(199,48,163,164,6,'com_content.article.55','Pools of the rich and famous','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(200,48,165,166,6,'com_content.article.77','Rockumentary - the making of a hero','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(201,48,167,168,6,'com_content.article.87','Techniques for the nineteenth hole','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(202,48,169,170,6,'com_content.article.75','The CEO Whisperer - contentment and success','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(203,48,173,174,6,'com_content.article.79','Weddings in far away places','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(204,47,127,128,6,'com_content.article.103','Theme Variations','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(205,47,129,130,6,'com_content.article.120','Joomla Bamboo Extensions','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(206,47,131,132,6,'com_content.article.141','Module classes','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(207,47,133,134,6,'com_content.article.104','Module Positions','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(208,47,135,136,6,'com_content.article.90','Typography','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}'),
	(209,47,137,138,6,'com_content.article.60','Zen Grid Framework','{\"core.delete\":[],\"core.edit\":[],\"core.edit.state\":[]}');

/*!40000 ALTER TABLE `#__assets` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__banner_clients
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__banner_clients`;

CREATE TABLE `#__banner_clients` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `contact` varchar(255) NOT NULL DEFAULT '',
  `email` varchar(255) NOT NULL DEFAULT '',
  `extrainfo` text NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `metakey` text NOT NULL,
  `own_prefix` tinyint(4) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  PRIMARY KEY (`id`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__banner_clients` WRITE;
/*!40000 ALTER TABLE `#__banner_clients` DISABLE KEYS */;

INSERT INTO `#__banner_clients` (`id`, `name`, `contact`, `email`, `extrainfo`, `state`, `checked_out`, `checked_out_time`, `metakey`, `own_prefix`, `metakey_prefix`, `purchase_type`, `track_clicks`, `track_impressions`)
VALUES
	(1,'Joomla!','Administrator','email@email.com','',1,0,'0000-00-00 00:00:00','',0,'',-1,-1,-1);

/*!40000 ALTER TABLE `#__banner_clients` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__banners
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__banners`;

CREATE TABLE `#__banners` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `cid` int(11) NOT NULL DEFAULT '0',
  `type` int(11) NOT NULL DEFAULT '0',
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `imptotal` int(11) NOT NULL DEFAULT '0',
  `impmade` int(11) NOT NULL DEFAULT '0',
  `clicks` int(11) NOT NULL DEFAULT '0',
  `clickurl` varchar(200) NOT NULL DEFAULT '',
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `description` text NOT NULL,
  `custombannercode` varchar(2048) NOT NULL,
  `sticky` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `params` text NOT NULL,
  `own_prefix` tinyint(1) NOT NULL DEFAULT '0',
  `metakey_prefix` varchar(255) NOT NULL DEFAULT '',
  `purchase_type` tinyint(4) NOT NULL DEFAULT '-1',
  `track_clicks` tinyint(4) NOT NULL DEFAULT '-1',
  `track_impressions` tinyint(4) NOT NULL DEFAULT '-1',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `reset` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `language` char(7) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  KEY `idx_state` (`state`),
  KEY `idx_own_prefix` (`own_prefix`),
  KEY `idx_metakey_prefix` (`metakey_prefix`),
  KEY `idx_banner_catid` (`catid`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__banners` WRITE;
/*!40000 ALTER TABLE `#__banners` DISABLE KEYS */;

INSERT INTO `#__banners` (`id`, `cid`, `type`, `name`, `alias`, `imptotal`, `impmade`, `clicks`, `clickurl`, `state`, `catid`, `description`, `custombannercode`, `sticky`, `ordering`, `metakey`, `params`, `own_prefix`, `metakey_prefix`, `purchase_type`, `track_clicks`, `track_impressions`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `reset`, `created`, `language`)
VALUES
	(2,1,0,'Shop 1','shop-1',0,16,0,'http://shop.joomla.org/amazoncom-bookstores.html',1,15,'Get books about Joomla! at the Joomla! book shop.','',0,1,'','{\"imageurl\":\"images\\/banners\\/shop-ad-books.jpg\",\"width\":\"\",\"height\":\"\",\"alt\":\"Joomla! Books\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-01 00:00:01','en-GB'),
	(3,1,0,'Shop 2','shop-2',0,22,0,'http://shop.joomla.org',1,15,'T Shirts, caps and more from the Joomla! Shop.','',0,2,'','{\"imageurl\":\"images\\/banners\\/shop-ad.jpg\",\"width\":\"\",\"height\":\"\",\"alt\":\"Joomla! Shop\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','2011-01-01 00:00:01','en-GB'),
	(4,1,0,'Support Joomla!','support-joomla',0,19,0,'http://contribute.joomla.org',1,15,'Your contributions of time, talent and money make Joomla! possible.','',0,3,'','{\"imageurl\":\"images\\/banners\\/white.png\",\"width\":\"\",\"height\":\"\",\"alt\":\"\"}',0,'',-1,0,0,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00','en-GB');

/*!40000 ALTER TABLE `#__banners` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__categories
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__categories`;

CREATE TABLE `#__categories` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0',
  `lft` int(11) NOT NULL DEFAULT '0',
  `rgt` int(11) NOT NULL DEFAULT '0',
  `level` int(10) unsigned NOT NULL DEFAULT '0',
  `path` varchar(255) NOT NULL DEFAULT '',
  `extension` varchar(50) NOT NULL DEFAULT '',
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `description` mediumtext,
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `access` int(10) unsigned DEFAULT NULL,
  `params` text NOT NULL,
  `metadesc` varchar(1024) NOT NULL COMMENT 'The meta description for the page.',
  `metakey` varchar(1024) NOT NULL COMMENT 'The meta keywords for the page.',
  `metadata` varchar(2048) NOT NULL COMMENT 'JSON encoded metadata properties.',
  `created_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `created_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_user_id` int(10) unsigned NOT NULL DEFAULT '0',
  `modified_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `cat_idx` (`extension`,`published`,`access`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_path` (`path`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__categories` WRITE;
/*!40000 ALTER TABLE `#__categories` DISABLE KEYS */;

INSERT INTO `#__categories` (`id`, `asset_id`, `parent_id`, `lft`, `rgt`, `level`, `path`, `extension`, `title`, `alias`, `note`, `description`, `published`, `checked_out`, `checked_out_time`, `access`, `params`, `metadesc`, `metakey`, `metadata`, `created_user_id`, `created_time`, `modified_user_id`, `modified_time`, `hits`, `language`)
VALUES
	(1,0,0,0,71,0,'','system','ROOT','root','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'2009-10-18 16:07:09',0,'0000-00-00 00:00:00',0,'*'),
	(2,27,1,61,62,1,'uncategorised','com_content','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:26:37',0,'0000-00-00 00:00:00',0,'*'),
	(3,28,1,63,64,1,'uncategorised','com_banners','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\",\"foobar\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:27:35',0,'0000-00-00 00:00:00',0,'*'),
	(4,29,1,65,66,1,'uncategorised','com_contact','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:27:57',0,'0000-00-00 00:00:00',0,'*'),
	(5,30,1,67,68,1,'uncategorised','com_newsfeeds','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:28:15',0,'0000-00-00 00:00:00',0,'*'),
	(6,31,1,69,70,1,'uncategorised','com_weblinks','Uncategorised','uncategorised','','',1,0,'0000-00-00 00:00:00',1,'{\"target\":\"\",\"image\":\"\"}','','','{\"page_title\":\"\",\"author\":\"\",\"robots\":\"\"}',42,'2010-06-28 13:28:33',0,'0000-00-00 00:00:00',0,'*'),
	(7,32,1,19,24,1,'news','com_content','News','news','','Select a news topic from the list below, then select a news article to read.',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(8,33,7,20,21,2,'news/latest-news','com_content','Latest','latest-news','','The latest news from the Joomla! Team',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(9,34,7,22,23,2,'news/newsflash','com_content','Newsflash','newsflash','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(10,35,1,25,36,1,'faqs','com_content','FAQs','faqs','','From the list below choose one of our FAQs topics, then select an FAQ to read. If you have a question which is not in this section, please contact us.',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(11,36,10,26,27,2,'faqs/new-to-joomla','com_content','New to Joomla!','new-to-joomla','','Questions for new users of Joomla!',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(12,37,10,28,29,2,'faqs/current-users','com_content','Current Users','current-users','','Questions that users migrating to Joomla! 1.5 are likely to raise<br />',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(13,38,10,30,31,2,'faqs/general','com_content','General','general','','General questions about the Joomla! CMS',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(14,39,10,32,33,2,'faqs/languages','com_content','Languages','languages','','Questions related to localisation and languages',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(15,40,10,34,35,2,'faqs/slideshow-items','com_content','Slideshow Items','slideshow-items','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(16,41,1,37,44,1,'about-joomla','com_content','About Joomla!','about-joomla','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(17,42,16,38,39,2,'about-joomla/the-project','com_content','The Project','the-project','','<p>General facts about Joomla!</p>',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(18,43,16,40,41,2,'about-joomla/the-cms','com_content','The CMS','the-cms','','Information about the software behind Joomla!<br />',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(19,44,16,42,43,2,'about-joomla/the-community','com_content','The Community','the-community','','About the millions of Joomla! users and Web sites<br />',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(20,45,1,45,60,1,'democontent','com_content','Democontent','democontent','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(21,46,20,46,47,2,'democontent/setting-up','com_content','Setting Up','setting-up','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(22,47,20,48,49,2,'democontent/features','com_content','Features','features','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(23,48,20,50,51,2,'democontent/democontent','com_content','Democontent','democontent','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(24,49,20,52,53,2,'democontent/slideshow-items','com_content','Slideshow Items','slideshow-items','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(25,50,20,54,55,2,'democontent/zen-grid-framework-features','com_content','Zen Grid Framework Features','zen-grid-framework-features','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(26,51,20,56,57,2,'democontent/extensions','com_content','Extensions','extensions','','',-2,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(27,52,20,58,59,2,'democontent/the-team','com_content','The Team','the-team','','',-2,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(28,160,1,17,18,1,'joomla','com_banners','Joomla','joomla','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(29,161,1,15,16,1,'text-ads','com_banners','Text Ads','text-ads','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(30,162,1,13,14,1,'joomla-promo','com_banners','Joomla! Promo','joomla-promo','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(31,163,1,11,12,1,'contacts','com_contact_details','Contacts','contacts','','Contact Details for this Web site',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(32,164,1,9,10,1,'joomla','com_newsfeeds','Joomla!','joomla','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(33,165,1,7,8,1,'free-and-open-source-software','com_newsfeeds','Free and Open Source Software','free-and-open-source-software','','Read the latest news about free and open source software from some of its leading advocates.',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(34,166,1,5,6,1,'related-projects','com_newsfeeds','Related Projects','related-projects','','Joomla builds on and collaborates with many other free and open source projects. Keep up with the latest news from some of them.',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(35,167,1,3,4,1,'joomla-specific-links','com_weblinks','Joomla! Specific Links','joomla-specific-links','','A selection of links that are all related to the Joomla! Project.',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*'),
	(36,168,1,1,2,1,'other-resources','com_weblinks','Other Resources','other-resources','','',1,0,'0000-00-00 00:00:00',1,'{}','','','',0,'0000-00-00 00:00:00',0,'0000-00-00 00:00:00',0,'*');

/*!40000 ALTER TABLE `#__categories` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__contact_details
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__contact_details`;

CREATE TABLE `#__contact_details` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `con_position` varchar(255) DEFAULT NULL,
  `address` text,
  `suburb` varchar(100) DEFAULT NULL,
  `state` varchar(100) DEFAULT NULL,
  `country` varchar(100) DEFAULT NULL,
  `postcode` varchar(100) DEFAULT NULL,
  `telephone` varchar(255) DEFAULT NULL,
  `fax` varchar(255) DEFAULT NULL,
  `misc` mediumtext,
  `image` varchar(255) DEFAULT NULL,
  `imagepos` varchar(20) DEFAULT NULL,
  `email_to` varchar(255) DEFAULT NULL,
  `default_con` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `params` text NOT NULL,
  `user_id` int(11) NOT NULL DEFAULT '0',
  `catid` int(11) NOT NULL DEFAULT '0',
  `access` int(10) unsigned DEFAULT NULL,
  `mobile` varchar(255) NOT NULL DEFAULT '',
  `webpage` varchar(255) NOT NULL DEFAULT '',
  `sortname1` varchar(255) NOT NULL,
  `sortname2` varchar(255) NOT NULL,
  `sortname3` varchar(255) NOT NULL,
  `language` char(7) NOT NULL,
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`published`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__contact_details` WRITE;
/*!40000 ALTER TABLE `#__contact_details` DISABLE KEYS */;

INSERT INTO `#__contact_details` (`id`, `name`, `alias`, `con_position`, `address`, `suburb`, `state`, `country`, `postcode`, `telephone`, `fax`, `misc`, `image`, `imagepos`, `email_to`, `default_con`, `published`, `checked_out`, `checked_out_time`, `ordering`, `params`, `user_id`, `catid`, `access`, `mobile`, `webpage`, `sortname1`, `sortname2`, `sortname3`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`)
VALUES
	(1,'Contact Name Here','name','Position','Street Address','Suburb','State','Country','Zip Code','Telephone','Fax','<p>Information about or by the contact.</p>','images/powered_by.png','top','email@email.com',1,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"1\",\"linka_name\":\"Twitter\",\"linka\":\"http:\\/\\/twitter.com\\/joomla\",\"linkb_name\":\"YouTube\",\"linkb\":\"http:\\/\\/www.youtube.com\\/user\\/joomla\",\"linkc_name\":\"Facebook\",\"linkc\":\"http:\\/\\/www.facebook.com\\/joomla\",\"linkd_name\":\"FriendFeed\",\"linkd\":\"http:\\/\\/friendfeed.com\\/joomla\",\"linke_name\":\"Scribed\",\"linke\":\"http:\\/\\/www.scribd.com\\/people\\/view\\/504592-joomla\",\"contact_layout\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,16,1,'','','last','first','middle','en-GB','2011-01-01 00:00:01',0,'','2011-01-08 17:39:00',42,'','','{\"robots\":\"\",\"rights\":\"\"}',1,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(2,'Webmaster','webmaster','','','','','','','','','','',NULL,'webmaster@example.com',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"show_email_form\":\"1\",\"show_email_copy\":\"1\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"1\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,34,1,'','','','','','en-GB','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"rights\":\"\"}',1,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(3,'Owner','owner','','','','','','','','','<p>I\'m the owner of this store.</p>','',NULL,'',0,1,0,'0000-00-00 00:00:00',2,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,36,1,'','','','','','*','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"rights\":\"\"}',1,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(4,'Buyer','buyer','','','','','','','','','<p>I am in charge of buying fruit. If you sell good fruit, contact me.</p>','',NULL,'',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"0\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,36,1,'','','','','','*','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"rights\":\"\"}',1,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(5,'Bananas','bananas','Scientific Name: Musa','Image Credit: Enzik\r\nRights: Creative Commons Share Alike Unported 3.0\r\nSource: http://commons.wikimedia.org/wiki/File:Bananas_-_Morocco.jpg','','Type: Herbaceous','Large Producers: India, China, Brasil','','','','<p>Bananas are a great source of potassium.</p>\r\n<p> </p>','images/sampledata/fruitshop/bananas_2.jpg',NULL,'',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"show_with_link\",\"show_contact_list\":\"\",\"presentation_style\":\"plain\",\"show_name\":\"\",\"show_position\":\"1\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"1\",\"show_postcode\":\"\",\"show_country\":\"1\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"1\",\"linka_name\":\"Wikipedia: Banana English\",\"linka\":\"http:\\/\\/en.wikipedia.org\\/wiki\\/Banana\",\"linkb_name\":\"Wikipedia:  \\u0939\\u093f\\u0928\\u094d\\u0926\\u0940 \\u0915\\u0947\\u0932\\u093e\",\"linkb\":\"http:\\/\\/hi.wikipedia.org\\/wiki\\/%E0%A4%95%E0%A5%87%E0%A4%B2%E0%A4%BE\",\"linkc_name\":\"Wikipedia:Banana Portugu\\u00eas\",\"linkc\":\"http:\\/\\/pt.wikipedia.org\\/wiki\\/Banana\",\"linkd_name\":\"Wikipedia: \\u0411\\u0430\\u043d\\u0430\\u043d  \\u0420\\u0443\\u0441\\u0441\\u043a\\u0438\\u0439\",\"linkd\":\"http:\\/\\/ru.wikipedia.org\\/\\u0411\\u0430\\u043d\\u0430\\u043d\",\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"beez5:encyclopedia\"}',0,39,1,'','','','','','*','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(6,'Apples','apples','Scientific Name: Malus domestica','Image Credit: Fievet\r\nRights: Public Domain\r\nSource: http://commons.wikimedia.org/wiki/File:Pommes_vertes.JPG','','Family: Rosaceae','Large: Producers: China, United States','','','','<p>Apples are a versatile fruit, used for eating, cooking, and preserving.</p>\r\n<p>There are more that 7500 different kinds of apples grown around the world.</p>','images/sampledata/fruitshop/apple.jpg',NULL,'',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"plain\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"1\",\"linka_name\":\"Wikipedia: Apples English\",\"linka\":\"http:\\/\\/en.wikipedia.org\\/wiki\\/Apple\",\"linkb_name\":\"Wikipedia: Manzana Espa\\u00f1ol \",\"linkb\":\"http:\\/\\/es.wikipedia.org\\/wiki\\/Manzana\",\"linkc_name\":\"Wikipedia: \\u82f9\\u679c \\u4e2d\\u6587\",\"linkc\":\"http:\\/\\/zh.wikipedia.org\\/zh\\/\\u82f9\\u679c\",\"linkd_name\":\"Wikipedia: Tofaa Kiswahili\",\"linkd\":\"http:\\/\\/sw.wikipedia.org\\/wiki\\/Tofaa\",\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"beez5:encyclopedia\"}',0,38,1,'','','','','','*','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(7,'Tamarind','tamarind','Scientific Name: Tamarindus indica','Image Credit: Franz Eugen Köhler, Köhler\'s Medizinal-Pflanzen \r\nRights: Public Domain\r\nSource:http://commons.wikimedia.org/wiki/File:Koeh-134.jpg','','Family: Fabaceae','Large Producers: India, United States','','','','<p>Tamarinds are a versatile fruit used around the world. In its young form it is used in hot sauces; ripened it is the basis for many refreshing drinks.</p>\r\n<p> </p>','images/sampledata/fruitshop/tamarind.jpg',NULL,'',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"plain\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"1\",\"linka_name\":\"Wikipedia: Tamarind English\",\"linka\":\"http:\\/\\/en.wikipedia.org\\/wiki\\/Tamarind\",\"linkb_name\":\"Wikipedia: \\u09a4\\u09c7\\u0981\\u09a4\\u09c1\\u09b2  \\u09ac\\u09be\\u0982\\u09b2\\u09be  \",\"linkb\":\"http:\\/\\/bn.wikipedia.org\\/wiki\\/\\u09a4\\u09c7\\u0981\\u09a4\\u09c1\\u09b2 \",\"linkc_name\":\"Wikipedia: Tamarinier Fran\\u00e7ais\",\"linkc\":\"http:\\/\\/fr.wikipedia.org\\/wiki\\/Tamarinier\",\"linkd_name\":\"Wikipedia:Tamaline lea faka-Tonga\",\"linkd\":\"http:\\/\\/to.wikipedia.org\\/wiki\\/Tamaline\",\"linke_name\":\"\",\"linke\":\"\",\"contact_layout\":\"beez5:encyclopedia\"}',0,57,1,'','','','','','*','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(8,'Shop Address','shop-address','','','Our City','Our Province','Our Country','','555-555-5555','','<p>Here are directions for how to get to our shop.</p>','',NULL,'',0,1,0,'0000-00-00 00:00:00',1,'{\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_profile\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linka\":\"\",\"linkb_name\":\"\",\"linkb\":\"\",\"linkc_name\":\"\",\"linkc\":\"\",\"linkd_name\":\"\",\"linkd\":\"\",\"linke_name\":\"\",\"linke\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\"}',0,35,1,'','','','','','*','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"rights\":\"\"}',1,'','0000-00-00 00:00:00','0000-00-00 00:00:00');

/*!40000 ALTER TABLE `#__contact_details` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__content
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__content`;

CREATE TABLE `#__content` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `asset_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to the #__assets table.',
  `title` varchar(255) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `title_alias` varchar(255) NOT NULL DEFAULT '',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `state` tinyint(3) NOT NULL DEFAULT '0',
  `sectionid` int(10) unsigned NOT NULL DEFAULT '0',
  `mask` int(10) unsigned NOT NULL DEFAULT '0',
  `catid` int(10) unsigned NOT NULL DEFAULT '0',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `images` text NOT NULL,
  `urls` text NOT NULL,
  `attribs` varchar(5120) NOT NULL,
  `version` int(10) unsigned NOT NULL DEFAULT '1',
  `parentid` int(10) unsigned NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `access` int(10) unsigned NOT NULL DEFAULT '0',
  `hits` int(10) unsigned NOT NULL DEFAULT '0',
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if article is featured.',
  `language` char(7) NOT NULL COMMENT 'The language code for the article.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__content` WRITE;
/*!40000 ALTER TABLE `#__content` DISABLE KEYS */;

INSERT INTO `#__content` (`id`, `asset_id`, `title`, `alias`, `title_alias`, `introtext`, `fulltext`, `state`, `sectionid`, `mask`, `catid`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `images`, `urls`, `attribs`, `version`, `parentid`, `ordering`, `metakey`, `metadesc`, `access`, `hits`, `metadata`, `featured`, `language`, `xreference`)
VALUES
	(1,53,'Welcome to Joomla!','welcome-to-joomla','','<div align=\"left\"><strong>Joomla! is a free open source framework and content publishing system designed for quickly creating highly interactive multi-language Web sites, online communities, media portals, blogs and eCommerce applications. <br /></strong></div><p><strong><br /></strong><img src=\"images/stories/powered_by.png\" border=\"0\" alt=\"Joomla! Logo\" title=\"Example Caption\" hspace=\"6\" vspace=\"0\" width=\"165\" height=\"68\" align=\"left\" />Joomla! provides an easy-to-use graphical user interface that simplifies the management and publishing of large volumes of content including HTML, documents, and rich media.  Joomla! is used by organisations of all sizes for intranets and extranets and is supported by a community of tens of thousands of users. </p>','With a fully documented library of developer resources, Joomla! allows the customisation of every aspect of a Web site including presentation, layout, administration, and the rapid integration with third-party applications.<p>Joomla! now provides more developer power while making the user experience all the more friendly. For those who always wanted increased extensibility, Joomla! 1.5 can make this happen.</p><p>A new framework, ground-up refactoring, and a highly-active development team brings the excitement of \'the next generation CMS\' to your fingertips.  Whether you are a systems architect or a complete \'noob\' Joomla! can take you to the next level of content delivery. \'More than a CMS\' is something we have been playing with as a catchcry because the new Joomla! API has such incredible power and flexibility, you are free to take whatever direction your creative mind takes you and Joomla! can help you get there so much more easily than ever before.</p><p>Thinking Web publishing? Think Joomla!</p>',1,0,0,8,'2008-08-12 10:00:00',62,'','2008-08-12 10:00:00',62,0,'0000-00-00 00:00:00','2006-01-03 01:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',29,0,1,'','',1,94,'',0,'*',''),
	(2,54,'Newsflash 1','newsflash-1','','<p>Joomla! makes it easy to launch a Web site of any kind. Whether you want a brochure site or you are building a large online community, Joomla! allows you to deploy a new site in minutes and add extra functionality as you need it. The hundreds of available Extensions will help to expand your site and allow you to deliver new services that extend your reach into the Internet.</p>','',1,0,0,9,'2008-08-10 06:30:34',62,'','2008-08-10 06:30:34',62,0,'0000-00-00 00:00:00','2004-08-09 10:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',7,0,3,'','',1,1,'',0,'*',''),
	(3,55,'Newsflash 2','newsflash-2','','<p>The one thing about a Web site, it always changes! Joomla! makes it easy to add Articles, content, images, videos, and more. Site administrators can edit and manage content \'in-context\' by clicking the \'Edit\' link. Webmasters can also edit content through a graphical Control Panel that gives you complete control over your site.</p>','',1,0,0,9,'2008-08-09 22:30:34',62,'','2008-08-09 22:30:34',62,0,'0000-00-00 00:00:00','2004-08-09 06:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',6,0,4,'','',1,0,'',0,'*',''),
	(4,56,'Newsflash 3','newsflash-3','','<p>With a library of thousands of free <a href=\"http://extensions.joomla.org\" target=\"_blank\" title=\"The Joomla! Extensions Directory\">Extensions</a>, you can add what you need as your site grows. Don\'t wait, look through the <a href=\"http://extensions.joomla.org/\" target=\"_blank\" title=\"Joomla! Extensions\">Joomla! Extensions</a>  library today. </p>','',1,0,0,9,'2008-08-10 06:30:34',62,'','2008-08-10 06:30:34',62,0,'0000-00-00 00:00:00','2004-08-09 10:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',7,0,5,'','',1,1,'',0,'*',''),
	(5,57,'Joomla! License Guidelines','joomla-license-guidelines','joomla-license-guidelines','<p>This Web site is powered by <a href=\"http://joomla.org/\" target=\"_blank\" title=\"Joomla!\">Joomla!</a> The software and default templates on which it runs are Copyright 2005-2008 <a href=\"http://www.opensourcematters.org/\" target=\"_blank\" title=\"Open Source Matters\">Open Source Matters</a>. The sample content distributed with Joomla! is licensed under the <a href=\"http://docs.joomla.org/JEDL\" target=\"_blank\" title=\"Joomla! Electronic Document License\">Joomla! Electronic Documentation License.</a> All data entered into this Web site and templates added after installation, are copyrighted by their respective copyright owners.</p> <p>If you want to distribute, copy, or modify Joomla!, you are welcome to do so under the terms of the <a href=\"http://www.gnu.org/licenses/old-licenses/gpl-2.0.html#SEC1\" target=\"_blank\" title=\"GNU General Public License\"> GNU General Public License</a>. If you are unfamiliar with this license, you might want to read <a href=\"http://www.gnu.org/licenses/old-licenses/gpl-2.0.html#SEC4\" target=\"_blank\" title=\"How To Apply These Terms To Your Program\">\'How To Apply These Terms To Your Program\'</a> and the <a href=\"http://www.gnu.org/licenses/old-licenses/gpl-2.0-faq.html\" target=\"_blank\" title=\"GNU General Public License FAQ\">\'GNU General Public License FAQ\'</a>.</p> <p>The Joomla! licence has always been GPL.</p>','',1,0,0,17,'2008-08-20 10:11:07',62,'','2008-08-20 10:11:07',62,0,'0000-00-00 00:00:00','2004-08-19 06:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',7,0,2,'','',1,149,'',0,'*',''),
	(6,58,'We are Volunteers','we-are-volunteers','','<p>The Joomla Core Team and Working Group members are volunteer developers, designers, administrators and managers who have worked together to take Joomla! to new heights in its relatively short life. Joomla! has some wonderfully talented people taking Open Source concepts to the forefront of industry standards.  Joomla! 1.5 is a major leap forward and represents the most exciting Joomla! release in the history of the project. </p>','',1,0,0,8,'2007-07-07 09:54:06',62,'','2007-07-07 09:54:06',62,0,'0000-00-00 00:00:00','2004-07-06 22:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',10,0,4,'','',1,54,'',0,'*',''),
	(9,59,'Millions of Smiles','millions-of-smiles','','<p>The Joomla! team has millions of good reasons to be smiling about the Joomla! 1.5. In its current incarnation, it\'s had millions of downloads, taking it to an unprecedented level of popularity.  The new code base is almost an entire re-factor of the old code base.  The user experience is still extremely slick but for developers the API is a dream.  A proper framework for real PHP architects seeking the best of the best.</p><p>If you\'re a former Mambo User or a 1.0 series Joomla! User, 1.5 is the future of CMSs for a number of reasons.  It\'s more powerful, more flexible, more secure, and intuitive.  Our developers and interface designers have worked countless hours to make this the most exciting release in the content management system sphere.</p><p>Go on ... get your FREE copy of Joomla! today and spread the word about this benchmark project. </p>','',1,0,0,8,'2007-07-07 09:54:06',62,'','2007-07-07 09:54:06',62,0,'0000-00-00 00:00:00','2004-07-06 22:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',5,0,7,'','',1,23,'',0,'*',''),
	(10,60,'How do I localise Joomla! to my language?','how-do-i-localise-joomla-to-my-language','','<h4>General<br /></h4><p>In Joomla! 1.5 all User interfaces can be localised. This includes the installation, the Back-end Control Panel and the Front-end Site.</p><p>The core release of Joomla! 1.5 is shipped with multiple language choices in the installation but, other than English (the default), languages for the Site and Administration interfaces need to be added after installation. Links to such language packs exist below.</p>','<p>Translation Teams for Joomla! 1.5 may have also released fully localised installation packages where site, administrator and sample data are in the local language. These localised releases can be found in the specific team projects on the <a href=\"http://extensions.joomla.org/component/option,com_mtree/task,listcats/cat_id,1837/Itemid,35/\" target=\"_blank\" title=\"JED\">Joomla! Extensions Directory</a>.</p><h4>How do I install language packs?</h4><ul><li>First download both the admin and the site language packs that you require.</li><li>Install each pack separately using the Extensions-&gt;Install/Uninstall Menu selection and then the package file upload facility.</li><li>Go to the Language Manager and be sure to select Site or Admin in the sub-menu. Then select the appropriate language and make it the default one using the Toolbar button.</li></ul><h4>How do I select languages?</h4><ul><li>Default languages can be independently set for Site and for Administrator</li><li>In addition, users can define their preferred language for each Site and Administrator. This takes affect after logging in.</li><li>While logging in to the Administrator Back-end, a language can also be selected for the particular session.</li></ul><h4>Where can I find Language Packs and Localised Releases?</h4><p><em>Please note that Joomla! 1.5 is new and language packs for this version may have not been released at this time.</em> </p><ul><li><a href=\"http://joomlacode.org/gf/project/jtranslation/\" target=\"_blank\" title=\"Accredited Translations\">The Joomla! Accredited Translations Project</a>  - This is a joint repository for language packs that were developed by teams that are members of the Joomla! Translations Working Group.</li><li><a href=\"http://extensions.joomla.org/component/option,com_mtree/task,listcats/cat_id,1837/Itemid,35/\" target=\"_blank\" title=\"Translations\">The Joomla! Extensions Site - Translations</a>  </li><li><a href=\"http://community.joomla.org/translations.html\" target=\"_blank\" title=\"Translation Work Group Teams\">List of Translation Teams and Translation Partner Sites for Joomla! 1.5</a> </li></ul>',1,0,0,14,'2008-07-30 14:06:37',62,'','2008-07-30 14:06:37',62,0,'0000-00-00 00:00:00','2006-09-29 10:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',9,0,5,'','',1,10,'',0,'*',''),
	(11,61,'How do I upgrade to Joomla! 1.5 ?','how-do-i-upgrade-to-joomla-15-','','<p>Joomla! 1.5 does not provide an upgrade path from earlier versions. Converting an older site to a Joomla! 1.5 site requires creation of a new empty site using Joomla! 1.5 and then populating the new site with the content from the old site. This migration of content is not a one-to-one process and involves conversions and modifications to the content dump.</p> <p>There are two ways to perform the migration:</p>',' <div id=\"post_content-107\"><li>An automated method of migration has been provided which uses a migrator Component to create the migration dump out of the old site (Mambo 4.5.x up to Joomla! 1.0.x) and a smart import facility in the Joomla! 1.5 Installation that performs required conversions and modifications during the installation process.</li> <li>Migration can be performed manually. This involves exporting the required tables, manually performing required conversions and modifications and then importing the content to the new site after it is installed.</li>  <p><!--more--></p> <h2><strong> Automated migration</strong></h2>  <p>This is a two phased process using two tools. The first tool is a migration Component named <font face=\"courier new,courier\">com_migrator</font>. This Component has been contributed by Harald Baer and is based on his <strong>eBackup </strong>Component. The migrator needs to be installed on the old site and when activated it prepares the required export dump of the old site\'s data. The second tool is built into the Joomla! 1.5 installation process. The exported content dump is loaded to the new site and all conversions and modification are performed on-the-fly.</p> <h3><u> Step 1 - Using com_migrator to export data from old site:</u></h3> <li>Install the <font face=\"courier new,courier\">com_migrator</font> Component on the <u><strong>old</strong></u> site. It can be found at the <a href=\"http://joomlacode.org/gf/project/pasamioprojects/frs/\" target=\"_blank\" title=\"JoomlaCode\">JoomlaCode developers forge</a>.</li> <li>Select the Component in the Component Menu of the Control Panel.</li> <li>Click on the <strong>Dump it</strong> icon. Three exported <em>gzipped </em>export scripts will be created. The first is a complete backup of the old site. The second is the migration content of all core elements which will be imported to the new site. The third is a backup of all 3PD Component tables.</li> <li>Click on the download icon of the particular exports files needed and store locally.</li> <li>Multiple export sets can be created.</li> <li>The exported data is not modified in anyway and the original encoding is preserved. This makes the <font face=\"courier new,courier\">com_migrator</font> tool a recommended tool to use for manual migration as well.</li> <h3><u> Step 2 - Using the migration facility to import and convert data during Joomla! 1.5 installation:</u></h3><p>Note: This function requires the use of the <em><font face=\"courier new,courier\">iconv </font></em>function in PHP to convert encodings. If <em><font face=\"courier new,courier\">iconv </font></em>is not found a warning will be provided.</p> <li>In step 6 - Configuration select the \'Load Migration Script\' option in the \'Load Sample Data, Restore or Migrate Backed Up Content\' section of the page.</li> <li>Enter the table prefix used in the content dump. For example: \'#__\' or \'site2_\' are acceptable values.</li> <li>Select the encoding of the dumped content in the dropdown list. This should be the encoding used on the pages of the old site. (As defined in the _ISO variable in the language file or as seen in the browser page info/encoding/source)</li> <li>Browse the local host and select the migration export and click on <strong>Upload and Execute</strong></li> <li>A success message should appear or alternately a listing of database errors</li> <li>Complete the other required fields in the Configuration step such as Site Name and Admin details and advance to the final step of installation. (Admin details will be ignored as the imported data will take priority. Please remember admin name and password from the old site)</li> <p><u><br /></u></p></div>',1,0,0,12,'2008-07-30 20:27:52',62,'','2008-07-30 20:27:52',62,0,'0000-00-00 00:00:00','2006-09-29 12:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',10,0,3,'','',1,14,'',0,'*',''),
	(12,62,'Why does Joomla! 1.5 use UTF-8 encoding?','why-does-joomla-15-use-utf-8-encoding','','<p>Well... how about never needing to mess with encoding settings again?</p><p>Ever needed to display several languages on one page or site and something always came up in Giberish?</p><p>With utf-8 (a variant of Unicode) glyphs (character forms) of basically all languages can be displayed with one single encoding setting. </p>','',1,0,0,13,'2008-08-05 01:11:29',62,'','2008-08-05 01:11:29',62,0,'0000-00-00 00:00:00','2006-10-03 10:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',8,0,8,'','',1,29,'',0,'*',''),
	(13,63,'What happened to the locale setting?','what-happened-to-the-locale-setting','','This is now defined in the Language [<em>lang</em>].xml file in the Language metadata settings. If you are having locale problems such as dates do not appear in your language for example, you might want to check/edit the entries in the locale tag. Note that multiple locale strings can be set and the host will usually accept the first one recognised.','',1,0,0,12,'2008-08-06 16:47:35',62,'','2008-08-06 16:47:35',62,0,'0000-00-00 00:00:00','2006-10-05 14:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',7,0,2,'','',1,11,'',0,'*',''),
	(14,64,'What is the FTP layer for?','what-is-the-ftp-layer-for','','<p>The FTP Layer allows file operations (such as installing Extensions or updating the main configuration file) without having to make all the folders and files writable. This has been an issue on Linux and other Unix based platforms in respect of file permissions. This makes the site admin\'s life a lot easier and increases security of the site.</p><p>You can check the write status of relevent folders by going to \'\'Help-&gt;System Info\" and then in the sub-menu to \"Directory Permissions\". With the FTP Layer enabled even if all directories are red, Joomla! will operate smoothly.</p><p>NOTE: the FTP layer is not required on a Windows host/server. </p>','',1,0,0,13,'2008-08-06 21:27:49',62,'','2008-08-06 21:27:49',62,0,'0000-00-00 00:00:00','2006-10-05 16:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\"}',6,0,6,'','',1,23,'',0,'*',''),
	(15,65,'Can Joomla! 1.5 operate with PHP Safe Mode On?','can-joomla-15-operate-with-php-safe-mode-on','','<p>Yes it can! This is a significant security improvement.</p><p>The <em>safe mode</em> limits PHP to be able to perform actions only on files/folders who\'s owner is the same as PHP is currently using (this is usually \'apache\'). As files normally are created either by the Joomla! application or by FTP access, the combination of PHP file actions and the FTP Layer allows Joomla! to operate in PHP Safe Mode.</p>','',1,0,0,13,'2008-08-06 19:28:35',62,'','2008-08-06 19:28:35',62,0,'0000-00-00 00:00:00','2006-10-05 14:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',7,0,4,'','',1,8,'',0,'*',''),
	(16,66,'Only one edit window! How do I create \"Read more...\"?','only-one-edit-window-how-do-i-create-qread-moreq','','<p>This is now implemented by inserting a <strong>Read more...</strong> tag (the button is located below the editor area) a dotted line appears in the edited text showing the split location for the <em>Read more....</em> A new Plugin takes care of the rest.</p><p>It is worth mentioning that this does not have a negative effect on migrated data from older sites. The new implementation is fully backward compatible.</p>','',1,0,0,12,'2008-08-06 19:29:28',62,'','2008-08-06 19:29:28',62,0,'0000-00-00 00:00:00','2006-10-05 14:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',7,0,4,'','',1,20,'',0,'*',''),
	(17,67,'My MySQL database does not support UTF-8. Do I have a problem?','my-mysql-database-does-not-support-utf-8-do-i-have-a-problem','','No you don\'t. Versions of MySQL lower than 4.1 do not have built in UTF-8 support. However, Joomla! 1.5 has made provisions for backward compatibility and is able to use UTF-8 on older databases. Let the installer take care of all the settings and there is no need to make any changes to the database (charset, collation, or any other).','',1,0,0,13,'2008-08-07 09:30:37',62,'','2008-08-07 09:30:37',62,0,'0000-00-00 00:00:00','2006-10-05 20:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',10,0,7,'','',1,9,'',0,'*',''),
	(18,68,'Joomla! Features','joomla-features','','<h4><font color=\"#ff6600\">Joomla! features:</font></h4> <ul><li>Completely database driven site engines </li><li>News, products, or services sections fully editable and manageable</li><li>Topics sections can be added to by contributing Authors </li><li>Fully customisable layouts including <em>left</em>, <em>center</em>, and <em>right </em>Menu boxes </li><li>Browser upload of images to your own library for use anywhere in the site </li><li>Dynamic Forum/Poll/Voting booth for on-the-spot results </li><li>Runs on Linux, FreeBSD, MacOSX server, Solaris, and AIX','  </li></ul> <h4>Extensive Administration:</h4> <ul><li>Change order of objects including news, FAQs, Articles etc. </li><li>Random Newsflash generator </li><li>Remote Author submission Module for News, Articles, FAQs, and Links </li><li>Object hierarchy - as many Sections, departments, divisions, and pages as you want </li><li>Image library - store all your PNGs, PDFs, DOCs, XLSs, GIFs, and JPEGs online for easy use </li><li>Automatic Path-Finder. Place a picture and let Joomla! fix the link </li><li>News Feed Manager. Easily integrate news feeds into your Web site.</li><li>E-mail a friend and Print format available for every story and Article </li><li>In-line Text editor similar to any basic word processor software </li><li>User editable look and feel </li><li>Polls/Surveys - Now put a different one on each page </li><li>Custom Page Modules. Download custom page Modules to spice up your site </li><li>Template Manager. Download Templates and implement them in seconds </li><li>Layout preview. See how it looks before going live </li><li>Banner Manager. Make money out of your site.</li></ul>',1,0,0,18,'2008-08-08 23:32:45',62,'','2008-08-08 23:32:45',62,0,'0000-00-00 00:00:00','2006-10-07 06:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',11,0,4,'','',1,59,'',0,'*',''),
	(19,69,'Joomla! Overview','joomla-overview','','<p>If you\'re new to Web publishing systems, you\'ll find that Joomla! delivers sophisticated solutions to your online needs. It can deliver a robust enterprise-level Web site, empowered by endless extensibility for your bespoke publishing needs. Moreover, it is often the system of choice for small business or home users who want a professional looking site that\'s simple to deploy and use. <em>We do content right</em>.<br /> </p><p>So what\'s the catch? How much does this system cost?</p><p> Well, there\'s good news ... and more good news! Joomla! 1.5 is free, it is released under an Open Source license - the GNU/General Public License v 2.0. Had you invested in a mainstream, commercial alternative, there\'d be nothing but moths left in your wallet and to add new functionality would probably mean taking out a second mortgage each time you wanted something adding!</p><p>Joomla! changes all that ... <br />Joomla! is different from the normal models for content management software. For a start, it\'s not complicated. Joomla! has been developed for everybody, and anybody can develop it further. It is designed to work (primarily) with other Open Source, free, software such as PHP, MySQL, and Apache. </p><p>It is easy to install and administer, and is reliable. </p><p>Joomla! doesn\'t even require the user or administrator of the system to know HTML to operate it once it\'s up and running.</p><p>To get the perfect Web site with all the functionality that you require for your particular application may take additional time and effort, but with the Joomla! Community support that is available and the many Third Party Developers actively creating and releasing new Extensions for the 1.5 platform on an almost daily basis, there is likely to be something out there to meet your needs. Or you could develop your own Extensions and make these available to the rest of the community. </p>','',1,0,0,18,'2008-08-09 07:49:20',62,'','2008-08-09 07:49:20',62,0,'0000-00-00 00:00:00','2006-10-07 10:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',13,0,2,'','',1,167,'',0,'*',''),
	(20,70,'Support and Documentation','support-and-documentation','','<h1>Support </h1><p>Support for the Joomla! CMS can be found on several places. The best place to start would be the <a href=\"http://docs.joomla.org/\" target=\"_blank\" title=\"Joomla! Official Documentation Wiki\">Joomla! Official Documentation Wiki</a>. Here you can help yourself to the information that is regularly published and updated as Joomla! develops. There is much more to come too!</p> <p>Of course you should not forget the Help System of the CMS itself. On the <em>topmenu </em>in the Back-end Control panel you find the Help button which will provide you with lots of explanation on features.</p> <p>Another great place would of course be the <a href=\"http://forum.joomla.org/\" target=\"_blank\" title=\"Forum\">Forum</a> . On the Joomla! Forum you can find help and support from Community members as well as from Joomla! Core members and Working Group members. The forum contains a lot of information, FAQ\'s, just about anything you are looking for in terms of support.</p> <p>Two other resources for Support are the <a href=\"http://developer.joomla.org/\" target=\"_blank\" title=\"Joomla! Developer Site\">Joomla! Developer Site</a> and the <a href=\"http://extensions.joomla.org/\" target=\"_blank\" title=\"Joomla! Extensions Directory\">Joomla! Extensions Directory</a> (JED). The Joomla! Developer Site provides lots of technical information for the experienced Developer as well as those new to Joomla! and development work in general. The JED whilst not a support site in the strictest sense has many of the Extensions that you will need as you develop your own Web site.</p> <p>The Joomla! Developers and Bug Squad members are regularly posting their blog reports about several topics such as programming techniques and security issues.</p> <h1>Documentation</h1> <p>Joomla! Documentation can of course be found on the <a href=\"http://docs.joomla.org/\" target=\"_blank\" title=\"Joomla! Official Documentation Wiki\">Joomla! Official Documentation Wiki</a>. You can find information for beginners, installation, upgrade, Frequently Asked Questions, developer topics, and a lot more. The Documentation Team helps oversee the wiki but you are invited to contribute content, as well.</p> <p>There are also books written about Joomla! You can find a listing of these books in the <a href=\"http://shop.joomla.org/\" target=\"_blank\" title=\"Joomla! Shop\">Joomla! Shop</a>.</p>','',1,0,0,17,'2008-08-09 08:33:57',62,'','2008-08-09 08:33:57',62,0,'0000-00-00 00:00:00','2006-10-07 10:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',13,0,1,'','',1,6,'',0,'*',''),
	(21,71,'Joomla! Facts','joomla-facts','','<p>Here are some interesting facts about Joomla!</p><ul><li><span>Over 210,000 active registered Users on the <a href=\"http://forum.joomla.org\" target=\"_blank\" title=\"Joomla Forums\">Official Joomla! community forum</a> and more on the many international community sites.</span><ul><li><span>over 1,000,000 posts in over 200,000 topics</span></li><li>over 1,200 posts per day</li><li>growing at 150 new participants each day!</li></ul></li><li><span>1168 Projects on the JoomlaCode (<a href=\"http://joomlacode.org/\" target=\"_blank\" title=\"JoomlaCode\">joomlacode.org</a> ). All for open source addons by third party developers.</span><ul><li><span>Well over 6,000,000 downloads of Joomla! since the migration to JoomlaCode in March 2007.<br /></span></li></ul></li><li><span>Nearly 4,000 extensions for Joomla! have been registered on the <a href=\"http://extensions.joomla.org\" target=\"_blank\" title=\"http://extensions.joomla.org\">Joomla! Extension Directory</a>  </span></li><li><span>Joomla.org exceeds 2 TB of traffic per month!</span></li></ul>','',1,0,0,19,'2008-08-09 16:46:37',62,'','2008-08-09 16:46:37',62,0,'0000-00-00 00:00:00','2006-10-07 14:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',13,0,1,'','',1,50,'',0,'*',''),
	(22,72,'What\'s New in 1.5?','whats-new-in-15','','<p>As with previous releases, Joomla! provides a unified and easy-to-use framework for delivering content for Web sites of all kinds. To support the changing nature of the Internet and emerging Web technologies, Joomla! required substantial restructuring of its core functionality and we also used this effort to simplify many challenges within the current user interface. Joomla! 1.5 has many new features.</p>','<p style=\"margin-bottom: 0in\">In Joomla! 1.5, you\'ll notice: </p>    <ul><li>     <p style=\"margin-bottom: 0in\">       Substantially improved usability, manageability, and scalability far beyond the original Mambo foundations</p>   </li><li>     <p style=\"margin-bottom: 0in\"> Expanded accessibility to support internationalisation, double-byte characters and right-to-left support for Arabic, Farsi, and Hebrew languages among others</p>   </li><li>     <p style=\"margin-bottom: 0in\"> Extended integration of external applications through Web services and remote authentication such as the Lightweight Directory Access Protocol (LDAP)</p>   </li><li>     <p style=\"margin-bottom: 0in\"> Enhanced content delivery, template and presentation capabilities to support accessibility standards and content delivery to any destination</p>   </li><li>     <p style=\"margin-bottom: 0in\">       A more sustainable and flexible framework for Component and Extension developers</p>   </li><li>     <p style=\"margin-bottom: 0in\">Backward compatibility with previous releases of Components, Templates, Modules, and other Extensions</p></li></ul>',1,0,0,18,'2008-08-11 22:13:58',62,'','2008-08-11 22:13:58',62,0,'0000-00-00 00:00:00','2006-10-10 18:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',10,0,1,'','',1,99,'',0,'*',''),
	(23,73,'Platforms and Open Standards','platforms-and-open-standards','','<p class=\"MsoNormal\">Joomla! runs on any platform including Windows, most flavours of Linux, several Unix versions, and the Apple OS/X platform.  Joomla! depends on PHP and the MySQL database to deliver dynamic content.  </p>            <p class=\"MsoNormal\">The minimum requirements are:</p>      <ul><li>Apache 1.x, 2.x and higher</li><li>PHP 4.3 and higher</li><li>MySQL 3.23 and higher</li></ul>It will also run on alternative server platforms such as Windows IIS - provided they support PHP and MySQL - but these require additional configuration in order for the Joomla! core package to be successful installed and operated.','',1,0,0,17,'2008-08-11 04:22:14',62,'','2008-08-11 04:22:14',62,0,'0000-00-00 00:00:00','2006-10-10 08:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',7,0,3,'','',1,11,'',0,'*',''),
	(24,74,'Content Layouts','content-layouts','','<p>Joomla! provides plenty of flexibility when displaying your Web content. Whether you are using Joomla! for a blog site, news or a Web site for a company, you\'ll find one or more content styles to showcase your information. You can also change the style of content dynamically depending on your preferences. Joomla! calls how a page is laid out a <strong>layout</strong>. Use the guide below to understand which layouts are available and how you might use them. </p> <h2>Content </h2> <p>Joomla! makes it extremely easy to add and display content. All content  is placed where your mainbody tag in your template is located. There are three main types of layouts available in Joomla! and all of them can be customised via parameters. The display and parameters are set in the Menu Item used to display the content your working on. You create these layouts by creating a Menu Item and choosing how you want the content to display.</p> <h3>Blog Layout<br /> </h3> <p>Blog layout will show a listing of all Articles of the selected blog type (Section or Category) in the mainbody position of your template. It will give you the standard title, and Intro of each Article in that particular Category and/or Section. You can customise this layout via the use of the Preferences and Parameters, (See Article Parameters) this is done from the Menu not the Section Manager!</p> <h3>Blog Archive Layout<br /> </h3> <p>A Blog Archive layout will give you a similar output of Articles as the normal Blog Display but will add, at the top, two drop down lists for month and year plus a search button to allow Users to search for all Archived Articles from a specific month and year.</p> <h3>List Layout<br /> </h3> <p>Table layout will simply give you a <em>tabular </em>list<em> </em>of all the titles in that particular Section or Category. No Intro text will be displayed just the titles. You can set how many titles will be displayed in this table by Parameters. The table layout will also provide a filter Section so that Users can reorder, filter, and set how many titles are listed on a single page (up to 50)</p> <h2>Wrapper</h2> <p>Wrappers allow you to place stand alone applications and Third Party Web sites inside your Joomla! site. The content within a Wrapper appears within the primary content area defined by the \"mainbody\" tag and allows you to display their content as a part of your own site. A Wrapper will place an IFRAME into the content Section of your Web site and wrap your standard template navigation around it so it appears in the same way an Article would.</p> <h2>Content Parameters</h2> <p>The parameters for each layout type can be found on the right hand side of the editor boxes in the Menu Item configuration screen. The parameters available depend largely on what kind of layout you are configuring.</p>','',1,0,0,18,'2008-08-12 22:33:10',62,'','2008-08-12 22:33:10',62,0,'0000-00-00 00:00:00','2006-10-11 06:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',11,0,5,'','',1,70,'',0,'*',''),
	(25,75,'What are the requirements to run Joomla! 1.5?','what-are-the-requirements-to-run-joomla-15','','<p>Joomla! runs on the PHP pre-processor. PHP comes in many flavours, for a lot of operating systems. Beside PHP you will need a Web server. Joomla! is optimized for the Apache Web server, but it can run on different Web servers like Microsoft IIS it just requires additional configuration of PHP and MySQL. Joomla! also depends on a database, for this currently you can only use MySQL. </p>Many people know from their own experience that it\'s not easy to install an Apache Web server and it gets harder if you want to add MySQL, PHP and Perl. XAMPP, WAMP, and MAMP are easy to install distributions containing Apache, MySQL, PHP and Perl for the Windows, Mac OSX and Linux operating systems. These packages are for localhost installations on non-public servers only.<br />The minimum version requirements are:<br /><ul><li>Apache 1.x or 2.x</li><li>PHP 4.3 or up</li><li>MySQL 3.23 or up</li></ul>For the latest minimum requirements details, see <a href=\"http://www.joomla.org/about-joomla/technical-requirements.html\" target=\"_blank\" title=\"Joomla! Technical Requirements\">Joomla! Technical Requirements</a>.','',1,0,0,13,'2008-08-11 00:42:31',62,'','2008-08-11 00:42:31',62,0,'0000-00-00 00:00:00','2006-10-10 06:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',6,0,5,'','',1,26,'',0,'*',''),
	(26,76,'Extensions','extensions','','<p>Out of the box, Joomla! does a great job of managing the content needed to make your Web site sing. But for many people, the true power of Joomla! lies in the application framework that makes it possible for developers all around the world to create powerful add-ons that are called <strong>Extensions</strong>. An Extension is used to add capabilities to Joomla! that do not exist in the base core code. Here are just some examples of the hundreds of available Extensions:</p> <ul>   <li>Dynamic form builders</li>   <li>Business or organisational directories</li>   <li>Document management</li>   <li>Image and multimedia galleries</li>   <li>E-commerce and shopping cart engines</li>   <li>Forums and chat software</li>   <li>Calendars</li>   <li>E-mail newsletters</li>   <li>Data collection and reporting tools</li>   <li>Banner advertising systems</li>   <li>Paid subscription services</li>   <li>and many, many, more</li> </ul> <p>You can find more examples over at our ever growing <a href=\"http://extensions.joomla.org\" target=\"_blank\" title=\"Joomla! Extensions Directory\">Joomla! Extensions Directory</a>. Prepare to be amazed at the amount of exciting work produced by our active developer community!</p><p>A useful guide to the Extension site can be found at:<br /><a href=\"http://extensions.joomla.org/content/view/15/63/\" target=\"_blank\" title=\"Guide to the Joomla! Extension site\">http://extensions.joomla.org/content/view/15/63/</a> </p> <h3>Types of Extensions </h3><p>There are five types of extensions:</p> <ul>   <li>Components</li>   <li>Modules</li>   <li>Templates</li>   <li>Plugins</li>   <li>Languages</li> </ul> <p>You can read more about the specifics of these using the links in the Article Index - a Table of Contents (yet another useful feature of Joomla!) - at the top right or by clicking on the <strong>Next </strong>link below.<br /> </p> <hr title=\"Components\" class=\"system-pagebreak\" /> <h3><img src=\"images/stories/ext_com.png\" border=\"0\" alt=\"Component - Joomla! Extension Directory\" title=\"Component - Joomla! Extension Directory\" width=\"17\" height=\"17\" /> Components</h3> <p>A Component is the largest and most complex of the Extension types.  Components are like mini-applications that render the main body of the  page. An analogy that might make the relationship easier to understand  would be that Joomla! is a book and all the Components are chapters in  the book. The core Article Component (<font face=\"courier new,courier\">com_content</font>), for example, is the  mini-application that handles all core Article rendering just as the  core registration Component (<font face=\"courier new,courier\">com_user</font>) is the mini-application  that handles User registration.</p> <p>Many of Joomla!\'s core features are provided by the use of default Components such as:</p> <ul>   <li>Contacts</li>   <li>Front Page</li>   <li>News Feeds</li>   <li>Banners</li>   <li>Mass Mail</li>   <li>Polls</li></ul><p>A Component will manage data, set displays, provide functions, and in general can perform any operation that does not fall under the general functions of the core code.</p> <p>Components work hand in hand with Modules and Plugins to provide a rich variety of content display and functionality aside from the standard Article and content display. They make it possible to completely transform Joomla! and greatly expand its capabilities.</p>  <hr title=\"Modules\" class=\"system-pagebreak\" /> <h3><img src=\"images/stories/ext_mod.png\" border=\"0\" alt=\"Module - Joomla! Extension Directory\" title=\"Module - Joomla! Extension Directory\" width=\"17\" height=\"17\" /> Modules</h3> <p>A more lightweight and flexible Extension used for page rendering is a Module. Modules are used for small bits of the page that are generally  less complex and able to be seen across different Components. To  continue in our book analogy, a Module can be looked at as a footnote  or header block, or perhaps an image/caption block that can be rendered  on a particular page. Obviously you can have a footnote on any page but  not all pages will have them. Footnotes also might appear regardless of  which chapter you are reading. Simlarly Modules can be rendered  regardless of which Component you have loaded.</p> <p>Modules are like little mini-applets that can be placed anywhere on your site. They work in conjunction with Components in some cases and in others are complete stand alone snippets of code used to display some data from the database such as Articles (Newsflash) Modules are usually used to output data but they can also be interactive form items to input data for example the Login Module or Polls.</p> <p>Modules can be assigned to Module positions which are defined in your Template and in the back-end using the Module Manager and editing the Module Position settings. For example, \"left\" and \"right\" are common for a 3 column layout. </p> <h4>Displaying Modules</h4> <p>Each Module is assigned to a Module position on your site. If you wish it to display in two different locations you must copy the Module and assign the copy to display at the new location. You can also set which Menu Items (and thus pages) a Module will display on, you can select all Menu Items or you can pick and choose by holding down the control key and selecting multiple locations one by one in the Modules [Edit] screen</p> <p>Note: Your Main Menu is a Module! When you create a new Menu in the Menu Manager you are actually copying the Main Menu Module (<font face=\"courier new,courier\">mod_mainmenu</font>) code and giving it the name of your new Menu. When you copy a Module you do not copy all of its parameters, you simply allow Joomla! to use the same code with two separate settings.</p> <h4>Newsflash Example</h4> <p>Newsflash is a Module which will display Articles from your site in an assignable Module position. It can be used and configured to display one Category, all Categories, or to randomly choose Articles to highlight to Users. It will display as much of an Article as you set, and will show a <em>Read more...</em> link to take the User to the full Article.</p> <p>The Newsflash Component is particularly useful for things like Site News or to show the latest Article added to your Web site.</p>  <hr title=\"Plugins\" class=\"system-pagebreak\" /> <h3><img src=\"images/stories/ext_plugin.png\" border=\"0\" alt=\"Plugin - Joomla! Extension Directory\" title=\"Plugin - Joomla! Extension Directory\" width=\"17\" height=\"17\" /> Plugins</h3> <p>One  of the more advanced Extensions for Joomla! is the Plugin. In previous  versions of Joomla! Plugins were known as Mambots. Aside from changing their name their  functionality has been expanded. A Plugin is a section of code that  runs when a pre-defined event happens within Joomla!. Editors are Plugins, for example, that execute when the Joomla! event <font face=\"courier new,courier\">onGetEditorArea</font> occurs. Using a Plugin allows a developer to change  the way their code behaves depending upon which Plugins are installed  to react to an event.</p>  <hr title=\"Languages\" class=\"system-pagebreak\" /> <h3><img src=\"images/stories/ext_lang.png\" border=\"0\" alt=\"Language - Joomla! Extensions Directory\" title=\"Language - Joomla! Extensions Directory\" width=\"17\" height=\"17\" /> Languages</h3> <p>New  to Joomla! 1.5 and perhaps the most basic and critical Extension is a Language. Joomla! is released with multiple Installation Languages but the base Site and Administrator are packaged in just the one Language <strong>en-GB</strong> - being English with GB spelling for example. To include all the translations currently available would bloat the core package and make it unmanageable for uploading purposes. The Language files enable all the User interfaces both Front-end and Back-end to be presented in the local preferred language. Note these packs do not have any impact on the actual content such as Articles. </p> <p>More information on languages is available from the <br />   <a href=\"http://community.joomla.org/translations.html\" target=\"_blank\" title=\"Joomla! Translation Teams\">http://community.joomla.org/translations.html</a></p>','',1,0,0,18,'2008-08-11 06:00:00',62,'','2008-08-11 06:00:00',62,0,'0000-00-00 00:00:00','2006-10-10 22:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',24,0,3,'About Joomla!, General, Extensions','',1,139,'',0,'*',''),
	(27,77,'The Joomla! Community','the-joomla-community','','<p><strong>Got a question? </strong>With more than 210,000 members, the Joomla! Discussion Forums at <a href=\"http://forum.joomla.org/\" target=\"_blank\" title=\"Forums\">forum.joomla.org</a> are a great resource for both new and experienced users. Ask your toughest questions the community is waiting to see what you\'ll do with your Joomla! site.</p><p><strong>Do you want to show off your new Joomla! Web site?</strong> Visit the <a href=\"http://forum.joomla.org/viewforum.php?f=514\" target=\"_blank\" title=\"Site Showcase\">Site Showcase</a> section of our forum.</p><p><strong>Do you want to contribute?</strong></p><p>If you think working with Joomla is fun, wait until you start working on it. We\'re passionate about helping Joomla users become contributors. There are many ways you can help Joomla\'s development:</p><ul>	<li>Submit news about Joomla. We syndicate Joomla-related news on <a href=\"http://news.joomla.org\" target=\"_blank\" title=\"JoomlaConnect\">JoomlaConnect<sup>TM</sup></a>. If you have Joomla news that you would like to share with the community, find out how to get connected <a href=\"http://community.joomla.org/connect.html\" target=\"_blank\" title=\"JoomlaConnect\">here</a>.</li>	<li>Report bugs and request features in our <a href=\"http://joomlacode.org/gf/project/joomla/tracker/\" target=\"_blank\" title=\"Joomla! developement trackers\">trackers</a>. Please read <a href=\"http://docs.joomla.org/Filing_bugs_and_issues\" target=\"_blank\" title=\"Reporting Bugs\">Reporting Bugs</a>, for details on how we like our bug reports served up</li><li>Submit patches for new and/or fixed behaviour. Please read <a href=\"http://docs.joomla.org/Patch_submission_guidelines\" target=\"_blank\" title=\"Submitting Patches\">Submitting Patches</a>, for details on how to submit a patch.</li><li>Join the <a href=\"http://forum.joomla.org/viewforum.php?f=509\" target=\"_blank\" title=\"Joomla! development forums\">developer forums</a> and share your ideas for how to improve Joomla. We\'re always open to suggestions, although we\'re likely to be sceptical of large-scale suggestions without some code to back it up.</li><li>Join any of the <a href=\"http://www.joomla.org/about-joomla/the-project/working-groups.html\" target=\"_blank\" title=\"Joomla! working groups\">Joomla Working Groups</a> and bring your personal expertise to the Joomla community. </li></ul><p>These are just a few ways you can contribute. See <a href=\"http://www.joomla.org/about-joomla/contribute-to-joomla.html\" target=\"_blank\" title=\"Contribute\">Contribute to Joomla</a> for many more ways.</p>','',1,0,0,19,'2008-08-12 16:50:48',62,'','2008-08-12 16:50:48',62,0,'0000-00-00 00:00:00','2006-10-11 02:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',12,0,2,'','',1,59,'',0,'*',''),
	(28,78,'How do I install Joomla! 1.5?','how-do-i-install-joomla-15','','<p>Installing of Joomla! 1.5 is pretty easy. We assume you have set-up your Web site, and it is accessible with your browser.<br /><br />Download Joomla! 1.5, unzip it and upload/copy the files into the directory you Web site points to, fire up your browser and enter your Web site address and the installation will start.  </p><p>For full details on the installation processes check out the <a href=\"http://help.joomla.org/content/category/48/268/302\" target=\"_blank\" title=\"Joomla! 1.5 Installation Manual\">Installation Manual</a> on the <a href=\"http://help.joomla.org\" target=\"_blank\" title=\"Joomla! Help Site\">Joomla! Help Site</a> where you will also find download instructions for a PDF version too. </p>','',1,0,0,13,'2008-08-11 01:10:59',62,'','2008-08-11 01:10:59',62,0,'0000-00-00 00:00:00','2006-10-10 06:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',5,0,3,'','',1,7,'',0,'*',''),
	(29,79,'What is the purpose of the collation selection in the installation screen?','what-is-the-purpose-of-the-collation-selection-in-the-installation-screen','','The collation option determines the way ordering in the database is done. In languages that use special characters, for instance the German umlaut, the database collation determines the sorting order. If you don\'t know which collation you need, select the \"utf8_general_ci\" as most languages use this. The other collations listed are exceptions in regards to the general collation. If your language is not listed in the list of collations it most likely means that \"utf8_general_ci is suitable.','',1,0,0,14,'2008-08-11 03:11:38',62,'','2008-08-11 03:11:38',62,0,'0000-00-00 00:00:00','2006-10-10 08:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\"}',4,0,4,'','',1,8,'',0,'*',''),
	(30,80,'What languages are supported by Joomla! 1.5?','what-languages-are-supported-by-joomla-15','','Within the Installer you will find a wide collection of languages. The installer currently supports the following languages: Arabic, Bulgarian, Bengali, Czech, Danish, German, Greek, English, Spanish, Finnish, French, Hebrew, Devanagari(India), Croatian(Croatia), Magyar (Hungary), Italian, Malay, Norwegian bokmal, Dutch, Portuguese(Brasil), Portugues(Portugal), Romanian, Russian, Serbian, Svenska, Thai and more are being added all the time.<br />By default the English language is installed for the Back and Front-ends. You can download additional language files from the <a href=\"http://extensions.joomla.org\" target=\"_blank\" title=\"Joomla! Extensions Directory\">Joomla!Extensions Directory</a>. ','',1,0,0,14,'2008-08-11 01:12:18',62,'','2008-08-11 01:12:18',62,0,'0000-00-00 00:00:00','2006-10-10 06:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',5,0,2,'','',1,8,'',0,'*',''),
	(31,81,'Is it useful to install the sample data?','is-it-useful-to-install-the-sample-data','','Well you are reading it right now! This depends on what you want to achieve. If you are new to Joomla! and have no clue how it all fits together, just install the sample data. If you don\'t like the English sample data because you - for instance - speak Chinese, then leave it out.','',1,0,0,11,'2008-08-11 09:12:55',62,'','2008-08-11 09:12:55',62,0,'0000-00-00 00:00:00','2006-10-10 10:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',6,0,3,'','',1,3,'',0,'*',''),
	(32,82,'Where is the Static Content Item?','where-is-the-static-content-item','','<p>In Joomla! versions prior to 1.5 there were separate processes for creating a Static Content Item and normal Content Items. The processes have been combined now and whilst both content types are still around they are renamed as Articles for Content Items and Uncategorized Articles for Static Content Items. </p><p>If you want to create a static item, create a new Article in the same way as for standard content and rather than relating this to a particular Section and Category just select <span style=\"font-style: italic\">Uncategorized</span> as the option in the Section and Category drop down lists.</p>','',1,0,0,12,'2008-08-10 23:13:33',62,'','2008-08-10 23:13:33',62,0,'0000-00-00 00:00:00','2006-10-10 04:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',6,0,6,'','',1,5,'',0,'*',''),
	(33,83,'What is an Uncategorised Article?','what-is-an-uncategorised-article','','Most Articles will be assigned to a Section and Category. In many cases, you might not know where you want it to appear so put the Article in the <em>Uncategorized </em>Section/Category. The Articles marked as <em>Uncategorized </em>are handled as static content.','',1,0,0,13,'2008-08-11 15:14:11',62,'','2008-08-11 15:14:11',62,0,'0000-00-00 00:00:00','2006-10-10 12:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',8,0,2,'','',1,8,'',0,'*',''),
	(34,84,'Does the PDF icon render pictures and special characters?','does-the-pdf-icon-render-pictures-and-special-characters','','Yes! Prior to Joomla! 1.5, only the text values of an Article and only for ISO-8859-1 encoding was allowed in the PDF rendition. With the new PDF library in place, the complete Article including images is rendered and applied to the PDF. The PDF generator also handles the UTF-8 texts and can handle any character sets from any language. The appropriate fonts must be installed but this is done automatically during a language pack installation.','',1,0,0,14,'2008-08-11 17:14:57',62,'','2008-08-11 17:14:57',62,0,'0000-00-00 00:00:00','2006-10-10 14:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',7,0,3,'','',1,6,'',0,'*',''),
	(35,85,'Is it possible to change A Menu Item\'s Type?','is-it-possible-to-change-a-menu-items-type','','<p>You indeed can change the Menu Item\'s Type to whatever you want, even after they have been created. </p><p>If, for instance, you want to change the Blog Section of a Menu link, go to the Control Panel-&gt;Menus Menu-&gt;[menuname]-&gt;Menu Item Manager and edit the Menu Item. Select the <strong>Change Type</strong> button and choose the new style of Menu Item Type from the available list. Thereafter, alter the Details and Parameters to reconfigure the display for the new selection  as you require it.</p>','',1,0,0,13,'2008-08-10 23:15:36',62,'','2008-08-10 23:15:36',62,0,'0000-00-00 00:00:00','2006-10-10 04:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',6,0,1,'','',1,302,'',0,'*',''),
	(36,86,'Where did the Installers go?','where-did-the-installers-go','','The improved Installer can be found under the Extensions Menu. With versions prior to Joomla! 1.5 you needed to select a specific Extension type when you wanted to install it and use the Installer associated with it, with Joomla! 1.5 you just select the Extension you want to upload, and click on install. The Installer will do all the hard work for you.','',1,0,0,12,'2008-08-10 23:16:20',62,'','2008-08-10 23:16:20',62,0,'0000-00-00 00:00:00','2006-10-10 04:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',6,0,1,'','',1,4,'',0,'*',''),
	(37,87,'Where did the Mambots go?','where-did-the-mambots-go','','<p>Mambots have been renamed as Plugins. </p><p>Mambots were introduced in Mambo and offered possibilities to add plug-in logic to your site mainly for the purpose of manipulating content. In Joomla! 1.5, Plugins will now have much broader capabilities than Mambots. Plugins are able to extend functionality at the framework layer as well.</p>','',1,0,0,12,'2008-08-11 09:17:00',62,'','2008-08-11 09:17:00',62,0,'0000-00-00 00:00:00','2006-10-10 10:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',6,0,5,'','',1,4,'',0,'*',''),
	(38,88,'I installed with my own language, but the Back-end is still in English','i-installed-with-my-own-language-but-the-back-end-is-still-in-english','','<p>A lot of different languages are available for the Back-end, but by default this language may not be installed. If you want a translated Back-end, get your language pack and install it using the Extension Installer. After this, go to the Extensions Menu, select Language Manager and make your language the default one. Your Back-end will be translated immediately.</p><p>Users who have access rights to the Back-end may choose the language they prefer in their Personal Details parameters. This is of also true for the Front-end language.</p><p> A good place to find where to download your languages and localised versions of Joomla! is <a href=\"http://extensions.joomla.org/index.php?option=com_mtree&task=listcats&cat_id=1837&Itemid=35\" target=\"_blank\" title=\"Translations for Joomla!\">Translations for Joomla!</a> on JED.</p>','',1,0,0,14,'2008-08-11 17:18:14',62,'','2008-08-11 17:18:14',62,0,'0000-00-00 00:00:00','2006-10-10 14:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',7,0,1,'','',1,7,'',0,'*',''),
	(39,89,'How do I remove an Article?','how-do-i-remove-an-article','','<p>To completely remove an Article, select the Articles that you want to delete and move them to the Trash. Next, open the Article Trash in the Content Menu and select the Articles you want to delete. After deleting an Article, it is no longer available as it has been deleted from the database and it is not possible to undo this operation.  </p>','',1,0,0,11,'2008-08-11 09:19:01',62,'','2008-08-11 09:19:01',62,0,'0000-00-00 00:00:00','2006-10-10 10:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',6,0,2,'','',1,6,'',0,'*',''),
	(40,90,'What is the difference between Archiving and Trashing an Article? ','what-is-the-difference-between-archiving-and-trashing-an-article','','<p>When you <em>Archive </em>an Article, the content is put into a state which removes it from your site as published content. The Article is still available from within the Control Panel and can be <em>retrieved </em>for editing or republishing purposes. Trashed Articles are just one step from being permanently deleted but are still available until you Remove them from the Trash Manager. You should use Archive if you consider an Article important, but not current. Trash should be used when you want to delete the content entirely from your site and from future search results.  </p>','',1,0,0,11,'2008-08-11 05:19:43',62,'','2008-08-11 05:19:43',62,0,'0000-00-00 00:00:00','2006-10-10 06:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',8,0,1,'','',1,5,'',0,'*',''),
	(41,91,'Newsflash 5','newsflash-5','','Joomla! 1.5 - \'Experience the Freedom\'!. It has never been easier to create your own dynamic Web site. Manage all your content from the best CMS admin interface and in virtually any language you speak.','',1,0,0,9,'2008-08-12 00:17:31',62,'','2008-08-12 00:17:31',62,0,'0000-00-00 00:00:00','2006-10-11 06:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',5,0,2,'','',1,4,'',0,'*',''),
	(42,92,'Newsflash 4','newsflash-4','','Yesterday all servers in the U.S. went out on strike in a bid to get more RAM and better CPUs. A spokes person said that the need for better RAM was due to some fool increasing the front-side bus speed. In future, buses will be told to slow down in residential motherboards.','',1,0,0,9,'2008-08-12 00:25:50',62,'','2008-08-12 00:25:50',62,0,'0000-00-00 00:00:00','2006-10-11 06:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',5,0,1,'','',1,5,'',0,'*',''),
	(43,93,'Example Pages and Menu Links','example-pages-and-menu-links','','<h4>This page is an example of content that is <em>Uncategorized</em>; that is, it does not belong to any Section or Category. You will see there is a new Menu in the left column. It shows links to the same content presented in 4 different page layouts.</h4>\r\n<ul>\r\n<li>Section Blog</li>\r\n<li>Section Table</li>\r\n<li> Blog Category</li>\r\n<li>Category Table</li>\r\n</ul>\r\n<p>Follow the links in the <strong>Example Pages</strong> Menu to see some of the options available to you to present all the different types of content included within the default installation of Joomla!.</p>\r\n<p>This includes Components and individual Articles. These links or Menu Item Types (to give them their proper name) are all controlled from within the <strong><span style=\"font-family: \'courier new\', courier;\">Menu Manager-&gt;[menuname]-&gt;Menu Items Manager</span></strong>.</p>','',1,0,0,2,'2008-08-12 09:26:52',62,'','2010-06-23 04:53:56',62,0,'0000-00-00 00:00:00','2006-10-11 10:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',11,0,1,'Uncategorized, Uncategorized, Example Pages and Menu Links','',1,56,'',0,'*',''),
	(44,94,'Joomla! Security Strike Team','joomla-security-strike-team','','<p>The Joomla! Project has assembled a top-notch team of experts to form the new Joomla! Security Strike Team. This new team will solely focus on investigating and resolving security issues. Instead of working in relative secrecy, the JSST will have a strong public-facing presence at the <a href=\"http://developer.joomla.org/security.html\" target=\"_blank\" title=\"Joomla! Security Center\">Joomla! Security Center</a>.</p>','<p>The new JSST will call the new <a href=\"http://developer.joomla.org/security.html\" target=\"_blank\" title=\"Joomla! Security Center\">Joomla! Security Center</a> their home base. The Security Center provides a public presence for <a href=\"http://developer.joomla.org/security/news.html\" target=\"_blank\" title=\"Joomla! Security News\">security issues</a> and a platform for the JSST to <a href=\"http://developer.joomla.org/security/articles-tutorials.html\" target=\"_blank\" title=\"Joomla! Security Articles\">help the general public better understand security</a> and how it relates to Joomla!. The Security Center also offers users a clearer understanding of how security issues are handled. There\'s also a <a href=\"http://feeds.joomla.org/JoomlaSecurityNews\" target=\"_blank\" title=\"Joomla! Security News Feed\">news feed</a>, which provides subscribers an up-to-the-minute notification of security issues as they arise.</p>',1,0,0,8,'2007-07-07 09:54:06',62,'','2007-07-07 09:54:06',62,0,'0000-00-00 00:00:00','2004-07-06 22:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',1,0,3,'','',1,0,'',0,'*',''),
	(45,95,'Joomla! Community Portal','joomla-community-portal','','<p>The <a href=\"http://community.joomla.org/\" target=\"_blank\" title=\"Joomla! Community Portal\">Joomla! Community Portal</a> is now online. There, you will find a constant source of information about the activities of contributors powering the Joomla! Project. Learn about <a href=\"http://community.joomla.org/events.html\" target=\"_blank\" title=\"Joomla! Events\">Joomla! Events</a> worldwide, and see if there is a <a href=\"http://community.joomla.org/user-groups.html\" target=\"_blank\" title=\"Joomla! User Groups\">Joomla! User Group</a> nearby.</p><p>The <a href=\"http://community.joomla.org/magazine.html\" target=\"_blank\" title=\"Joomla! Community Magazine\">Joomla! Community Magazine</a> promises an interesting overview of feature articles, community accomplishments, learning topics, and project updates each month. Also, check out <a href=\"http://community.joomla.org/connect.html\" target=\"_blank\" title=\"JoomlaConnect\">JoomlaConnect&#0153;</a>. This aggregated RSS feed brings together Joomla! news from all over the world in your language. Get the latest and greatest by clicking <a href=\"http://community.joomla.org/connect.html\" target=\"_blank\" title=\"JoomlaConnect\">here</a>.</p>','',1,0,0,8,'2007-07-07 09:54:06',62,'','2007-07-07 09:54:06',62,0,'0000-00-00 00:00:00','2004-07-06 22:00:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',2,0,2,'','',1,5,'',0,'*',''),
	(49,197,'Maintaining equity in your assets','maintaining-equity-in-your-assets','','<p><img class=\"border floatleft\" src=\"images/democontent/iStock_000005912337XSmall.jpg\" border=\"0\" alt=\"iStock_000005912337XSmall\" width=\"459\" height=\"261\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,23,'2010-06-23 03:04:53',62,'','2011-07-23 09:06:54',42,0,'0000-00-00 00:00:00','2010-06-23 03:04:53','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',10,0,10,'','',1,22,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(50,97,'Interiors do as interiors are.','interiors-do-as-interiors-are','','<p><img alt=\"interior\" height=\"494\" width=\"920\" src=\"images/stories/democontent/interior.jpg\" /></p>\r\n','\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla non eros nibh, non viverra nulla. Fusce venenatis, leo ac congue rutrum, lectus lectus sodales tortor, vitae faucibus risus orci vel mi. Pellentesque ut magna ut leo adipiscing rutrum. Sed ut fermentum turpis.</p>',1,0,0,15,'2010-06-29 00:00:00',62,'','2010-07-09 02:31:01',62,0,'0000-00-00 00:00:00','2010-06-10 03:34:09','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',4,0,2,'','',1,26,'',0,'*',''),
	(51,98,'A lily in the hand is worth two on the mantelpiece?','a-lily-in-the-hand-is-worth-two-on-the-mantelpiece','','<p><img alt=\"lily\" height=\"572\" width=\"939\" src=\"images/stories/democontent/lily.jpg\" /></p>\r\n','\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla non eros nibh, non viverra nulla. Fusce venenatis, leo ac congue rutrum, lectus lectus sodales tortor, vitae faucibus risus orci vel mi. Pellentesque ut magna ut leo adipiscing rutrum. Sed ut fermentum turpis.</p>',1,0,0,15,'2010-06-10 03:34:09',62,'','2010-07-09 02:31:07',62,0,'0000-00-00 00:00:00','2010-06-10 03:34:09','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',4,0,3,'','',1,6,'',0,'*',''),
	(52,99,'Lorem ipsum dolor sit amet consectetur adipiscing elit','lorem-ipsum-dolor-sit-amet-consectetur-adipiscing-elit','','<p><img border=\"0\" src=\"images/stories/democontent/banner.jpg\" /></p>\r\n','\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nulla non eros nibh, non viverra nulla. Fusce venenatis, leo ac congue rutrum, lectus lectus sodales tortor, vitae faucibus risus orci vel mi. Pellentesque ut magna ut leo adipiscing rutrum. Sed ut fermentum turpis.</p>',1,0,0,15,'2010-06-29 00:00:00',62,'','2010-07-09 02:30:54',62,0,'0000-00-00 00:00:00','2010-06-10 03:34:09','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',3,0,1,'','',1,11,'',0,'*',''),
	(54,194,'Eco business systems and environmental transaction','eco-business-systems-and-environmental-transaction','','<p><img class=\"border floatleft\" src=\"images/democontent/macroPlant.jpg\" border=\"0\" alt=\"macroPlant\" width=\"317\" height=\"318\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,23,'2010-06-23 03:06:13',62,'','2011-07-23 09:06:14',42,0,'0000-00-00 00:00:00','2010-06-23 03:06:13','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',7,0,13,'','',1,28,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(55,199,'Pools of the rich and famous','pools-of-the-rich-and-famous','','<p><img class=\"border floatleft\" src=\"images/democontent/Fotolia_7159470_XS.jpg\" border=\"0\" alt=\"Fotolia_7159470_XS\" width=\"438\" height=\"274\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n','\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,23,'2010-06-23 03:04:53',62,'','2011-07-23 09:07:35',42,0,'0000-00-00 00:00:00','2010-06-23 03:04:53','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',6,0,4,'','',1,10,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(56,193,'A lone flower starts to uncurl','a-lone-flower-starts-to-uncurl','','<p><img class=\"border floatleft\" src=\"images/democontent/Fotolia_697232_XS.jpg\" border=\"0\" alt=\"Fotolia_697232_XS\" width=\"400\" height=\"300\" /></p>\r\n<p> </p>\r\n<p>This is the start and this is the end. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,23,'2010-06-23 03:06:13',62,'','2011-07-23 09:06:03',42,0,'0000-00-00 00:00:00','2010-06-23 03:06:13','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',26,0,1,'','',1,71,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),
	(59,103,'K2 Joomla Template','k2-joomla-template','','<p><img src=\"images/stories/democontent/k2.jpg\" alt=\"k2\" width=\"442\" height=\"216\" /></p>\r\n<p>This template provides additional styles for <a href=\"http://www.getk2.org/\">K2</a> from <a href=\"http://www.joomlaworks.gr/\">JoomlaWorks</a>. This very popular extension gives you additional means to control and create content. You are free to use Newstream without K2, but we have done the extra work to style K2 to fit the whole theme. Here is an excerpt about K2 and what it can do for you.</p>\r\n<p> </p>\r\n','\r\n<blockquote>\r\n<p>\"It provides an out-of-the box integrated solution featuring rich content  forms for items (think of Joomla! articles with additional fields for  article images, videos, image galleries and attachments), nested-level  categories, tags, comments, a system to extend the item base form with  additional fields (similar to <a href=\"http://drupal.org/project/cck\" target=\"_blank\">CCK</a> for those acquainted with <a href=\"http://drupal.org/\" target=\"_blank\">Drupal</a>), a powerful  plugin API to extend item, category and user forms, ACL, frontend  editing, sub-templates and a lot more! 						<br /><br /> Using K2, you can transform your Joomla! website to a  news/magazine site with author blogs, product catalogs, work portfolio,  knowledge base, download/document manager, directory listing, event  listing and more, all this bundled under one package! Since K2 is  extensible with additional fields to its base item form, you can easily  create category-specific content types, e.g. article, blog post, product  page, directory listing.\"</p>\r\n</blockquote>\r\n<p>Here is a list of some of its features:</p>\r\n<ul>\r\n<li>Content creation</li>\r\n<li>Custom fields</li>\r\n<li>Image galleries</li>\r\n<li>Add videos to items</li>\r\n<li>Author profiles</li>\r\n<li>Social bookmarking</li>\r\n<li>Dozens of modules to display K2 content</li>\r\n<li>And more!</li>\r\n</ul>',1,0,0,22,'2010-07-03 10:05:17',62,'','2010-09-06 05:03:38',62,0,'0000-00-00 00:00:00','2010-07-03 10:05:17','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',8,0,3,'','',1,7,'',0,'*',''),
	(60,209,'Zen Grid Framework','zen-grid-framework','','<p><img class=\"border\" src=\"images/democontent/zenGrid.gif\" border=\"0\" alt=\"zenGrid\" width=\"442\" height=\"208\" /></p>\r\n<p>This template is built on the Zen Grid Framework which makes changing, updating and editing the template incredibly easy. If you would like to learn more about the Zen Grid Framework take a look at the <a href=\"http://www.joomlabamboo.com/joomla-templates/2010-joomla-templates/zen-grid-framework\">Zen Grid feature item</a> on the Joomla Bamboo Site, or take a look through the <a href=\"http://www.joomlabamboo.com/documentation/zen-grid-2-documentation/zen-grid-framework-and-child-theme-installation\">Zen Grid framework knowledgebase</a>.</p>\r\n<p> </p>\r\n','\r\n<p> </p>\r\n<p>For specific instructions on how best to implement the Newstream template please refer to the Newstream documentation on the Joomla Bamboo site. The Newstream documentation highlights a few small changes to the way that the template is implemented within the framework and it also highlights the module settings required for some of the modules you see here on the demo site so its recommended that you look over that article as well as the core Zen Grid Framework documentation.</p>\r\n<p>The new stream template uses version 1.05 of the Zen Grid framework which includes a number of feature updates. The framework now uses Google fonts to render your logo, your headings, your body font, or your navigation font using any of the fonts available in the Google font directory. This is a cross browser former font replacement that is incredibly easy-to-use and adds dynamic styling ability to your website.</p>\r\n<p>Please view the Zen Grid  framework documentation for more information of what this update includes.</p>\r\n<p> </p>\r\n<h3></h3>',1,0,0,22,'2010-07-03 10:05:36',62,'','2011-07-24 14:14:09',42,0,'0000-00-00 00:00:00','2010-07-03 10:05:36','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',15,0,2,'','',1,101,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(75,202,'The CEO Whisperer - contentment and success','the-ceo-whisperer-contentment-and-success','','<p><img class=\"border floatleft\" src=\"images/democontent/iStock_000008352989XSmall.jpg\" border=\"0\" alt=\"iStock_000008352989XSmall\" width=\"426\" height=\"282\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,23,'2010-07-10 07:12:12',62,'','2011-07-23 09:08:32',42,0,'0000-00-00 00:00:00','2010-07-10 07:12:12','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',4,0,12,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(76,196,'Investors strike against corporate excess','investors-strike-against-corporate-excess','','<p><img class=\"border floatleft\" src=\"images/democontent/Fotolia_1147215_XS.jpg\" border=\"0\" alt=\"Fotolia_1147215_XS\" width=\"424\" height=\"283\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,23,'2010-06-23 03:04:53',62,'','2011-07-23 09:06:39',42,0,'0000-00-00 00:00:00','2010-06-23 03:04:53','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,11,'','',1,1,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(77,200,'Rockumentary - the making of a hero','rockumentary-the-making-of-a-hero','','<p><img class=\"border floatleft\" src=\"images/democontent/Fotolia_899328_XS.jpg\" border=\"0\" alt=\"Fotolia_899328_XS\" width=\"409\" height=\"294\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,23,'2010-07-10 07:14:59',62,'','2011-07-23 09:07:48',42,0,'0000-00-00 00:00:00','2010-07-10 07:14:59','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',4,0,8,'','',1,10,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(78,198,'Moonlight Classics - Summer viewing','moonlight-classics-summer-viewing','','<p><img class=\"border floatleft\" src=\"images/democontent/Fotolia_31467_XS.jpg\" border=\"0\" alt=\"Fotolia_31467_XS\" width=\"400\" height=\"300\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,23,'2010-07-10 07:15:23',62,'','2011-07-23 09:07:08',42,0,'0000-00-00 00:00:00','2010-07-10 07:15:23','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',4,0,9,'','',1,1,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(79,203,'Weddings in far away places','weddings-in-far-away-places','','<p><img class=\"border floatleft\" src=\"images/democontent/Fotolia_6355435_XS.jpg\" border=\"0\" alt=\"Fotolia_6355435_XS\" width=\"424\" height=\"283\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,23,'2010-07-10 07:16:43',62,'','2011-07-23 09:09:03',42,0,'0000-00-00 00:00:00','2010-07-10 07:16:43','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',4,0,5,'','',1,9,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(81,110,'Polar bears dont feel the cold','polar-bears-dont-feel-the-cold','','<p><img class=\"border floatleft\" src=\"images/democontent/Fotolia_8323460_XS.jpg\" border=\"0\" alt=\"Fotolia_8323460_XS\" width=\"401\" height=\"300\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,23,'2010-07-10 07:21:41',62,'','2011-07-23 09:07:22',42,0,'0000-00-00 00:00:00','2010-07-10 07:21:41','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',4,0,3,'','',1,9,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),
	(82,111,'Toes, massage and lotus birth','toes-massage-and-lotus-birth','','<p><img class=\"border floatleft\" src=\"images/democontent/Fotolia_7059891_XS.jpg\" border=\"0\" alt=\"Fotolia_7059891_XS\" width=\"424\" height=\"283\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,23,'2010-07-10 07:22:09',62,'','2011-07-23 09:08:45',42,0,'0000-00-00 00:00:00','2010-07-10 07:22:09','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',5,0,2,'','',1,11,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',1,'*',''),
	(87,201,'Techniques for the nineteenth hole','techniques-for-the-nineteenth-hole','','<p><img class=\"border floatleft\" src=\"images/democontent/iStock_000009077366XSmall.jpg\" border=\"0\" alt=\"iStock_000009077366XSmall\" width=\"419\" height=\"286\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,23,'2010-07-10 07:41:34',62,'','2011-07-23 09:08:00',42,0,'0000-00-00 00:00:00','2010-07-10 07:41:34','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',4,0,6,'','',1,11,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(88,195,'Focus remains a useful creative tension','focus-remains-a-useful-creative-tension','','<p><img class=\"border floatleft\" src=\"images/democontent/iStock_000010038981XSmall.jpg\" border=\"0\" alt=\"iStock_000010038981XSmall\" width=\"425\" height=\"282\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,23,'2010-07-10 07:42:04',62,'','2011-07-23 09:06:27',42,0,'0000-00-00 00:00:00','2010-07-10 07:42:04','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',4,0,7,'','',1,10,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(90,208,'Typography','typography','','<p><img class=\"border\" src=\"images/democontent/type.png\" border=\"0\" alt=\"type\" width=\"442\" height=\"232\" /></p>\r\n<p> </p>\r\n<p>This page gives you an overview of all of the typographical elements included with the template. You can apply these styles in your Joomla website easily if you use the content editor, and we recommend using <a href=\"http://www.joomlacontenteditor.net/\">JCE</a> as the default editor.</p>\r\n<p>For more advanced typographical styling please visit the <a href=\"http://www.joomlabamboo.com/joomla-extensions/jb-type-joomla-typography-plugin\">JB Type plugin page on the main Joomla Bamboo site</a>.</p>\r\n<p> </p>\r\n','\r\n<p><strong>Demonstration</strong></p>\r\n<h1>Heading 1</h1>\r\n<p>Aenean sit amet sem. Phasellus rhoncus venenatis felis. Suspendisse  iaculis mattis dolor. Donec congue. Morbi auctor hendrerit dui. Aliquam  turpis. Maecenas molestie augue in urna. Donec gravida magna eget nulla.  Phasellus sed pede et turpis mollis aliquam. Quisque aliquet pede nec  turpis. Maecenas ultricies.</p>\r\n<p> </p>\r\n<h2>Heading 2</h2>\r\n<p>Aenean sit amet sem. Phasellus rhoncus venenatis felis. Suspendisse  iaculis mattis dolor. Donec congue. Morbi auctor hendrerit dui. Aliquam  turpis. Maecenas molestie augue in urna. Donec gravida magna eget nulla.  Phasellus sed pede et turpis mollis aliquam. Quisque aliquet pede nec  turpis. Maecenas ultricies.</p>\r\n<p> </p>\r\n<h3>Heading 3</h3>\r\n<p>Aenean sit amet sem. Phasellus rhoncus venenatis felis. Suspendisse  iaculis mattis dolor. Donec congue. Morbi auctor hendrerit dui. Aliquam  turpis. Maecenas molestie augue in urna. Donec gravida magna eget nulla.  Phasellus sed pede et turpis mollis aliquam. Quisque aliquet pede nec  turpis. Maecenas ultricies.</p>\r\n<p> </p>\r\n<h4>Heading 4</h4>\r\n<p>Aenean sit amet sem. Phasellus rhoncus venenatis felis. Suspendisse  iaculis mattis dolor. Donec congue. Morbi auctor hendrerit dui. Aliquam  turpis. Maecenas molestie augue in urna. Donec gravida magna eget nulla.  Phasellus sed pede et turpis mollis aliquam. Quisque aliquet pede nec  turpis. Maecenas ultricies.</p>\r\n<p> </p>\r\n<h5>Heading 5</h5>\r\n<p>Aenean sit amet sem. Phasellus rhoncus venenatis felis. Suspendisse  iaculis mattis dolor. Donec congue. Morbi auctor hendrerit dui. Aliquam  turpis. Maecenas molestie augue in urna. Donec gravida magna eget nulla.  Phasellus sed pede et turpis mollis aliquam. Quisque aliquet pede nec  turpis. Maecenas ultricies.</p>\r\n<p> </p>\r\n<h6>Heading 6</h6>\r\n<p>Aenean sit amet sem. Phasellus rhoncus venenatis felis. Suspendisse  iaculis mattis dolor. Donec congue. Morbi auctor hendrerit dui. Aliquam  turpis. Maecenas molestie augue in urna. Donec gravida magna eget nulla.  Phasellus sed pede et turpis mollis aliquam. Quisque aliquet pede nec  turpis. Maecenas ultricies.</p>\r\n<p> </p>\r\n<blockquote />\r\n<p>This is a blockquote. To use this class use the following html:  &lt;blockquote&gt;&lt;p&gt;This is where you put the  content&lt;/p&gt;&lt;/blockquote&gt;. You can also use this html to  havejust an opening quotation mark &lt;p class=\"blockquote&gt;Some more  content here&lt;/p&gt;&lt;/p&gt;\r\n&lt;/blockquote&gt;\r\n&lt;p&gt; &lt;/p&gt;\r\n&lt;p&gt;This is an unordered list:&lt;/p&gt;\r\n&lt;ul&gt;\r\n&lt;li&gt;Donec imperdiet ipsum eu mauris.&lt;/li&gt;\r\n&lt;li&gt;Morbi facilisis purus in dui.&lt;/li&gt;\r\n&lt;li&gt;Donec pharetra orci eu justo.&lt;/li&gt;\r\n&lt;li&gt;Donec porta tellus id leo.&lt;/li&gt;\r\n&lt;li&gt;Aenean commodo sagittis orci.&lt;/li&gt;\r\n&lt;/ul&gt;\r\n&lt;p&gt; &lt;/p&gt;\r\n&lt;p&gt;This is an ordered list&lt;/p&gt;\r\n&lt;ol&gt;\r\n&lt;li&gt;Donec imperdiet ipsum eu mauris.&lt;/li&gt;\r\n&lt;li&gt;Morbi facilisis purus in dui.&lt;/li&gt;\r\n&lt;li&gt;Donec pharetra orci eu justo.&lt;/li&gt;\r\n&lt;li&gt;Donec porta tellus id leo.&lt;/li&gt;\r\n&lt;li&gt;Aenean commodo sagittis orci.&lt;/li&gt;\r\n&lt;/ol&gt;\r\n&lt;p&gt; &lt;/p&gt;\r\n&lt;p&gt;&lt;strong&gt;This is some bold text.&lt;/strong&gt;&lt;/p&gt;\r\n&lt;p&gt;&lt;em&gt;This is some italicised text.&lt;/em&gt;&lt;/p&gt;\r\n&lt;p&gt;&lt;span style=&quot;text-decoration: underline;\">This is some underlined text.</span></p>',1,0,0,22,'2010-07-15 05:46:16',62,'','2011-07-24 12:00:51',42,0,'0000-00-00 00:00:00','2010-07-15 05:46:16','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',15,0,7,'','',1,73,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(91,115,'JB Slideshow','jb-slideshow','','<p><img class=\"floatleft\" alt=\"Slideshow\" height=\"128\" width=\"128\" src=\"images/stories/democontent/extensions/Slideshow.png\" />JB Slideshow is a powerful Joomla and K2 content slider and fader. The slideshow module can be used to showcase your content in a fast and effective slideshow - in fact we like it so much that it features heavily in most of our <a target=\"_blank\" href=\"http://demo.joomlabamboo.com\">Joomla template releases</a>.</p>\r\n<p>The slideshow can draw the images from your Joomla content or K2 items and display their titles, content, category name, date published, and in the case of K2, the comment count for each item.</p>\r\n','\r\n<p> </p>\r\n<p>The slideshow has a huge range of features which can help you control the layout and appearance of the slideshow. Be sure to check the full documentation on how to control the slideshow.</p>\r\n<p> </p>\r\n<p><b>Key Features</b></p>\r\n<ul>\r\n<li>Display images, titles, introtext from your Joomla or K2 items</li>\r\n<li>15 transition types to choose from</li>\r\n<li>Absolute control over positioning of the image, text, navigation on the page</li>\r\n<li>Smart image resizing or display original image</li>\r\n</ul>\r\n<p> </p>\r\n<p>View a full run down of what this module can do on the <a target=\"_blank\" href=\"http://www.joomlabamboo.com/joomla-extensions/jb-slideshow-v3\">JB Slideshow page</a>.</p>\r\n<p> </p>\r\n<ul>\r\n</ul>\r\n<p><b>Demonstration</b></p>\r\n<p>{loadposition jbslideshow}</p>\r\n<p><b>Requirements</b></p>\r\n<ul>\r\n<li>Joomla 1.5</li>\r\n<li>JB Library</li>\r\n</ul>',-2,0,0,26,'2010-07-15 05:49:46',62,'','2010-09-14 05:00:02',62,0,'0000-00-00 00:00:00','2010-07-15 05:49:46','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',13,0,1,'','',1,68,'',0,'*',''),
	(92,116,'JB Type','jb-type','','<p><strong><img class=\"floatleft\" alt=\"JBtype\" height=\"128\" width=\"128\" src=\"images/stories/democontent/extensions/JBtype.png\" />JB Type</strong> is a Joomla style and typography plugin for your content. By using some simple Joomla syntax you can create some awesome typography for your site without knowing any html at all.</p>\r\n','\r\n<p> </p>\r\n<p><b><br /></b></p>\r\n<p><strong>Features</strong></p>\r\n<ul>\r\n<li>Use simple syntax to trigger the JB Type styles.</li>\r\n<li>Currently two icon styles with more on the way</li>\r\n</ul>\r\n<p> </p>\r\n<p><strong>Dependancies</strong></p>\r\n<p>Joomla 1.5.</p>\r\n<p> </p>\r\n<ul>\r\n</ul>\r\n<p><b>Demonstration</b></p>\r\n<p><b><strong>The following styles are generated using our free JB Type plugin</strong><br /></b></p>\r\n<p>{jb_clear}{/jb_clear} {jb_quote}jb_quote - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_quote}</p>\r\n<p>{jb_quoteleft}jb_quoteleft - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_quoteleft}</p>\r\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula. Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula. Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.</p>\r\n<p>{jb_clear}{/jb_clear}</p>\r\n<p>{jb_quoteright}jb_quoteright - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_quoteright}</p>\r\n<p>Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula. Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula. Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.</p>\r\n<p>{jb_clear}{/jb_clear} {jb_info}jb_info - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_info}</p>\r\n<p>{jb_warning}jb_warning - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_warning} {jb_film}jb_film - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_film}</p>\r\n<p>{jb_pin}jb_pin - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_pin}</p>\r\n<p>{jb_lightbulb}jb_lightbulb - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_lightbulb}</p>\r\n<p>{jb_recycle}jb_recycle - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_recycle}</p>\r\n<p>{jb_camera}jb_camera - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_camera}</p>\r\n<p>{jb_comment}jb_comment - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_comment}</p>\r\n<p>{jb_chat}jb_chat - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_chat}</p>\r\n<p>{jb_document}jb_document - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_document}</p>\r\n<p>{jb_accessible}jb_accessible - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_accessible}</p>\r\n<p>{jb_star}jb_star - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_star}</p>\r\n<p>{jb_heart}jb_heart - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_heart}</p>\r\n<p>{jb_previous}jb_previous - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_previous}</p>\r\n<p>{jb_cart}jb_cart - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_cart}</p>\r\n<p>{jb_sound}jb_sound - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_sound}</p>\r\n<p>{jb_new}jb_new - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_new}</p>\r\n<p>{jb_code}jb_code - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_code}</p>\r\n<p>{jb_attachment}jb_attachment - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_attachment} {jb_calculator}jb_calculator - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_calculator} {jb_cut}jb_cut - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_cut} {jb_dollar}jb_dollar - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_dollar} {jb_pound}jb_pound - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_pound} {jb_euro}jb_euro - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_euro} {jb_mail}jb_mail Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_mail} {jb_support}jb_support - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_support} {jb_next}jb_next - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_next} {jb_blackbox}jb_blackbox - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_blackbox} {jb_greenbox}jb_greenbox - tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_greenbox} {jb_redbox}jb_redbox - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_redbox} {jb_purplebox}jb_purplebox - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_purplebox} {jb_bluebox}jb_bluebox - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_bluebox}</p>\r\n<p>{jb_brownbox}jb_brownbox - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_brownbox}</p>\r\n<p>{jb_yellowbox}jb_yellowbox - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_yellowbox} {jb_dropcap}T{/jb_dropcap}his is the jb_dropcapDonec tempus fringilla neque ac iaculis. Aenean eget ipsum elit, ac dapibus turpis. Nulla non felis est. Duis lacinia felis eu metus suscipit volutpat. Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.</p>\r\n<p>{jb_clear}{/jb_clear}</p>\r\n<p>{jb_left45}jb_left45 - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_left45}</p>\r\n<p>{jb_right45}jb_right45 - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_right45}</p>\r\n<p>{jb_clear}{/jb_clear}</p>\r\n<p>{jb_black}jb_black - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_black}</p>\r\n<p>{jb_blue}jb_blue - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_blue}</p>\r\n<p>{jb_red}jb_red - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_red}</p>\r\n<p>{jb_green}jb_green - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_green}</p>\r\n<p>{jb_yellow}jb_yellow - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_yellow}</p>\r\n<p>{jb_white}jb_white - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_white}</p>\r\n<p>{jb_brown}jb_brown - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_brown}</p>\r\n<p>{jb_purple}jb_purple - Morbi tincidunt lectus nec sapien tempus at faucibus ante fermentum. Aliquam condimentum volutpat odio lacinia vehicula.{/jb_purple}</p>',-2,0,0,26,'2010-07-15 05:52:04',62,'','2010-09-14 05:01:08',62,0,'0000-00-00 00:00:00','2010-07-15 05:52:04','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',18,0,2,'','',1,39,'',0,'*',''),
	(93,117,'JB Library','jb-library','','<p><img class=\"floatleft\" alt=\"JBLibrary\" height=\"128\" width=\"128\" src=\"images/stories/democontent/extensions/JBLibrary.png\" />The JB Library plugin is a system utility we use in our Joomla templates to help ease the pain of javascript conflicts and the common occurrence of having multiple versions of a javascript library loaded into your Joomla site. The jQuery library plugin neatly loads the native version of mootools first and then it loads the latest version of jQuery from the Google api, but only when necessary. Many of our Joomla modules require this library, but you can use it on any Joomla site.</p>\r\n','\r\n<p> </p>\r\n<p><b>Overview</b></p>\r\n<p><strong>Why are we using this method for embedding jQuery?</strong></p>\r\n<p>By adding jQuery as a plugin we can add other jQuery plugins and scripts in our modules on the fly. That means that there is no need to add script references to the head of your template and it also means that scripts only get loaded if the module is present.</p>\r\n<p> </p>\r\n<p><strong>Examples</strong></p>\r\n<p>Since its a plugin, <a href=\"http://showcase.joomlabamboo.com/oct09/\">you can only see the effect by looking at our Strata template\'s source code to see the inclusion of jQuery&nbsp;</a>&nbsp;or take a peak under the hood of the Joomla bamboo site you are on and view its source.</p>\r\n<p> </p>\r\n<p><strong>Dependancies </strong></p>\r\n<p><strong> </strong>Joomla  1.5</p>\r\n<p>Most of our jQuery enabled modules require this plugin to be installed and published.</p>\r\n<p><strong>features</strong></p>\r\n<ul>\r\n<li>Easily add jQuery to your site</li>\r\n<li>Allows you to use a copy of the jQuery library from your site, or to load it from Google</li>\r\n<li>Strips out extra jQuery library references that other Joomla extensions might load unnecessarily</li>\r\n<li>Ability to strip any other javascript file that is being loaded on the site</li>\r\n<li>Option to strip mootools from the output</li>\r\n<li>Option to replace core mootools file with one of your choice</li>\r\n<li>Needed by many JB extensions</li>\r\n<li>Includes an option for Scroll to top button automatically created when the user scrolls down the page.</li>\r\n<li>Includes an option to use the jQuery Lazyload script for images.</li>\r\n<li>Includes a browser warning for users using the outdated ie6 browser.</li>\r\n</ul>',-2,0,0,26,'2010-07-15 05:52:14',62,'','2010-09-14 04:59:10',62,0,'0000-00-00 00:00:00','2010-07-15 05:52:14','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',8,0,3,'','',1,13,'',0,'*',''),
	(95,118,'Microblog','microblog','','<p><img src=\"images/stories/democontent/extensions/Microblog.png\" width=\"128\" height=\"128\" alt=\"Microblog\" class=\"floatleft\" />The JB Microblog module is a very handy club extension that allows you to display your Joomla or K2 content in a module in a number of different ways. You can choose between the flat list layout, column layout, date and title and also the leading plus links layouts. You can also choose to display the intro and full text parts of the content item in a floating lightbox that sits above the main website.</p>\r\n<p>For more information please visit the <a href=\"http://www.joomlabamboo.com/joomla-extensions/microblog\">Microblog documentation page</a>.</p>\r\n','\r\n<p> </p>\r\n<p><b>Features</b></p>\r\n<ul>\r\n<li>Works like the default latest news module, but adds more functionality&nbsp;</li>\r\n<li>Variety of layouts to display your content.&nbsp;</li>\r\n<li>Choose to use Joomla Articles or K2 Items as content source&nbsp;</li>\r\n<li>You can choose what order the items are displayed&nbsp;</li>\r\n<li>The first image of the article can be automatically included as a small thumbnail.&nbsp;</li>\r\n<li>Displays the intro text for the article, or limit the text based on number of words&nbsp;</li>\r\n<li>Render plugins within the module&nbsp;</li>\r\n<li>Integration with lightbox, to open the content right there or links to the article layout page&nbsp;</li>\r\n<li>Comes with various themes for the lightbox to suit your template&nbsp;</li>\r\n<li>Can choose to show the date of the news</li>\r\n</ul>\r\n<p> </p>\r\n<p><strong>Demonstration</strong></p>\r\n<p><a href=\"index.php?option=com_content&amp;view=article&amp;id=134:microblog-flat-view&amp;catid=53&amp;Itemid=122\">Flat List</a></p>\r\n<p><a href=\"index.php?option=com_content&amp;view=article&amp;id=132:microblog-column-view&amp;catid=50&amp;Itemid=123\">Column View</a></p>\r\n<p><a href=\"index.php?option=com_content&amp;view=article&amp;id=137:microblog-filter-view&amp;catid=53&amp;Itemid=119\">Filter View</a></p>\r\n<p><a href=\"index.php?option=com_content&amp;view=article&amp;id=135:microblog-title-date-view&amp;catid=53&amp;Itemid=126\">Date Title</a></p>\r\n<p><a href=\"index.php?option=com_content&amp;view=article&amp;id=136:microblog-leading-then-list-view&amp;catid=53&amp;Itemid=125\">Leading then Intro</a></p>\r\n<p><a href=\"index.php?option=com_content&amp;view=article&amp;id=133:microblog-max-biz-view&amp;catid=53&amp;Itemid=124\">MaxBiz</a></p>\r\n<p> </p>\r\n<p><b>Requirements</b></p>\r\n<ul>\r\n<li>Joomla 1.5</li>\r\n<li>JB Library - only required if using the fade effect or lightbox option</li>\r\n</ul>',-2,0,0,26,'2010-07-15 05:52:44',62,'','2010-09-14 05:05:45',62,0,'0000-00-00 00:00:00','2010-07-15 05:52:44','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',13,0,5,'','',1,30,'',0,'*',''),
	(96,119,'jTweet','jtweet','','<p><img class=\"floatleft\" alt=\"JTweet\" height=\"128\" width=\"128\" src=\"images/stories/democontent/extensions/JTweet.png\" />jTweet is our very popular free Twitter module for Joomla. Its based on the sea of clouds twitter script. The jTweet script has a good range of options to help you to personalise your twitter stream making it a flexible and stylish option for integrating your tweets into your site. It utilizes jQuery, and is a must have for anyone who needs a Joomla twitter module.</p>\r\n<p> </p>\r\n','\r\n<strong>Features</strong> \r\n<ul>\r\n<li>Set the number of tweets to display&nbsp;</li>\r\n<li>Choose whether to display your avatar or not.&nbsp;</li>\r\n<li>Assign a funky twitter icon to the first tweet in your stream.&nbsp;</li>\r\n<li>Select whether to display just your tweets or all tweets related to a particular topic&nbsp;</li>\r\n<li>Select auto join phrases according to the nature of your tweet eg specific intro text for replies, verbs, replying to tweets and more.&nbsp;</li>\r\n<li>Set the text to appear while the tweets loads.&nbsp;</li>\r\n<li>Filter your own tweets via keywords. eg only display tweets that contain the word \"joomla\".</li>\r\n<li>Control the follow me text at the bottom of the module.</li>\r\n</ul>\r\n<p> </p>\r\n<p><b>Demonstration</b></p>\r\n<p>{loadposition jTweet}</p>\r\n<p> </p>\r\n<p><b>Requirements</b></p>\r\n<ul>\r\n<li>Joomla 1.5</li>\r\n<li>JB Library plugin</li>\r\n</ul>',-2,0,0,26,'2010-07-15 05:53:08',62,'','2010-09-14 04:58:49',62,0,'0000-00-00 00:00:00','2010-07-15 05:53:08','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',6,0,4,'','',1,26,'',0,'*',''),
	(97,120,'Captify Content','captify-content','','<p><img src=\"images/stories/democontent/extensions/captifyContent.png\" width=\"128\" height=\"128\" alt=\"captifyContent\" class=\"floatleft\" />The captifyContent module is a slick new way to display the images attached to your Joomla sections, Joomla categories, Joomla content, k2 Categories or K2 content items on your Joomla site in a grid based layout.</p>\r\n<p>The module resizes the image that you have assigned to the section, category, content or K2 item, lays it out in a simple grid. You can select whether or not to display the item title in a jQuery driven sliding or fading overlay or display the item title below the image.</p>\r\n<p>For more information please visit the <a target=\"_blank\" href=\"http://www.joomlabamboo.com/joomla-extensions/captifycontent-beautiful-captions-for-your-content\">captifyContent documentation page</a>.</p>\r\n','\r\n<p><b>Features</b></p>\r\n<p> </p>\r\n<p><b>Demonstration</b></p>\r\n<p>{loadposition captify}</p>\r\n<p> </p>\r\n<p><b>Requirements</b></p>\r\n<ul>\r\n<li>Joomla 1.5</li>\r\n<li>JB Library Plugin</li>\r\n</ul>',-2,0,0,26,'2010-07-15 05:53:27',62,'','2010-09-14 04:56:43',62,0,'0000-00-00 00:00:00','2010-07-15 05:53:27','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',12,0,6,'','',1,129,'',0,'*',''),
	(98,121,'Minimoo2','minimoo2','','<p><img class=\"floatleft\" alt=\"Minimoo2\" height=\"128\" width=\"128\" src=\"images/stories/democontent/extensions/Minimoo2.png\" />The minimoo2 module gallery for Joomla is a simpel to use image slider that references images from a folder of your choice. With the help of jQuery and the shifting pixel resize script creating a sliding image gallery is almost effortless. Minimoo2 uses jQuery in no conflict mode so it should work with any other javascript.</p>\r\n','\r\n<p>This beautiful and simple image slider is perfect for showcasing your images without the hassle of major extensions, and comes with an amazing set of features that will satisfy your every need.</p>\r\n<p>You can see a demonstration of the minimoo2 slider gallery below or visit the <a target=\"_blank\" href=\"http://www.joomlabamboo.com/joomla-extensions/minimoo2-gallery\">Minimoo2 documentation page</a> for further information.</p>\r\n<p> </p>\r\n<p><b>Features</b></p>\r\n<ul>\r\n<li>Load unlimited images into the module automatically from a folder on your webserver&nbsp;</li>\r\n<li>Smart Image resizer from Shifting Pixel resizes one image to create thumbnail and main images.&nbsp;</li>\r\n<li>Easy setting of cropping ratio to crop images to fit desire width or height.&nbsp;</li>\r\n<li>Your choice of prettyPhoto open in new window, open in same window as options to display the original image when the image is clicked.&nbsp;</li>\r\n<li>Belated PNGFix built in for prettyPhoto.&nbsp;</li>\r\n<li>31 transitions using the jQuery easing script.</li>\r\n<li>Minimoo2 uses jQuery in no conflict mode</li>\r\n</ul>\r\n<p> </p>\r\n<p><b>Demonstration</b></p>\r\n<p><b>{loadposition minimoo2}</b></p>\r\n<p><b>Requirements</b></p>\r\n<ul>\r\n<li>Joomla 1.5</li>\r\n<li>JB Library plugin</li>\r\n</ul>',-2,0,0,26,'2010-07-15 05:53:50',62,'','2010-09-14 04:57:40',62,0,'0000-00-00 00:00:00','2010-07-15 05:53:50','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',11,0,7,'','',1,50,'',0,'*',''),
	(100,122,'Google Fonts','google-fonts','','<p>The font stacks section of the template administrator controls the appearance of the fonts on your site. These styles are written to the body class of the template and a container div in the template. The Zen Grid Framework is able to load a selection of font stacks that are commonly available across the web and it also has the capacity to load fonts from the Google web font directory.</p>\r\n<p>There are 18 different font families available in the repository and unlike other font replacement techniques the Google font solution is standard across browsers.</p>\r\n<p>For a full run down of the fonts available please plus some more information on using fonts with the Zen Grid Framework please visit the <a target=\"_blank\" href=\"http://www.joomlabamboo.com/documentation/zen-grid-framework-font-stacks\">Zen Grid Knowledgebase</a>.</p>','',-2,0,0,25,'2010-07-15 05:58:16',62,'','2010-09-14 06:03:04',62,0,'0000-00-00 00:00:00','2010-07-15 05:58:16','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',3,0,6,'','',1,25,'',0,'*',''),
	(102,123,'PrettyBox','prettybox','','<p><b><img class=\"floatleft\" alt=\"Prettybox\" height=\"128\" width=\"128\" src=\"images/stories/democontent/extensions/Prettybox.png\" />PrettyBox</b> is an extremely flexible and effective module gallery for Joomla.</p>\r\n<p>It can display images from a folder you nominate in a module or in your content using the l<a href=\"http://www.joomlabamboo.com/blog/tutorials/using-the-loadposition-plugin-in-joomla\" target=\"_blank\">oadposition syntax for Joomla 1.5</a>.&nbsp;It\'s a simple extension that has a lot of powerful features that can really spice up your image gallery.</p>\r\n<p> </p>\r\n','\r\n<p><b>Features</b></p>\r\n<ul>\r\n<li>Upload images to a folder and have them display on your website.&nbsp;</li>\r\n<li>Crop the images to any size or width height ratio you desire.&nbsp;</li>\r\n<li>Display images titles, description, date or author.</li>\r\n<li>Options for when the image is clicked include open in a lightbox, open in same window, open in a new window, no link, open a content item or open a blog category.&nbsp;</li>\r\n<li>All options for the images are defined in the image title (see below.)&nbsp;</li>\r\n<li>Multiple galleries per page.&nbsp;</li>\r\n<li>Unlimited number of images per gallery.</li>\r\n<li>Display jpgs, pngs or gifs.</li>\r\n</ul>\r\n<p> </p>\r\n<p>For a full overview of the Pretty Box features please visit the&nbsp;<a href=\"http://www.joomlabamboo.com/joomla-extensions/prettybox\" target=\"_blank\" style=\"color: #1b57b1; text-decoration: none; font-weight: normal;\">prettyBox documentation page</a>.</p>\r\n<p> </p>\r\n<p><b>Demonstration</b></p>\r\n<p>{loadposition prettybox}</p>\r\n<p> </p>\r\n<p><b>Requirements</b></p>\r\n<ul>\r\n<li>Joomla 1.5</li>\r\n<li>JB Library</li>\r\n</ul>',-2,0,0,26,'2010-07-15 06:01:00',62,'','2010-09-14 04:57:11',62,0,'0000-00-00 00:00:00','2010-07-15 06:01:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',18,0,8,'','',1,60,'',0,'*',''),
	(103,204,'Theme Variations','theme-variations','','<p><img class=\"border\" src=\"images/democontent/rasa.jpg\" border=\"0\" alt=\"rasa\" width=\"442\" height=\"221\" /></p>\r\n<p> </p>\r\n<p>Newstream comes with thirteen distinct colour schemes that are big, bold and beautiful. <strong>A news or magazine site traditionally needs to set the general tone via a clean or minimal backdrop with a focus on simplicity but it can also emphasize its content with a dynamic and striking colour palette.</strong> Newstream does this by providing ample white space with a simple and striking colour hierachy that creates an elegant theme to accompany your news.</p>\r\n','\r\n<p style=\"margin-top: 8px; margin-right: 0px; margin-bottom: 8px; margin-left: 0px;\">The colour scheme css files can be found in the templates/newstream/css/hilite folder and are very easy to edit in order to create your own colour palette.</p>\r\n<p style=\"margin-top: 8px; margin-right: 0px; margin-bottom: 8px; margin-left: 0px;\"> </p>\r\n<p style=\"margin-top: 8px; margin-right: 0px; margin-bottom: 8px; margin-left: 0px;\"><strong>Click on the images below to see larger screenshots of the Rasa template.</strong></p>\r\n<p style=\"margin-top: 8px; margin-right: 0px; margin-bottom: 8px; margin-left: 0px;\"> </p>\r\n<p>{loadposition themes}</p>',1,0,0,22,'2010-07-15 06:04:42',62,'','2011-07-24 10:53:01',42,0,'0000-00-00 00:00:00','2010-07-15 06:04:42','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',9,0,6,'','',1,52,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(104,207,'Module Positions','module-positions','','<p><img src=\"images/democontent/documentation/modulepositionImage.png\" border=\"0\" alt=\"modulepositionImage\" width=\"455\" height=\"234\" />This template is built using the Zen Grid Framework and contains a lot fo module positions. For a full understanding of how the module positions work in framework compatible templates please visit the Zen Grid Framework documentation.</p>\r\n<p>The screenshot below highlights the modules available in this template. For a run down on how we created the demo site for this template please visit the setup menu icon and review the documentation available there.</p>\r\n<p> </p>\r\n','\r\n<p><img src=\"images/democontent/documentation/newstreamPositions.png\" border=\"0\" alt=\"newstreamPositions\" width=\"455\" height=\"1387\" /></p>',1,0,0,22,'2010-07-15 06:04:55',62,'','2011-07-24 12:00:24',42,0,'0000-00-00 00:00:00','2010-07-15 06:04:55','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',7,0,5,'','',1,25,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(105,126,'Superfish Menu','superfish-menu','','<p>The superfish menu is a slick and slippery sliding suckerfish that smoothly drops down when the user glides over a parent menu item. Replicating the superfish menu is as simple as following and reproducing the settings as shown on the <a href=\"http://www.joomlabamboo.com/documentation/zen-grid-framework-setting-up-the-superfish-menu\">Zen Grid framework knowledgebase</a>.</p>\r\n<p> </p>\r\n<p>You will notice that the only thing that differentiates the super fish menu display and the panel menu display is the module class suffix -superfish. Beyond that setting up the two modules are completely the same.</p>','',-2,0,0,25,'2010-07-15 06:05:36',62,'','2010-09-14 06:06:59',62,0,'0000-00-00 00:00:00','2010-07-15 06:05:36','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',3,0,5,'','',1,6,'',0,'*',''),
	(106,127,'Panel menu','panel-menu','','<p>The panel menu in the Zen Grid framework is an accordion-like jQuery menu that utilises the inbuilt Joomla core module plus a small snippet of code. It is very easy to set up once you have the correct menu structure created for your menu which can be found on the <a href=\"http://www.joomlabamboo.com/documentation/zen-grid-framework-setting-up-the-panel-menu\">Zen Grid documentation page</a>.</p>\r\n<p>Replicating the panel menu is as simple as following and reproducing the settings as shown on the doc page. You will notice that the only thing that differentiates the panel menu display and the superfish display is the module class suffix -panelmenu. Beyond that setting up the two modules are completely the same.</p>','',-2,0,0,25,'2010-07-15 06:05:47',62,'','2010-09-14 06:08:16',62,0,'0000-00-00 00:00:00','2010-07-15 06:05:47','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',3,0,4,'','',1,6,'',0,'*',''),
	(107,128,'Module Sliders','module-sliders','','<p>Zen Grid compatible templates have the ability to transform standard Joomla modules into sliding accordion-like modules. The sliders are initiated by simply adding the module class suffix -slide to the module. Once you have done that the title of the module becomes the trigger which either hides or displays the module content via a smooth jQuery transition.</p>\r\n<p>For more information regarding the slide module class suffix and step by step tutorials on how to apply the module class suffix please visit the <a href=\"http://www.joomlabamboo.com/documentation/zen-grid-framework-general-layout-settings\" target=\"_blank\">Zen Grid Framework knowledgebase</a>.</p>','',-2,0,0,25,'2010-07-15 06:05:57',62,'','2010-07-17 04:48:52',62,0,'0000-00-00 00:00:00','2010-07-15 06:05:57','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',5,0,3,'','',1,9,'',0,'*',''),
	(108,129,'Hidden Panel','hidden-panel','','<p>The hidden panel is a core feature of the Zen Grid Framework and is an easy way to store non essential but important information in a sliding panel that can be toggled on or off on the screen. The panel is automatically displayed on the page when you publish any module to the panel1 to panel4 position.</p>\r\n<p>For more information regarding the hidden panel please refer to the documentation in the <a href=\"http://www.joomlabamboo.com/documentation/zzen-grid-framework-hidden-panel\" target=\"_blank\">Zen Grid Framework knowledgebase</a>.</p>','',-2,0,0,25,'2010-07-15 06:07:26',62,'','2010-07-17 04:39:12',62,0,'0000-00-00 00:00:00','2010-07-15 06:07:26','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',7,0,2,'','',1,7,'',0,'*',''),
	(110,130,'How to install a Joomla template','how-to-install-a-joomla-template','','<p>Choose this option if you already have your site created or have at least made changes to the default Joomla installation and want to overlay this theme onto your site. For a complete installation of the demo site on your server please refer to installing the quickstart package.</p>\r\n<p><br /><strong>Installing the template is achieved using the same method as installing any other template or extension.</strong></p>\r\n<ul>\r\n<li>Navigate to your Joomla admin area at yoursite.com/administrator</li>\r\n<li>Navigate to Extensions &gt; Install/uninstall</li>\r\n<li>Click browse and locate the template zip on your harddrive.</li>\r\n<li>Click upload and install.</li>\r\n<li>After you receive the success message, navigate to Extensions &gt; Template Manager</li>\r\n<li>Select the radio checkbox next to the Canvas template and then click on the button at the top right of the screen that says default.</li>\r\n<li>Now if you navigate to the front page of your site and you should see the Canvas template installed into your Joomla site.</li>\r\n</ul>','',1,0,0,21,'2010-07-15 06:33:00',62,'','2010-07-16 00:16:26',62,0,'0000-00-00 00:00:00','2010-07-15 06:33:00','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',2,0,8,'','',1,2,'',0,'*',''),
	(111,131,'How to install a Joomla extension','how-to-install-a-joomla-extension','','<p>The demo site for the Grid template showcases a number of different modules that accompany the template. Most of these modules and the JB LIbrary plugin can be found in the free extension and club extensions folder in the <a target=\"_blank\" href=\"http://www.joomlabamboo.com/downloads\">Joomla Bamboo download area</a>.</p>\r\n<p class=\"page\">The specific Joomla extensions used on the demo site include:</p>\r\n<ul>\r\n<li><span style=\"line-height: 23px;\">the prettyBox module - used for the various galleries used on the site.</span></li>\r\n<li><span style=\"line-height: 23px;\">the Extended Menu Module - used for the Superfish Menu and Panel Menu.</span></li>\r\n<li><span style=\"line-height: 23px;\">the JB LIbrary Plugin - this is a system plugin used for all jQuery effects on the site.</span></li>\r\n<li><span style=\"line-height: 23px;\">the jTweet module - used in the bottom slider area.</span></li>\r\n<li><span style=\"line-height: 23px;\">the captifyContent module - used on the front page grid layout.</span></li>\r\n<li><span style=\"line-height: 23px;\">JB Slideshow - Used for the ticker you see under the menu.</span></li>\r\n</ul>\r\n','\r\n<p><strong>Installing the modules.</strong></p>\r\n<ul>\r\n<li>Navigate to your Joomla admin area at yoursite.com/administrator</li>\r\n<li>Navigate to Extensions &gt; Install/uninstall</li>\r\n<li> Click browse and locate the extension zip on your hard drive. If the zip is named unzipfirst then you must unzip the files.</li>\r\n<li>Click upload and install.</li>\r\n<li>After you receive the success message, navigate to Extensions &gt; Module Manager</li>\r\n<li>Select the radio checkbox next to the module you just installed and begin to configure the options. </li>\r\n<li>Ensure that the module is published, is assigned to a menu item on the bottom left and all of the necessary parameters are configured.</li>\r\n<li>Apply or save the changes you have made.</li>\r\n</ul>\r\n<p> </p>\r\n<p><strong>Installing the JB Library Plugin</strong></p>\r\n<p>Once you have installed this plugin please ensure that the plugin is published. You can do this by doing the following:</p>\r\n<ul>\r\n<li>Navigate to your Joomla admin area at yoursite.com/administrator</li>\r\n<li>Navigate to Extensions &gt; Install/uninstall</li>\r\n<li> Click browse and locate the extension zip on your hard drive. If the zip is named unzipfirst then you must unzip the files.</li>\r\n<li>Click upload and install.</li>\r\n<li>Navigate to Extensions &gt; Plugin Manager.</li>\r\n<li>Scroll to the system group of plugins and locate JB LIbrary.</li>\r\n<li>Select the checkbox to the left of the plugin name and scroll to the top right of the page and click publish.</li>\r\n</ul>\r\n<p class=\"finger\">This plugin inserts a script reference into the head of the template that loads jQuery to load and enables all of the jQuery driven effects on the site to work properly. For more information see the content item for the <a href=\"../wallpaper/index.php?option=com_content&amp;view=article&amp;id=74:jb-library-plugin&amp;catid=35:features&amp;Itemid=89\">JB Library plugin</a>.</p>',1,0,0,21,'2010-07-15 06:34:43',62,'','2010-07-16 00:17:00',62,0,'0000-00-00 00:00:00','2010-07-15 06:34:43','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',2,0,7,'','',1,32,'',0,'*',''),
	(114,132,'Setting up with a fresh version of Joomla','setting-up-with-a-fresh-version-of-joomla','','<p>Setting up the Rasa template in a fresh installation of Joomla is reasonably straight forward. This document assumes that you have already setup Joomla and you have also included the default Joomla sample data.</p>\r\n<p>\r\n','\r\n</p>\r\n<p><strong> Elements to install. </strong></p>\r\n<ul>\r\n<li>Essential elements  Install the Zen Grid Framework</li>\r\n<li>Install the Ecolift template and set it to default</li>\r\n<li>Install the JB LIbrary plugin and enable it in the extensions &gt; plugin manager</li>\r\n</ul>\r\n<p> </p>\r\n<p><strong>Optional Elements </strong></p>\r\n<ul>\r\n<li>Install JB Slideshow</li>\r\n<li>Install Microblog</li>\r\n<li>Install the JB BB Code plugin (For two line menus)</li>\r\n<li>Install K2</li>\r\n</ul>\r\n<p> </p>\r\n<p><strong>Elements to unpublish </strong></p>\r\n<ul>\r\n<li>Unpublish all modules in the right column</li>\r\n<li>Unpublish all modules in the left module position except for the resources module</li>\r\n<li>Disable the module title in the breadcrumb module</li>\r\n<li>Disable main menu items except for home menu item</li>\r\n</ul>\r\n<p> </p>\r\n<p><strong>Elements to publish</strong></p>\r\n<p>Publish the search module to the search position and do not enable the search button. Also ensure the search module title is unpublished.</p>\r\n<p> </p>\r\n<p><strong>Change the position of some elements on the page</strong></p>\r\n<p>Move main menu to the menu position and make sure the module title is disabled. While you are there also set the number of columns to 1 for the main menu item.</p>\r\n<p>While you are there if you intend to use the drop down menus ensure that you have set up the menu as per <a href=\"http://www.joomlabamboo.com/documentation/zen-grid-framework-setting-up-the-superfish-menu\" target=\"_blank\">this knowledgebase item</a> and also removed the module class _menu that the main menu ships with by default.</p>\r\n<p> </p>\r\n<p>At this stage you should have a pretty simple and straight forward site to start creating your site from. For a detailed anlalysis of how to setup the slideshow and microblog modules on the demo site please refer to the main Joomla Bamboo documentation for the Rasa template.  The screenshot below shows you the default Joomla installation after following the points above.</p>\r\n<p> </p>\r\n<p><img class=\"border\" src=\"images/stories/democontent/documentation/RasaFreshStart.jpg\" border=\"0\" alt=\"RasaFreshStart\" width=\"540\" height=\"1325\" /></p>',1,0,0,21,'2010-07-15 06:36:49',62,'','2010-10-09 10:15:04',62,0,'0000-00-00 00:00:00','2010-07-15 06:36:49','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',6,0,6,'','',1,65,'',0,'*',''),
	(115,133,'Installing the quickstart package','installing-the-quickstart-package','','<p>Most of our templates come with quickstart packages that are as easy as setting up a standard installation of Joomla. Different server setups can often have different requirements for setting up Joomla and its probably best to search the <a target=\"_self\" href=\"http://forum.joomla.org/\">Joomla.org</a> forums to get an overview of the type of server environment that Joomla requires, but lets assume you already have the server set up and you are ready to install A JB template plus the demo content you see on our demo sites.</p>\r\n<p><span style=\"line-height: 17px; font-size: 12px;\"> </span></p>\r\n','\r\n<p> </p>\r\n<p class=\"refresh\">The following is a step by step process for installing a Quick Start package on a cpanel server using Joomla 1.5.</p>\r\n<p>1. The first step is to download the quickstart package you want to use from the download area. We are in the process of updating all of our quick start template packages to V2.0 and thats what we are covering in this tutorial.</p>\r\n<p><img height=\"264\" width=\"500\" title=\"downloadarea.jpg\" alt=\"downloadarea.jpg\" border=\"0\" src=\"http://www.joomlabamboo.com/images/stories/quickstart/downloadarea.jpg\" class=\"border\" /></p>\r\n<p>2. You can then unzip and upload the package contents to your server using your favourite ftp client. Or fi you have shell access then you can upload the zip and unzip the zip directly on the server. Its much faster! In this example we are going to unzip the package on our local server into a folder called vision.</p>\r\n<p>We like using <a target=\"_blank\" href=\"http://www.panic.com/\">Coda</a> for our ftp client and <a target=\"_blank\" href=\"http://filezilla-project.org/download.php\">filezilla</a> is a great open source application for osx and windows.</p>\r\n<p>3. Next you need to navigate to the folder that you uploaded your package to. Your url might look like this http://www.mysite.com/joomla/index.php</p>\r\n<p>4. Once the page opens it should look something like the image below.Select the language you want to use with your installation and press next.</p>\r\n<p><img height=\"416\" width=\"500\" title=\"install 1\" alt=\"install1.jpg\" border=\"0\" src=\"http://www.joomlabamboo.com/images/stories/quickstart/install1.jpg\" class=\"border\" /></p>\r\n<p> </p>\r\n<p>5. The next page will give you a sense of your server compatibility. You will need to troubleshoot any of the flagged areas that are unsuitable for a Joomla installation before you continue here. Once you get the all clear ... click next again.</p>\r\n<p><img height=\"416\" width=\"500\" title=\"Install 2\" alt=\"install2.jpg\" border=\"0\" src=\"http://www.joomlabamboo.com/images/stories/quickstart/install2.jpg\" class=\"border\" /></p>\r\n<p> </p>\r\n<p>6. Install page 3 is the GNU/GPL page .. you need to agree to the terms before continuing.</p>\r\n<img height=\"416\" width=\"500\" title=\"install 3\" alt=\"Install Joomla 3\" border=\"0\" src=\"http://www.joomlabamboo.com/images/stories/quickstart/install3.jpg\" class=\"border\" />\r\n<p> </p>\r\n<p>7. Install page 4 is the database page. The details you enter here  are important as this is where the actual information for your Joomla installation are going to be stored. In a nutshell you need to create a mysql database, a user for the database and then assign that user to the database you created.This step requires a slight detour and we need to open up cpanl on our server.</p>\r\n<p><img height=\"416\" width=\"500\" title=\"install 4\" alt=\"Install Joomla 4\" border=\"0\" src=\"http://www.joomlabamboo.com/images/stories/quickstart/install4.jpg\" class=\"border\" /></p>\r\n<p> </p>\r\n<p>8. Open the cpanel account on your server. Most of the time you find this by navigating to http://www.mysite.com/cpanel. Once you have logged in navigate to the database area of the cpanel account. This may look different on your server depending on the theme ... but the image below shows you what it looks like on one of our servers.</p>\r\n<p><img height=\"113\" width=\"500\" title=\"databases.jpg\" alt=\"databases.jpg\" border=\"0\" src=\"http://www.joomlabamboo.com/images/stories/quickstart/databases.jpg\" class=\"border\" /></p>\r\n<p>You can use the database wizard to step through the process but for those who dont have the wizard on their cpanel install this is how you create the database.</p>\r\n<p>Click on the mysql database icon and write the name of the database you want to use for your site in the window provided. You can use any name you want to here. Click on the Create database button and you should receive a success message telling you that the database has been created.</p>\r\n<p><img height=\"113\" width=\"500\" title=\"databases.jpg\" alt=\"Create New database\" border=\"0\" src=\"http://www.joomlabamboo.com/images/stories/quickstart/newdb.jpg\" class=\"border\" /></p>\r\n<p> </p>\r\n<p>Navigate back to the mysql database page and scroll down to where the Create new mysql user input boxes are.</p>\r\n<img title=\"databases.jpg\" alt=\"Create new user for database\" border=\"0\" src=\"http://www.joomlabamboo.com/images/stories/quickstart/create_user.jpg\" class=\"border\" />\r\n<p> </p>\r\n<p>The username and password you put in here are really up to you, but for your Joomla site security its advisable that you use the random password generator if you have it on the page.</p>\r\n<p> </p>\r\n<p>After clicking Create New User you should receive the success message and you should then be able to navigate back to the mysql page and scroll down the page again. Take a note of the username and password - as we will need this later.</p>\r\n<p> </p>\r\n<p>You now need to assign the user to the database. So where it says \"Add user to database\" select the database and the user you have just created and make sure they appear in the top and the bottom drop down boxes.</p>\r\n<img title=\"databases.jpg\" alt=\"Add User to database\" border=\"0\" src=\"http://www.joomlabamboo.com/images/stories/quickstart/add.jpg\" class=\"border\" />\r\n<p> </p>\r\n<p>Once you have the new user and new database in the select boxes click add. The following screen should appear.</p>\r\n<img title=\"databases.jpg\" alt=\"Manage User\" border=\"0\" src=\"http://www.joomlabamboo.com/images/stories/quickstart/manage_user.jpg\" class=\"border\" />\r\n<p>Assign full or all privileges to the user and click \"make changes\" submit or add user or whichever submit button you have there. You should receive another success message telling you that your user ha been added to the database. You need to pay close attention to the names they use here as the database prefix and user prefix will be needed when filling out the information in the next step. As an example the dummy database we created while doing this tutorial is called test and on our server we can access it by using jbamboo_test.</p>\r\n<p> </p>\r\n<p>9. We are now ready to enter the information into the fourth installation screen. In Joomla 1.5 it gives you the option of choosing whetehr to use mysl or mysqli - in most cases you will choose MYSQL.</p>\r\n<p>In the label where it says host name you need to write the name provided by your host for your hosting plan. In most cases this should be localhost but on other server environments this may be different.</p>\r\n<p>In the username and password field enter the details from the previous step. Dont forget to put in the prefix to the database. Next is the database name field - grab the name of the database and put it in that field - when ready press next.</p>\r\n<p> </p>\r\n<p>10. The next page is where you configure the ftp settings for the site. The ftp layer was brought into J1.5 as  way of helping out with file permissions in some server configurations. Using it is optional and can be initiated later on when using your site. So you can either fill out the details and click next or simply click next.</p>\r\n<p><img height=\"439\" width=\"500\" title=\"install 5\" alt=\"Install Joomla 5\" border=\"0\" src=\"http://www.joomlabamboo.com/images/stories/quickstart/install5.jpg\" class=\"border\" /></p>\r\n<p> </p>\r\n<p>11. The next page is the sample data page and when using the quick start packages its really very important to install the sample data. Fill out the site name, email, admin name and password and then scroll down to the utton that says \"Install sample Data\" and click it. You should get a success message shortly afterwards which means all of the content from the demo site has been loaded into the database you created as a part of step 8.</p>\r\n<img height=\"439\" width=\"500\" title=\"Install 6\" alt=\"Install Joomla 6\" border=\"0\" src=\"http://www.joomlabamboo.com/images/stories/quickstart/install6.jpg\" class=\"border\" />\r\n<p> </p>\r\n<p>12. After clicking next you should reach the final page that tells you that you have successfully installed the package. There are two links on the top right hand corner that will take you to the front end and back end of your site but before you do that you need to remove or rename the instllation file in the Joomla directory. Navigate to the folder on your server and delete or rename.</p>\r\n<img height=\"439\" width=\"500\" title=\"success\" alt=\"Success\" border=\"0\" src=\"http://www.joomlabamboo.com/images/stories/quickstart/success.jpg\" class=\"border\" />\r\n<p> </p>\r\n<p>Once you have done that you should successfully be able to navigate to the front end of your site and see the template set up exactly the same way as the demo site.</p>\r\n<p class=\"person\">You are now free to edit, change and add to the site to personalise it and start to market your Joomla web presence. Good Luck.</p>',1,0,0,21,'2010-07-16 00:17:16',62,'','0000-00-00 00:00:00',0,0,'0000-00-00 00:00:00','2010-07-16 00:17:16','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',1,0,5,'','',1,18,'',0,'*',''),
	(116,134,'Working with the Zen Grid Framework','working-with-the-zen-grid-framework','','<img src=\"images/stories/democontent/zenGrid.gif\" width=\"442\" height=\"208\" alt=\"zenGrid\" class=\"border\" />\r\n<p> </p>\r\n<p>Grid2 is built on the Zen Grid Framework which makes changing, updating and editing the template incredibly easy. If you would like to learn more about the Zen Grid Framework take a look at the <a href=\"http://www.joomlabamboo.com/joomla-templates/2010-joomla-templates/zen-grid-framework\">Zen Grid feature item</a> on the Joomla Bamboo Site, or take a look through the <a href=\"http://www.joomlabamboo.com/documentation/zen-grid-2-documentation/zen-grid-framework-and-child-theme-installation\">Zen Grid framework knowledgebase</a>.</p>\r\n<p> </p>\r\n<p>For specific instructions on how best to implement the Grid2 template please refer to the Grid2 documentation on the Joomla Bamboo site. The Grid2 documentation highlights a few small changes to the way that the template is implemented within the framework and it also highlights the module settings required for some of the modules you see here on the demo site so its recommended that you look over that article as well as the core Zen Grid Framework documentation.</p>','',1,0,0,21,'2010-07-16 00:18:35',62,'','2010-09-06 04:58:07',62,0,'0000-00-00 00:00:00','2010-07-16 00:18:35','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',8,0,4,'','',1,24,'',0,'*',''),
	(117,191,'Friends and lovers','friends-and-lovers','','<p><img class=\"border floatleft\" src=\"images/democontent/slideshow/twostaring.jpg\" border=\"0\" alt=\"twostaring\" width=\"701\" height=\"240\" />Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,24,'2010-06-23 03:06:13',62,'','2011-07-23 09:04:08',42,0,'0000-00-00 00:00:00','2010-06-23 03:06:13','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',4,0,3,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(118,192,'Interior design for exterior people','interior-design-for-exterior-people','','<p><img class=\"border floatleft\" src=\"images/democontent/slideshow/golfguy.jpg\" border=\"0\" alt=\"golfguy\" width=\"701\" height=\"240\" />Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,24,'2010-07-10 07:22:09',62,'','2011-07-23 09:04:20',42,0,'0000-00-00 00:00:00','2010-07-10 07:22:09','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',5,0,2,'','',1,3,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(119,190,'Dont be afraid to commit to change','dont-be-afraid-to-commit-to-change','','<p><img class=\"border floatleft\" src=\"images/democontent/slideshow/woman.jpg\" border=\"0\" alt=\"woman\" width=\"621\" height=\"318\" />Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est.  Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',1,0,0,24,'2010-07-10 07:21:41',62,'','2011-07-23 09:03:56',42,0,'0000-00-00 00:00:00','2010-07-10 07:21:41','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',4,0,1,'','',1,0,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(120,205,'Joomla Bamboo Extensions','joomla-bamboo-extensions','','<p><img class=\"floatleft\" src=\"images/democontent/extensions/Microblog.png\" border=\"0\" alt=\"Microblog\" width=\"128\" height=\"128\" />This template is compatible with all of the extensions in the Joomla Bamboo catalogue. While not all extensions may be featured in the demo site you can safely use the extensions listed below on your site using this template.</p>\r\n<p> </p>\r\n','\r\n<p> </p>\r\n<p> </p>\r\n<h3>Joomla Bamboo Extensions</h3>\r\n<p>{loadposition extensions}</p>',1,0,0,22,'2010-07-17 03:41:52',62,'','2011-07-24 11:59:24',42,0,'0000-00-00 00:00:00','2010-07-17 03:41:52','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',18,0,4,'','',1,45,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*',''),
	(121,139,'Template Features','template-features','','<p>The following features are included in this template. You can also find information on the core features of the Zen Grid Framework and other Joomla Bamboo extensions on this demo site.</p>\r\n<p> </p>\r\n<p>{loadposition features}</p>','',1,0,0,23,'2010-07-17 03:56:13',62,'','2010-09-09 06:54:55',62,0,'0000-00-00 00:00:00','2010-07-17 03:56:13','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',3,0,15,'','',1,102,'',0,'*',''),
	(122,140,'Controlling widths in the framework','controlling-widths-in-the-framework','','<p>The layout for Zen Grid Framework compatible templates is very easy to control.&nbsp;The framework is built upon the logic that underpins the <a href=\"http://960.gs\" target=\"_blank\">960 Grid system</a> which divides the template width into 12 or 16 columns (depending on the setting you choose in the template administrator). The columns are then separated by a gutter, whose width is also defined in the template parameters, which serves to create an even separation between each column across the page.</p>\r\n<p>Controlling the width of each module block is a simple task that is either controlled by the template itself or determined by individual settings that you assign via the layout parameters. The positioning of the module elements is entirely intuitive via the framework control interface, which means its very easy for advanced or new users to control all elements of the layout of the template.</p>\r\n<p>For more information please visit the <a href=\"http://www.joomlabamboo.com/documentation/zen-grid-framework-general-layout-settings\">Zen Grid Framework knowledgebase</a>.</p>','',-2,0,0,25,'2010-07-17 04:15:23',62,'','2010-07-17 04:38:29',62,0,'0000-00-00 00:00:00','2010-07-17 04:15:23','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',7,0,1,'','',1,5,'',0,'*',''),
	(123,141,'__404__','404','__404__','<h1>Bad karma: we can\'t find that page!</h1>\r\n<p>You asked for <strong>{%sh404SEF_404_URL%}</strong>, but despite our computers looking very hard, we could not find it. What happened ?</p>\r\n<ul>\r\n<li>the link you clicked to arrive here has a typo in it</li>\r\n<li>or somehow we removed that page, or gave it another name</li>\r\n<li>or, quite unlikely for sure, maybe you typed it yourself and there was a little mistake ?</li>\r\n</ul>\r\n<h4>{sh404sefSimilarUrlsCommentStart}It\'s not the end of everything though : you may be interested in the following pages on our site:{sh404sefSimilarUrlsCommentEnd}</h4>\r\n<p>{sh404sefSimilarUrls}</p>\r\n<p> </p>','',1,0,0,2,'2009-01-09 12:00:00',62,'','2010-08-25 11:25:12',62,0,'2009-01-09 12:00:00','2009-01-09 12:00:00','0000-00-00 00:00:00','','','{\"menu_image\":-1,\"show_title\":0,\"show_section\":0,\"show_category\":\"0show_vote=0\",\"show_author\":0,\"show_create_date\":0,\"show_modify_date\":0,\"show_pdf_icon\":0,\"show_print_icon\":0,\"show_email_icon\":0,\"pageclass_sfx\":\"\"}',1,0,0,'','',1,0,'',0,'*',''),
	(124,142,'Amber Hendry','amber-hendry','','<img class=\"border floatleft\" src=\"images/stories/democontent/people/7475803_s.jpg\" width=\"267\" height=\"274\" alt=\"7475803_s\" />\r\n<p> </p>\r\n<p>Donec quis sem sed dui porta ultrices vitae nec nibh. Quisque pulvinar ipsum sed felis tristique sagittis. Aliquam sit amet nunc mauris. Praesent id condimentum dui. Morbi ultricies elit at magna ornare consequat. Fusce id tortor ante, accumsan ultricies justo.</p>\r\n','\r\n<p> </p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed blandit mi quis ante congue dictum. Fusce diam lacus, varius cursus volutpat nec, vulputate sed nulla. Suspendisse rhoncus nibh vitae tellus fringilla vel egestas neque feugiat. Nam fringilla elit non erat viverra facilisis. Quisque sodales, nulla eu posuere placerat, est massa consequat ipsum, vel vestibulum erat sem ac sapien. In hac habitasse platea dictumst. Donec elementum turpis erat.</p>',-2,0,0,27,'2010-08-26 04:57:03',62,'','2010-09-10 02:00:45',62,0,'0000-00-00 00:00:00','2010-08-26 04:57:03','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',8,0,8,'lover geek designer coder','',1,3,'',0,'*',''),
	(125,143,'Seb Wonder','seb-wonder','','<img alt=\"7355830_s\" height=\"400\" width=\"267\" src=\"images/stories/democontent/people/7355830_s.jpg\" class=\"border floatleft\" />\r\n<p> </p>\r\n<p>Donec quis sem sed dui porta ultrices vitae nec nibh. Quisque pulvinar ipsum sed felis tristique sagittis. Aliquam sit amet nunc mauris. Praesent id condimentum dui. Morbi ultricies elit at magna ornare consequat. Fusce id tortor ante, accumsan ultricies justo.</p>\r\n','\r\n<p> </p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed blandit mi quis ante congue dictum. Fusce diam lacus, varius cursus volutpat nec, vulputate sed nulla. Suspendisse rhoncus nibh vitae tellus fringilla vel egestas neque feugiat. Nam fringilla elit non erat viverra facilisis. Quisque sodales, nulla eu posuere placerat, est massa consequat ipsum, vel vestibulum erat sem ac sapien. In hac habitasse platea dictumst. Donec elementum turpis erat.</p>',-2,0,0,27,'2010-08-26 04:57:03',62,'','2010-09-10 02:00:39',62,0,'0000-00-00 00:00:00','2010-08-26 04:57:03','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',6,0,7,'lover designer coder geek','',1,1,'',0,'*',''),
	(126,144,'Peter Julius','peter-julius','','<img alt=\"7191695_s\" height=\"267\" width=\"400\" src=\"images/stories/democontent/people/7191695_s.jpg\" class=\"border floatleft\" />\r\n<p> </p>\r\n<p>Donec quis sem sed dui porta ultrices vitae nec nibh. Quisque pulvinar ipsum sed felis tristique sagittis. Aliquam sit amet nunc mauris. Praesent id condimentum dui. Morbi ultricies elit at magna ornare consequat. Fusce id tortor ante, accumsan ultricies justo.</p>\r\n','\r\n<p> </p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed blandit mi quis ante congue dictum. Fusce diam lacus, varius cursus volutpat nec, vulputate sed nulla. Suspendisse rhoncus nibh vitae tellus fringilla vel egestas neque feugiat. Nam fringilla elit non erat viverra facilisis. Quisque sodales, nulla eu posuere placerat, est massa consequat ipsum, vel vestibulum erat sem ac sapien. In hac habitasse platea dictumst. Donec elementum turpis erat.</p>',-2,0,0,27,'2010-08-26 04:57:03',62,'','2010-09-10 02:00:33',62,0,'0000-00-00 00:00:00','2010-08-26 04:57:03','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',4,0,6,'lover geek coder','',1,6,'',0,'*',''),
	(127,145,'Tonya Winter','tonya-winter','','<img alt=\"7178365_s\" height=\"267\" width=\"400\" src=\"images/stories/democontent/people/7178365_s.jpg\" class=\"border floatleft\" />\r\n<p> </p>\r\n<p>Donec quis sem sed dui porta ultrices vitae nec nibh. Quisque pulvinar ipsum sed felis tristique sagittis. Aliquam sit amet nunc mauris. Praesent id condimentum dui. Morbi ultricies elit at magna ornare consequat. Fusce id tortor ante, accumsan ultricies justo.</p>\r\n','\r\n<p> </p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed blandit mi quis ante congue dictum. Fusce diam lacus, varius cursus volutpat nec, vulputate sed nulla. Suspendisse rhoncus nibh vitae tellus fringilla vel egestas neque feugiat. Nam fringilla elit non erat viverra facilisis. Quisque sodales, nulla eu posuere placerat, est massa consequat ipsum, vel vestibulum erat sem ac sapien. In hac habitasse platea dictumst. Donec elementum turpis erat.</p>',-2,0,0,27,'2010-08-26 04:57:03',62,'','2010-09-10 02:00:28',62,0,'0000-00-00 00:00:00','2010-08-26 04:57:03','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',6,0,5,'lover geek admin','',1,7,'',0,'*',''),
	(128,146,'Anton Briggs','anton-briggs','','<img class=\"border floatleft\" src=\"images/stories/democontent/people/6433914_s.jpg\" width=\"267\" height=\"245\" alt=\"6433914_s\" />\r\n<p> </p>\r\n<p>Donec quis sem sed dui porta ultrices vitae nec nibh. Quisque pulvinar ipsum sed felis tristique sagittis. Aliquam sit amet nunc mauris. Praesent id condimentum dui. Morbi ultricies elit at magna ornare consequat. Fusce id tortor ante, accumsan ultricies justo.</p>\r\n','\r\n<p> </p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed blandit mi quis ante congue dictum. Fusce diam lacus, varius cursus volutpat nec, vulputate sed nulla. Suspendisse rhoncus nibh vitae tellus fringilla vel egestas neque feugiat. Nam fringilla elit non erat viverra facilisis. Quisque sodales, nulla eu posuere placerat, est massa consequat ipsum, vel vestibulum erat sem ac sapien. In hac habitasse platea dictumst. Donec elementum turpis erat.</p>',-2,0,0,27,'2010-08-26 04:57:03',62,'','2010-09-10 02:00:23',62,0,'0000-00-00 00:00:00','2010-08-26 04:57:03','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',5,0,4,'fighter geek coder admin','',1,3,'',0,'*',''),
	(129,147,'Matt Stokes','matt-stokes','','<p> <img alt=\"5447898_s\" height=\"400\" width=\"327\" src=\"images/stories/democontent/people/5447898_s.jpg\" class=\"border floatleft\" />\r\n</p>\r\n<p>Donec quis sem sed dui porta ultrices vitae nec nibh. Quisque pulvinar ipsum sed felis tristique sagittis. Aliquam sit amet nunc mauris. Praesent id condimentum dui. Morbi ultricies elit at magna ornare consequat. Fusce id tortor ante, accumsan ultricies justo.</p>\r\n','\r\n<p> </p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed blandit mi quis ante congue dictum. Fusce diam lacus, varius cursus volutpat nec, vulputate sed nulla. Suspendisse rhoncus nibh vitae tellus fringilla vel egestas neque feugiat. Nam fringilla elit non erat viverra facilisis. Quisque sodales, nulla eu posuere placerat, est massa consequat ipsum, vel vestibulum erat sem ac sapien. In hac habitasse platea dictumst. Donec elementum turpis erat.</p>',-2,0,0,27,'2010-08-26 04:57:03',62,'','2010-09-11 06:32:11',62,0,'0000-00-00 00:00:00','2010-08-26 04:57:03','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',6,0,3,'designer lover','',1,6,'',0,'*',''),
	(130,148,'Jessica Han','jessica-han','','<p><img class=\"border floatleft\" src=\"images/stories/democontent/people/4194217_s.jpg\" width=\"400\" height=\"267\" alt=\"4194217_s\" />\r\n</p>\r\n<p>Donec quis sem sed dui porta ultrices vitae nec nibh. Quisque pulvinar ipsum sed felis tristique sagittis. Aliquam sit amet nunc mauris. Praesent id condimentum dui. Morbi ultricies elit at magna ornare consequat. Fusce id tortor ante, accumsan ultricies justo.</p>\r\n','\r\n<p> </p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed blandit mi quis ante congue dictum. Fusce diam lacus, varius cursus volutpat nec, vulputate sed nulla. Suspendisse rhoncus nibh vitae tellus fringilla vel egestas neque feugiat. Nam fringilla elit non erat viverra facilisis. Quisque sodales, nulla eu posuere placerat, est massa consequat ipsum, vel vestibulum erat sem ac sapien. In hac habitasse platea dictumst. Donec elementum turpis erat.</p>',-2,0,0,27,'2010-08-26 04:57:03',62,'','2010-09-11 06:14:54',62,0,'0000-00-00 00:00:00','2010-08-26 04:57:03','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',10,0,2,'designer admin fighter','',1,8,'',0,'*',''),
	(131,149,'Sarah Watson','sarah-watson','','<p><img class=\"border floatleft\" src=\"images/stories/democontent/people/215462_s.jpg\" width=\"400\" height=\"266\" alt=\"215462_s\" />\r\n</p>\r\n<p>Donec quis sem sed dui porta ultrices vitae nec nibh. Quisque pulvinar ipsum sed felis tristique sagittis. Aliquam sit amet nunc mauris. Praesent id condimentum dui. Morbi ultricies elit at magna ornare consequat. Fusce id tortor ante, accumsan ultricies justo.</p>\r\n','\r\n<p> </p>\r\n<p>Lorem ipsum dolor sit amet, consectetur adipiscing elit. Sed blandit mi quis ante congue dictum. Fusce diam lacus, varius cursus volutpat nec, vulputate sed nulla. Suspendisse rhoncus nibh vitae tellus fringilla vel egestas neque feugiat. Nam fringilla elit non erat viverra facilisis. Quisque sodales, nulla eu posuere placerat, est massa consequat ipsum, vel vestibulum erat sem ac sapien. In hac habitasse platea dictumst. Donec elementum turpis erat.</p>',-2,0,0,27,'2010-08-26 04:57:03',62,'','2010-09-11 06:14:42',62,0,'0000-00-00 00:00:00','2010-08-26 04:57:03','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',6,0,1,'coder lover designer','',1,11,'',0,'*',''),
	(132,150,'Microblog - Column View','microblog-column-view','','<p><img class=\"floatleft\" src=\"images/stories/democontent/extensions/Microblog.png\" width=\"128\" height=\"128\" alt=\"Microblog\" />&nbsp;The column layout for the Microblog module is flexible column based solution for displaying a selection of your k2 or Joomla content in a module. The styling for the Microblog module has some extra styling from the Rasa template.</p>\r\n<p> </p>\r\n<p> </p>\r\n<p> </p>\r\n<p><b>Demonstration</b></p>\r\n<p>{loadposition microblog2}</p>\r\n<p><b><br /></b></p>','',-2,0,0,26,'2010-08-26 05:04:09',62,'','2010-09-14 05:06:08',62,0,'0000-00-00 00:00:00','2010-08-26 05:04:09','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',21,0,11,'','',1,427,'',0,'*',''),
	(133,151,'Microblog - Max Biz View','microblog-max-biz-view','','<img alt=\"Microblog\" height=\"128\" width=\"128\" src=\"images/stories/democontent/extensions/Microblog.png\" class=\"floatleft\" />\r\n<p>The MaxBiz view for the Microblog module is a layout that was derived for the Template called MaxBiz that was released back in July 2008.</p>\r\n<p> </p>\r\n<p> </p>\r\n<p> </p>\r\n<p> </p><p>{loadposition microblog5}</p>\r\n<p><b><br /></b></p>','',-2,0,0,26,'2010-08-26 05:04:09',62,'','2010-09-14 04:47:11',62,0,'0000-00-00 00:00:00','2010-08-26 05:04:09','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',4,0,9,'','',1,19,'',0,'*',''),
	(134,152,'Microblog - Flat View','microblog-flat-view','','<img class=\"floatleft\" src=\"images/stories/democontent/extensions/Microblog.png\" width=\"128\" height=\"128\" alt=\"Microblog\" />\r\n<p>The flat view is a microblog format that gives you a nice readable display of selected content from your site.</p>\r\n<p> </p>\r\n<p> </p>\r\n<p> </p>\r\n<p> </p>\r\n<p><b>Demonstration</b></p>\r\n<p>{loadposition microblog3}</p>\r\n<p><b><br /></b></p>','',-2,0,0,26,'2010-08-26 05:04:09',62,'','2010-09-14 04:45:44',62,0,'0000-00-00 00:00:00','2010-08-26 05:04:09','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',5,0,14,'','',1,19,'',0,'*',''),
	(135,153,'Microblog - Title Date View','microblog-title-date-view','','<img class=\"floatleft\" src=\"images/stories/democontent/extensions/Microblog.png\" width=\"128\" height=\"128\" alt=\"Microblog\" />\r\n<p>This microblog view is a simple flat list with the option to display the date. You can also choose to launch the introtext in a lightbox as per the other microblog views.</p>\r\n<p> </p>\r\n<p> </p>\r\n<b> Demonstration </b>\r\n<p>{loadposition microblog6}</p>\r\n<p><b><br /></b></p>','',-2,0,0,26,'2010-08-26 05:04:09',62,'','2010-09-14 04:43:53',62,0,'0000-00-00 00:00:00','2010-08-26 05:04:09','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',4,0,10,'','',1,14,'',0,'*',''),
	(136,154,'Microblog - Leading then list View','microblog-leading-then-list-view','','<img class=\"floatleft\" src=\"images/stories/democontent/extensions/Microblog.png\" width=\"128\" height=\"128\" alt=\"Microblog\" />\r\n<p>The leading then list view displays the image and introtext from the first item in the module then displays the rest of the items in the module in a flat list. It\'s a great layout to use for new portals or magazine layouts where you might want to show a teaser of what\'s available in a category without showing everything.</p>\r\n<p> </p>\r\n<p> </p>\r\n<p><b>Demonstration</b></p>\r\n<p>{loadposition microblog4}</p>','',-2,0,0,26,'2010-08-26 05:04:09',62,'','2010-09-14 04:42:25',62,0,'0000-00-00 00:00:00','2010-08-26 05:04:09','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',5,0,13,'','',1,11,'',0,'*',''),
	(137,155,'Microblog - Filter View','microblog-filter-view','','<p><img class=\"floatleft\" src=\"images/stories/democontent/extensions/Microblog.png\" width=\"128\" height=\"128\" alt=\"Microblog\" />Our team is made up of all sorts of creative people. Check out who is who by clicking on the links below.</p>\r\n<p> </p>\r\n<p>{loadposition microblog1}</p>\r\n<p> </p>\r\n<p>The filter view is a new view for the Microblog module and is really very simple to use.&nbsp;</p>\r\n<p><b><br /></b></p>','',-2,0,0,26,'2010-08-26 05:04:09',62,'','2010-09-14 04:37:20',62,0,'0000-00-00 00:00:00','2010-08-26 05:04:09','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',4,0,12,'','',1,15,'',0,'*',''),
	(138,156,'Recreating the frontpage layout','recreating-the-frontpage-layout','','<p>The front page layout of the Rasa template is reasonably straightforward. The main focus is the use of our JB Slideshow module in the advert1 position and the microblog module in the advert4 position. You can see screenshots of the settings used for these module below.</p>\r\n','\r\n<p> </p>\r\n<img class=\"border\" alt=\"Frontpagesetup\" height=\"980\" width=\"574\" src=\"images/stories/democontent/documentation/Frontpagesetup.jpg\" />\r\n<p><b>General Overview</b></p>\r\n<p>Here is a quick run down of the modules we have used on the front page of the demo site.</p>\r\n<ul>\r\n<li>The contact us menu is a core Joomla menu module published to top1.</li>\r\n<li>The twitter and Rss feed buttons int he top right are social networking buttons that are hardcoded into the template. The settings that control these buttons are located in the template parameters under the appearance tab.</li>\r\n<li>The logo is controlled in the template parameters also and has a width of 4 cols to match the width of the left column below it.</li>\r\n<li>The slogan at the top of the page is a custom html module published to the header4 module position and has a width of 8 cols set.</li>\r\n<li>The main menu is a core Joomla menu published the menu position. You can see a full run down of the settings required to recreate the layout and the superfish menu in the <a href=\"http://www.joomlabamboo.com/documentation/zen-grid-framework-setting-up-the-superfish-menu\" target=\"_blank\">Zen Grid Framework documentation</a>. The two line menu is achieved by using our slight reworking of the original YVBB plugin that renders BB code anywhere on your Joomla site. Take a look at the <a href=\"index.php?option=com_content&amp;view=article&amp;id=139:creating-two-line-menu-items&amp;catid=48&amp;Itemid=79\">creating &nbsp;a two line menu</a> tutorial for more information on how to do this.</li>\r\n<li>The search module is positioned int he search position and is a core Joomla search position.</li>\r\n</ul>\r\n<p> </p>\r\n<p><b>Setting up the slideshow</b></p>\r\n<p><img class=\"floatleft\" alt=\"Slideshow\" height=\"128\" width=\"128\" src=\"images/stories/democontent/extensions/Slideshow.png\" />The slideshow module has the ability to display both Joomla content items and K2 items in a content fading / sliding / scrolling &nbsp;module. The demo site uses Joomla content to display the content and the settings that were used are below:</p>\r\n<div class=\"clear\"></div>\r\n<p><img class=\"border\" alt=\"ERasaSlideshowFrontpage\" height=\"5024\" width=\"536\" src=\"images/stories/democontent/documentation/ERasaSlideshowFrontpage.png\" /></p>\r\n<p> </p>\r\n<p><b>Microblog Settings</b></p>\r\n<p><img src=\"images/stories/democontent/extensions/Microblog.png\" width=\"128\" height=\"128\" alt=\"Microblog\" class=\"floatleft\" />The following screenshot highlights the settings used for the microblog module on the front page of the rasa demo site.</p>\r\n<p><b><br /></b></p>\r\n<p><img src=\"images/stories/democontent/documentation/RasaFrontpageMicroblog.png\" width=\"536\" height=\"4656\" alt=\"RasaFrontpageMicroblog\" class=\"border\" /></p>',1,0,0,21,'2010-09-13 10:19:35',62,'','2010-09-14 05:27:29',62,0,'0000-00-00 00:00:00','2010-09-13 10:19:35','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":0,\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":0,\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',16,0,3,'','',1,10,'',0,'*',''),
	(139,157,'Creating two line menu items','creating-two-line-menu-items','','<p><img src=\"images/stories/democontent/documentation/twolinemenuitems.jpg\" width=\"453\" height=\"109\" alt=\"twolinemenuitems\" class=\"border\" />&nbsp;</p>\r\n<p>One of the striking features of the Rasa template is the two line menu that you can see at the top of the page. This menu system uses the core Joomla menu module in addition to a slightly revamped version of the <a target=\"_blank\" href=\"http://yurivolkov.com/Joomla/yvBBCode/index_en.html\">YVBB bbcode plugin</a> that was featured on the <a href=\"http://www.joomlabamboo.com/blog/tutorials/creating-two-line-menus-in-joomla\">Joomla Bamboo blog</a>. We have rewritten parts of this plug-in to make it compatible for use in Joomla menu items without the code getting rendered in the breadcrumbs on your site.</p>\r\n<p> </p>\r\n','\r\n<p>For those of you who are new to bbcode, its the code that is traditionally used in forums and some comment systems - or a more in depth explanation from the&nbsp;<a href=\"http://www.bbcode.org/\" target=\"_blank\" style=\"color: #333333;\">BBCode website</a>:</p>\r\n<p><strong>\"It is similar to HTML in the sense that in BBCode one does also use&nbsp;</strong><em><strong>tags</strong></em><strong> to format something specific (contained within the tag). In BBCode tags are indicated by rectangular brackets surrounding a keyword, which is in turn transformed into HTML before being delivered to a web browser.\"</strong></p>\r\n<p> </p>\r\n<h4>The beauty of this plugin is that it has the ability to transform bbcode anywhere in Joomla.&nbsp;</h4>\r\n<p>Joomla\'s normal behaviour is to either strip out any html or render the actual html markup whenever you want to add it to fields such as content item titles, menu item titles etc The YVBB plugin on the otherhand, allows you to render html markup in menu items, content titles or any other field that you can normally only affect at a deeper template level.</p>\r\n<p> </p>\r\n<p><strong>So when it comes to creating a two line menu item with the core Joomla menu - this plugin makes it very easy.</strong></p>\r\n<p>The following screenshot highlights the syntax we have used on the demo site. &nbsp;You don\'t of course have to use this exact syntax and you can specify any other type of BB code syntax for your menu items.</p>\r\n<p><img class=\"border\" src=\"images/stories/democontent/documentation/twolinemenusyntax.png\" width=\"455\" height=\"132\" alt=\"twolinemenusyntax\" /></p>\r\n<p> </p>\r\n<p> </p>\r\n<p><strong>As you can see the plugin also renders the BBCode in the joomla admin.</strong></p>\r\n<p><img class=\"border\" src=\"images/stories/democontent/documentation/twolinemenusyntaxrenders.png\" width=\"450\" height=\"131\" alt=\"twolinemenusyntaxrenders\" /></p>\r\n<p> </p>\r\n<p> </p>\r\n<p>The plugin can also (of course) render bbcode in content items and there are some very handy article linking options available also. Check out the <a target=\"_blank\" href=\"http://yurivolkov.com/Joomla/yvBBCode/index_en.html\">documentation page for an overview of the other features of the plugin</a>.</p>',1,0,0,21,'2010-09-13 11:15:28',62,'','2010-09-14 05:09:55',62,0,'0000-00-00 00:00:00','2010-09-13 11:15:28','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',9,0,2,'','',1,7,'',0,'*',''),
	(140,158,'Recreating the home menu item','recreating-the-home-menu-item','','<p>You have probably noticed that the home menuitem on the Rasa demo uses an icon rather than the words home. There are a few ways to replicate this in Joomla but the way we chose to do it for the demo was to use the JB BB plugin which is based on the YV BB plugin - that can be used to render bbcode anywhere in Joomla.</p>\r\n','\r\n<p>The process to do this is very simple - involving two steps if you have already installed the bbcode plugin.</p>\r\n<p> </p>\r\n<p>1. Upload the image you want to use for the home menu. (The one we used on the demo is available in the template\'s zip.)</p>\r\n<p>2. Edit the home menu item and add the following code:</p>\r\n<p> </p>\r\n<p>[jb_code}[img ]images/stories/home.png[/img ][/jb_code}</p>\r\n<p> </p>\r\n<p><b>(Where home.png is the filename of the image you want to use for the menu item.). Also please note that there is an extra space int he code above to prevent the plugin from rendering the image here on this page.</b></p>\r\n<p><b><br /></b></p>\r\n<p>You can see how we have done this in the screenshot below:</p>\r\n<p><img class=\"border\" alt=\"imageMenu\" height=\"243\" width=\"540\" src=\"images/stories/democontent/documentation/imageMenu.jpg\" /></p>\r\n<p>For ease of use you may like to make it an absolute link eg [img]http://mysite.com/images/stories/home.png[/img]. Using an absolute url in the admin means that the ho,em image will show up in the menu manager just like the screenshot below:</p>\r\n<p><img src=\"images/stories/democontent/documentation/imageMenuExample%20in%20backend.jpg\" width=\"540\" height=\"243\" alt=\"imageMenuExample in backend\" class=\"border\" /></p>',1,0,0,21,'2010-09-14 05:33:15',62,'','2010-09-14 05:49:17',62,0,'0000-00-00 00:00:00','2010-09-14 05:33:15','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_section\":\"\",\"link_section\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_vote\":\"\",\"show_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_pdf_icon\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"language\":\"\",\"keyref\":\"\",\"readmore\":\"\"}',10,0,1,'','',1,11,'',0,'*',''),
	(141,206,'Module classes','module-classes','','<p>The Rasa template has a range of colourful variations of the base module classes that you see on the demo. There are essentially two types of module classes - a standard module title with a bevel edge underline and the smaller more discreet ribbon class.</p>\r\n<p> </p>\r\n','\r\n<p> </p>\r\n<p>Each theme in the Rasa template uses a different colour for the base -ribbon class suffix. You can see in the screenshot below how to recreate the smaller -ribbon class.</p>\r\n<p><img src=\"images/democontent/documentation/ribbon.jpg\" border=\"0\" alt=\"ribbon\" width=\"495\" height=\"166\" /></p>\r\n<p> </p>\r\n<p>This base colour can be overwritten by adding a colour to -ribbon class suffix as per the screenshot below:</p>\r\n<p><img src=\"images/democontent/documentation/ribbonPlusColour.jpg\" border=\"0\" alt=\"ribbonPlusColour\" width=\"495\" height=\"166\" /></p>\r\n<p> </p>\r\n<p>There are 13 colour variations to choose from:</p>\r\n<p>{loadposition moduleclasses}</p>',1,0,0,22,'2010-09-14 10:36:43',62,'','2011-07-24 11:59:54',42,0,'0000-00-00 00:00:00','2010-09-14 10:36:43','0000-00-00 00:00:00','','','{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_vote\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"alternative_readmore\":\"\",\"article_layout\":\"\"}',3,0,1,'','',1,22,'{\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}',0,'*','');

/*!40000 ALTER TABLE `#__content` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__content_frontpage
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__content_frontpage`;

CREATE TABLE `#__content_frontpage` (
  `content_id` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`content_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__content_frontpage` WRITE;
/*!40000 ALTER TABLE `#__content_frontpage` DISABLE KEYS */;

INSERT INTO `#__content_frontpage` (`content_id`, `ordering`)
VALUES
	(56,3),
	(82,2),
	(81,1);

/*!40000 ALTER TABLE `#__content_frontpage` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__extensions
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__extensions`;

CREATE TABLE `#__extensions` (
  `extension_id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(100) NOT NULL,
  `type` varchar(20) NOT NULL,
  `element` varchar(100) NOT NULL,
  `folder` varchar(100) NOT NULL,
  `client_id` tinyint(3) NOT NULL,
  `enabled` tinyint(3) NOT NULL DEFAULT '1',
  `access` int(10) unsigned DEFAULT NULL,
  `protected` tinyint(3) NOT NULL DEFAULT '0',
  `manifest_cache` text NOT NULL,
  `params` text NOT NULL,
  `custom_data` text NOT NULL,
  `system_data` text NOT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) DEFAULT '0',
  `state` int(11) DEFAULT '0',
  PRIMARY KEY (`extension_id`),
  KEY `element_clientid` (`element`,`client_id`),
  KEY `element_folder_clientid` (`element`,`folder`,`client_id`),
  KEY `extension` (`type`,`element`,`folder`,`client_id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__extensions` WRITE;
/*!40000 ALTER TABLE `#__extensions` DISABLE KEYS */;

INSERT INTO `#__extensions` (`extension_id`, `name`, `type`, `element`, `folder`, `client_id`, `enabled`, `access`, `protected`, `manifest_cache`, `params`, `custom_data`, `system_data`, `checked_out`, `checked_out_time`, `ordering`, `state`)
VALUES
	(1,'com_mailto','component','com_mailto','',0,1,1,1,'{\"legacy\":false,\"name\":\"com_mailto\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_MAILTO_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(2,'com_wrapper','component','com_wrapper','',0,1,1,1,'{\"legacy\":false,\"name\":\"com_wrapper\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(3,'com_admin','component','com_admin','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_admin\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_ADMIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(4,'com_banners','component','com_banners','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_banners\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}','{\"purchase_type\":\"3\",\"track_impressions\":\"0\",\"track_clicks\":\"0\",\"metakey_prefix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(5,'com_cache','component','com_cache','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_cache\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_CACHE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(6,'com_categories','component','com_categories','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_categories\",\"type\":\"component\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(7,'com_checkin','component','com_checkin','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_checkin\",\"type\":\"component\",\"creationDate\":\"Unknown\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2008 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_CHECKIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(8,'com_contact','component','com_contact','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_contact\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_CONTACT_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_contact_category\":\"hide\",\"show_contact_list\":\"0\",\"presentation_style\":\"sliders\",\"show_name\":\"1\",\"show_position\":\"1\",\"show_email\":\"0\",\"show_street_address\":\"1\",\"show_suburb\":\"1\",\"show_state\":\"1\",\"show_postcode\":\"1\",\"show_country\":\"1\",\"show_telephone\":\"1\",\"show_mobile\":\"1\",\"show_fax\":\"1\",\"show_webpage\":\"1\",\"show_misc\":\"1\",\"show_image\":\"1\",\"image\":\"\",\"allow_vcard\":\"0\",\"show_articles\":\"0\",\"show_profile\":\"0\",\"show_links\":\"0\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"contact_icons\":\"0\",\"icon_address\":\"\",\"icon_email\":\"\",\"icon_telephone\":\"\",\"icon_mobile\":\"\",\"icon_fax\":\"\",\"icon_misc\":\"\",\"show_headings\":\"1\",\"show_position_headings\":\"1\",\"show_email_headings\":\"0\",\"show_telephone_headings\":\"1\",\"show_mobile_headings\":\"0\",\"show_fax_headings\":\"0\",\"allow_vcard_headings\":\"0\",\"show_suburb_headings\":\"1\",\"show_state_headings\":\"1\",\"show_country_headings\":\"1\",\"show_email_form\":\"1\",\"show_email_copy\":\"1\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"1\",\"custom_reply\":\"0\",\"redirect\":\"\",\"show_category_crumb\":\"0\",\"metakey\":\"\",\"metadesc\":\"\",\"robots\":\"\",\"author\":\"\",\"rights\":\"\",\"xreference\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(9,'com_cpanel','component','com_cpanel','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_cpanel\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_CPANEL_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(10,'com_installer','component','com_installer','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_installer\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_INSTALLER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(11,'com_languages','component','com_languages','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_languages\",\"type\":\"component\",\"creationDate\":\"2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}','{\"administrator\":\"en-GB\",\"site\":\"en-GB\"}','','',0,'0000-00-00 00:00:00',0,0),
	(12,'com_login','component','com_login','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_login\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(13,'com_media','component','com_media','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_media\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_MEDIA_XML_DESCRIPTION\",\"group\":\"\"}','{\"upload_extensions\":\"bmp,csv,doc,gif,ico,jpg,jpeg,odg,odp,ods,odt,pdf,png,ppt,swf,txt,xcf,xls,BMP,CSV,DOC,GIF,ICO,JPG,JPEG,ODG,ODP,ODS,ODT,PDF,PNG,PPT,SWF,TXT,XCF,XLS\",\"upload_maxsize\":\"10\",\"file_path\":\"images\",\"image_path\":\"images\",\"restrict_uploads\":\"1\",\"allowed_media_usergroup\":\"3\",\"check_mime\":\"1\",\"image_extensions\":\"bmp,gif,jpg,png\",\"ignore_extensions\":\"\",\"upload_mime\":\"image\\/jpeg,image\\/gif,image\\/png,image\\/bmp,application\\/x-shockwave-flash,application\\/msword,application\\/excel,application\\/pdf,application\\/powerpoint,text\\/plain,application\\/x-zip\",\"upload_mime_illegal\":\"text\\/html\",\"enable_flash\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(14,'com_menus','component','com_menus','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_menus\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_MENUS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(15,'com_messages','component','com_messages','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_messages\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_MESSAGES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(16,'com_modules','component','com_modules','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_modules\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_MODULES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(17,'com_newsfeeds','component','com_newsfeeds','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_newsfeeds\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_feed_image\":\"1\",\"show_feed_description\":\"1\",\"show_item_description\":\"1\",\"feed_word_count\":\"0\",\"show_headings\":\"1\",\"show_name\":\"1\",\"show_articles\":\"0\",\"show_link\":\"1\",\"show_description\":\"1\",\"show_description_image\":\"1\",\"display_num\":\"\",\"show_pagination_limit\":\"1\",\"show_pagination\":\"1\",\"show_pagination_results\":\"1\",\"show_cat_items\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(18,'com_plugins','component','com_plugins','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_plugins\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_PLUGINS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(19,'com_search','component','com_search','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_search\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}','{\"enabled\":\"0\",\"show_date\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(20,'com_templates','component','com_templates','',1,1,1,1,'{\"legacy\":false,\"name\":\"com_templates\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_TEMPLATES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(21,'com_weblinks','component','com_weblinks','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_weblinks\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\n\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{\"show_comp_description\":\"1\",\"comp_description\":\"\",\"show_link_hits\":\"1\",\"show_link_description\":\"1\",\"show_other_cats\":\"0\",\"show_headings\":\"0\",\"show_numbers\":\"0\",\"show_report\":\"1\",\"count_clicks\":\"1\",\"target\":\"0\",\"link_icons\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(22,'com_content','component','com_content','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_content\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{\"article_layout\":\"_:default\",\"show_title\":\"1\",\"link_titles\":\"1\",\"show_intro\":\"1\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"0\",\"show_author\":\"1\",\"link_author\":\"1\",\"show_create_date\":\"1\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"1\",\"show_vote\":\"0\",\"show_readmore\":\"1\",\"show_readmore_title\":\"0\",\"readmore_limit\":\"100\",\"show_icons\":\"1\",\"show_print_icon\":\"1\",\"show_email_icon\":\"1\",\"show_hits\":\"0\",\"show_noauth\":\"0\",\"category_layout\":\"_:blog\",\"show_category_title\":\"0\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"maxLevel\":\"1\",\"show_empty_categories\":\"0\",\"show_no_articles\":\"1\",\"show_subcat_desc\":\"1\",\"show_cat_num_articles\":\"0\",\"show_base_description\":\"1\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"0\",\"show_subcat_desc_cat\":\"1\",\"show_cat_num_articles_cat\":\"1\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"0\",\"show_subcategory_content\":\"0\",\"show_pagination_limit\":\"1\",\"filter_field\":\"hide\",\"show_headings\":\"1\",\"list_show_date\":\"0\",\"date_format\":\"\",\"list_show_hits\":\"1\",\"list_show_author\":\"1\",\"orderby_pri\":\"order\",\"orderby_sec\":\"rdate\",\"order_date\":\"published\",\"show_pagination\":\"2\",\"show_pagination_results\":\"1\",\"show_feed_link\":\"1\",\"feed_summary\":\"0\",\"filters\":{\"1\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"6\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"7\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"2\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"3\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"4\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"5\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"10\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"12\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"8\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"}}}','','',0,'0000-00-00 00:00:00',0,0),
	(23,'com_config','component','com_config','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_config\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_CONFIG_XML_DESCRIPTION\",\"group\":\"\"}','{\"filters\":{\"1\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"6\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"7\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"2\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"3\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"4\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"5\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"},\"8\":{\"filter_type\":\"BL\",\"filter_tags\":\"\",\"filter_attributes\":\"\"}}}','','',0,'0000-00-00 00:00:00',0,0),
	(24,'com_redirect','component','com_redirect','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_redirect\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(25,'com_users','component','com_users','',1,1,0,1,'{\"legacy\":false,\"name\":\"com_users\",\"type\":\"component\",\"creationDate\":\"April 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\\t\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"COM_USERS_XML_DESCRIPTION\",\"group\":\"\"}','{\"allowUserRegistration\":\"1\",\"new_usertype\":\"2\",\"useractivation\":\"1\",\"frontend_userparams\":\"1\",\"mailSubjectPrefix\":\"\",\"mailBodySuffix\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(100,'PHPMailer','library','phpmailer','',0,1,1,1,'{\"legacy\":false,\"name\":\"PHPMailer\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"PHPMailer\",\"copyright\":\"Copyright (C) PHPMailer.\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/phpmailer.codeworxtech.com\\/\",\"version\":\"1.7.0\",\"description\":\"Classes for sending email\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(101,'SimplePie','library','simplepie','',0,1,1,1,'{\"legacy\":false,\"name\":\"SimplePie\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"SimplePie\",\"copyright\":\"Copyright (C) 2008 SimplePie\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/simplepie.org\\/\",\"version\":\"1.0.1\",\"description\":\"A PHP-Based RSS and Atom Feed Framework.\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(102,'phputf8','library','phputf8','',0,1,1,1,'{\"legacy\":false,\"name\":\"phputf8\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"Harry Fuecks\",\"copyright\":\"Copyright various authors\",\"authorEmail\":\"\",\"authorUrl\":\"http:\\/\\/sourceforge.net\\/projects\\/phputf8\",\"version\":\"1.7.0\",\"description\":\"Classes for UTF8\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(103,'Joomla! Web Application Framework','library','joomla','',0,1,1,1,'{\"legacy\":false,\"name\":\"Joomla! Web Application Framework\",\"type\":\"library\",\"creationDate\":\"2008\",\"author\":\"Joomla\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"The Joomla! Web Application Framework is the Core of the Joomla! Content Management System\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(200,'mod_articles_archive','module','mod_articles_archive','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_archive\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters.\\n\\t\\tAll rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_ARTICLES_ARCHIVE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(201,'mod_articles_latest','module','mod_articles_latest','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_LATEST_NEWS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(202,'mod_articles_popular','module','mod_articles_popular','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_articles_popular\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(203,'mod_banners','module','mod_banners','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_banners\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_BANNERS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(204,'mod_breadcrumbs','module','mod_breadcrumbs','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_breadcrumbs\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_BREADCRUMBS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(205,'mod_custom','module','mod_custom','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(206,'mod_feed','module','mod_feed','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(207,'mod_footer','module','mod_footer','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_footer\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_FOOTER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(208,'mod_login','module','mod_login','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(209,'mod_menu','module','mod_menu','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(210,'mod_articles_news','module','mod_articles_news','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_articles_news\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_ARTICLES_NEWS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(211,'mod_random_image','module','mod_random_image','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_random_image\",\"type\":\"module\",\"creationDate\":\"July 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_RANDOM_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(212,'mod_related_items','module','mod_related_items','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_related_items\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_RELATED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(213,'mod_search','module','mod_search','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_search\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_SEARCH_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(214,'mod_stats','module','mod_stats','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_stats\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_STATS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(215,'mod_syndicate','module','mod_syndicate','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_syndicate\",\"type\":\"module\",\"creationDate\":\"May 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_SYNDICATE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(216,'mod_users_latest','module','mod_users_latest','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_users_latest\",\"type\":\"module\",\"creationDate\":\"December 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_USERS_LATEST_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(217,'mod_weblinks','module','mod_weblinks','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_weblinks\",\"type\":\"module\",\"creationDate\":\"July 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(218,'mod_whosonline','module','mod_whosonline','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_whosonline\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_WHOSONLINE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(219,'mod_wrapper','module','mod_wrapper','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_wrapper\",\"type\":\"module\",\"creationDate\":\"October 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_WRAPPER_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(220,'mod_articles_category','module','mod_articles_category','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_category\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters.\\n\\t\\tAll rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_ARTICLES_CATEGORY_XML_DESCRIPTION\\n\\t\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(221,'mod_articles_categories','module','mod_articles_categories','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_articles_categories\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_ARTICLES_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(222,'mod_languages','module','mod_languages','',0,1,1,1,'{\"legacy\":false,\"name\":\"mod_languages\",\"type\":\"module\",\"creationDate\":\"February 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_LANGUAGES_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(300,'mod_custom','module','mod_custom','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_custom\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_CUSTOM_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(301,'mod_feed','module','mod_feed','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_feed\",\"type\":\"module\",\"creationDate\":\"July 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_FEED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(302,'mod_latest','module','mod_latest','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_latest\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_LATEST_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(303,'mod_logged','module','mod_logged','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_logged\",\"type\":\"module\",\"creationDate\":\"January 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_LOGGED_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(304,'mod_login','module','mod_login','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_login\",\"type\":\"module\",\"creationDate\":\"March 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_LOGIN_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(305,'mod_menu','module','mod_menu','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_menu\",\"type\":\"module\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_MENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(306,'mod_online','module','mod_online','',1,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(307,'mod_popular','module','mod_popular','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_popular\",\"type\":\"module\",\"creationDate\":\"July 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_POPULAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(308,'mod_quickicon','module','mod_quickicon','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_quickicon\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_QUICKICON_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(309,'mod_status','module','mod_status','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_status\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_STATUS_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(310,'mod_submenu','module','mod_submenu','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_submenu\",\"type\":\"module\",\"creationDate\":\"Feb 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_SUBMENU_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(311,'mod_title','module','mod_title','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_title\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_TITLE_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(312,'mod_toolbar','module','mod_toolbar','',1,1,1,1,'{\"legacy\":false,\"name\":\"mod_toolbar\",\"type\":\"module\",\"creationDate\":\"Nov 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"MOD_TOOLBAR_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(313,'mod_unread','module','mod_unread','',1,1,1,0,'','','','',0,'0000-00-00 00:00:00',0,0),
	(400,'plg_authentication_gmail','plugin','gmail','authentication',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_authentication_gmail\",\"type\":\"plugin\",\"creationDate\":\"February 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_GMAIL_XML_DESCRIPTION\",\"group\":\"\"}','{\"applysuffix\":\"0\",\"suffix\":\"\",\"verifypeer\":\"1\",\"user_blacklist\":\"\"}','','',0,'0000-00-00 00:00:00',1,0),
	(401,'plg_authentication_joomla','plugin','joomla','authentication',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_authentication_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_AUTH_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(402,'plg_authentication_ldap','plugin','ldap','authentication',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_authentication_ldap\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_LDAP_XML_DESCRIPTION\",\"group\":\"\"}','{\"host\":\"\",\"port\":\"389\",\"use_ldapV3\":\"0\",\"negotiate_tls\":\"0\",\"no_referrals\":\"0\",\"auth_method\":\"bind\",\"base_dn\":\"\",\"search_string\":\"\",\"users_dn\":\"\",\"username\":\"admin\",\"password\":\"bobby7\",\"ldap_fullname\":\"fullName\",\"ldap_email\":\"mail\",\"ldap_uid\":\"uid\"}','','',0,'0000-00-00 00:00:00',3,0),
	(404,'plg_content_emailcloak','plugin','emailcloak','content',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_content_emailcloak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_CONTENT_EMAILCLOAK_XML_DESCRIPTION\",\"group\":\"\"}','{\"mode\":\"1\"}','','',0,'0000-00-00 00:00:00',1,0),
	(405,'plg_content_geshi','plugin','geshi','content',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_content_geshi\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"\",\"authorUrl\":\"qbnz.com\\/highlighter\",\"version\":\"1.7.0\",\"description\":\"PLG_CONTENT_GESHI_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),
	(406,'plg_content_loadmodule','plugin','loadmodule','content',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_content_loadmodule\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_LOADMODULE_XML_DESCRIPTION\",\"group\":\"\"}','{\"style\":\"none\"}','','',0,'0000-00-00 00:00:00',0,0),
	(407,'plg_content_pagebreak','plugin','pagebreak','content',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_content_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_CONTENT_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}','{\"title\":\"1\",\"multipage_toc\":\"1\",\"showall\":\"1\"}','','',0,'0000-00-00 00:00:00',4,0),
	(408,'plg_content_pagenavigation','plugin','pagenavigation','content',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_content_pagenavigation\",\"type\":\"plugin\",\"creationDate\":\"January 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_PAGENAVIGATION_XML_DESCRIPTION\",\"group\":\"\"}','{\"position\":\"1\"}','','',0,'0000-00-00 00:00:00',5,0),
	(409,'plg_content_vote','plugin','vote','content',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_content_vote\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_VOTE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',6,0),
	(410,'plg_editors_codemirror','plugin','codemirror','editors',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors_codemirror\",\"type\":\"plugin\",\"creationDate\":\"28 March 2011\",\"author\":\"Marijn Haverbeke\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"1.0\",\"description\":\"PLG_CODEMIRROR_XML_DESCRIPTION\",\"group\":\"\"}','{\"linenumbers\":\"0\",\"tabmode\":\"indent\"}','','',0,'0000-00-00 00:00:00',1,0),
	(411,'plg_editors_none','plugin','none','editors',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors_none\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Unknown\",\"copyright\":\"\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"\",\"version\":\"1.7.0\",\"description\":\"PLG_NONE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),
	(412,'plg_editors_tinymce','plugin','tinymce','editors',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors_tinymce\",\"type\":\"plugin\",\"creationDate\":\"2005-2011\",\"author\":\"Moxiecode Systems AB\",\"copyright\":\"Moxiecode Systems AB\",\"authorEmail\":\"N\\/A\",\"authorUrl\":\"tinymce.moxiecode.com\\/\",\"version\":\"3.4.3.2\",\"description\":\"PLG_TINY_XML_DESCRIPTION\",\"group\":\"\"}','{\"mode\":\"1\",\"skin\":\"0\",\"compressed\":\"0\",\"cleanup_startup\":\"0\",\"cleanup_save\":\"2\",\"entity_encoding\":\"raw\",\"lang_mode\":\"0\",\"lang_code\":\"en\",\"text_direction\":\"ltr\",\"content_css\":\"1\",\"content_css_custom\":\"\",\"relative_urls\":\"1\",\"newlines\":\"0\",\"invalid_elements\":\"script,applet,iframe\",\"extended_elements\":\"\",\"toolbar\":\"top\",\"toolbar_align\":\"left\",\"html_height\":\"550\",\"html_width\":\"750\",\"element_path\":\"1\",\"fonts\":\"1\",\"paste\":\"1\",\"searchreplace\":\"1\",\"insertdate\":\"1\",\"format_date\":\"%Y-%m-%d\",\"inserttime\":\"1\",\"format_time\":\"%H:%M:%S\",\"colors\":\"1\",\"table\":\"1\",\"smilies\":\"1\",\"media\":\"1\",\"hr\":\"1\",\"directionality\":\"1\",\"fullscreen\":\"1\",\"style\":\"1\",\"layer\":\"1\",\"xhtmlxtras\":\"1\",\"visualchars\":\"1\",\"nonbreaking\":\"1\",\"template\":\"1\",\"blockquote\":\"1\",\"wordcount\":\"1\",\"advimage\":\"1\",\"advlink\":\"1\",\"autosave\":\"1\",\"contextmenu\":\"1\",\"inlinepopups\":\"1\",\"safari\":\"0\",\"custom_plugin\":\"\",\"custom_button\":\"\"}','','',0,'0000-00-00 00:00:00',3,0),
	(413,'plg_editors-xtd_article','plugin','article','editors-xtd',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_editors-xtd_article\",\"type\":\"plugin\",\"creationDate\":\"October 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_ARTICLE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),
	(414,'plg_editors-xtd_image','plugin','image','editors-xtd',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_editors-xtd_image\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_IMAGE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',2,0),
	(415,'plg_editors-xtd_pagebreak','plugin','pagebreak','editors-xtd',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_editors-xtd_pagebreak\",\"type\":\"plugin\",\"creationDate\":\"August 2004\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_EDITORSXTD_PAGEBREAK_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0),
	(416,'plg_editors-xtd_readmore','plugin','readmore','editors-xtd',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_editors-xtd_readmore\",\"type\":\"plugin\",\"creationDate\":\"March 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_READMORE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',4,0),
	(417,'plg_search_categories','plugin','categories','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_categories\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SEARCH_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(418,'plg_search_contacts','plugin','contacts','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_contacts\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SEARCH_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(419,'plg_search_content','plugin','content','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_content\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SEARCH_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(420,'plg_search_newsfeeds','plugin','newsfeeds','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SEARCH_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(421,'plg_search_weblinks','plugin','weblinks','search',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_search_weblinks\",\"type\":\"plugin\",\"creationDate\":\"November 2005\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SEARCH_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_content\":\"1\",\"search_archived\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(422,'plg_system_languagefilter','plugin','languagefilter','system',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_system_languagefilter\",\"type\":\"plugin\",\"creationDate\":\"July 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SYSTEM_LANGUAGEFILTER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),
	(423,'plg_system_p3p','plugin','p3p','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_p3p\",\"type\":\"plugin\",\"creationDate\":\"September 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_P3P_XML_DESCRIPTION\",\"group\":\"\"}','{\"headers\":\"NOI ADM DEV PSAi COM NAV OUR OTRo STP IND DEM\"}','','',0,'0000-00-00 00:00:00',2,0),
	(424,'plg_system_cache','plugin','cache','system',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_system_cache\",\"type\":\"plugin\",\"creationDate\":\"February 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_CACHE_XML_DESCRIPTION\",\"group\":\"\"}','{\"browsercache\":\"0\",\"cachetime\":\"15\"}','','',0,'0000-00-00 00:00:00',9,0),
	(425,'plg_system_debug','plugin','debug','system',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_system_debug\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_DEBUG_XML_DESCRIPTION\",\"group\":\"\"}','{\"profile\":\"1\",\"queries\":\"1\",\"memory\":\"1\",\"language_files\":\"1\",\"language_strings\":\"1\",\"strip-first\":\"1\",\"strip-prefix\":\"\",\"strip-suffix\":\"\"}','','',0,'0000-00-00 00:00:00',4,0),
	(426,'plg_system_log','plugin','log','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_log\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_LOG_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',5,0),
	(427,'plg_system_redirect','plugin','redirect','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_redirect\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_REDIRECT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',6,0),
	(428,'plg_system_remember','plugin','remember','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_remember\",\"type\":\"plugin\",\"creationDate\":\"April 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_REMEMBER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',7,0),
	(429,'plg_system_sef','plugin','sef','system',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_system_sef\",\"type\":\"plugin\",\"creationDate\":\"December 2007\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SEF_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',8,0),
	(430,'plg_system_logout','plugin','logout','system',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_system_logout\",\"type\":\"plugin\",\"creationDate\":\"April 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_SYSTEM_LOGOUT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',3,0),
	(431,'plg_user_contactcreator','plugin','contactcreator','user',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_user_contactcreator\",\"type\":\"plugin\",\"creationDate\":\"August 2009\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_CONTACTCREATOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"autowebpage\":\"\",\"category\":\"34\",\"autopublish\":\"0\"}','','',0,'0000-00-00 00:00:00',1,0),
	(432,'plg_user_joomla','plugin','joomla','user',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_user_joomla\",\"type\":\"plugin\",\"creationDate\":\"December 2006\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2009 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_USER_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{\"autoregister\":\"1\"}','','',0,'0000-00-00 00:00:00',2,0),
	(433,'plg_user_profile','plugin','profile','user',0,0,1,1,'{\"legacy\":false,\"name\":\"plg_user_profile\",\"type\":\"plugin\",\"creationDate\":\"January 2008\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_USER_PROFILE_XML_DESCRIPTION\",\"group\":\"\"}','{\"register-require_address1\":\"1\",\"register-require_address2\":\"1\",\"register-require_city\":\"1\",\"register-require_region\":\"1\",\"register-require_country\":\"1\",\"register-require_postal_code\":\"1\",\"register-require_phone\":\"1\",\"register-require_website\":\"1\",\"register-require_favoritebook\":\"1\",\"register-require_aboutme\":\"1\",\"register-require_tos\":\"1\",\"register-require_dob\":\"1\",\"profile-require_address1\":\"1\",\"profile-require_address2\":\"1\",\"profile-require_city\":\"1\",\"profile-require_region\":\"1\",\"profile-require_country\":\"1\",\"profile-require_postal_code\":\"1\",\"profile-require_phone\":\"1\",\"profile-require_website\":\"1\",\"profile-require_favoritebook\":\"1\",\"profile-require_aboutme\":\"1\",\"profile-require_tos\":\"1\",\"profile-require_dob\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(434,'plg_extension_joomla','plugin','joomla','extension',0,1,1,1,'{\"legacy\":false,\"name\":\"plg_extension_joomla\",\"type\":\"plugin\",\"creationDate\":\"May 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_EXTENSION_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',1,0),
	(435,'plg_content_joomla','plugin','joomla','content',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_content_joomla\",\"type\":\"plugin\",\"creationDate\":\"November 2010\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"PLG_CONTENT_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(500,'atomic','template','atomic','',0,1,1,0,'{\"legacy\":false,\"name\":\"atomic\",\"type\":\"template\",\"creationDate\":\"10\\/10\\/09\",\"author\":\"Ron Severdia\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"contact@kontentdesign.com\",\"authorUrl\":\"http:\\/\\/www.kontentdesign.com\",\"version\":\"1.7.0\",\"description\":\"TPL_ATOMIC_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(502,'bluestork','template','bluestork','',1,1,1,0,'{\"legacy\":false,\"name\":\"bluestork\",\"type\":\"template\",\"creationDate\":\"07\\/02\\/09\",\"author\":\"Ron Severdia\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"contact@kontentdesign.com\",\"authorUrl\":\"http:\\/\\/www.kontentdesign.com\",\"version\":\"1.7.0\",\"description\":\"TPL_BLUESTORK_XML_DESCRIPTION\",\"group\":\"\"}','{\"useRoundedCorners\":\"1\",\"showSiteName\":\"0\",\"textBig\":\"0\",\"highContrast\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(503,'beez_20','template','beez_20','',0,1,1,0,'{\"legacy\":false,\"name\":\"beez_20\",\"type\":\"template\",\"creationDate\":\"25 November 2009\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"1.7.0\",\"description\":\"TPL_BEEZ2_XML_DESCRIPTION\",\"group\":\"\"}','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"templatecolor\":\"nature\"}','','',0,'0000-00-00 00:00:00',0,0),
	(504,'hathor','template','hathor','',1,1,1,0,'{\"legacy\":false,\"name\":\"hathor\",\"type\":\"template\",\"creationDate\":\"May 2010\",\"author\":\"Andrea Tarr\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"hathor@tarrconsulting.com\",\"authorUrl\":\"http:\\/\\/www.tarrconsulting.com\",\"version\":\"1.7.0\",\"description\":\"TPL_HATHOR_XML_DESCRIPTION\",\"group\":\"\"}','{\"showSiteName\":\"0\",\"colourChoice\":\"0\",\"boldText\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(505,'beez5','template','beez5','',0,1,1,0,'{\"legacy\":false,\"name\":\"beez5\",\"type\":\"template\",\"creationDate\":\"21 May 2010\",\"author\":\"Angie Radtke\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters, Inc. All rights reserved.\",\"authorEmail\":\"a.radtke@derauftritt.de\",\"authorUrl\":\"http:\\/\\/www.der-auftritt.de\",\"version\":\"1.7.0\",\"description\":\"TPL_BEEZ5_XML_DESCRIPTION\",\"group\":\"\"}','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"sitetitle\":\"\",\"sitedescription\":\"\",\"navposition\":\"center\",\"html5\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(600,'English (United Kingdom)','language','en-GB','',0,1,1,1,'{\"legacy\":false,\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"en-GB site language\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(601,'English (United Kingdom)','language','en-GB','',1,1,1,1,'{\"legacy\":false,\"name\":\"English (United Kingdom)\",\"type\":\"language\",\"creationDate\":\"2008-03-15\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"en-GB administrator language\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(700,'files_joomla','file','joomla','',0,1,1,1,'{\"legacy\":false,\"name\":\"files_joomla\",\"type\":\"file\",\"creationDate\":\"July 2011\",\"author\":\"Joomla!\",\"copyright\":\"(C) 2005 - 2011 Open Source Matters. All rights reserved\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.3\",\"description\":\"FILES_JOOMLA_XML_DESCRIPTION\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(10000,'ZenGridFramework','template','zengridframework','',0,1,1,0,'{\"legacy\":false,\"name\":\"Zen Grid Framework\",\"type\":\"template\",\"creationDate\":\"October, 2009\",\"author\":\"Anthony Olsen\",\"copyright\":\"(C) 2007 - 2010 Joomla Bamboo. All rights reserved.\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"www.joomlabamboo.com\",\"version\":\"1.1.1\",\"description\":\"TPL_ZEN_XML_DESCRIPTION\",\"group\":\"\"}','[]','','',0,'0000-00-00 00:00:00',0,0),
	(10001,'System - JB Library','plugin','jblibrary','system',0,1,1,0,'{\"legacy\":false,\"name\":\"System - JB Library\",\"type\":\"plugin\",\"creationDate\":\"Feb 2009\",\"author\":\"Joomla Bamboo\",\"copyright\":\"(C) 2007-2009 Joomla Bamboo\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"www.joomlabamboo.com\",\"version\":\"1.0\",\"description\":\"JB_LIBRARY_DESC\",\"group\":\"\"}','{\"jQueryVersion\":\"1.6\",\"source\":\"local\",\"noConflict\":\"1\",\"jqunique\":\"1\",\"jqregex\":\"([\\\\\\/a-zA-Z0-9_:\\\\.-]*)jquery([0-9\\\\.-]|min|pack)*?.js\",\"stripCustom\":\"0\",\"customScripts\":\"mootools-core.js,\",\"stripMootools\":\"0\",\"replaceMootools\":\"0\",\"mootoolsPath\":\"http:\\/\\/ajax.googleapis.com\\/ajax\\/libs\\/mootools\\/1.2.4\\/mootools-yui-compressed.js\",\"stripMootoolsMore\":\"0\",\"ie6Warning\":\"1\",\"scrollTop\":\"1\",\"scrollStyle\":\"dark\",\"scrollText\":\"^ Back to Top\",\"lazyLoad\":\"0\",\"llSelector\":\"img\"}','','',42,'2011-07-20 06:17:56',0,0),
	(10002,'JB Slideshow v3.0','module','mod_slideshow3','',0,1,0,0,'{\"legacy\":false,\"name\":\"JB Slideshow v3.0\",\"type\":\"module\",\"creationDate\":\"April 2011\",\"author\":\"Joomla Bamboo\",\"copyright\":\"This extension in released under the GNU\\/GPL License - http:\\/\\/www.gnu.org\\/copyleft\\/gpl.html\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"http:\\/\\/www.joomlabamboo.com\",\"version\":\"1.0.2\",\"description\":\"JB Slideshow scrolls and fades latest news and images of your choice in a module position.\",\"group\":\"\"}','{\"display_ticker\":\"1\",\"display_slideshow\":\"1\",\"info1\":\"The following options determine how the css and javascript\\/jquery files are referenced on your site. The option to load the scripts in the head of the template is ideal but will not work if Joomla cache is turned on. The option to load them in the website body is easy but is not xhtml compliant. The last option disables the scripts all together and is ideal if you are using more than one instance of the module on the page. If you select the last option then you need to make sure that the scripts are included at least once on the page in your template or via another module.\",\"loadCSS\":\"head\",\"loadJS\":\"head\",\"ssTheme\":\"None\",\"ticker_transition\":\"fade\",\"slideshow_height\":\"400\",\"slideshow_width\":\"100%\",\"sstime\":\"10000\",\"ssSpeed\":\"1500\",\"content_image\":\"1\",\"imageLink\":\"1\",\"image_top\":\"0\",\"image_left\":\"380\",\"imgBorder\":\"1\",\"info2\":\"The options below are only relevant if you have selected directory as the source for the image in the settings above.\",\"imagedirectory\":\"\",\"lowercase\":\"0\",\"fileType\":\"jpg\",\"imageResize\":\"1\",\"image_width\":\"555\",\"image_height\":\"347\",\"option\":\"1\",\"count\":\"5\",\"show_front\":\"show\",\"category_filtering_type\":\"1\",\"catid\":\"\",\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"author_filtering_type\":\"1\",\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"ticker_height\":\"260\",\"ticker_width\":\"360\",\"margin_top\":\"100\",\"margin_left\":\"0\",\"bgOverlay\":\"no\",\"item_title\":\"1\",\"title_class\":\"h2\",\"title_link\":\"1\",\"linkTarget\":\"article\",\"ticker_text\":\"1\",\"introtext_limit\":\"40\",\"striptags\":\"yes\",\"tags\":\"<a><ul><li><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"render\",\"createdDate\":\"1\",\"dateFormat\":\"j M, y\",\"readMoreText\":\"Read More ...\",\"readMoreLink\":\"1\",\"showCategory\":\"0\",\"catLink\":\"0\",\"catPrefix\":\"Posted in\",\"display_nav\":\"thumbsNav\",\"navWidth\":\"400\",\"navHeight\":\"400\",\"navTop\":\"0\",\"navLeft\":\"0\",\"navButtons\":\"on\",\"navPrevText\":\"<<  Previous\",\"navNextText\":\"Next  >>\",\"scrollNav\":\"vertical\",\"numVis\":\"3\",\"navItemWidth\":\"40\",\"navItemHeight\":\"40\",\"titleLimit\":\"0\",\"titleSuffix\":\"...\",\"fadeEffect\":\"1\",\"hoverTransition\":\"no\",\"thumb_width\":\"60\",\"thumb_height\":\"40\",\"thumb_option\":\"1\",\"tickerIntro\":\" \",\"showDescriptionText\":\"none\",\"descriptionText\":\"\",\"descriptionMarginTop\":\"0\",\"descriptionMarginLeft\":\"0\",\"descriptionHeight\":\"50\",\"descriptionWidth\":\"100\",\"descriptionOverlay\":\"no\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10005,'JFlickr','module','mod_jflickr','',0,1,0,0,'{\"legacy\":false,\"name\":\"JFlickr\",\"type\":\"module\",\"creationDate\":\"August 2008\",\"author\":\"Joomla Bamboo\",\"copyright\":\"(C) 2008 Joomla Bamboo. All rights reserved.\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"www.joomlabamboo.com\",\"version\":\"1.2.0\",\"description\":\"MOD_JFLICKR_XML_DESCRIPTION\",\"group\":\"\"}','{\"number\":\"16\",\"type\":\"s\",\"photoset_id\":\"981332\",\"text\":\"\",\"sort\":\"relevance\",\"tags\":\"\",\"apiKey\":\"f28804be7a09c5845676349c7e47d636\",\"user_id\":\"\",\"group_id\":\"\",\"loadCSS\":\"head\",\"loadJS\":\"head\",\"tsize\":\"s\",\"size\":\"\",\"fancybox\":\"yes\",\"fancyboxScript\":\"yes\",\"fancyEasing\":\"yes\",\"fancyOverlayShow\":\"true\",\"fancyOverlay\":\"0.6\",\"fancyPadding\":\"30\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10006,'JB MicroBlog','module','mod_microblog','',0,1,0,0,'{\"legacy\":false,\"name\":\"JB MicroBlog\",\"type\":\"module\",\"creationDate\":\"April 2011\",\"author\":\"Joomla Bamboo\",\"copyright\":\"This extension in released under the GNU\\/GPL License - http:\\/\\/www.gnu.org\\/copyleft\\/gpl.html\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"http:\\/\\/www.joomlabamboo.com\",\"version\":\"1.0.4\",\"description\":\"The microblog module displays the latest news from selected sections and categories and controls whether the intro text is displayed, the time of the post, whether the title is a link and whether or not to display a read more button. For more information please check the documentation at http:\\/\\/www.joomlabamboo.com\",\"group\":\"\"}','{\"layout\":\"flat\",\"mbHeight\":\"\",\"info1\":\"The following options determine how the css and javascript\\/jquery files are referenced on your site. The option to load the scripts in the head of the template is ideal but will not work if Joomla cache is turned on. The option to load them in the website body is easy but is not xhtml compliant. The last option disables the scripts all together and is ideal if you are using more than one instance of the module on the page. If you select the last option then you need to make sure that the scripts are included at least once on the page in your template or via another module.\",\"loadCSS\":\"head\",\"loadJS\":\"head\",\"count\":\"5\",\"show_front\":\"show\",\"category_filtering_type\":\"1\",\"catid\":\"\",\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"author_filtering_type\":\"1\",\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"titlelink\":\"2\",\"linkTarget\":\"article\",\"titleClass\":\"h2\",\"titleLimit\":\"0\",\"titleSuffix\":\"\",\"showintro\":\"1\",\"wordCount\":\"\",\"introSuffix\":\"\",\"strip_tags\":\"1\",\"allowed_tags\":\"<p><a><ul><li><div><h1><h2><h3><h4><h5><h6><b><em><i><strong><blockquote><dd><dt><small><u><br><br \\/>\",\"renderPlugin\":\"strip\",\"displayMore\":\"1\",\"readonText\":\"\",\"showdate\":\"1\",\"dateFormat\":\"j M, y\",\"showCategory\":\"0\",\"catLink\":\"0\",\"catPrefix\":\"Posted in\",\"displayImages\":\"1\",\"resizeImage\":\"1\",\"image_width\":\"245\",\"image_height\":\"100\",\"option\":\"1\",\"fadeEffect\":\"1\",\"cbTheme\":\"1\",\"popupGallery\":\"1\",\"justImage\":\"1\",\"overlayOpacity\":\"0.6\",\"frameWidth\":\"800\",\"frameHeight\":\"500\",\"colorboxScrolling\":\"false\",\"addMargin\":\"1\",\"rightMargin\":\"5\",\"bottomMargin\":\"5\",\"imagesPerRow\":\"3\",\"colClearDiv\":\"1\",\"trigger1\":\"\",\"trigger2\":\"\",\"trigger3\":\"\",\"trigger4\":\"\",\"trigger5\":\"\",\"trigger6\":\"\",\"trigger7\":\"\",\"trigger8\":\"\",\"trigger9\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10008,'JBRasa','template','jbrasa','',0,1,1,0,'{\"legacy\":false,\"name\":\"JB Rasa\",\"type\":\"template\",\"creationDate\":\"June, 2009\",\"author\":\"Anthony Olsen\",\"copyright\":\"Joomla Bamboo, 2010.\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"www.joomlabamboo.com\",\"version\":\"1.1.4\",\"description\":\"TPL_ZEN_XML_DESCRIPTION\",\"group\":\"\"}','{\"rootCheck\":\"1\",\"zenTranslate\":\"1\",\"hilite\":\"hiliteGreen\",\"logoType\":\"text\",\"logoClass\":\"p\",\"logoPosition\":\"above\",\"logoText\":\"Rasa\",\"fontStackLogo\":\"Josefin\",\"logoFontSize\":\"2em\",\"logoWidth\":\"four\",\"logoLink\":\"index.php\",\"logoAltTag\":\"\",\"fonts\":\"3\",\"fontStackBody\":\"helvetica\",\"fontStackHeading\":\"georgia\",\"fontStackNav\":\"helvetica\",\"fontSize\":\"78%\",\"typekit\":\"0\",\"typekitId\":\"\",\"position\":\"center\",\"containerMargin\":\"150px\",\"tWidth\":\"960\",\"cols\":\"12\",\"allEqual\":\"0\",\"gutter\":\"20\",\"controlMainArea\":\"0\",\"topEqual\":\"0\",\"top1Width\":\"two\",\"top2Width\":\"two\",\"top3Width\":\"two\",\"top4Width\":\"six\",\"headerEqual\":\"0\",\"header1Width\":\"two\",\"header2Width\":\"six\",\"header3Width\":\"two\",\"header4Width\":\"two\",\"navLeft\":\"1\",\"navWidth\":\"twelve\",\"grid1Equal\":\"1\",\"grid1Width\":\"nine\",\"grid2Width\":\"nine\",\"grid3Width\":\"three\",\"grid4Width\":\"three\",\"grid2Equal\":\"1\",\"grid5Width\":\"six\",\"grid6Width\":\"six\",\"grid7Width\":\"three\",\"grid8Width\":\"six\",\"grid3Equal\":\"1\",\"grid9Width\":\"three\",\"grid10Width\":\"six\",\"grid11Width\":\"three\",\"grid12Width\":\"three\",\"mainLayout\":\"1\",\"advert1Width\":\"eight\",\"advert2Width\":\"four\",\"advert3Width\":\"four\",\"advert4Width\":\"eight\",\"advert5Width\":\"two\",\"advert6Width\":\"two\",\"grid4Equal\":\"1\",\"grid13Width\":\"three\",\"grid14Width\":\"three\",\"grid15Width\":\"three\",\"grid16Width\":\"three\",\"grid5Equal\":\"1\",\"grid17Width\":\"three\",\"grid18Width\":\"three\",\"grid19Width\":\"three\",\"grid20Width\":\"three\",\"grid6Equal\":\"1\",\"grid21Width\":\"three\",\"grid22Width\":\"three\",\"grid23Width\":\"three\",\"grid24Width\":\"three\",\"bottomEqual\":\"1\",\"bottom1Width\":\"three\",\"bottom2Width\":\"three\",\"bottom3Width\":\"three\",\"bottom4Width\":\"two\",\"bottom5Width\":\"three\",\"superfish\":\"yes\",\"sfEffect\":\"3\",\"sfSpeed\":\"normal\",\"sfhover\":\"1\",\"sfDelay\":\"800\",\"sfMinWidth\":\"10\",\"sfMaxWidth\":\"30\",\"openPanel\":\"Open Panel\",\"paneltype\":\"opacity\",\"panelHeight\":\"500\",\"panelWidth\":\"320\",\"panelEqual\":\"0\",\"panel1Width\":\"four\",\"panel2Width\":\"six\",\"panel3Width\":\"four\",\"panel4Width\":\"four\",\"analyticsPosition\":\"after\",\"analytics\":\"\",\"csscompress\":\"0\",\"combinescripts\":\"0\",\"removeMootools\":\"0\",\"removeJgen\":\"1\",\"disableTP\":\"0\",\"banner\":\"1\",\"bottom\":\"1\",\"closeContainer\":\"1\",\"footer\":\"1\",\"frontpage\":\"1\",\"grid1\":\"1\",\"grid2\":\"1\",\"grid3\":\"1\",\"grid4\":\"1\",\"grid5\":\"1\",\"grid6\":\"1\",\"header\":\"1\",\"main\":\"1\",\"nav\":\"1\",\"openContainer\":\"0\",\"panel\":\"1\",\"top\":\"1\",\"overwriteCSS\":\"0\",\"bodyColour\":\"\",\"aColour\":\"\",\"ahoverColour\":\"\",\"taglineCSS\":\"\",\"h1Colour\":\"\",\"h2Colour\":\"\",\"h3Colour\":\"\",\"h4Colour\":\"\",\"h5Colour\":\"\",\"h6Colour\":\"\",\"extraCSS\":\"\",\"enableTagline\":\"1\",\"tagline\":\"A blank slate for your business ...\",\"taglineTop\":\"0\",\"taglineLeft\":\"0\",\"leftCols2L\":\"four\",\"midCols2L\":\"eight\",\"midCols2R\":\"eight\",\"rightCols2R\":\"four\",\"leftCols3LR\":\"three\",\"midCols3LR\":\"six\",\"rightCols3LR\":\"three\",\"leftCols4LRC\":\"three\",\"midCols4LRC\":\"three\",\"centerCols4LRC\":\"three\",\"rightCols4LRC\":\"three\",\"leftCols3LC\":\"three\",\"centerCols3LC\":\"three\",\"midCols3LC\":\"six\",\"midCols3RC\":\"six\",\"centerCols3RC\":\"three\",\"rightCols3RC\":\"three\",\"pngfix\":\"1\",\"pngfixrules\":\"#paneltab a,.twitterFixed,.rssFixed,#overlay,.slideshowContent.dark,.mbDateCols,.jbLogo\",\"extraScripts\":\"\",\"footerWidth\":\"\",\"panelMenu\":\"yes\",\"splitMenu\":\"0\",\"splitMenuName\":\"mainmenu\",\"splitMenuTitle\":\"In this section ...\",\"splitMenuPos\":\"left\",\"tab1Title\":\"Tab1\",\"tab2Title\":\"Tab2\",\"tab3Title\":\"Tab3\",\"tab4Title\":\"Tab4\",\"removejblogo\":\"0\",\"customcopyright\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10010,'System - JB Type ','plugin','jbtype','system',0,1,1,0,'{\"legacy\":true,\"name\":\"System - JB Type \",\"type\":\"plugin\",\"creationDate\":\"Feb 2010\",\"author\":\"Joomla Bamboo\",\"copyright\":\"Copyright 2009 - joomlabamboo.com\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"www.joomlabamboo.com.com\",\"version\":\"1.5.6\",\"description\":\"<p style=\\\"line-height:180%;font-size:1.2em\\\"><a href=\\\"http:\\/\\/www.joomlabamboo.com\\/joomla-extensions\\/jb-type-joomla-typography-plugin\\\"><img src=\\\"http:\\/\\/d129tlhqmunv45.cloudfront.net\\/images\\/stories\\/blog\\/icons\\/JBtype.png?1305337042\\\" alt=\\\"JB Type\\\" style=\\\"float:left;margin:0 20px 20px 0px\\\"\\/><\\/a>JB Type is a Joomla style and typography plugin for your content. By using some simple Joomla syntax you can create some awesome typography for your site without knowing any html at all.<\\/p>\",\"group\":\"\"}','{\"iconStyle\":\"coquette\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10011,'prettyBox','module','mod_prettyBox','',0,1,0,0,'{\"legacy\":false,\"name\":\"prettyBox\",\"type\":\"module\",\"creationDate\":\"Jan 2009\",\"author\":\"Joomla Bamboo\",\"copyright\":\"Copyright (C) 2008 Joomla Bamboo. All rights reserved.\",\"authorEmail\":\"design@joomlabamboo.com\",\"authorUrl\":\"www.joomlabamboo.com\",\"version\":\"1.0\",\"description\":\"MOD_PRETTYBOX_XML_DESCRIPTION\",\"group\":\"\"}','{\"directory\":\"images\\/\",\"output\":\"random\",\"details\":\"0\",\"link\":\"0\",\"right_margin\":\"\",\"loadCSS\":\"head\",\"loadJS\":\"head\",\"prettyPhoto\":\"true\",\"theme\":\"dark_rounded\",\"opacity\":\"0.6\",\"resize\":\"true\",\"prettyBoxTitle\":\"false\",\"prettyBoxSpeed\":\"tfast\",\"overlayGallery\":\"false\",\"img_width\":\"200\",\"img_height\":\"100\",\"option\":\"1\",\"height\":\"150\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10012,'Joomla! Content Management System','package','pkg_joomla','',0,1,1,1,'{\"legacy\":false,\"name\":\"Joomla! Content Management System\",\"type\":\"package\",\"creationDate\":\"2006\",\"author\":\"Joomla!\",\"copyright\":\"Copyright (C) 2005 - 2011 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"http:\\/\\/www.joomla.org\",\"version\":\"1.7.0\",\"description\":\"The Joomla! Content Management System is one of the most popular content management system\'s available today.\",\"group\":\"\"}','','','',0,'0000-00-00 00:00:00',0,0),
	(10013,'K2 Comments','module','mod_k2_comments','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Comments\",\"type\":\"module\",\"creationDate\":\"March 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2012 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.5.5\",\"description\":\"MOD_K2_COMMENTS_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"module_usage\":\"\",\"\":\"K2_TOP_COMMENTERS\",\"catfilter\":\"0\",\"category_id\":\"\",\"comments_limit\":\"5\",\"comments_word_limit\":\"10\",\"commenterName\":\"1\",\"commentAvatar\":\"1\",\"commentAvatarWidthSelect\":\"custom\",\"commentAvatarWidth\":\"50\",\"commentDate\":\"1\",\"commentDateFormat\":\"absolute\",\"commentLink\":\"1\",\"itemTitle\":\"1\",\"itemCategory\":\"1\",\"feed\":\"1\",\"commenters_limit\":\"5\",\"commenterNameOrUsername\":\"1\",\"commenterAvatar\":\"1\",\"commenterAvatarWidthSelect\":\"custom\",\"commenterAvatarWidth\":\"50\",\"commenterLink\":\"1\",\"commenterCommentsCounter\":\"1\",\"commenterLatestComment\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10014,'K2 Content','module','mod_k2_content','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Content\",\"type\":\"module\",\"creationDate\":\"March 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2012 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.5.5\",\"description\":\"K2_MOD_K2_CONTENT_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"getTemplate\":\"Default\",\"source\":\"filter\",\"\":\"K2_OTHER_OPTIONS\",\"catfilter\":\"0\",\"category_id\":\"\",\"getChildren\":\"0\",\"itemCount\":\"5\",\"itemsOrdering\":\"\",\"FeaturedItems\":\"1\",\"popularityRange\":\"\",\"videosOnly\":\"0\",\"item\":\"\",\"items\":\"\",\"itemTitle\":\"1\",\"itemAuthor\":\"1\",\"itemAuthorAvatar\":\"1\",\"itemAuthorAvatarWidthSelect\":\"custom\",\"itemAuthorAvatarWidth\":\"50\",\"userDescription\":\"1\",\"itemIntroText\":\"1\",\"itemIntroTextWordLimit\":\"\",\"itemImage\":\"1\",\"itemImgSize\":\"Small\",\"itemVideo\":\"1\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemAttachments\":\"1\",\"itemTags\":\"1\",\"itemCategory\":\"1\",\"itemDateCreated\":\"1\",\"itemHits\":\"1\",\"itemReadMore\":\"1\",\"itemExtraFields\":\"0\",\"itemCommentsCounter\":\"1\",\"feed\":\"1\",\"itemPreText\":\"\",\"itemCustomLink\":\"0\",\"itemCustomLinkTitle\":\"\",\"itemCustomLinkURL\":\"http:\\/\\/\",\"itemCustomLinkMenuItem\":\"\",\"K2Plugins\":\"1\",\"JPlugins\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10015,'K2 Login','module','mod_k2_login','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Login\",\"type\":\"module\",\"creationDate\":\"March 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2012 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.5.5\",\"description\":\"K2_LOGIN_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"pretext\":\"\",\"\":\"K2_LOGIN_LOGOUT_REDIRECTION\",\"name\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"menu\":\"\",\"login\":\"\",\"logout\":\"\",\"usesecure\":\"0\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10016,'K2 Tools','module','mod_k2_tools','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Tools\",\"type\":\"module\",\"creationDate\":\"March 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2012 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.5.5\",\"description\":\"K2_TOOLS\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"module_usage\":\"0\",\"\":\"K2_CUSTOM_CODE_SETTINGS\",\"archiveItemsCounter\":\"1\",\"archiveCategory\":\"\",\"authors_module_category\":\"\",\"authorItemsCounter\":\"1\",\"authorAvatar\":\"1\",\"authorAvatarWidthSelect\":\"custom\",\"authorAvatarWidth\":\"50\",\"authorLatestItem\":\"1\",\"calendarCategory\":\"\",\"home\":\"\",\"seperator\":\"\",\"root_id\":\"\",\"end_level\":\"\",\"categoriesListOrdering\":\"\",\"categoriesListItemsCounter\":\"1\",\"root_id2\":\"\",\"catfilter\":\"0\",\"category_id\":\"\",\"getChildren\":\"0\",\"liveSearch\":\"\",\"width\":\"20\",\"text\":\"\",\"button\":\"\",\"imagebutton\":\"\",\"button_text\":\"\",\"min_size\":\"75\",\"max_size\":\"300\",\"cloud_limit\":\"30\",\"cloud_category\":\"0\",\"cloud_category_recursive\":\"0\",\"customCode\":\"\",\"parsePhp\":\"0\",\"K2Plugins\":\"0\",\"JPlugins\":\"0\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10017,'K2 Users','module','mod_k2_users','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 Users\",\"type\":\"module\",\"creationDate\":\"March 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2012 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.5.5\",\"description\":\"K2_MOD_K2_USERS_DESCRTIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"getTemplate\":\"Default\",\"source\":\"0\",\"\":\"K2_DISPLAY_OPTIONS\",\"filter\":\"1\",\"K2UserGroup\":\"\",\"ordering\":\"1\",\"limit\":\"4\",\"userIDs\":\"\",\"userName\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"userDescription\":\"1\",\"userDescriptionWordLimit\":\"\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeed\":\"1\",\"userItemCount\":\"1\",\"cache\":\"1\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10018,'K2 User','module','mod_k2_user','',0,1,0,0,'{\"legacy\":true,\"name\":\"K2 User\",\"type\":\"module\",\"creationDate\":\"March 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2012 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.5.5\",\"description\":\"K2_MOD_K2_USER_DESCRIPTION\",\"group\":\"\"}','{\"moduleclass_sfx\":\"\",\"pretext\":\"\",\"\":\"K2_LOGIN_LOGOUT_REDIRECTION\",\"name\":\"1\",\"userAvatar\":\"1\",\"userAvatarWidthSelect\":\"custom\",\"userAvatarWidth\":\"50\",\"menu\":\"\",\"login\":\"\",\"logout\":\"\",\"usesecure\":\"0\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10019,'K2 Quick Icons (admin)','module','mod_k2_quickicons','',1,1,2,0,'{\"legacy\":true,\"name\":\"K2 Quick Icons (admin)\",\"type\":\"module\",\"creationDate\":\"March 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2012 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.5.5\",\"description\":\"K2_QUICKICONS_FOR_USE_IN_THE_JOOMLA_CONTROL_PANEL_DASHBOARD_PAGE\",\"group\":\"\"}','{\"modCSSStyling\":\"1\",\"modLogo\":\"1\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10020,'K2 Stats (admin)','module','mod_k2_stats','',1,1,2,0,'{\"legacy\":true,\"name\":\"K2 Stats (admin)\",\"type\":\"module\",\"creationDate\":\"March 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2012 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.5.5\",\"description\":\"K2_STATS_FOR_USE_IN_THE_K2_DASHBOARD_PAGE\",\"group\":\"\"}','{\"latestItems\":\"1\",\"popularItems\":\"1\",\"mostCommentedItems\":\"1\",\"latestComments\":\"1\",\"statistics\":\"1\",\"cache\":\"0\",\"cache_time\":\"900\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10021,'plg_finder_k2','plugin','k2','finder',0,1,1,0,'{\"legacy\":false,\"name\":\"plg_finder_k2\",\"type\":\"plugin\",\"creationDate\":\"March 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2012 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.5.5\",\"description\":\"PLG_FINDER_K2_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10022,'Search - K2','plugin','k2','search',0,1,1,0,'{\"legacy\":true,\"name\":\"Search - K2\",\"type\":\"plugin\",\"creationDate\":\"March 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2012 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.5.5\",\"description\":\"K2_THIS_PLUGIN_EXTENDS_THE_DEFAULT_JOOMLA_SEARCH_FUNCTIONALITY_TO_K2_CONTENT\",\"group\":\"\"}','{\"search_limit\":\"50\",\"search_tags\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10023,'System - K2','plugin','k2','system',0,1,1,0,'{\"legacy\":true,\"name\":\"System - K2\",\"type\":\"plugin\",\"creationDate\":\"March 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2012 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.5.5\",\"description\":\"K2_THE_K2_SYSTEM_PLUGIN_IS_USED_TO_ASSIST_THE_PROPER_FUNCTIONALITY_OF_THE_K2_COMPONENT_SITE_WIDE_MAKE_SURE_ITS_ALWAYS_PUBLISHED_WHEN_THE_K2_COMPONENT_IS_INSTALLED\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10024,'User - K2','plugin','k2','user',0,1,1,0,'{\"legacy\":true,\"name\":\"User - K2\",\"type\":\"plugin\",\"creationDate\":\"March 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2012 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.5.5\",\"description\":\"K2_A_USER_SYNCHRONIZATION_PLUGIN_FOR_K2\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10025,'k2','component','com_k2','',1,1,1,0,'{\"legacy\":true,\"name\":\"K2\",\"type\":\"component\",\"creationDate\":\"March 7th, 2012\",\"author\":\"JoomlaWorks\",\"copyright\":\"Copyright (c) 2006 - 2012 JoomlaWorks Ltd. All rights reserved.\",\"authorEmail\":\"contact@joomlaworks.net\",\"authorUrl\":\"www.joomlaworks.net\",\"version\":\"2.5.5\",\"description\":\"Thank you for installing K2 by JoomlaWorks, the powerful content extension for Joomla!\",\"group\":\"\"}','{\"enable_css\":\"1\",\"jQueryHandling\":\"1.7remote\",\"backendJQueryHandling\":\"remote\",\"userName\":\"1\",\"userImage\":\"1\",\"userDescription\":\"1\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeedLink\":\"1\",\"userFeedIcon\":\"1\",\"userItemCount\":\"10\",\"userItemTitle\":\"1\",\"userItemTitleLinked\":\"1\",\"userItemDateCreated\":\"1\",\"userItemImage\":\"1\",\"userItemIntroText\":\"1\",\"userItemCategory\":\"1\",\"userItemTags\":\"1\",\"userItemCommentsAnchor\":\"1\",\"userItemReadMore\":\"1\",\"userItemK2Plugins\":\"1\",\"tagItemCount\":\"10\",\"tagItemTitle\":\"1\",\"tagItemTitleLinked\":\"1\",\"tagItemDateCreated\":\"1\",\"tagItemImage\":\"1\",\"tagItemIntroText\":\"1\",\"tagItemCategory\":\"1\",\"tagItemReadMore\":\"1\",\"tagItemExtraFields\":\"0\",\"tagOrdering\":\"\",\"tagFeedLink\":\"1\",\"tagFeedIcon\":\"1\",\"genericItemCount\":\"10\",\"genericItemTitle\":\"1\",\"genericItemTitleLinked\":\"1\",\"genericItemDateCreated\":\"1\",\"genericItemImage\":\"1\",\"genericItemIntroText\":\"1\",\"genericItemCategory\":\"1\",\"genericItemReadMore\":\"1\",\"genericItemExtraFields\":\"0\",\"genericFeedLink\":\"1\",\"genericFeedIcon\":\"1\",\"feedLimit\":\"10\",\"feedItemImage\":\"1\",\"feedImgSize\":\"S\",\"feedItemIntroText\":\"1\",\"feedTextWordLimit\":\"\",\"feedItemFullText\":\"1\",\"feedItemTags\":\"0\",\"feedItemVideo\":\"0\",\"feedItemGallery\":\"0\",\"feedItemAttachments\":\"0\",\"feedBogusEmail\":\"\",\"introTextCleanup\":\"0\",\"introTextCleanupExcludeTags\":\"\",\"introTextCleanupTagAttr\":\"\",\"fullTextCleanup\":\"0\",\"fullTextCleanupExcludeTags\":\"\",\"fullTextCleanupTagAttr\":\"\",\"xssFiltering\":\"0\",\"linkPopupWidth\":\"900\",\"linkPopupHeight\":\"600\",\"imagesQuality\":\"100\",\"itemImageXS\":\"100\",\"itemImageS\":\"200\",\"itemImageM\":\"400\",\"itemImageL\":\"600\",\"itemImageXL\":\"900\",\"itemImageGeneric\":\"300\",\"catImageWidth\":\"100\",\"catImageDefault\":\"1\",\"userImageWidth\":\"100\",\"userImageDefault\":\"1\",\"commenterImgWidth\":\"48\",\"onlineImageEditor\":\"splashup\",\"imageTimestamp\":\"0\",\"imageMemoryLimit\":\"\",\"socialButtonCode\":\"\",\"twitterUsername\":\"\",\"facebookImage\":\"Small\",\"comments\":\"1\",\"commentsOrdering\":\"DESC\",\"commentsLimit\":\"10\",\"commentsFormPosition\":\"below\",\"commentsPublishing\":\"1\",\"commentsReporting\":\"2\",\"commentsReportRecipient\":\"\",\"inlineCommentsModeration\":\"0\",\"gravatar\":\"1\",\"recaptcha\":\"0\",\"commentsFormNotes\":\"1\",\"commentsFormNotesText\":\"\",\"frontendEditing\":\"1\",\"showImageTab\":\"1\",\"showImageGalleryTab\":\"1\",\"showVideoTab\":\"1\",\"showExtraFieldsTab\":\"1\",\"showAttachmentsTab\":\"1\",\"showK2Plugins\":\"1\",\"sideBarDisplayFrontend\":\"0\",\"mergeEditors\":\"1\",\"sideBarDisplay\":\"1\",\"attachmentsFolder\":\"\",\"hideImportButton\":\"0\",\"taggingSystem\":\"1\",\"lockTags\":\"0\",\"showTagFilter\":\"0\",\"googleSearch\":\"0\",\"googleSearchContainer\":\"k2Container\",\"K2UserProfile\":\"1\",\"K2UserGroup\":\"\",\"redirect\":\"\",\"adminSearch\":\"simple\",\"cookieDomain\":\"\",\"recaptcha_public_key\":\"\",\"recaptcha_private_key\":\"\",\"recaptcha_theme\":\"clean\",\"recaptchaOnRegistration\":\"0\",\"showItemsCounterAdmin\":\"1\",\"showChildCatItems\":\"1\",\"disableCompactOrdering\":\"0\",\"metaDescLimit\":\"150\",\"SEFReplacements\":\"\",\"sh404SefLabelCat\":\"\",\"sh404SefLabelUser\":\"blog\",\"sh404SefLabelItem\":\"2\",\"sh404SefTitleAlias\":\"alias\",\"sh404SefModK2ContentFeedAlias\":\"feed\",\"cbIntegration\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10026,'com_finder','component','com_finder','',1,1,1,0,'{\"legacy\":false,\"name\":\"com_finder\",\"type\":\"component\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"COM_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10027,'mod_finder','module','mod_finder','',0,1,1,0,'{\"legacy\":false,\"name\":\"mod_finder\",\"type\":\"module\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','{\"searchfilter\":\"\",\"show_autosuggest\":\"1\",\"show_advanced\":\"0\",\"moduleclass_sfx\":\"\",\"field_size\":\"25\",\"show_label\":\"1\",\"label_pos\":\"top\",\"show_button\":\"0\",\"button_pos\":\"right\",\"opensearch\":\"1\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10028,'mod_multilangstatus','module','mod_multilangstatus','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_multilangstatus\",\"type\":\"module\",\"creationDate\":\"September 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"1.7.1\",\"description\":\"MOD_MULTILANGSTATUS_XML_DESCRIPTION\",\"group\":\"\"}','{\"cache\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10029,'mod_version','module','mod_version','',1,1,1,0,'{\"legacy\":false,\"name\":\"mod_version\",\"type\":\"module\",\"creationDate\":\"January 2012\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"MOD_VERSION_XML_DESCRIPTION\",\"group\":\"\"}','{\"format\":\"short\",\"product\":\"1\",\"cache\":\"0\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10030,'plg_captcha_recaptcha','plugin','recaptcha','captcha',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_captcha_recaptcha\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CAPTCHA_RECAPTCHA_XML_DESCRIPTION\",\"group\":\"\"}','{\"public_key\":\"\",\"private_key\":\"\",\"theme\":\"clean\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10031,'plg_content_finder','plugin','finder','content',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_content_finder\",\"type\":\"plugin\",\"creationDate\":\"December 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_CONTENT_FINDER_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10032,'plg_finder_categories','plugin','categories','finder',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_finder_categories\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_CATEGORIES_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10033,'plg_finder_contacts','plugin','contacts','finder',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_finder_contacts\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_CONTACTS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10034,'plg_finder_content','plugin','content','finder',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_finder_content\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_CONTENT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10035,'plg_finder_newsfeeds','plugin','newsfeeds','finder',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_finder_newsfeeds\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_NEWSFEEDS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10036,'plg_finder_weblinks','plugin','weblinks','finder',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_finder_weblinks\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_FINDER_WEBLINKS_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10037,'plg_quickicon_extensionupdate','plugin','extensionupdate','quickicon',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_quickicon_extensionupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_QUICKICON_EXTENSIONUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{\"context\":\"mod_quickicon\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10038,'plg_quickicon_joomlaupdate','plugin','joomlaupdate','quickicon',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_quickicon_joomlaupdate\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_QUICKICON_JOOMLAUPDATE_XML_DESCRIPTION\",\"group\":\"\"}','{\"context\":\"mod_quickicon\"}','','',0,'0000-00-00 00:00:00',0,0),
	(10039,'plg_system_highlight','plugin','highlight','system',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_system_highlight\",\"type\":\"plugin\",\"creationDate\":\"August 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"(C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_HIGHLIGHT_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0),
	(10040,'plg_system_languagecode','plugin','languagecode','system',0,0,1,0,'{\"legacy\":false,\"name\":\"plg_system_languagecode\",\"type\":\"plugin\",\"creationDate\":\"November 2011\",\"author\":\"Joomla! Project\",\"copyright\":\"Copyright (C) 2005 - 2012 Open Source Matters. All rights reserved.\",\"authorEmail\":\"admin@joomla.org\",\"authorUrl\":\"www.joomla.org\",\"version\":\"2.5.0\",\"description\":\"PLG_SYSTEM_LANGUAGECODE_XML_DESCRIPTION\",\"group\":\"\"}','{}','','',0,'0000-00-00 00:00:00',0,0);

/*!40000 ALTER TABLE `#__extensions` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_attachments
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_attachments`;

CREATE TABLE `#__k2_attachments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `filename` varchar(255) NOT NULL,
  `title` varchar(255) NOT NULL,
  `titleAttribute` text NOT NULL,
  `hits` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table #__k2_categories
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_categories`;

CREATE TABLE `#__k2_categories` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `alias` varchar(255) NOT NULL,
  `description` text NOT NULL,
  `parent` int(11) DEFAULT '0',
  `extraFieldsGroup` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `image` varchar(255) NOT NULL,
  `params` text NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `category` (`published`,`access`,`trash`),
  KEY `parent` (`parent`),
  KEY `ordering` (`ordering`),
  KEY `published` (`published`),
  KEY `access` (`access`),
  KEY `trash` (`trash`),
  KEY `language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_categories` WRITE;
/*!40000 ALTER TABLE `#__k2_categories` DISABLE KEYS */;

INSERT INTO `#__k2_categories` (`id`, `name`, `alias`, `description`, `parent`, `extraFieldsGroup`, `published`, `access`, `ordering`, `image`, `params`, `trash`, `plugins`, `language`)
VALUES
	(14,'Democontent','democontent','',0,0,1,1,1,'','{\"inheritFrom\":\"0\",\"theme\":\"Responsive\",\"num_leading_items\":\"10\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"0\",\"num_primary_columns\":\"0\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"0\",\"num_secondary_columns\":\"0\",\"secondaryImgSize\":\"Small\",\"num_links\":\"0\",\"num_links_columns\":\"0\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"0\",\"catTitleItemCounter\":\"0\",\"catDescription\":\"0\",\"catImage\":\"0\",\"catFeedLink\":\"0\",\"catFeedIcon\":\"0\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"1\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"1\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"1\",\"catItemHits\":\"1\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"1\",\"catItemAttachmentsCounter\":\"1\",\"catItemVideo\":\"1\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"1\",\"catItemImageGallery\":\"1\",\"catItemDateModified\":\"1\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"1\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"1\",\"itemRelatedFulltext\":\"1\",\"itemRelatedAuthor\":\"1\",\"itemRelatedMedia\":\"1\",\"itemRelatedImageGallery\":\"1\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(20,'Democontent','democontent','',31,0,1,1,1,'','{\"inheritFrom\":\"14\",\"theme\":\"Responsive\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(21,'Extensions','extensions','',37,0,-2,1,1,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(22,'The Team','the-team','',37,0,-2,1,2,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(23,'Uncategorised','uncategorised','',0,0,1,1,1,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(24,'News','news','Select a news topic from the list below, then select a news article to read.',0,0,1,1,1,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(25,'Latest','latest','The latest news from the Joomla! Team',41,0,1,1,1,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(26,'Newsflash','newsflash','',41,0,1,1,2,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(27,'FAQs','faqs','From the list below choose one of our FAQs topics, then select an FAQ to read. If you have a question which is not in this section, please contact us.',0,0,1,1,1,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(28,'New to Joomla!','new-to-joomla','Questions for new users of Joomla!',27,0,1,1,1,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(29,'Current Users','current-users','Questions that users migrating to Joomla! 1.5 are likely to raise<br />',27,0,1,1,2,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(30,'General','general','General questions about the Joomla! CMS',27,0,1,1,3,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(31,'Languages','languages','Questions related to localisation and languages',27,0,1,1,4,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(32,'Slideshow Items','slideshow-items','',27,0,1,1,5,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(33,'About Joomla!','about-joomla','',0,0,1,1,1,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(34,'The Project','the-project','<p>General facts about Joomla!</p>',33,0,1,1,1,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(35,'The CMS','the-cms','Information about the software behind Joomla!<br />',33,0,1,1,2,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(36,'The Community','the-community','About the millions of Joomla! users and Web sites<br />',33,0,1,1,3,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(37,'Democontent','democontent','',0,0,1,1,1,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',0,'','*'),
	(38,'Setting Up','setting-up','',37,0,1,1,3,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(39,'Features','features','',37,0,1,1,4,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(40,'Democontent','democontent','',37,0,1,1,1,'','{\"inheritFrom\":\"0\",\"theme\":\"rasa\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',0,'','*'),
	(41,'Slideshow Items','slideshow-items','',37,0,1,1,6,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*'),
	(42,'Zen Grid Framework Features','zen-grid-framework-features','',37,0,1,1,7,'','{\"theme\":\"default\",\"num_leading_items\":\"2\",\"num_leading_columns\":\"1\",\"leadingImgSize\":\"Large\",\"num_primary_items\":\"4\",\"num_primary_columns\":\"2\",\"primaryImgSize\":\"Medium\",\"num_secondary_items\":\"4\",\"num_secondary_columns\":\"1\",\"secondaryImgSize\":\"Small\",\"num_links\":\"4\",\"num_links_columns\":\"1\",\"linksImgSize\":\"XSmall\",\"catCatalogMode\":\"0\",\"catFeaturedItems\":\"1\",\"catOrdering\":\"\",\"catPagination\":\"2\",\"catPaginationResults\":\"1\",\"catTitle\":\"1\",\"catTitleItemCounter\":\"1\",\"catDescription\":\"1\",\"catImage\":\"1\",\"catFeedLink\":\"1\",\"catFeedIcon\":\"1\",\"subCategories\":\"1\",\"subCatColumns\":\"2\",\"subCatOrdering\":\"\",\"subCatTitle\":\"1\",\"subCatTitleItemCounter\":\"1\",\"subCatDescription\":\"1\",\"subCatImage\":\"1\",\"itemImageXS\":\"\",\"itemImageS\":\"\",\"itemImageM\":\"\",\"itemImageL\":\"\",\"itemImageXL\":\"\",\"catItemTitle\":\"1\",\"catItemTitleLinked\":\"1\",\"catItemFeaturedNotice\":\"0\",\"catItemAuthor\":\"1\",\"catItemDateCreated\":\"1\",\"catItemRating\":\"0\",\"catItemImage\":\"1\",\"catItemIntroText\":\"1\",\"catItemIntroTextWordLimit\":\"\",\"catItemExtraFields\":\"0\",\"catItemHits\":\"0\",\"catItemCategory\":\"1\",\"catItemTags\":\"1\",\"catItemAttachments\":\"0\",\"catItemAttachmentsCounter\":\"0\",\"catItemVideo\":\"0\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"0\",\"catItemImageGallery\":\"0\",\"catItemDateModified\":\"0\",\"catItemReadMore\":\"1\",\"catItemCommentsAnchor\":\"1\",\"catItemK2Plugins\":\"1\",\"itemDateCreated\":\"1\",\"itemTitle\":\"1\",\"itemFeaturedNotice\":\"1\",\"itemAuthor\":\"1\",\"itemFontResizer\":\"1\",\"itemPrintButton\":\"1\",\"itemEmailButton\":\"1\",\"itemSocialButton\":\"1\",\"itemVideoAnchor\":\"1\",\"itemImageGalleryAnchor\":\"1\",\"itemCommentsAnchor\":\"1\",\"itemRating\":\"1\",\"itemImage\":\"1\",\"itemImgSize\":\"Large\",\"itemImageMainCaption\":\"1\",\"itemImageMainCredits\":\"1\",\"itemIntroText\":\"1\",\"itemFullText\":\"1\",\"itemExtraFields\":\"1\",\"itemDateModified\":\"1\",\"itemHits\":\"1\",\"itemCategory\":\"1\",\"itemTags\":\"1\",\"itemAttachments\":\"1\",\"itemAttachmentsCounter\":\"1\",\"itemVideo\":\"1\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"0\",\"itemVideoCaption\":\"1\",\"itemVideoCredits\":\"1\",\"itemImageGallery\":\"1\",\"itemNavigation\":\"1\",\"itemComments\":\"1\",\"itemTwitterButton\":\"1\",\"itemFacebookButton\":\"1\",\"itemGooglePlusOneButton\":\"1\",\"itemAuthorBlock\":\"1\",\"itemAuthorImage\":\"1\",\"itemAuthorDescription\":\"1\",\"itemAuthorURL\":\"1\",\"itemAuthorEmail\":\"0\",\"itemAuthorLatest\":\"1\",\"itemAuthorLatestLimit\":\"5\",\"itemRelated\":\"1\",\"itemRelatedLimit\":\"5\",\"itemRelatedTitle\":\"1\",\"itemRelatedCategory\":\"0\",\"itemRelatedImageSize\":\"0\",\"itemRelatedIntrotext\":\"0\",\"itemRelatedFulltext\":\"0\",\"itemRelatedAuthor\":\"0\",\"itemRelatedMedia\":\"0\",\"itemRelatedImageGallery\":\"0\",\"itemK2Plugins\":\"1\",\"catMetaDesc\":\"\",\"catMetaKey\":\"\",\"catMetaRobots\":\"\",\"catMetaAuthor\":\"\"}',1,'','*');

/*!40000 ALTER TABLE `#__k2_categories` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_comments
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_comments`;

CREATE TABLE `#__k2_comments` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `itemID` int(11) NOT NULL,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) NOT NULL,
  `commentDate` datetime NOT NULL,
  `commentText` text NOT NULL,
  `commentEmail` varchar(255) NOT NULL,
  `commentURL` varchar(255) NOT NULL,
  `published` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `itemID` (`itemID`),
  KEY `userID` (`userID`),
  KEY `published` (`published`),
  KEY `latestComments` (`published`,`commentDate`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_comments` WRITE;
/*!40000 ALTER TABLE `#__k2_comments` DISABLE KEYS */;

INSERT INTO `#__k2_comments` (`id`, `itemID`, `userID`, `userName`, `commentDate`, `commentText`, `commentEmail`, `commentURL`, `published`)
VALUES
	(1,88,0,'The Commenter','2010-10-06 05:09:29','This is a comment. But i think you can tell that already.','comment@commenter.com','',1),
	(2,88,0,'Commenter','2010-10-06 05:10:34','This is another comment that Im leaving. I hope it adds to the experience for you.','comment@commenter.com','',1),
	(3,88,0,'asd','2011-09-20 06:26:33','Message me','sdf@j.com','http://dasf',1),
	(4,88,62,'Administrator','2011-09-20 10:49:16','dfgh','design@joomlabamboo.com','',1),
	(5,144,0,'Anthony','2012-01-23 01:53:00','This is a comment','design@joodmlabamboo.com','http://www.joomlabamboo.com',1),
	(6,144,0,'Paulo Griiettner','2012-02-01 00:03:33','I\'m testing the commenting area','oi@email.com','',1),
	(7,144,0,'Paulo Griiettner','2012-02-01 00:12:25','I\'m testing the commenting area','oi@email.com','',1);

/*!40000 ALTER TABLE `#__k2_comments` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_extra_fields
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_extra_fields`;

CREATE TABLE `#__k2_extra_fields` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `value` text NOT NULL,
  `type` varchar(255) NOT NULL,
  `group` int(11) NOT NULL,
  `published` tinyint(4) NOT NULL,
  `ordering` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `group` (`group`),
  KEY `published` (`published`),
  KEY `ordering` (`ordering`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table #__k2_extra_fields_groups
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_extra_fields_groups`;

CREATE TABLE `#__k2_extra_fields_groups` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;



# Dump of table #__k2_items
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_items`;

CREATE TABLE `#__k2_items` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(255) NOT NULL,
  `alias` varchar(255) DEFAULT NULL,
  `catid` int(11) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  `introtext` mediumtext NOT NULL,
  `fulltext` mediumtext NOT NULL,
  `video` text,
  `gallery` varchar(255) DEFAULT NULL,
  `extra_fields` text,
  `extra_fields_search` text NOT NULL,
  `created` datetime NOT NULL,
  `created_by` int(11) NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL,
  `checked_out` int(10) unsigned NOT NULL,
  `checked_out_time` datetime NOT NULL,
  `modified` datetime NOT NULL,
  `modified_by` int(11) NOT NULL DEFAULT '0',
  `publish_up` datetime NOT NULL,
  `publish_down` datetime NOT NULL,
  `trash` smallint(6) NOT NULL DEFAULT '0',
  `access` int(11) NOT NULL DEFAULT '0',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `featured` smallint(6) NOT NULL DEFAULT '0',
  `featured_ordering` int(11) NOT NULL DEFAULT '0',
  `image_caption` text NOT NULL,
  `image_credits` varchar(255) NOT NULL,
  `video_caption` text NOT NULL,
  `video_credits` varchar(255) NOT NULL,
  `hits` int(10) unsigned NOT NULL,
  `params` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `metakey` text NOT NULL,
  `plugins` text NOT NULL,
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `item` (`published`,`publish_up`,`publish_down`,`trash`,`access`),
  KEY `catid` (`catid`),
  KEY `created_by` (`created_by`),
  KEY `ordering` (`ordering`),
  KEY `featured` (`featured`),
  KEY `featured_ordering` (`featured_ordering`),
  KEY `hits` (`hits`),
  KEY `created` (`created`),
  KEY `language` (`language`),
  FULLTEXT KEY `search` (`title`,`introtext`,`fulltext`,`extra_fields_search`,`image_caption`,`image_credits`,`video_caption`,`video_credits`,`metadesc`,`metakey`),
  FULLTEXT KEY `title` (`title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_items` WRITE;
/*!40000 ALTER TABLE `#__k2_items` DISABLE KEYS */;

INSERT INTO `#__k2_items` (`id`, `title`, `alias`, `catid`, `published`, `introtext`, `fulltext`, `video`, `gallery`, `extra_fields`, `extra_fields_search`, `created`, `created_by`, `created_by_alias`, `checked_out`, `checked_out_time`, `modified`, `modified_by`, `publish_up`, `publish_down`, `trash`, `access`, `ordering`, `featured`, `featured_ordering`, `image_caption`, `image_credits`, `video_caption`, `video_credits`, `hits`, `params`, `metadesc`, `metadata`, `metakey`, `plugins`, `language`)
VALUES
	(56,'Open Book','open-book',20,1,'<p><img class=\"border floatleft\" src=\"images/democontent/democontent/open-book.jpg\" border=\"0\" align=\"left\" /></p>\r\n<p>This is the start and this is the end. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n','\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',NULL,NULL,'[]','','2010-06-23 03:06:13',42,'',0,'0000-00-00 00:00:00','2012-03-05 04:04:49',42,'2010-06-23 03:06:13','0000-00-00 00:00:00',1,1,4,0,0,'','','','',102,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(77,'Give more colors to your life','give-more-colors-to-your-life',20,1,'<p><img class=\"border floatleft\" src=\"images/democontent/democontent/color-card-paint-samples.jpg\" border=\"0\" align=\"left\" /></p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n','\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',NULL,NULL,'[]','','2010-07-10 07:14:59',42,'',0,'0000-00-00 00:00:00','2012-03-05 04:04:37',42,'2010-07-10 07:14:59','0000-00-00 00:00:00',1,1,6,0,0,'','','','',58,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(79,'Less than zero','less-than-zero',20,1,'<p><img class=\"border floatleft\" src=\"images/democontent/democontent/blue-sky.jpg\" border=\"0\" align=\"left\" /></p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>','',NULL,NULL,'[]','','2010-07-10 07:16:43',42,'',0,'0000-00-00 00:00:00','2012-03-05 04:04:16',42,'2010-07-10 07:16:43','0000-00-00 00:00:00',1,1,5,0,0,'','','','',9,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(143,'Quit Smoking and Drinking','quit-smoking-and-drinking',20,1,'<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n<p><img class=\"border floatleft\" src=\"images/democontent/democontent/cigar-on-drink.jpg\" border=\"0\" align=\"left\" /></p>\r\n<p>Placerat rhoncus quis diam mid? Amet sed. Enim, integer est turpis nascetur rhoncus est, turpis! Ac porta, pid ut! Platea, sed porttitor et sagittis, nec dignissim, natoque etiam adipiscing habitasse aliquet dignissim, ultrices, duis magna! In egestas rhoncus parturient auctor integer, augue urna scelerisque placerat placerat pulvinar, cum adipiscing quis elementum magna eros, phasellus velit! Porttitor elit scelerisque cursus! Elementum rhoncus lundium proin, amet. Elementum placerat, in sit, augue ut rhoncus ridiculus sit arcu turpis augue sed, scelerisque, placerat augue. Aliquam velit scelerisque, etiam sagittis nisi dignissim! Ut urna? Adipiscing amet diam augue amet, sed turpis, integer eros, urna? Cursus turpis sed egestas lundium, enim, lorem rhoncus, ultrices et proin. Nisi, tincidunt pid! Magnis etiam rhoncus lorem elit ultrices.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',NULL,NULL,'[]','','2010-07-10 07:41:34',42,'',0,'0000-00-00 00:00:00','2012-03-05 04:04:09',42,'2010-07-10 07:41:34','0000-00-00 00:00:00',1,1,3,0,0,'','','','',12,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(144,'Little Creatures','little-creatures',20,1,'<p><img class=\"border floatleft\" src=\"images/democontent/democontent/honey-bee.jpg\" border=\"0\" align=\"left\" /></p>\r\n<p>Vel dictumst amet? Sit montes? Magnis, pid amet ac amet facilisis, dolor pellentesque tortor, auctor, pid augue. Lectus duis duis amet penatibus proin purus est ultricies, ultricies ac mauris? Dolor purus integer magna etiam, hac. In placerat phasellus amet? Magnis montes! Turpis penatibus augue scelerisque elit in, ut porttitor pellentesque proin lorem dolor arcu? Vel augue ridiculus nascetur dignissim, mus integer mauris dapibus turpis integer, mid hac natoque, aliquet est egestas? Magna ac lacus elementum, ac velit ultricies sociis? Sit tortor! In scelerisque. Magna augue sit hac montes elementum? Nec aliquam nascetur phasellus tincidunt, augue natoque placerat pid urna! Penatibus in turpis ultrices non tincidunt pulvinar penatibus. Penatibus ac nunc ac ridiculus, in, cum. Lacus, urna sed? Pid sit.</p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',NULL,NULL,'[]','','2010-07-10 07:42:04',42,'',0,'0000-00-00 00:00:00','2012-03-05 04:03:56',42,'2010-07-10 07:42:04','0000-00-00 00:00:00',1,1,2,0,0,'','','','',471,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(145,'Head in the clouds, but feet on ground','head-in-the-clouds-but-feet-on-ground',20,1,'<p>Sed, tortor lorem. Odio. Nec ridiculus, risus nec platea vut a, a tempor, rhoncus rhoncus adipiscing scelerisque, tincidunt turpis scelerisque, tortor? Nunc est, natoque turpis dis porta. Platea cum. Sagittis tincidunt in risus tristique arcu, nec turpis placerat? Pellentesque, natoque diam integer cum mus mid auctor in enim quis, integer nec ridiculus turpis elementum enim lectus aliquam aliquam sit. Porttitor adipiscing nisi nunc facilisis in nascetur porttitor? Ut. Non pulvinar nec sociis eros? Nunc augue tortor augue nec? Montes platea, turpis lacus, tincidunt mattis placerat lectus mus, ac, sagittis! Pellentesque et integer porttitor, urna tortor, lundium penatibus a lorem? Etiam mauris parturient nec augue et tincidunt sed tristique velit ut, tortor. Adipiscing lundium. Nunc nunc. Eu egestas, mauris augue.</p>\r\n<p><img class=\"border floatleft\" src=\"images/democontent/democontent/blue-sky-with-white-clouds.jpg\" border=\"0\" align=\"left\" /></p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',NULL,NULL,'[]','','2010-07-10 07:14:59',42,'',0,'0000-00-00 00:00:00','2012-03-05 04:03:49',42,'2010-07-10 07:14:59','0000-00-00 00:00:00',1,1,1,1,0,'','','','',16,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(237,'Moonlight Classics - Summer viewing','moonlight-classics-summer-viewing',40,1,'<p><img class=\"border floatleft\" src=\"images/democontent/Fotolia_31467_XS.jpg\" border=\"0\" alt=\"Fotolia_31467_XS\" width=\"400\" height=\"300\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',NULL,NULL,'[]','','2010-07-10 07:15:23',42,'',0,'0000-00-00 00:00:00','2012-03-19 23:49:38',42,'2010-07-10 07:15:23','0000-00-00 00:00:00',0,1,6,0,0,'','','','',1,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(238,'Weddings in far away places','weddings-in-far-away-places',40,1,'<p><img class=\"border floatleft\" src=\"images/democontent/Fotolia_6355435_XS.jpg\" border=\"0\" alt=\"Fotolia_6355435_XS\" width=\"424\" height=\"283\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',NULL,NULL,'[]','','2010-07-10 07:16:43',42,'',0,'0000-00-00 00:00:00','2012-03-19 23:49:32',42,'2010-07-10 07:16:43','0000-00-00 00:00:00',0,1,3,0,0,'','','','',9,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(239,'Polar bears dont feel the cold','polar-bears-dont-feel-the-cold',40,1,'<p><img class=\"border floatleft\" src=\"images/democontent/Fotolia_8323460_XS.jpg\" border=\"0\" alt=\"Fotolia_8323460_XS\" width=\"401\" height=\"300\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',NULL,NULL,'[]','','2010-07-10 07:21:41',42,'',0,'0000-00-00 00:00:00','2012-03-19 23:49:25',42,'2010-07-10 07:21:41','0000-00-00 00:00:00',0,1,2,1,0,'','','','',9,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(240,'Toes, massage and lotus birth','toes-massage-and-lotus-birth',40,1,'<p><img class=\"border floatleft\" src=\"images/democontent/Fotolia_7059891_XS.jpg\" border=\"0\" alt=\"Fotolia_7059891_XS\" width=\"424\" height=\"283\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',NULL,NULL,'[]','','2010-07-10 07:22:09',42,'',0,'0000-00-00 00:00:00','2012-03-19 23:49:19',42,'2010-07-10 07:22:09','0000-00-00 00:00:00',0,1,1,1,0,'','','','',11,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(241,'Techniques for the nineteenth hole','techniques-for-the-nineteenth-hole',40,1,'<p><img class=\"border floatleft\" src=\"images/democontent/iStock_000009077366XSmall.jpg\" border=\"0\" alt=\"iStock_000009077366XSmall\" width=\"419\" height=\"286\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',NULL,NULL,'[]','','2010-07-10 07:41:34',42,'',0,'0000-00-00 00:00:00','2012-03-19 23:49:12',42,'2010-07-10 07:41:34','0000-00-00 00:00:00',0,1,4,0,0,'','','','',11,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*'),
	(242,'Focus remains a useful creative tension','focus-remains-a-useful-creative-tension',40,1,'<p><img class=\"border floatleft\" src=\"images/democontent/iStock_000010038981XSmall.jpg\" border=\"0\" alt=\"iStock_000010038981XSmall\" width=\"425\" height=\"282\" /></p>\r\n<p> </p>\r\n<p>Donec mollis orci vel turpis tempus aliquam. Suspendisse tincidunt tincidunt ante eget lacinia. In iaculis pulvinar urna, in iaculis lacus blandit in. Vivamus euismod, nisi eget interdum mollis, augue leo vulputate diam, eu vulputate lectus elit et augue. Cras a leo in quam bibendum dapibus tempus euismod est.</p>\r\n','\r\n<p>Nunc sit amet urna non augue sodales semper non et velit. Nullam sodales dapibus tempor. Aliquam quis turpis sed nulla convallis feugiat. Vestibulum laoreet venenatis iaculis. Vivamus augue erat, sagittis vestibulum aliquet non, blandit ac sem. Sed eros tellus, dapibus eu auctor ac, sodales ac est. Aliquam neque lacus, fringilla quis sagittis lobortis, bibendum eget tellus. Nam blandit adipiscing nisi eget suscipit. Mauris auctor lobortis enim sit amet ullamcorper. Morbi nulla lorem, auctor at varius eu, hendrerit eget lectus. Suspendisse nec auctor nulla.</p>\r\n<p> </p>\r\n<p>Vivamus ac lorem et elit fringilla sagittis eu in sapien. Sed vel nisl ut magna volutpat porta ac a diam. Pellentesque habitant morbi tristique senectus et netus et malesuada fames ac turpis egestas. Vestibulum enim lectus, euismod id pretium dapibus, malesuada vitae mauris. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Vestibulum malesuada molestie elit tristique mattis. In commodo, velit id accumsan tristique, neque purus ultricies ipsum, et aliquet diam erat a risus. Sed vehicula ullamcorper tortor, quis blandit odio tincidunt nec.</p>\r\n<p>Morbi aliquet, quam ut rutrum bibendum, sapien urna tempor lacus, porttitor consequat nisi justo euismod odio. Donec pretium mattis pulvinar. Maecenas tincidunt fringilla massa. Nulla odio sapien, aliquam bibendum placerat quis, dictum non orci.</p>',NULL,NULL,'[]','','2010-07-10 07:42:04',42,'',0,'0000-00-00 00:00:00','2012-03-20 00:03:53',42,'2010-07-10 07:42:04','0000-00-00 00:00:00',0,1,5,0,0,'','','','',11,'{\"catItemTitle\":\"\",\"catItemTitleLinked\":\"\",\"catItemFeaturedNotice\":\"\",\"catItemAuthor\":\"\",\"catItemDateCreated\":\"\",\"catItemRating\":\"\",\"catItemImage\":\"\",\"catItemIntroText\":\"\",\"catItemExtraFields\":\"\",\"catItemHits\":\"\",\"catItemCategory\":\"\",\"catItemTags\":\"\",\"catItemAttachments\":\"\",\"catItemAttachmentsCounter\":\"\",\"catItemVideo\":\"\",\"catItemVideoWidth\":\"\",\"catItemVideoHeight\":\"\",\"catItemAudioWidth\":\"\",\"catItemAudioHeight\":\"\",\"catItemVideoAutoPlay\":\"\",\"catItemImageGallery\":\"\",\"catItemDateModified\":\"\",\"catItemReadMore\":\"\",\"catItemCommentsAnchor\":\"\",\"catItemK2Plugins\":\"\",\"itemDateCreated\":\"\",\"itemTitle\":\"\",\"itemFeaturedNotice\":\"\",\"itemAuthor\":\"\",\"itemFontResizer\":\"\",\"itemPrintButton\":\"\",\"itemEmailButton\":\"\",\"itemSocialButton\":\"\",\"itemVideoAnchor\":\"\",\"itemImageGalleryAnchor\":\"\",\"itemCommentsAnchor\":\"\",\"itemRating\":\"\",\"itemImage\":\"\",\"itemImgSize\":\"\",\"itemImageMainCaption\":\"\",\"itemImageMainCredits\":\"\",\"itemIntroText\":\"\",\"itemFullText\":\"\",\"itemExtraFields\":\"\",\"itemDateModified\":\"\",\"itemHits\":\"\",\"itemCategory\":\"\",\"itemTags\":\"\",\"itemAttachments\":\"\",\"itemAttachmentsCounter\":\"\",\"itemVideo\":\"\",\"itemVideoWidth\":\"\",\"itemVideoHeight\":\"\",\"itemAudioWidth\":\"\",\"itemAudioHeight\":\"\",\"itemVideoAutoPlay\":\"\",\"itemVideoCaption\":\"\",\"itemVideoCredits\":\"\",\"itemImageGallery\":\"\",\"itemNavigation\":\"\",\"itemComments\":\"\",\"itemTwitterButton\":\"\",\"itemFacebookButton\":\"\",\"itemGooglePlusOneButton\":\"\",\"itemAuthorBlock\":\"\",\"itemAuthorImage\":\"\",\"itemAuthorDescription\":\"\",\"itemAuthorURL\":\"\",\"itemAuthorEmail\":\"\",\"itemAuthorLatest\":\"\",\"itemAuthorLatestLimit\":\"\",\"itemRelated\":\"\",\"itemRelatedLimit\":\"\",\"itemRelatedTitle\":\"\",\"itemRelatedCategory\":\"\",\"itemRelatedImageSize\":\"\",\"itemRelatedIntrotext\":\"\",\"itemRelatedFulltext\":\"\",\"itemRelatedAuthor\":\"\",\"itemRelatedMedia\":\"\",\"itemRelatedImageGallery\":\"\",\"itemK2Plugins\":\"\"}','','robots=\nauthor=','','','*');

/*!40000 ALTER TABLE `#__k2_items` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_rating
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_rating`;

CREATE TABLE `#__k2_rating` (
  `itemID` int(11) NOT NULL DEFAULT '0',
  `rating_sum` int(11) unsigned NOT NULL DEFAULT '0',
  `rating_count` int(11) unsigned NOT NULL DEFAULT '0',
  `lastip` varchar(50) NOT NULL DEFAULT '',
  PRIMARY KEY (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_rating` WRITE;
/*!40000 ALTER TABLE `#__k2_rating` DISABLE KEYS */;

INSERT INTO `#__k2_rating` (`itemID`, `rating_sum`, `rating_count`, `lastip`)
VALUES
	(88,4,1,'::1'),
	(144,5,1,'::1');

/*!40000 ALTER TABLE `#__k2_rating` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_tags
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_tags`;

CREATE TABLE `#__k2_tags` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `published` smallint(6) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  KEY `published` (`published`),
  FULLTEXT KEY `name` (`name`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_tags` WRITE;
/*!40000 ALTER TABLE `#__k2_tags` DISABLE KEYS */;

INSERT INTO `#__k2_tags` (`id`, `name`, `published`)
VALUES
	(1,'About Joomla!',1),
	(2,'General',1),
	(3,'Extensions',1),
	(4,'lover geek designer coder',1),
	(5,'lover designer coder geek',1),
	(6,'lover geek coder',1),
	(7,'lover geek admin',1),
	(8,'fighter geek coder admin',1),
	(9,'designer lover',1),
	(10,'designer admin fighter',1),
	(11,'coder lover designer',1),
	(12,'Uncategorized',1),
	(13,'Example Pages and Menu Links',1),
	(14,'healthy food',1),
	(15,'shopping',1),
	(16,'blog',1),
	(17,'business',1),
	(18,'nature',1),
	(19,'color',1),
	(20,'focus,',1),
	(21,'focus',1);

/*!40000 ALTER TABLE `#__k2_tags` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_tags_xref
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_tags_xref`;

CREATE TABLE `#__k2_tags_xref` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `tagID` int(11) NOT NULL,
  `itemID` int(11) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `tagID` (`tagID`),
  KEY `itemID` (`itemID`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_tags_xref` WRITE;
/*!40000 ALTER TABLE `#__k2_tags_xref` DISABLE KEYS */;

INSERT INTO `#__k2_tags_xref` (`id`, `tagID`, `itemID`)
VALUES
	(47,16,143),
	(45,18,144),
	(43,17,145),
	(42,16,145),
	(44,16,144),
	(46,14,143),
	(49,19,77),
	(48,16,77),
	(51,17,56),
	(50,16,56),
	(67,21,242);

/*!40000 ALTER TABLE `#__k2_tags_xref` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_user_groups
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_user_groups`;

CREATE TABLE `#__k2_user_groups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `name` varchar(255) NOT NULL,
  `permissions` text NOT NULL,
  PRIMARY KEY (`id`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_user_groups` WRITE;
/*!40000 ALTER TABLE `#__k2_user_groups` DISABLE KEYS */;

INSERT INTO `#__k2_user_groups` (`id`, `name`, `permissions`)
VALUES
	(1,'Registered','frontEdit=0\nadd=0\neditOwn=0\neditAll=0\npublish=0\ncomment=1\ninheritance=0\ncategories=all\n\n'),
	(2,'Site Owner','frontEdit=1\nadd=1\neditOwn=1\neditAll=1\npublish=1\ncomment=1\ninheritance=1\ncategories=all\n\n');

/*!40000 ALTER TABLE `#__k2_user_groups` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__k2_users
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__k2_users`;

CREATE TABLE `#__k2_users` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `userID` int(11) NOT NULL,
  `userName` varchar(255) DEFAULT NULL,
  `gender` enum('m','f') NOT NULL DEFAULT 'm',
  `description` text NOT NULL,
  `image` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `group` int(11) NOT NULL DEFAULT '0',
  `plugins` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `userID` (`userID`),
  KEY `group` (`group`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__k2_users` WRITE;
/*!40000 ALTER TABLE `#__k2_users` DISABLE KEYS */;

INSERT INTO `#__k2_users` (`id`, `userID`, `userName`, `gender`, `description`, `image`, `url`, `group`, `plugins`)
VALUES
	(1,62,'Administrator','m','',NULL,'',2,'');

/*!40000 ALTER TABLE `#__k2_users` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__menu
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__menu`;

CREATE TABLE `#__menu` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL COMMENT 'The type of menu this item belongs to. FK to #__menu_types.menutype',
  `title` varchar(255) NOT NULL COMMENT 'The display title of the menu item.',
  `alias` varchar(255) NOT NULL COMMENT 'The SEF alias of the menu item.',
  `note` varchar(255) NOT NULL DEFAULT '',
  `path` varchar(1024) NOT NULL COMMENT 'The computed path of the menu item based on the alias field.',
  `link` varchar(1024) NOT NULL COMMENT 'The actually link the menu item refers to.',
  `type` varchar(16) NOT NULL COMMENT 'The type of link: Component, URL, Alias, Separator',
  `published` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The published state of the menu link.',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '1' COMMENT 'The parent menu item in the menu tree.',
  `level` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'The relative level in the tree.',
  `component_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__extensions.id',
  `ordering` int(11) NOT NULL DEFAULT '0' COMMENT 'The relative ordering of the menu item in the tree.',
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'FK to #__users.id',
  `checked_out_time` timestamp NOT NULL DEFAULT '0000-00-00 00:00:00' COMMENT 'The time the menu item was checked out.',
  `browserNav` tinyint(4) NOT NULL DEFAULT '0' COMMENT 'The click behaviour of the link.',
  `access` int(10) unsigned DEFAULT NULL,
  `img` varchar(255) NOT NULL COMMENT 'The image of the menu item.',
  `template_style_id` int(10) unsigned NOT NULL DEFAULT '0',
  `params` text NOT NULL COMMENT 'JSON encoded data for the menu item.',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `home` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Indicates if this menu item is the home or default page.',
  `language` char(7) NOT NULL DEFAULT '',
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_client_id_parent_id_alias_language` (`client_id`,`parent_id`,`alias`,`language`),
  KEY `idx_componentid` (`component_id`,`menutype`,`published`,`access`),
  KEY `idx_menutype` (`menutype`),
  KEY `idx_left_right` (`lft`,`rgt`),
  KEY `idx_alias` (`alias`),
  KEY `idx_path` (`path`(333)),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__menu` WRITE;
/*!40000 ALTER TABLE `#__menu` DISABLE KEYS */;

INSERT INTO `#__menu` (`id`, `menutype`, `title`, `alias`, `note`, `path`, `link`, `type`, `published`, `parent_id`, `level`, `component_id`, `ordering`, `checked_out`, `checked_out_time`, `browserNav`, `access`, `img`, `template_style_id`, `params`, `lft`, `rgt`, `home`, `language`, `client_id`)
VALUES
	(1,'','Menu_Item_Root','root','','','','',1,0,0,0,0,0,'0000-00-00 00:00:00',0,0,'',0,'',0,205,0,'*',0),
	(2,'menu','com_banners','Banners','','Banners','index.php?option=com_banners','component',0,1,1,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',77,86,0,'*',1),
	(3,'menu','com_banners','Banners','','Banners/Banners','index.php?option=com_banners','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners',0,'',78,79,0,'*',1),
	(4,'menu','com_banners_categories','Categories','','Banners/Categories','index.php?option=com_categories&extension=com_banners','component',0,2,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:banners-cat',0,'',80,81,0,'*',1),
	(5,'menu','com_banners_clients','Clients','','Banners/Clients','index.php?option=com_banners&view=clients','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners-clients',0,'',82,83,0,'*',1),
	(6,'menu','com_banners_tracks','Tracks','','Banners/Tracks','index.php?option=com_banners&view=tracks','component',0,2,2,4,0,0,'0000-00-00 00:00:00',0,0,'class:banners-tracks',0,'',84,85,0,'*',1),
	(7,'menu','com_contact','Contacts','','Contacts','index.php?option=com_contact','component',0,1,1,8,0,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',87,92,0,'*',1),
	(8,'menu','com_contact','Contacts','','Contacts/Contacts','index.php?option=com_contact','component',0,7,2,8,0,0,'0000-00-00 00:00:00',0,0,'class:contact',0,'',88,89,0,'*',1),
	(9,'menu','com_contact_categories','Categories','','Contacts/Categories','index.php?option=com_categories&extension=com_contact','component',0,7,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:contact-cat',0,'',90,91,0,'*',1),
	(10,'menu','com_messages','Messaging','','Messaging','index.php?option=com_messages','component',0,1,1,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages',0,'',93,98,0,'*',1),
	(11,'menu','com_messages_add','New Private Message','','Messaging/New Private Message','index.php?option=com_messages&task=message.add','component',0,10,2,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages-add',0,'',94,95,0,'*',1),
	(12,'menu','com_messages_read','Read Private Message','','Messaging/Read Private Message','index.php?option=com_messages','component',0,10,2,15,0,0,'0000-00-00 00:00:00',0,0,'class:messages-read',0,'',96,97,0,'*',1),
	(13,'menu','com_newsfeeds','News Feeds','','News Feeds','index.php?option=com_newsfeeds','component',0,1,1,17,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',99,104,0,'*',1),
	(14,'menu','com_newsfeeds_feeds','Feeds','','News Feeds/Feeds','index.php?option=com_newsfeeds','component',0,13,2,17,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds',0,'',100,101,0,'*',1),
	(15,'menu','com_newsfeeds_categories','Categories','','News Feeds/Categories','index.php?option=com_categories&extension=com_newsfeeds','component',0,13,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:newsfeeds-cat',0,'',102,103,0,'*',1),
	(16,'menu','com_redirect','Redirect','','Redirect','index.php?option=com_redirect','component',0,1,1,24,0,0,'0000-00-00 00:00:00',0,0,'class:redirect',0,'',113,114,0,'*',1),
	(17,'menu','com_search','Search','','Search','index.php?option=com_search','component',0,1,1,19,0,0,'0000-00-00 00:00:00',0,0,'class:search',0,'',105,106,0,'*',1),
	(18,'menu','com_weblinks','Weblinks','','Weblinks','index.php?option=com_weblinks','component',0,1,1,21,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',107,112,0,'*',1),
	(19,'menu','com_weblinks_links','Links','','Weblinks/Links','index.php?option=com_weblinks','component',0,18,2,21,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks',0,'',108,109,0,'*',1),
	(20,'menu','com_weblinks_categories','Categories','','Weblinks/Categories','index.php?option=com_categories&extension=com_weblinks','component',0,18,2,6,0,0,'0000-00-00 00:00:00',0,0,'class:weblinks-cat',0,'',110,111,0,'*',1),
	(503,'footer','Login','login-bottom','','login-bottom','index.php?option=com_users&view=login','component',1,1,1,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',117,118,0,'*',0),
	(504,'top','Contact Us','contact-link','','contact-link','index.php?option=com_contact&view=contact&id=1','component',1,1,1,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',119,120,0,'*',0),
	(506,'mainmenu','Features{jb_br}{jb_i}Under the hood{/jb_i}','features','','features','index.php?option=com_content&view=category&layout=blog&id=22','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"0\",\"show_description_image\":\"0\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"1\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',3,14,0,'*',0),
	(517,'mainmenu','Zen Grid Framework','template-features-framework','','features/template-features-framework','index.php?option=com_content&view=article&id=60','component',1,506,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',4,5,0,'*',0),
	(518,'mainmenu','Typography','typography','','features/typography','index.php?option=com_content&view=article&id=90','component',1,506,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',6,7,0,'*',0),
	(519,'mainmenu','Module Position Overview','module-positions','','features/module-positions','index.php?option=com_content&view=article&id=104','component',1,506,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',8,9,0,'*',0),
	(520,'mainmenu','Theme Variations','theme-variations','','features/theme-variations','index.php?option=com_content&view=article&id=103','component',1,506,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',10,11,0,'*',0),
	(477,'mainmenu','News Feeds','news-feeds','','joomla/news-feeds','index.php?option=com_newsfeeds&view=categories&id=0','component',1,482,2,17,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',46,53,0,'*',0),
	(478,'mainmenu','All News feeds','all-news-feeds','','joomla/news-feeds/all-news-feeds','index.php?option=com_newsfeeds&view=categories&id=0','component',1,477,3,17,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',47,48,0,'*',0),
	(475,'mainmenu','Single Contacts','single-contacts','','joomla/contacts/single-contacts','index.php?option=com_contact&view=contact&id=1','component',1,472,3,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',37,38,0,'*',0),
	(476,'mainmenu','Featured Contact','featured-contact','','joomla/contacts/featured-contact','index.php?option=com_contact&view=featured','component',1,472,3,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',43,44,0,'*',0),
	(479,'mainmenu','News feeds in a category','news-feeds-in-a-category','','joomla/news-feeds/news-feeds-in-a-category','index.php?option=com_newsfeeds&view=category&id=17','component',1,477,3,17,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_articles\":\"\",\"show_link\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',49,50,0,'*',0),
	(480,'mainmenu','Single News Feed','single-news-feed','','joomla/news-feeds/single-news-feed','index.php?option=com_newsfeeds&view=newsfeed&id=2','component',1,477,3,17,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_feed_image\":\"\",\"show_feed_description\":\"\",\"show_item_description\":\"\",\"feed_character_count\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',51,52,0,'*',0),
	(481,'mainmenu','Weblinks','weblinks','','joomla/weblinks','index.php?option=com_weblinks&view=categories&id=0','component',1,482,2,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',30,35,0,'*',0),
	(482,'mainmenu','Joomla{jb_br}{jb_i}Default Joomla Views{/jb_i}','joomla','','joomla','','separator',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu_image\":\"\",\"menu_text\":1}',15,76,0,'*',0),
	(483,'mainmenu','Weblinks','weblinks','','joomla/weblinks/weblinks','index.php?option=com_weblinks&view=categories&id=0','component',1,481,3,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"-1\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_links_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_links\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_link_description\":\"\",\"show_link_hits\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',31,32,0,'*',0),
	(484,'mainmenu','Submit Web Link','submit-web-link','','joomla/weblinks/submit-web-link','index.php?option=com_weblinks&view=form&layout=edit','component',1,481,3,21,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',33,34,0,'*',0),
	(485,'mainmenu','Search','search','','joomla/search','index.php?option=com_search&view=search','component',1,482,2,19,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"search_areas\":\"\",\"show_date\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',54,55,0,'*',0),
	(486,'mainmenu','User','user','','joomla/user','index.php?option=com_users&view=login','component',1,482,2,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',56,69,0,'*',0),
	(487,'mainmenu','Login','login','','joomla/user/login','index.php?option=com_users&view=login','component',1,486,3,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"login_redirect_url\":\"\",\"logindescription_show\":\"1\",\"login_description\":\"\",\"login_image\":\"\",\"logout_redirect_url\":\"\",\"logoutdescription_show\":\"1\",\"logout_description\":\"\",\"logout_image\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',57,58,0,'*',0),
	(488,'mainmenu','Profile','profile','','joomla/user/profile','index.php?option=com_users&view=profile','component',1,486,3,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',59,60,0,'*',0),
	(489,'mainmenu','Edit Profile','edit-profile','','joomla/user/edit-profile','index.php?option=com_users&view=profile&layout=edit','component',1,486,3,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',61,62,0,'*',0),
	(490,'mainmenu','Registration Profile','registration-profile','','joomla/user/registration-profile','index.php?option=com_users&view=registration','component',1,486,3,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',63,64,0,'*',0),
	(491,'mainmenu','Username Request','username-request','','joomla/user/username-request','index.php?option=com_users&view=remind','component',1,486,3,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',65,66,0,'*',0),
	(492,'mainmenu','Password Reset','password-reset','','joomla/user/password-reset','index.php?option=com_users&view=reset','component',1,486,3,25,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',67,68,0,'*',0),
	(493,'mainmenu','Wrapper','wrapper','','joomla/wrapper','index.php?option=com_wrapper&view=wrapper','component',1,482,2,2,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"url\":\"http:\\/\\/www.google.com\",\"scrolling\":\"auto\",\"width\":\"100%\",\"height\":\"500\",\"height_auto\":\"0\",\"add_scheme\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',70,71,0,'*',0),
	(494,'mainmenu','External URL','2011-04-24-02-56-40','','joomla/2011-04-24-02-56-40','http://www.joomlabamboo.com','url',1,482,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',72,73,0,'*',0),
	(495,'mainmenu','Menu Item Alias','2011-04-24-02-57-19','','joomla/2011-04-24-02-57-19','index.php?Itemid=','alias',1,482,2,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"aliasoptions\":\"468\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\"}',74,75,0,'*',0),
	(474,'mainmenu','Contacts in a category','contacts-in-a-category','','joomla/contacts/contacts-in-a-category','index.php?option=com_contact&view=category&id=16','component',1,472,3,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',41,42,0,'*',0),
	(473,'mainmenu','All Contact Categories','all-contact-categories','','joomla/contacts/all-contact-categories','index.php?option=com_contact&view=categories&id=0','component',1,472,3,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',39,40,0,'*',0),
	(471,'mainmenu','Create Article','create-article','','joomla/content/create-article','index.php?option=com_content&view=form&layout=edit','component',1,465,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',27,28,0,'*',0),
	(472,'mainmenu','Contacts','contacts','','joomla/contacts','index.php?option=com_contact&view=categories&id=0','component',1,482,2,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_items_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_subcat_desc\":\"\",\"show_cat_items\":\"\",\"show_pagination_limit\":\"\",\"show_headings\":\"\",\"show_position_headings\":\"\",\"show_email_headings\":\"\",\"show_telephone_headings\":\"\",\"show_mobile_headings\":\"\",\"show_fax_headings\":\"\",\"show_suburb_headings\":\"\",\"show_state_headings\":\"\",\"show_country_headings\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"presentation_style\":\"\",\"show_contact_category\":\"\",\"show_contact_list\":\"\",\"show_name\":\"\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',36,45,0,'*',0),
	(470,'mainmenu','Featured Articles','featured-articles','','joomla/content/featured-articles','index.php?option=com_content&view=featured','component',1,465,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"0\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"0\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"Featured Articles\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',23,24,0,'*',0),
	(521,'mainmenu','{jb_img}images/home.png{/jb_img}','homepage','','homepage','index.php?option=com_content&view=featured','component',1,1,1,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"featured_categories\":[\"\"],\"layout_type\":\"blog\",\"num_leading_articles\":\"0\",\"num_intro_articles\":\"0\",\"num_columns\":\"2\",\"num_links\":\"0\",\"multi_column_order\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"0\",\"link_category\":\"0\",\"show_parent_category\":\"0\",\"link_parent_category\":\"\",\"show_author\":\"0\",\"link_author\":\"\",\"show_create_date\":\"0\",\"show_modify_date\":\"0\",\"show_publish_date\":\"0\",\"show_item_navigation\":\"0\",\"show_vote\":\"\",\"show_readmore\":\"0\",\"show_readmore_title\":\"\",\"show_icons\":\"0\",\"show_print_icon\":\"0\",\"show_email_icon\":\"0\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"A Blank Slate\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',1,2,1,'*',0),
	(467,'mainmenu','List all categories','list-all-categories','','joomla/content/list-all-categories','index.php?option=com_content&view=categories&id=0','component',1,465,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_articles_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"List all categories\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',19,20,0,'*',0),
	(468,'mainmenu','Category Blog','category-blog','','joomla/content/category-blog','index.php?option=com_content&view=category&layout=blog&id=81','component',1,465,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"layout_type\":\"blog\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"num_leading_articles\":\"\",\"num_intro_articles\":\"3\",\"num_columns\":\"1\",\"num_links\":\"\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"Content Category\",\"show_page_heading\":1,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',21,22,0,'*',0),
	(469,'mainmenu','Category List','category-list','','joomla/content/category-list','index.php?option=com_content&view=category&id=78','component',1,465,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"page_subheading\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"Category List\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',25,26,0,'*',0),
	(465,'mainmenu','Content','content','','joomla/content','index.php?option=com_content&view=categories&id=78','component',1,482,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_base_description\":\"\",\"categories_description\":\"\",\"maxLevelcat\":\"\",\"show_empty_categories_cat\":\"\",\"show_subcat_desc_cat\":\"\",\"show_cat_num_articles_cat\":\"\",\"show_category_title\":\"\",\"show_description\":\"\",\"show_description_image\":\"\",\"maxLevel\":\"\",\"show_empty_categories\":\"\",\"show_no_articles\":\"\",\"show_subcat_desc\":\"\",\"show_cat_num_articles\":\"\",\"num_leading_articles\":\"1\",\"num_intro_articles\":\"4\",\"num_columns\":\"2\",\"num_links\":\"4\",\"multi_column_order\":\"\",\"show_subcategory_content\":\"\",\"orderby_pri\":\"\",\"orderby_sec\":\"\",\"order_date\":\"\",\"show_pagination\":\"\",\"show_pagination_results\":\"\",\"show_pagination_limit\":\"\",\"filter_field\":\"\",\"show_headings\":\"\",\"list_show_date\":\"\",\"date_format\":\"\",\"list_show_hits\":\"\",\"list_show_author\":\"\",\"display_num\":\"10\",\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_readmore\":\"\",\"show_readmore_title\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"show_feed_link\":\"\",\"feed_summary\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',16,29,0,'*',0),
	(466,'mainmenu','Single Article','single-article','','joomla/content/single-article','index.php?option=com_content&view=article&id=72','component',1,465,3,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',17,18,0,'*',0),
	(522,'footer','Contact Us','contact-us','','contact-us','index.php?option=com_contact&view=contact&id=2','component',1,1,1,8,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"presentation_style\":\"plain\",\"show_contact_category\":\"hide\",\"show_contact_list\":\"0\",\"show_name\":\"0\",\"show_position\":\"\",\"show_email\":\"\",\"show_street_address\":\"\",\"show_suburb\":\"\",\"show_state\":\"\",\"show_postcode\":\"\",\"show_country\":\"\",\"show_telephone\":\"\",\"show_mobile\":\"\",\"show_fax\":\"\",\"show_webpage\":\"\",\"show_misc\":\"\",\"show_image\":\"\",\"allow_vcard\":\"\",\"show_articles\":\"\",\"show_links\":\"\",\"linka_name\":\"\",\"linkb_name\":\"\",\"linkc_name\":\"\",\"linkd_name\":\"\",\"linke_name\":\"\",\"show_email_form\":\"\",\"show_email_copy\":\"\",\"banned_email\":\"\",\"banned_subject\":\"\",\"banned_text\":\"\",\"validate_session\":\"\",\"custom_reply\":\"\",\"redirect\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',115,116,0,'*',0),
	(523,'mainmenu','Module Classes','module-classes','','features/module-classes','index.php?option=com_content&view=article&id=141','component',1,506,2,22,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"show_title\":\"\",\"link_titles\":\"\",\"show_intro\":\"\",\"show_category\":\"\",\"link_category\":\"\",\"show_parent_category\":\"\",\"link_parent_category\":\"\",\"show_author\":\"\",\"link_author\":\"\",\"show_create_date\":\"\",\"show_modify_date\":\"\",\"show_publish_date\":\"\",\"show_item_navigation\":\"\",\"show_vote\":\"\",\"show_icons\":\"\",\"show_print_icon\":\"\",\"show_email_icon\":\"\",\"show_hits\":\"\",\"show_noauth\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',12,13,0,'*',0),
	(524,'mainmenu','Extensions{jb_br}{jb_i}Joomla modules{/jb_i}','2011-07-24-11-00-07','','2011-07-24-11-00-07','http://www.joomlabamboo.com/joomla-extensions/joomla-extensions','url',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',121,132,0,'*',0),
	(525,'mainmenu','Setup{jb_br}{jb_i}Put Rasa into action{/jb_i}','2011-07-24-11-02-15','','2011-07-24-11-02-15','http://docs.joomlabamboo.com/item/633-rasa-documentation','url',1,1,1,0,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1}',133,134,0,'*',0),
	(573,'mainmenu','K2','k2','','2011-07-24-11-00-07/k2','index.php?option=com_k2&view=item&layout=item&id=145','component',1,524,2,10025,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',122,131,0,'*',0),
	(574,'mainmenu','K2 Category','k2-category','','2011-07-24-11-00-07/k2/k2-category','index.php?option=com_k2&view=itemlist&layout=category&task=category&id=40','component',1,573,3,10025,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"categories\":[\"40\"],\"singleCatOrdering\":\"\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',123,124,0,'*',0),
	(572,'main','K2_INFORMATION','k2-information','','com-k2/k2-information','index.php?option=com_k2&view=info','component',0,562,2,10025,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',202,203,0,'',1),
	(571,'main','K2_MEDIA_MANAGER','k2-media-manager','','com-k2/k2-media-manager','index.php?option=com_k2&view=media','component',0,562,2,10025,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',200,201,0,'',1),
	(570,'main','K2_EXTRA_FIELD_GROUPS','k2-extra-field-groups','','com-k2/k2-extra-field-groups','index.php?option=com_k2&view=extrafieldsgroups','component',0,562,2,10025,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',198,199,0,'',1),
	(569,'main','K2_EXTRA_FIELDS','k2-extra-fields','','com-k2/k2-extra-fields','index.php?option=com_k2&view=extrafields','component',0,562,2,10025,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',196,197,0,'',1),
	(568,'main','K2_USER_GROUPS','k2-user-groups','','com-k2/k2-user-groups','index.php?option=com_k2&view=usergroups','component',0,562,2,10025,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',194,195,0,'',1),
	(567,'main','K2_USERS','k2-users','','com-k2/k2-users','index.php?option=com_k2&view=users','component',0,562,2,10025,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',192,193,0,'',1),
	(565,'main','K2_TAGS','k2-tags','','com-k2/k2-tags','index.php?option=com_k2&view=tags','component',0,562,2,10025,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',188,189,0,'',1),
	(566,'main','K2_COMMENTS','k2-comments','','com-k2/k2-comments','index.php?option=com_k2&view=comments','component',0,562,2,10025,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',190,191,0,'',1),
	(564,'main','K2_CATEGORIES','k2-categories','','com-k2/k2-categories','index.php?option=com_k2&view=categories','component',0,562,2,10025,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',186,187,0,'',1),
	(562,'main','COM_K2','com-k2','','com-k2','index.php?option=com_k2','component',0,1,1,10025,0,0,'0000-00-00 00:00:00',0,1,'../media/k2/assets/images/system/k2_16x16.png',0,'',183,204,0,'',1),
	(563,'main','K2_ITEMS','k2-items','','com-k2/k2-items','index.php?option=com_k2&view=items','component',0,562,2,10025,0,0,'0000-00-00 00:00:00',0,1,'class:component',0,'',184,185,0,'',1),
	(539,'main','COM_FINDER','com-finder','','com-finder','index.php?option=com_finder','component',0,1,1,10026,0,0,'0000-00-00 00:00:00',0,1,'class:finder',0,'',159,160,0,'',1),
	(575,'mainmenu','K2 Tags','k2-tags','','2011-07-24-11-00-07/k2/k2-tags','index.php?option=com_k2&view=itemlist&layout=tag&tag=focus&task=tag','component',1,573,3,10025,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"rasa\",\"tagOrdering\":\"\",\"tagFeedLink\":\"1\",\"tagFeedIcon\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',125,126,0,'*',0),
	(576,'mainmenu','K2 User Page','k2-user-page','','2011-07-24-11-00-07/k2/k2-user-page','index.php?option=com_k2&view=itemlist&layout=user&id=42&task=user','component',1,573,3,10025,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"rasa\",\"userCategoriesFilter\":[\"40\"],\"userOrdering\":\"\",\"userFeedLink\":\"1\",\"userFeedIcon\":\"1\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',127,128,0,'*',0),
	(577,'mainmenu','Latest Items Category','latest-items-category','','2011-07-24-11-00-07/k2/latest-items-category','index.php?option=com_k2&view=latest&layout=latest','component',1,573,3,10025,0,0,'0000-00-00 00:00:00',0,1,'',0,'{\"theme\":\"rasa\",\"source\":\"1\",\"latestItemsCols\":\"2\",\"latestItemsLimit\":\"3\",\"latestItemsDisplayEffect\":\"all\",\"userName\":\"1\",\"userImage\":\"1\",\"userDescription\":\"1\",\"userURL\":\"1\",\"userEmail\":\"0\",\"userFeed\":\"1\",\"categoryIDs\":[\"40\"],\"categoryTitle\":\"1\",\"categoryDescription\":\"1\",\"categoryImage\":\"1\",\"categoryFeed\":\"1\",\"latestItemTitle\":\"1\",\"latestItemTitleLinked\":\"1\",\"latestItemDateCreated\":\"1\",\"latestItemImage\":\"1\",\"latestItemImageSize\":\"Medium\",\"latestItemVideo\":\"1\",\"latestItemVideoWidth\":\"\",\"latestItemVideoHeight\":\"\",\"latestItemAudioWidth\":\"\",\"latestItemAudioHeight\":\"\",\"latestItemVideoAutoPlay\":\"0\",\"latestItemIntroText\":\"1\",\"latestItemCategory\":\"1\",\"latestItemTags\":\"1\",\"latestItemReadMore\":\"1\",\"latestItemCommentsAnchor\":\"0\",\"feedLink\":\"1\",\"latestItemK2Plugins\":\"0\",\"menu-anchor_title\":\"\",\"menu-anchor_css\":\"\",\"menu_image\":\"\",\"menu_text\":1,\"page_title\":\"\",\"show_page_heading\":0,\"page_heading\":\"\",\"pageclass_sfx\":\"\",\"menu-meta_description\":\"\",\"menu-meta_keywords\":\"\",\"robots\":\"\",\"secure\":0}',129,130,0,'*',0);

/*!40000 ALTER TABLE `#__menu` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__menu_types
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__menu_types`;

CREATE TABLE `#__menu_types` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `menutype` varchar(24) NOT NULL,
  `title` varchar(48) NOT NULL,
  `description` varchar(255) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_menutype` (`menutype`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__menu_types` WRITE;
/*!40000 ALTER TABLE `#__menu_types` DISABLE KEYS */;

INSERT INTO `#__menu_types` (`id`, `menutype`, `title`, `description`)
VALUES
	(9,'top','Top Menu',''),
	(6,'mainmenu','Main Menu','Simple Home Menu'),
	(8,'footer','Footer Menu','');

/*!40000 ALTER TABLE `#__menu_types` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__modules
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__modules`;

CREATE TABLE `#__modules` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `title` varchar(100) NOT NULL DEFAULT '',
  `note` varchar(255) NOT NULL DEFAULT '',
  `content` text NOT NULL,
  `ordering` int(11) NOT NULL DEFAULT '0',
  `position` varchar(50) DEFAULT NULL,
  `checked_out` int(10) unsigned NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `published` tinyint(1) NOT NULL DEFAULT '0',
  `module` varchar(50) DEFAULT NULL,
  `access` int(10) unsigned DEFAULT NULL,
  `showtitle` tinyint(3) unsigned NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `client_id` tinyint(4) NOT NULL DEFAULT '0',
  `language` char(7) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `published` (`published`,`access`),
  KEY `newsfeeds` (`module`,`published`),
  KEY `idx_language` (`language`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__modules` WRITE;
/*!40000 ALTER TABLE `#__modules` DISABLE KEYS */;

INSERT INTO `#__modules` (`id`, `title`, `note`, `content`, `ordering`, `position`, `checked_out`, `checked_out_time`, `publish_up`, `publish_down`, `published`, `module`, `access`, `showtitle`, `params`, `client_id`, `language`)
VALUES
	(1,'Main Menu','','',1,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_menu',1,1,'{\"menutype\":\"mainmenu\",\"startLevel\":\"0\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"\",\"moduleclass_sfx\":\"_menu\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),
	(2,'Login','','',1,'login',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,1,'',1,'*'),
	(3,'Popular Articles','','',3,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_popular',3,1,'{\"count\":\"5\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),
	(4,'Recently Added Articles','','',4,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_latest',3,1,'{\"count\":\"5\",\"ordering\":\"c_dsc\",\"catid\":\"\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),
	(8,'Toolbar','','',1,'toolbar',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_toolbar',3,1,'',1,'*'),
	(9,'Quick Icons','','',1,'icon',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_quickicon',3,1,'',1,'*'),
	(10,'Logged-in Users','','',2,'cpanel',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_logged',3,1,'{\"count\":\"5\",\"name\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"automatic_title\":\"1\"}',1,'*'),
	(12,'Admin Menu','','',1,'menu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',3,1,'{\"layout\":\"\",\"moduleclass_sfx\":\"\",\"shownew\":\"1\",\"showhelp\":\"1\",\"cache\":\"0\"}',1,'*'),
	(13,'Admin Submenu','','',1,'submenu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_submenu',3,1,'',1,'*'),
	(14,'User Status','','',1,'status',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_status',3,1,'',1,'*'),
	(15,'Title','','',1,'title',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_title',3,1,'',1,'*'),
	(16,'Login Form','','',7,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_login',1,1,'{\"greeting\":\"1\",\"name\":\"0\"}',0,'*'),
	(17,'Breadcrumbs','','',1,'position-2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_breadcrumbs',1,1,'{\"moduleclass_sfx\":\"\",\"showHome\":\"1\",\"homeText\":\"Home\",\"showComponent\":\"1\",\"separator\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),
	(18,'Book Store','','',1,'position-10',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_banners',1,0,'{\"target\":\"1\",\"count\":\"1\",\"cid\":\"3\",\"catid\":[\"\"],\"tag_search\":\"0\",\"ordering\":\"0\",\"header_text\":\"\",\"footer_text\":\"Books!\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\"}',0,'*'),
	(19,'Main Menu','','',0,'menu',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,0,'{\"menutype\":\"mainmenu\",\"menu_style\":\"list\",\"startLevel\":1,\"endLevel\":0,\"showAllChildren\":1,\"window_open\":\"\",\"show_whitespace\":0,\"cache\":1,\"tag_id\":\"\",\"class_sfx\":\"\",\"moduleclass_sfx\":\"\",\"maxdepth\":10,\"menu_images\":0,\"menu_images_align\":0,\"menu_images_link\":0,\"expand_menu\":1,\"activate_parent\":1,\"full_active_id\":1,\"indent_image\":0,\"indent_image1\":\"\",\"indent_image2\":\"\",\"indent_image3\":\"\",\"indent_image4\":\"\",\"indent_image5\":\"\",\"indent_image6\":\"\",\"spacer\":\"\",\"end_spacer\":\"\"}',0,'*'),
	(20,'User Menu','','',2,'position-6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_menu',2,1,'{\"menutype\":\"usermenu\",\"moduleclass_sfx\":\"_menu\",\"cache\":1}',0,'*'),
	(21,'Login Form','','',0,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_login',1,1,'{\"cache\":0,\"moduleclass_sfx\":\"\",\"pretext\":\"\",\"posttext\":\"\",\"login\":\"\",\"logout\":\"\",\"greeting\":1,\"name\":0,\"usesecure\":0}',0,'*'),
	(22,'Latest News','','',1,'bottom5',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(23,'Statistics','','',4,'position-6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_stats',1,1,'{\"serverinfo\":1,\"siteinfo\":1,\"counter\":1,\"increase\":0,\"moduleclass_sfx\":\"\"}',0,'*'),
	(24,'Who\'s Online','','',1,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_whosonline',1,1,'{\"online\":1,\"users\":1,\"moduleclass_sfx\":\"\"}',0,'*'),
	(25,'Popular','','',1,'bottom1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_popular',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_front\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(26,'Archive','','',5,'position-6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_articles_archive',1,1,'{\"cache\":1}',0,'*'),
	(27,'Newsflash','','',1,'position-1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_articles_news',1,1,'{\"catid\":3,\"style\":\"random\",\"items\":\"\",\"moduleclass_sfx\":\"\"}',0,'*'),
	(28,'Related Items','','',7,'position-6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_related_items',1,1,'{}',0,'*'),
	(29,'Search','','',0,'position-8',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_search',1,0,'{\"moduleclass_sfx\":\"\",\"width\":16,\"text\":\"\",\"button\":\"\",\"button_pos\":\"right\",\"imagebutton\":\"\",\"button_text\":\"\",\"set_itemid\":\"\",\"cache\":1,\"cache_time\":900}',0,'*'),
	(30,'Random Image','','',9,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_random_image',1,1,'{}',0,'*'),
	(31,'Footer Menu','','',1,'footer',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,0,'{\"menutype\":\"footer\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"-nav\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),
	(46,'Frontpage Slideshow','','',0,'advert1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_slideshow3',1,0,'{\"display_ticker\":\"1\",\"display_slideshow\":\"1\",\"loadCSS\":\"head\",\"loadJS\":\"head\",\"ssTheme\":\"None\",\"ticker_transition\":\"fade\",\"slideshow_height\":\"300px\",\"slideshow_width\":\"578px\",\"sstime\":\"10000\",\"ssSpeed\":\"1500\",\"content_image\":\"content\",\"imageLink\":\"1\",\"image_top\":\"0\",\"image_left\":\"0\",\"imgBorder\":\"1\",\"imagedirectory\":\"\",\"lowercase\":\"0\",\"fileType\":\"jpg\",\"imageResize\":\"1\",\"image_width\":\"578\",\"image_height\":\"300\",\"option\":\"crop\",\"count\":\"10\",\"category_filtering_type\":\"1\",\"catid\":[\"24\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"show_front\":\"show\",\"article_filtering_type\":\"1\",\"author_filtering_type\":\"1\",\"created_by\":[\"\"],\"ordering\":\"a.created\",\"ordering_direction\":\"ASC\",\"ticker_height\":\"40\",\"ticker_width\":\"566\",\"margin_top\":\"254\",\"margin_left\":\"6\",\"bgOverlay\":\"dark\",\"item_title\":\"1\",\"title_class\":\"h2\",\"title_link\":\"1\",\"linkTarget\":\"article\",\"ticker_text\":\"1\",\"introtext_limit\":\"0\",\"striptags\":\"1\",\"tags\":\"\",\"renderPlugin\":\"render\",\"createdDate\":\"1\",\"dateFormat\":\"j M, y\",\"readMoreText\":\"Read More ...\",\"readMoreLink\":\"1\",\"showCategory\":\"0\",\"catLink\":\"0\",\"catPrefix\":\"Posted in\",\"display_nav\":\"indexNavButtons\",\"navWidth\":\"586\",\"navHeight\":\"40\",\"navTop\":\"300\",\"navLeft\":\"0\",\"navButtons\":\"0\",\"navPrevText\":\"  Previous\",\"navNextText\":\"Next  >>\",\"scrollNav\":\"none\",\"numVis\":\"3\",\"navItemWidth\":\"40\",\"navItemHeight\":\"40\",\"titleLimit\":\"0\",\"titleSuffix\":\"...\",\"fadeEffect\":\"1\",\"hoverTransition\":\"1\",\"thumb_width\":\"60\",\"thumb_height\":\"40\",\"thumb_option\":\"crop\",\"tickerIntro\":\" \",\"showDescriptionText\":\"none\",\"descriptionText\":\"\",\"descriptionMarginTop\":\"0\",\"descriptionMarginLeft\":\"0\",\"descriptionHeight\":\"50\",\"descriptionWidth\":\"100\",\"descriptionOverlay\":\"no\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}',0,'*'),
	(32,'Banners','','',1,'position-9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_banners',1,0,'{\"target\":1,\"count\":1,\"cid\":1,\"catid\":33,\"tag_search\":0,\"ordering\":\"random\",\"header_text\":\"\",\"footer_text\":\"\",\"moduleclass_sfx\":\"\",\"cache\":1,\"cache_time\":15}',0,'*'),
	(33,'Wrapper','','',8,'position-6',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_wrapper',1,1,'{}',0,'*'),
	(34,'Footer','','',2,'position-9',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_footer',1,0,'{\"cache\":1}',0,'*'),
	(35,'Breadcrumbs','','',1,'breadcrumb',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_breadcrumbs',1,0,'{\"showHere\":\"0\",\"showHome\":\"1\",\"homeText\":\"Home\",\"showLast\":\"1\",\"separator\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),
	(36,'Syndication','','',3,'syndicate',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_syndicate',1,0,'{}',0,'*'),
	(37,'Advertisement','','',3,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_banners',1,1,'{\"count\":4,\"randomise\":0,\"cid\":0,\"catid\":14,\"header_text\":\"Featured Links:\",\"footer_text\":\"<a href=\\\"http:\\/\\/www.joomla.org\\\">Ads by Joomla!<\\/a>\",\"moduleclass_sfx\":\"_text\",\"cache\":0}',0,'*'),
	(38,'Panel Menu','','',0,'position-7',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',-2,'mod_menu',1,1,'{\"menutype\":\"panel-menu\",\"menu_style\":\"list\",\"startLevel\":1,\"endLevel\":0,\"showAllChildren\":1,\"window_open\":\"\",\"show_whitespace\":0,\"cache\":1,\"tag_id\":\"\",\"class_sfx\":\"\",\"moduleclass_sfx\":\"-panelmenu green\",\"maxdepth\":10,\"menu_images\":0,\"menu_images_align\":0,\"menu_images_link\":0,\"expand_menu\":1,\"activate_parent\":1,\"full_active_id\":1,\"indent_image\":0,\"indent_image1\":\"\",\"indent_image2\":\"\",\"indent_image3\":\"\",\"indent_image4\":\"\",\"indent_image5\":\"\",\"indent_image6\":\"\",\"spacer\":\"\",\"end_spacer\":\"\"}',0,'*'),
	(39,'Top Menu','','',1,'top1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_menu',1,0,'{\"menutype\":\"footer\",\"startLevel\":\"1\",\"endLevel\":\"0\",\"showAllChildren\":\"0\",\"tag_id\":\"\",\"class_sfx\":\"\",\"window_open\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),
	(40,'New? Start Here ...','','<p>After serving more than 3000 businesses in the area why not start with our range of professional stuff now.</p>\r\n<p><a class=\"button\" href=\"#\">Get Started</a></p>',1,'left',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(41,'Our Services','','<ul>\r\n<li>Complete brand prototyping</li>\r\n<li>Ingenious image moulding</li>\r\n<li>Planetary enlightenment</li>\r\n<li>Shadow Politics</li>\r\n<li>Counter balanced economics</li>\r\n</ul>',1,'left',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-ribbon\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(42,'Let\'s get social','','<div>\r\n<ul class=\"icons\">\r\n<li><img src=\"images/democontent/icons/twitterIcon.png\" border=\"0\" alt=\"twitterIcon\" width=\"40\" height=\"40\" /><span>Follow us on twitter</span></li>\r\n<li><img src=\"images/democontent/icons/skype.png\" border=\"0\" alt=\"skype\" width=\"40\" height=\"40\" /><span>Contact via skype</span></li>\r\n<li><img src=\"images/democontent/icons/rss-badge.png\" border=\"0\" alt=\"rss-badge\" width=\"40\" height=\"40\" /><span>Feed yourself our latest news</span></li>\r\n<li><img src=\"images/democontent/icons/vimeo.png\" border=\"0\" alt=\"vimeo\" width=\"40\" height=\"40\" /><span>We make videos</span></li>\r\n<li><img src=\"images/democontent/icons/flickr.png\" border=\"0\" alt=\"flickr\" width=\"40\" height=\"40\" /><span>Our photography stream</span></li>\r\n</ul>\r\n</div>',1,'left',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,1,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"-ribbon top\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(43,'More news ...','','',1,'bottom2',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(44,'Featured','','',1,'bottom3',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_articles_latest',1,1,'{\"catid\":[\"\"],\"count\":\"5\",\"show_featured\":\"\",\"ordering\":\"c_dsc\",\"user_id\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(45,'Slogan','','<p>{jb_quote}Minimalism is more than leaving stuff out, in fact ... <br />minimalism is a state of mind.{/jb_quote}</p>',1,'header4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_custom',1,0,'{\"prepare_content\":\"1\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"static\"}',0,'*'),
	(47,'Featured Articles','','',1,'advert4',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_microblog',1,0,'{\"layout\":\"columns\",\"mbHeight\":\"\",\"loadCSS\":\"head\",\"loadJS\":\"head\",\"count\":\"8\",\"category_filtering_type\":\"1\",\"catid\":[\"23\"],\"show_child_category_articles\":\"0\",\"levels\":\"1\",\"show_front\":\"hide\",\"article_filtering_type\":\"1\",\"author_filtering_type\":\"1\",\"created_by\":[\"\"],\"ordering\":\"a.ordering\",\"ordering_direction\":\"ASC\",\"titlelink\":\"1\",\"linkTarget\":\"article\",\"titleClass\":\"h2\",\"titleLimit\":\"16\",\"titleSuffix\":\"...\",\"showintro\":\"1\",\"wordCount\":\"40\",\"introSuffix\":\"...\",\"strip_tags\":\"1\",\"allowed_tags\":\"\",\"renderPlugin\":\"strip\",\"displayMore\":\"0\",\"readonText\":\"\",\"showdate\":\"1\",\"dateFormat\":\"j M, y\",\"showCategory\":\"1\",\"catLink\":\"1\",\"catPrefix\":\"Posted in\",\"displayImages\":\"article\",\"resizeImage\":\"1\",\"image_width\":\"120\",\"image_height\":\"80\",\"option\":\"crop\",\"fadeEffect\":\"1\",\"cbTheme\":\"1\",\"popupGallery\":\"1\",\"justImage\":\"1\",\"overlayOpacity\":\"0.6\",\"frameWidth\":\"800\",\"frameHeight\":\"500\",\"colorboxScrolling\":\"false\",\"addMargin\":\"1\",\"rightMargin\":\"0\",\"bottomMargin\":\"0\",\"imagesPerRow\":\"2\",\"colClearDiv\":\"1\",\"trigger1\":\"\",\"trigger2\":\"\",\"trigger3\":\"\",\"trigger4\":\"\",\"trigger5\":\"\",\"trigger6\":\"\",\"trigger7\":\"\",\"trigger8\":\"\",\"trigger9\":\"\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}',0,'*'),
	(48,'Login ','','',1,'panel1',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_login',1,1,'{\"pretext\":\"\",\"posttext\":\"\",\"login\":\"\",\"logout\":\"\",\"greeting\":\"1\",\"name\":\"0\",\"usesecure\":\"0\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"0\"}',0,'*'),
	(49,'Themes','','',1,'themes',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_prettyBox',1,0,'{\"directory\":\"\\/images\\/democontent\\/themes\",\"output\":\"2\",\"details\":\"1\",\"link\":\"1\",\"right_margin\":\"20\",\"loadCSS\":\"head\",\"loadJS\":\"head\",\"prettyPhoto\":\"true\",\"theme\":\"dark_rounded\",\"opacity\":\"0.6\",\"resize\":\"true\",\"prettyBoxTitle\":\"false\",\"prettyBoxSpeed\":\"fast\",\"overlayGallery\":\"true\",\"img_width\":\"200\",\"img_height\":\"340\",\"option\":\"smart\",\"height\":\"400\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}',0,'*'),
	(50,'search','','',0,'search',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_search',1,0,'{\"label\":\"\",\"width\":\"16\",\"text\":\"\",\"button\":\"\",\"button_pos\":\"right\",\"imagebutton\":\"\",\"button_text\":\"\",\"set_itemid\":\"\",\"layout\":\"_:default\",\"moduleclass_sfx\":\"\",\"cache\":\"1\",\"cache_time\":\"900\",\"cachemode\":\"itemid\"}',0,'*'),
	(51,'Module Classes','','',1,'moduleclasses',0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',1,'mod_prettyBox',1,0,'{\"directory\":\"\\/images\\/democontent\\/moduleclasses\",\"output\":\"1\",\"details\":\"1\",\"link\":\"1\",\"right_margin\":\"20\",\"loadCSS\":\"head\",\"loadJS\":\"head\",\"prettyPhoto\":\"true\",\"theme\":\"dark_rounded\",\"opacity\":\"0.6\",\"resize\":\"true\",\"prettyBoxTitle\":\"false\",\"prettyBoxSpeed\":\"fast\",\"overlayGallery\":\"true\",\"img_width\":\"300\",\"img_height\":\"60\",\"option\":\"smart\",\"height\":\"150\",\"cache\":\"0\",\"cache_time\":\"900\",\"moduleclass_sfx\":\"\"}',0,'*'),
	(52,'K2 Comments','','',0,NULL,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_comments',1,1,'',0,'*'),
	(53,'K2 Content','','',0,NULL,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_content',1,1,'',0,'*'),
	(54,'K2 Login','','',0,NULL,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_login',1,1,'',0,'*'),
	(55,'K2 Tools','','',0,NULL,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_tools',1,1,'',0,'*'),
	(56,'K2 Users','','',0,NULL,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_users',1,1,'',0,'*'),
	(57,'K2 User','','',0,NULL,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_user',1,1,'',0,'*'),
	(58,'K2 Quick Icons (admin)','','',0,NULL,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_quickicons',1,1,'',1,'*'),
	(59,'K2 Stats (admin)','','',0,NULL,0,'0000-00-00 00:00:00','0000-00-00 00:00:00','0000-00-00 00:00:00',0,'mod_k2_stats',1,1,'',1,'*');

/*!40000 ALTER TABLE `#__modules` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__modules_menu
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__modules_menu`;

CREATE TABLE `#__modules_menu` (
  `moduleid` int(11) NOT NULL DEFAULT '0',
  `menuid` int(11) NOT NULL DEFAULT '0',
  PRIMARY KEY (`moduleid`,`menuid`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__modules_menu` WRITE;
/*!40000 ALTER TABLE `#__modules_menu` DISABLE KEYS */;

INSERT INTO `#__modules_menu` (`moduleid`, `menuid`)
VALUES
	(1,0),
	(2,0),
	(3,0),
	(4,0),
	(6,0),
	(7,0),
	(8,0),
	(9,0),
	(10,0),
	(12,0),
	(13,0),
	(14,0),
	(15,0),
	(16,205),
	(16,435),
	(17,465),
	(17,466),
	(17,467),
	(17,468),
	(17,469),
	(17,470),
	(17,471),
	(17,472),
	(17,473),
	(17,474),
	(17,475),
	(17,476),
	(17,477),
	(17,478),
	(17,479),
	(17,480),
	(17,481),
	(17,482),
	(17,483),
	(17,484),
	(17,485),
	(17,486),
	(17,487),
	(17,488),
	(17,489),
	(17,490),
	(17,491),
	(17,492),
	(17,493),
	(17,494),
	(17,495),
	(17,503),
	(17,504),
	(17,506),
	(17,507),
	(17,508),
	(17,509),
	(17,510),
	(17,511),
	(17,512),
	(17,513),
	(17,514),
	(17,515),
	(17,516),
	(17,517),
	(17,518),
	(17,519),
	(17,520),
	(18,0),
	(19,-463),
	(19,-462),
	(19,-433),
	(19,-432),
	(19,-431),
	(19,-430),
	(19,-429),
	(19,-427),
	(19,-400),
	(19,-399),
	(19,-296),
	(19,-244),
	(19,-243),
	(19,-242),
	(19,-234),
	(20,0),
	(22,0),
	(23,-463),
	(23,-462),
	(23,-433),
	(23,-432),
	(23,-431),
	(23,-430),
	(23,-429),
	(23,-427),
	(23,-400),
	(23,-399),
	(23,-296),
	(23,-244),
	(23,-243),
	(23,-242),
	(23,-238),
	(23,-234),
	(25,0),
	(26,-463),
	(26,-462),
	(26,-433),
	(26,-432),
	(26,-431),
	(26,-430),
	(26,-429),
	(26,-427),
	(26,-400),
	(26,-399),
	(26,-296),
	(26,-244),
	(26,-243),
	(26,-242),
	(26,-238),
	(26,-234),
	(27,325),
	(28,310),
	(29,-520),
	(30,410),
	(31,0),
	(32,309),
	(33,307),
	(34,326),
	(35,0),
	(36,304),
	(37,311),
	(38,300),
	(39,0),
	(40,0),
	(41,0),
	(42,0),
	(43,0),
	(44,0),
	(45,0),
	(46,521),
	(47,521),
	(48,0),
	(49,0),
	(50,0),
	(51,0),
	(52,416),
	(56,305),
	(57,238),
	(57,427),
	(57,429),
	(57,430),
	(57,431),
	(57,432),
	(57,433),
	(57,462),
	(57,463),
	(58,0),
	(58,427),
	(58,429),
	(58,430),
	(58,431),
	(58,432),
	(58,433),
	(58,462),
	(58,463),
	(59,0),
	(61,443),
	(62,231),
	(62,234),
	(62,242),
	(62,243),
	(62,244),
	(62,296),
	(62,399),
	(62,400),
	(63,0),
	(64,447),
	(65,427),
	(65,429),
	(65,430),
	(65,431),
	(65,432),
	(65,433),
	(65,462),
	(65,463),
	(68,243),
	(69,459),
	(70,285),
	(70,316),
	(71,285),
	(71,316),
	(72,285),
	(72,316),
	(73,285),
	(73,316),
	(74,285),
	(74,316),
	(75,285),
	(75,316),
	(76,0),
	(77,521),
	(79,0),
	(80,0),
	(81,0),
	(82,0),
	(83,0),
	(84,0),
	(85,0),
	(86,-520),
	(87,0),
	(88,0),
	(89,0),
	(90,0),
	(91,435),
	(92,520),
	(93,-520),
	(94,520),
	(95,520),
	(96,520),
	(97,0),
	(98,520),
	(99,520),
	(100,520),
	(101,520),
	(102,520),
	(103,520),
	(104,0),
	(105,520),
	(106,0),
	(107,520),
	(108,0),
	(109,-520),
	(110,520),
	(111,520),
	(112,520),
	(113,520),
	(114,520),
	(115,520),
	(116,520),
	(117,520),
	(118,520),
	(119,520),
	(120,520),
	(121,520),
	(122,520),
	(123,520),
	(124,520),
	(125,520),
	(126,520),
	(127,520),
	(128,520),
	(129,520),
	(130,520),
	(131,520),
	(132,520),
	(133,520),
	(134,520),
	(135,520),
	(136,520),
	(137,-520);

/*!40000 ALTER TABLE `#__modules_menu` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__template_styles
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__template_styles`;

CREATE TABLE `#__template_styles` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `template` varchar(50) NOT NULL DEFAULT '',
  `client_id` tinyint(1) unsigned NOT NULL DEFAULT '0',
  `home` char(7) NOT NULL DEFAULT '0',
  `title` varchar(255) NOT NULL DEFAULT '',
  `params` text NOT NULL,
  PRIMARY KEY (`id`),
  KEY `idx_template` (`template`),
  KEY `idx_home` (`home`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__template_styles` WRITE;
/*!40000 ALTER TABLE `#__template_styles` DISABLE KEYS */;

INSERT INTO `#__template_styles` (`id`, `template`, `client_id`, `home`, `title`, `params`)
VALUES
	(2,'bluestork',1,'1','Bluestork - Default','{\"useRoundedCorners\":\"1\",\"showSiteName\":\"0\"}'),
	(3,'atomic',0,'0','Atomic - Default','{}'),
	(4,'beez_20',0,'0','Beez2 - Default','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/joomla_black.gif\",\"sitetitle\":\"Joomla!\",\"sitedescription\":\"Open Source Content Management\",\"navposition\":\"left\",\"templatecolor\":\"personal\",\"html5\":\"0\"}'),
	(5,'hathor',1,'0','Hathor - Default','{\"showSiteName\":\"0\",\"colourChoice\":\"\",\"boldText\":\"0\"}'),
	(6,'beez5',0,'0','Beez5 - Default-Fruit Shop','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"images\\/sampledata\\/fruitshop\\/fruits.gif\",\"sitetitle\":\"Matuna Market \",\"sitedescription\":\"Fruit Shop Sample Site\",\"navposition\":\"left\",\"html5\":\"0\"}'),
	(114,'beez_20',0,'0','Beez2 - Parks Site','{\"wrapperSmall\":\"53\",\"wrapperLarge\":\"72\",\"logo\":\"\",\"sitetitle\":\"Australian Parks\",\"sitedescription\":\"Parks Sample Site\",\"navposition\":\"center\",\"templatecolor\":\"nature\"}'),
	(115,'zengridframework',0,'0','ZenGridFramework - Default','[]'),
	(118,'jbrasa',0,'1','JBRasa - Default','{\"rootCheck\":\"1\",\"zenTranslate\":\"1\",\"hilite\":\"hiliteGreen\",\"logoType\":\"image\",\"logoClass\":\"p\",\"logoPosition\":\"above\",\"logoText\":\"Rasa\",\"fontStackLogo\":\"Josefin\",\"logoFontSize\":\"2em\",\"logoFile\":\"images\\/logos\\/logo.png\",\"logoWidth\":\"four\",\"logoLink\":\"index.php\",\"logoAltTag\":\"\",\"fonts\":\"3\",\"fontStackBody\":\"helvetica\",\"fontStackHeading\":\"georgia\",\"fontStackNav\":\"helvetica\",\"fontSize\":\"78%\",\"typekit\":\"0\",\"typekitId\":\"\",\"position\":\"center\",\"containerMargin\":\"150px\",\"tWidth\":\"960\",\"cols\":\"12\",\"allEqual\":\"0\",\"gutter\":\"20\",\"controlMainArea\":\"0\",\"topEqual\":\"0\",\"top1Width\":\"two\",\"top2Width\":\"two\",\"top3Width\":\"two\",\"top4Width\":\"six\",\"headerEqual\":\"0\",\"header1Width\":\"two\",\"header2Width\":\"six\",\"header3Width\":\"two\",\"header4Width\":\"eight\",\"navLeft\":\"1\",\"navWidth\":\"twelve\",\"grid1Equal\":\"1\",\"grid1Width\":\"nine\",\"grid2Width\":\"nine\",\"grid3Width\":\"three\",\"grid4Width\":\"three\",\"grid2Equal\":\"1\",\"grid5Width\":\"six\",\"grid6Width\":\"six\",\"grid7Width\":\"three\",\"grid8Width\":\"six\",\"grid3Equal\":\"1\",\"grid9Width\":\"three\",\"grid10Width\":\"six\",\"grid11Width\":\"three\",\"grid12Width\":\"three\",\"mainLayout\":\"1\",\"advert1Width\":\"eight\",\"advert2Width\":\"four\",\"advert3Width\":\"four\",\"advert4Width\":\"eight\",\"advert5Width\":\"two\",\"advert6Width\":\"two\",\"grid4Equal\":\"1\",\"grid13Width\":\"three\",\"grid14Width\":\"three\",\"grid15Width\":\"three\",\"grid16Width\":\"three\",\"grid5Equal\":\"1\",\"grid17Width\":\"three\",\"grid18Width\":\"three\",\"grid19Width\":\"three\",\"grid20Width\":\"three\",\"grid6Equal\":\"1\",\"grid21Width\":\"three\",\"grid22Width\":\"three\",\"grid23Width\":\"three\",\"grid24Width\":\"three\",\"bottomEqual\":\"1\",\"bottom1Width\":\"three\",\"bottom2Width\":\"three\",\"bottom3Width\":\"three\",\"bottom4Width\":\"two\",\"bottom5Width\":\"three\",\"superfish\":\"yes\",\"sfEffect\":\"3\",\"sfSpeed\":\"normal\",\"sfhover\":\"1\",\"sfDelay\":\"800\",\"sfMinWidth\":\"10\",\"sfMaxWidth\":\"30\",\"openPanel\":\"Open Panel\",\"paneltype\":\"opacity\",\"panelHeight\":\"500\",\"panelWidth\":\"320\",\"panelEqual\":\"0\",\"panel1Width\":\"four\",\"panel2Width\":\"six\",\"panel3Width\":\"four\",\"panel4Width\":\"four\",\"analyticsPosition\":\"after\",\"analytics\":\"\",\"csscompress\":\"0\",\"combinescripts\":\"0\",\"removeMootools\":\"0\",\"removeJgen\":\"1\",\"disableTP\":\"0\",\"banner\":\"1\",\"bottom\":\"1\",\"closeContainer\":\"1\",\"footer\":\"1\",\"frontpage\":\"1\",\"grid1\":\"1\",\"grid2\":\"1\",\"grid3\":\"1\",\"grid4\":\"1\",\"grid5\":\"1\",\"grid6\":\"1\",\"header\":\"1\",\"main\":\"1\",\"nav\":\"1\",\"openContainer\":\"0\",\"panel\":\"1\",\"top\":\"1\",\"overwriteCSS\":\"0\",\"bodyColour\":\"\",\"aColour\":\"\",\"ahoverColour\":\"\",\"taglineCSS\":\"\",\"h1Colour\":\"\",\"h2Colour\":\"\",\"h3Colour\":\"\",\"h4Colour\":\"\",\"h5Colour\":\"\",\"h6Colour\":\"\",\"extraCSS\":\"\",\"enableTagline\":\"1\",\"tagline\":\"A blank slate for your business ...\",\"taglineTop\":\"0\",\"taglineLeft\":\"0\",\"leftCols2L\":\"four\",\"midCols2L\":\"eight\",\"midCols2R\":\"eight\",\"rightCols2R\":\"four\",\"leftCols3LR\":\"three\",\"midCols3LR\":\"six\",\"rightCols3LR\":\"three\",\"leftCols4LRC\":\"three\",\"midCols4LRC\":\"three\",\"centerCols4LRC\":\"three\",\"rightCols4LRC\":\"three\",\"leftCols3LC\":\"three\",\"centerCols3LC\":\"three\",\"midCols3LC\":\"six\",\"midCols3RC\":\"six\",\"centerCols3RC\":\"three\",\"rightCols3RC\":\"three\",\"pngfix\":\"1\",\"pngfixrules\":\"#paneltab a,.twitterFixed,.rssFixed,#overlay,.slideshowContent.dark,.mbDateCols,.jbLogo\",\"extraScripts\":\"\",\"footerWidth\":\"two\",\"panelMenu\":\"yes\",\"splitMenu\":\"0\",\"splitMenuName\":\"mainmenu\",\"splitMenuTitle\":\"In this section ...\",\"splitMenuPos\":\"left\",\"tab1Title\":\"Tab1\",\"tab2Title\":\"Tab2\",\"tab3Title\":\"Tab3\",\"tab4Title\":\"Tab4\",\"removejblogo\":\"0\",\"customcopyright\":\"\"}');

/*!40000 ALTER TABLE `#__template_styles` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__usergroups
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__usergroups`;

CREATE TABLE `#__usergroups` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `parent_id` int(10) unsigned NOT NULL DEFAULT '0' COMMENT 'Adjacency List Reference Id',
  `lft` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set lft.',
  `rgt` int(11) NOT NULL DEFAULT '0' COMMENT 'Nested set rgt.',
  `title` varchar(100) NOT NULL DEFAULT '',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_usergroup_parent_title_lookup` (`parent_id`,`title`),
  KEY `idx_usergroup_title_lookup` (`title`),
  KEY `idx_usergroup_adjacency_lookup` (`parent_id`),
  KEY `idx_usergroup_nested_set_lookup` (`lft`,`rgt`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8;

LOCK TABLES `#__usergroups` WRITE;
/*!40000 ALTER TABLE `#__usergroups` DISABLE KEYS */;

INSERT INTO `#__usergroups` (`id`, `parent_id`, `lft`, `rgt`, `title`)
VALUES
	(1,0,1,20,'Public'),
	(2,1,6,17,'Registered'),
	(3,2,7,14,'Author'),
	(4,3,8,11,'Editor'),
	(5,4,9,10,'Publisher'),
	(6,1,2,5,'Manager'),
	(7,6,3,4,'Administrator'),
	(8,1,18,19,'Super Users');

/*!40000 ALTER TABLE `#__usergroups` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__viewlevels
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__viewlevels`;

CREATE TABLE `#__viewlevels` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT COMMENT 'Primary Key',
  `title` varchar(100) NOT NULL DEFAULT '',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `rules` varchar(5120) NOT NULL COMMENT 'JSON encoded access control.',
  PRIMARY KEY (`id`),
  UNIQUE KEY `idx_assetgroup_title_lookup` (`title`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__viewlevels` WRITE;
/*!40000 ALTER TABLE `#__viewlevels` DISABLE KEYS */;

INSERT INTO `#__viewlevels` (`id`, `title`, `ordering`, `rules`)
VALUES
	(1,'Public',0,'[1]'),
	(2,'Registered',1,'[6,2,8]'),
	(3,'Special',2,'[6,3,8]'),
	(4,'Customer Access Level',3,'[6,3,12]');

/*!40000 ALTER TABLE `#__viewlevels` ENABLE KEYS */;
UNLOCK TABLES;


# Dump of table #__weblinks
# ------------------------------------------------------------

DROP TABLE IF EXISTS `#__weblinks`;

CREATE TABLE `#__weblinks` (
  `id` int(10) unsigned NOT NULL AUTO_INCREMENT,
  `catid` int(11) NOT NULL DEFAULT '0',
  `sid` int(11) NOT NULL DEFAULT '0',
  `title` varchar(250) NOT NULL DEFAULT '',
  `alias` varchar(255) NOT NULL DEFAULT '',
  `url` varchar(250) NOT NULL DEFAULT '',
  `description` text NOT NULL,
  `date` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `hits` int(11) NOT NULL DEFAULT '0',
  `state` tinyint(1) NOT NULL DEFAULT '0',
  `checked_out` int(11) NOT NULL DEFAULT '0',
  `checked_out_time` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `ordering` int(11) NOT NULL DEFAULT '0',
  `archived` tinyint(1) NOT NULL DEFAULT '0',
  `approved` tinyint(1) NOT NULL DEFAULT '1',
  `access` int(11) NOT NULL DEFAULT '1',
  `params` text NOT NULL,
  `language` char(7) NOT NULL DEFAULT '',
  `created` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `created_by` int(10) unsigned NOT NULL DEFAULT '0',
  `created_by_alias` varchar(255) NOT NULL DEFAULT '',
  `modified` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `modified_by` int(10) unsigned NOT NULL DEFAULT '0',
  `metakey` text NOT NULL,
  `metadesc` text NOT NULL,
  `metadata` text NOT NULL,
  `featured` tinyint(3) unsigned NOT NULL DEFAULT '0' COMMENT 'Set if link is featured.',
  `xreference` varchar(50) NOT NULL COMMENT 'A reference to enable linkages to external data sets.',
  `publish_up` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  `publish_down` datetime NOT NULL DEFAULT '0000-00-00 00:00:00',
  PRIMARY KEY (`id`),
  KEY `idx_access` (`access`),
  KEY `idx_checkout` (`checked_out`),
  KEY `idx_state` (`state`),
  KEY `idx_catid` (`catid`),
  KEY `idx_createdby` (`created_by`),
  KEY `idx_featured_catid` (`featured`,`catid`),
  KEY `idx_language` (`language`),
  KEY `idx_xreference` (`xreference`)
) ENGINE=MyISAM DEFAULT CHARSET=utf8;

LOCK TABLES `#__weblinks` WRITE;
/*!40000 ALTER TABLE `#__weblinks` DISABLE KEYS */;

INSERT INTO `#__weblinks` (`id`, `catid`, `sid`, `title`, `alias`, `url`, `description`, `date`, `hits`, `state`, `checked_out`, `checked_out_time`, `ordering`, `archived`, `approved`, `access`, `params`, `language`, `created`, `created_by`, `created_by_alias`, `modified`, `modified_by`, `metakey`, `metadesc`, `metadata`, `featured`, `xreference`, `publish_up`, `publish_down`)
VALUES
	(1,32,0,'Joomla!','joomla','http://www.joomla.org','<p>Home of Joomla!</p>','0000-00-00 00:00:00',3,1,0,'0000-00-00 00:00:00',1,0,1,1,'{\"target\":\"0\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(2,33,0,'php.net','php','http://www.php.net','<p>The language that Joomla! is developed in</p>','0000-00-00 00:00:00',6,1,0,'0000-00-00 00:00:00',1,0,1,1,'{\"target\":\"\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(3,33,0,'MySQL','mysql','http://www.mysql.com','<p>The database that Joomla! uses</p>','0000-00-00 00:00:00',1,1,0,'0000-00-00 00:00:00',2,0,1,1,'{\"target\":\"\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(4,32,0,'OpenSourceMatters','opensourcematters','http://www.opensourcematters.org','<p>Home of OSM</p>','0000-00-00 00:00:00',11,1,0,'0000-00-00 00:00:00',3,0,1,1,'{\"target\":\"0\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(5,32,0,'Joomla! - Forums','joomla-forums','http://forum.joomla.org','<p>Joomla! Forums</p>','0000-00-00 00:00:00',4,1,0,'0000-00-00 00:00:00',2,0,1,1,'{\"target\":\"0\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(6,33,0,'Ohloh Tracking of Joomla!','ohloh-tracking-of-joomla','http://www.ohloh.net/projects/20','<p>Objective reports from Ohloh about Joomla\'s development activity. Joomla! has some star developers with serious kudos.</p>','0000-00-00 00:00:00',1,1,0,'0000-00-00 00:00:00',3,0,1,1,'{\"target\":\"0\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(7,31,0,'Baw Baw National Park','baw-baw-national-park','http://www.parkweb.vic.gov.au/1park_display.cfm?park=44','<p>Park of the Austalian Alps National Parks system, Baw Baw  features sub alpine vegetation, beautiful views, and opportunities for hiking, skiing and other outdoor activities.</p>','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',1,0,1,1,'{\"target\":\"0\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(8,31,0,'Kakadu','kakadu','http://www.environment.gov.au/parks/kakadu/index.html','<p>Kakadu is known for both its cultural heritage and its natural features. It is one of a small number of places listed as World Heritage Places for both reasons. Extensive rock art is found there.</p>','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',2,0,1,1,'{\"target\":\"0\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','0000-00-00 00:00:00','0000-00-00 00:00:00'),
	(9,31,0,'Pulu Keeling','pulu-keeling','http://www.environment.gov.au/parks/cocos/index.html','<p>Located on an atoll 2000 kilometers north of Perth, Pulu Keeling is Australia\'s smallest national park.</p>','0000-00-00 00:00:00',0,1,0,'0000-00-00 00:00:00',3,0,1,1,'{\"target\":\"0\",\"count_clicks\":\"\"}','en-GB','2011-01-01 00:00:01',0,'','2011-01-01 00:00:01',42,'','','{\"robots\":\"\",\"author\":\"\",\"rights\":\"\"}',0,'','2010-07-10 23:44:03','0000-00-00 00:00:00');

/*!40000 ALTER TABLE `#__weblinks` ENABLE KEYS */;
UNLOCK TABLES;



/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;
/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
